(* ---------------------------------------------------------------
Title         Q&D Yes/No Quiz
Overview      see help
Usage         see help
Notes         as usual, Q&D rules ! :-(

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
	          (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              see XDS, //XDSTS and //FIXME

              note Win32 default width is 66 instead of DOS 74

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs
Wish List     yes, we should use dynamic allocation... but what for ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 22 Nov 15 an really ugly 30mn Q&D port from QUIZYN v1.0 for DOS
              useless port "justified" by a new random visit
              to World's Smallest Political Quiz Web site
              and to Mr Caplan's Web site while we were at it
              (seems data file does not need any change
              compared to the one created a few years ago)
--------------------------------------------------------------- *)

MODULE QuizYN32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
    charBlank     = 40C; (* //XDS silly octal requirement for concatenation ! *)
    charEscape    = 33C; (* //XDS see supra *)
    charBS	  = 10C; (* //XDS see supra *)
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    questionmark  = "?";   (* // changed from question to questionmark for this program only *)
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;


PROCEDURE vidWrStr (s : ARRAY OF CHAR);
CONST
    (* stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *) *)
    (* stderr        = FIO.ErrorOutput; *)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    extEXE          = ".EXE";
    extDAT          = ".DAT";
    extLOG          = ".LOG";
CONST
    ProgEXEname     = "QUIZYN32";
    ProgTitle       = "Q&D Yes/No Quiz (Win32)";
    ProgVersion     = "v0.9 (from v1.0 for DOS)";
    ProgCopyright   = "by PhG";
    Banner          = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParameter        = 3;
    errDataNotFound     = 4;
    errTooManyQuestions = 5;
    errTooManyScorings  = 6;
    errBadQuestion      = 7;
    errBadScoring       = 8;
    errBadWeight        = 9;
    errBadUpper         = 10;
    errRedirected       = 11;
    errAborted          = 12;
    errNotWithResume    = 13;
    errBadWidth         = 14;
    errLogNotFound      = 15;
    errBadLog           = 16;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" [-d:datafile["+extDAT+"]] [-l:logfile[+extLOG+]] [option]..."+nl+
nl+
"This is a computerized Yes/No quiz."+nl+
nl+
"   -d:$ data file (default is "+ProgEXEname+extDAT+")"+nl+
"   -l:$ log file (default is data file with "+extLOG+" extension)"+nl+
"   -o   do not shuffle questions"+nl+
"   -s   save results to log file file"+nl+
"   -r   resume using data from log file"+nl+
"   -w:# line width (default is 66)"+nl+
nl+
"a) -s option is required for quiz to be saved at program exit,"+nl+
"   while -r is required for saved quiz to be reloaded."+nl+
"   Please note both -r and -s options are required for saved quiz"+nl+
"   to be reloaded then saved again at program exit."+nl+
"b) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str1024; (* //XDS was str256 *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errOption:
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errParameter:
        Str.Concat(S,"Useless ",einfo);Str.Append(S," parameter !");
    | errDataNotFound:
        Str.Concat(S,einfo," data file does not exist !");
    | errTooManyQuestions:
        S:="Too many questions in data file !";
    | errTooManyScorings:
        S:="Too many scoring entries in data file !";
    | errBadQuestion:
        Str.Concat(S,"Bad question format at line ",einfo);Str.Append(S," !");
    | errBadScoring:
        Str.Concat(S,"Bad scoring entry format at line ",einfo);Str.Append(S," !");
    | errBadWeight:
        Str.Concat(S,"Bad weight value at line ",einfo);Str.Append(S," !");
    | errBadUpper:
        Str.Concat(S,"Bad upper value at line ",einfo);Str.Append(S," !");
    | errRedirected:
        S:="Output redirection is a nonsense !";
    | errAborted:
        S:="Aborted by user !";
    | errNotWithResume:
        S:="-o option is a nonsense with -r option !";
    | errBadWidth :
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," line width !");
    | errLogNotFound:
        Str.Concat(S,einfo," log file does not exist !");
    | errBadLog:
        Str.Concat(S,"Corrupted ",einfo);Str.Append(S," log file !");

    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp: ;
    ELSE
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode( SHORTCARRD(e) ); *)
    HALT (e) ;
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBuffer : ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC; (* //XDS BYTE was too simple ! *)

CONST
    sep          = " : ";
    msgReading   = "Reading...";
    msgShuffling = "Shuffling...";
    msgSaving    = "Saving...";
    msgResuming  = "Loading...";
    undefined    = " ";
    reindexed    = "*";
CONST
    prefixinfo    = "### ";
    prefix        = "::: ";
    msgQuestion   = prefix+"Question ";
    msgOutOf      = " out of ";
    msgChoice     = " [Y/N/Q]";
    legalchoices  = "YNQ"+charEscape; (* //XDS +CHR(27) was too simple ! *)
    msgYes        = " Yes";
    msgNo         = " No";
    msgQuit       = " Quit";
    msgYourScore  = prefix+"Your score"+sep;
    msgCreated    = " has been created !";
    msgLoaded     = " has been loaded !";
TYPE
    questiontype = RECORD
        index  : CARDINAL;
        weight : INTEGER;
        text   : str256; (* should do *)
        answer : CHAR;
    END;
    scoringtype = RECORD
        upper : INTEGER;
        text  : str256;  (* should do *)
    END;
CONST
    firstQuestion = 1;
    maxQuestion   = 100;
    firstScoring  = 1;
    maxScoring    = 20;
VAR
    question     : ARRAY[firstQuestion..maxQuestion] OF questiontype;
    scoring      : ARRAY[firstScoring..maxScoring] OF scoringtype;
    lastQuestion : CARDINAL;
    lastScoring  : CARDINAL;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE readentry (hnd:FIO.File;
                     VAR currline:CARDINAL;
                     VAR R:ARRAY OF CHAR):BOOLEAN ;
VAR
    len:CARDINAL;
BEGIN
    LOOP
        FIO.RdStr(hnd,R);
        INC(currline);
        LtrimBlanks(R);
        RtrimBlanks(R);
        CASE R[0] OF
        | CHR(0): ; (* empty string *)
        | semicolon : ; (* comment *)
        | dollar : RETURN TRUE; (* end of section *)
        | doublequote,singlequote:
            len:=Str.Length(R);
            IF len >= 2 THEN
                IF R[len-1]=R[0] THEN
                    R[len-1]:=0C;
                    Str.Delete(R,0,1);
                END;
            END;
            RETURN FALSE;
        ELSE
            RETURN FALSE; (* not done yet *)
        END;
        IF FIO.EOF THEN RETURN TRUE; END;
    END;
END readentry;

PROCEDURE dump (wi:CARDINAL; lastCR:BOOLEAN; para:ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
    R:str128;
BEGIN
    ok:=dmpTTX (para,wi,R,TRUE);
    WHILE ok DO
        WrStr(R);
        ok:=dmpTTX(para,wi,R,FALSE);
        IF ok THEN
            WrLn;
        ELSE
            IF lastCR THEN WrLn;END;
        END;
    END;
END dump;

PROCEDURE getintval (S:ARRAY OF CHAR):INTEGER;
VAR
    lc:LONGINT;
    ok:BOOLEAN;
BEGIN
    lc:=Str.StrToInt(S,10,ok);
    IF ok=FALSE THEN RETURN MAX(INTEGER);END;
    IF lc>MAX(INTEGER) THEN RETURN MAX(INTEGER);END;
    RETURN INTEGER(lc);
END getintval;

PROCEDURE getcardval (S:ARRAY OF CHAR):CARDINAL;
VAR
    lc:LONGCARD;
    ok:BOOLEAN;
BEGIN
    lc:=Str.StrToCard(S,10,ok);
    IF ok=FALSE THEN RETURN MAX(CARDINAL);END;
    IF lc>MAX(CARDINAL) THEN RETURN MAX(CARDINAL);END;
    RETURN CARDINAL(lc);
END getcardval;

PROCEDURE getrndwithin (lowerlimit,upperlimit:CARDINAL):CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * Lib.RAND()+ lowerbound ;
    RETURN CARDINAL(rnd);
END getrndwithin;

PROCEDURE getchoice (legal:ARRAY OF CHAR):CHAR;
VAR
    ch:CHAR;
BEGIN
    LOOP
        ch:=IO.RdKey();
        IF ch=CHR(0) THEN
            ch:=IO.RdKey();
        ELSE
            IF Str.CharPos(legal,ch) # MAX(CARDINAL) THEN EXIT; END;
            ch:=CAP(ch);
            IF Str.CharPos(legal,ch) # MAX(CARDINAL) THEN EXIT; END;
        END;
    END;
    RETURN ch;
END getchoice;

PROCEDURE getCard (VAR wi:CARDINAL;
                   lower,upper:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc:LONGCARD;
BEGIN
    IF GetLongCard(S,lc)=FALSE THEN RETURN FALSE;END;
    IF lc > MAX(CARDINAL) THEN RETURN FALSE; END;
    wi:=CARDINAL(lc);
    IF ( (wi < lower) OR (wi > upper) ) THEN RETURN FALSE; END;
    RETURN TRUE;
END getCard;

(* uses a few globerks ! ;-) *)

PROCEDURE loadData (debug:BOOLEAN;datafile:pathtype;wi:CARDINAL;
                    VAR info:ARRAY OF CHAR):CARDINAL;
VAR
    hnd:FIO.File;
    i,currline,p,rc:CARDINAL;
    done:BOOLEAN;
    S:str128; (* oversized *)
    para:str1024; (* should do for intro longest line *)
BEGIN
    FIO.EOF:=FALSE;
    hnd:=FIO.OpenRead(datafile);
    FIO.AssignBuffer(hnd,ioBuffer);
    currline:=0;
    FOR i:=1 TO 2 DO (* title then intro *)
        LOOP
            done:=readentry(hnd,currline,para);
            IF done THEN EXIT;END;
            dump(wi,TRUE,para);
        END;
        WrLn;
    END;

    video(msgReading,TRUE);

    rc:=errNone;
    lastQuestion:=firstQuestion-1; (* read questions *)
    LOOP
        done:=readentry(hnd,currline,para);
        IF done THEN EXIT;END;
        INC(lastQuestion);
        IF lastQuestion > maxQuestion THEN
            rc:=errTooManyQuestions;
            EXIT;
        END;
        IF Str.Match(para,"*:*")=FALSE THEN
            rc:=errBadQuestion;
            EXIT;
        END;
        p:=Str.CharPos(para,colon);
        Str.Slice(S,para,0,p);
        question[lastQuestion].weight:=getintval(S);
        IF question[lastQuestion].weight=MAX(INTEGER) THEN
            rc:=errBadWeight;
            EXIT;
        END;
        Str.Delete(para,0,p+1);
        Str.Copy(question[lastQuestion].text,para);
        IF debug THEN
            IO.WrCard(lastQuestion,4);
            IO.WrInt(question[lastQuestion].weight,4);
            WrStr(sep);
            WrStr(question[lastQuestion].text);WrLn;
        END;
    END;
    IF rc # errNone THEN
        FIO.Close(hnd);
        video(msgReading,FALSE);
        Str.CardToStr(LONGCARD(currline),info,10,done);
        RETURN rc;
    END;

    rc:=errNone;
    lastScoring:=firstScoring-1; (* read scoring entries *)
    LOOP
        done:=readentry(hnd,wi,para);
        IF done THEN EXIT;END;
        INC(lastScoring);
        IF lastScoring > maxScoring THEN
            rc:=errTooManyScorings;
            EXIT;
        END;
        IF Str.Match(para,"*:*")=FALSE THEN
            rc:=errBadScoring;
            EXIT;
        END;
        p:=Str.CharPos(para,colon);
        Str.Slice(S,para,0,p);
        scoring[lastScoring].upper:=getintval(S);
        IF scoring[lastScoring].upper=MAX(INTEGER) THEN
            rc:=errBadUpper;
            EXIT;
        END;
        Str.Delete(para,0,p+1);
        Str.Copy(scoring[lastScoring].text,para);
        IF debug THEN
            IO.WrCard(lastScoring,4);
            IO.WrCard(scoring[lastScoring].upper,4);
            WrStr(sep);
            WrStr(scoring[lastScoring].text);WrLn;
        END;
    END;
    IF rc # errNone THEN
        FIO.Close(hnd);
        video(msgReading,FALSE);
        Str.CardToStr(LONGCARD(currline),info,10,done);
        RETURN rc;
    END;
    FIO.Close(hnd);
    video(msgReading,FALSE);

    RETURN errNone;
END loadData;

PROCEDURE saveLog (debug:BOOLEAN;logfile:pathtype);
VAR
    hnd:FIO.File;
    i,p:CARDINAL;
BEGIN
    video(msgSaving,TRUE);
    hnd:=FIO.Create(logfile);
    FOR i:=firstQuestion TO lastQuestion DO
        p:=question[i].index;
        FIO.WrCard(hnd,p,4);
        FIO.WrStr(hnd,sep);
        FIO.WrStr(hnd,question[p].answer);
        FIO.WrLn(hnd);
        IF debug THEN
           IO.WrCard(p,4);
           WrStr(sep);
           WrStr(question[p].answer);
           WrLn;
        END;
    END;
    FIO.WrLn(hnd); (* //XDS safety for its unreliable FIO.EOF handling *)
    FIO.Close(hnd);
    video(msgSaving,FALSE);
    WrStr(prefixinfo);WrStr(logfile);WrStr(msgCreated);WrLn;
END saveLog;

PROCEDURE loadLog (debug:BOOLEAN;logfile:pathtype):BOOLEAN ;
VAR
    hnd:FIO.File;
    i,p,len:CARDINAL;
    S,R:str128;
BEGIN
    len:=Str.Length(sep);
    video(msgResuming,TRUE);
    hnd:=FIO.OpenRead(logfile);
    FIO.AssignBuffer(hnd,ioBuffer);

    FOR i:=firstQuestion TO lastQuestion DO
        FIO.RdStr(hnd,S);
        IF debug THEN WrStr(S);WrLn;END;
        p:=Str.Pos(S,sep);
        IF p = MAX(CARDINAL) THEN
            FIO.Close(hnd);
            video(msgResuming,FALSE);
            RETURN FALSE;
        END;
        Str.Slice(R,S,0,p);
        LtrimBlanks(R);
        RtrimBlanks(R);
        Str.Delete(S,0,p+len);
        p:=getcardval(R);
        question[i].index:=p;
        IF S[0] = reindexed THEN S[0] := undefined; END; (* should never happen *)
        question[p].answer:=S[0];
        IF debug THEN
            IO.WrCard(question[i].index,4);
            WrStr(sep);
            WrStr(question[p].answer);
            WrLn;
        END;
    END;
    FIO.Close(hnd);
    video(msgResuming,FALSE);
    RETURN TRUE;
END loadLog;

PROCEDURE initQuestions (  );
VAR
    i:CARDINAL ;
BEGIN
    FOR i:=firstQuestion TO lastQuestion DO
        question[i].index  := i;
        question[i].answer := undefined;
    END;
END initQuestions;

PROCEDURE shuffleQuestions (  );
VAR
    i,p:CARDINAL;
BEGIN
    video(msgShuffling,TRUE);
    FOR i:=firstQuestion TO lastQuestion DO
        LOOP
            p:=getrndwithin(firstQuestion,lastQuestion);
            IF question[p].answer=" " THEN
                question[p].answer:=reindexed;
                question[i].index :=p;
                EXIT;
            END;
        END;
    END;
    FOR i:=firstQuestion TO lastQuestion DO
        question[i].answer := undefined;
    END;
    video(msgShuffling,FALSE);
END shuffleQuestions;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    minWidth     = 1;
    maxWidth     = 256; (* longest possible line, eh eh *)
    defaultWidth = 66;  (* // was 74 *)
VAR
    DEBUG,log,shuffle,resume:BOOLEAN;
    wi:CARDINAL;
    datafile,logfile,u,d,n,e:pathtype; (* was str128 *)
    score:INTEGER;
    para:str1024; (* was str256, should DO *)
    ch:CHAR;
VAR
    parmcount,i,opt,p:CARDINAL;
    S,R:pathtype;      (* //XDS was str128 *)
    state:(waiting,gotsomething);
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    WrLn;

    DEBUG  := FALSE;
    log    := FALSE;
    shuffle:= TRUE;
    resume := FALSE;
    wi     := defaultWidth;
    Str.Copy(datafile,"");
    Str.Copy(logfile,"");

    state:=waiting;
    parmcount := Lib.ParamCount();
    (* IF parmcount=0 THEN abort(errHelp,"");END; *)
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        RtrimBlanks(R); (* try and fix Yet Another TopSpeed bug ! *)
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "DEBUG"+delim+
                                   "S"+delim+"SAVE"+delim+
                                   "O"+delim+"ORDERED"+delim+
                                   "R"+delim+"RESUME"+delim+
                                   "W:"+delim+"WIDTH:"+delim+
                                   "L:"+delim+"LOG:"+delim+
                                   "D:"+delim+"DATA:"
                               );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4     : DEBUG := TRUE;
            | 5,6   : log := TRUE;
            | 7,8   : shuffle:=FALSE;
            | 9,10  : resume:=TRUE;
            | 11,12 : IF getCard(wi,minWidth,maxWidth,S)=FALSE THEN
                          abort(errBadWidth,S);
                      END;
            | 13,14 : GetString(R,logfile);
            | 15,16 : GetString(R,datafile);
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting:
                abort(errParameter,S);
            ELSE
                ; (* //XDS silly requirement for CASE ! *)
            END;
            INC(state);
        END;
    END;

    (*
    // we won't detect if output is redirected from Vindoze : we dump the question for now
    // this is a really Q&D port after all... ;-)
    IF ( (DEBUG=FALSE) AND IsRedirected() ) THEN abort(errRedirected,"");END;
    *)

    IF (resume AND (shuffle=FALSE) ) THEN abort(errNotWithResume,"");END;

    IF same(datafile,"") THEN
        Lib.ParamStr(datafile,0);
        qdSplitAllPath(datafile,u,d,n,e);
        Lib.MakeAllPath(datafile,u,d,n,extDAT);
    ELSE
        IF Str.CharPos(datafile,dot)=MAX(CARDINAL) THEN
            Str.Append(datafile,extDAT);
        END;
    END;
    IF FIO.Exists(datafile)=FALSE THEN abort(errDataNotFound,datafile);END;

    IF same(logfile,"") THEN
        qdSplitAllPath(datafile,u,d,n,e);
        Lib.MakeAllPath(logfile,u,d,n,extLOG);
    ELSE
        IF Str.CharPos(logfile,dot)=MAX(CARDINAL) THEN
            Str.Append(logfile,extLOG);
        END;
    END;

    Lib.RANDOMIZE;

    WrStr(Banner);WrLn;
    WrLn;

    i:=loadData(DEBUG,datafile,wi,R);
    IF i # errNone THEN abort(i,R);END;

    initQuestions;

    IF resume THEN
        IF FIO.Exists(logfile)=FALSE THEN abort(errLogNotFound,logfile);END;
        IF loadLog(DEBUG,logfile)=FALSE THEN abort(errBadLog,logfile);END;
        WrStr(prefixinfo);WrStr(logfile);WrStr(msgLoaded);WrLn;
        WrLn;
    ELSE
        IF shuffle THEN shuffleQuestions();END;
    END;

    IF DEBUG THEN
        FOR i:=firstQuestion TO lastQuestion DO
            p:=question[i].index;
            IO.WrCard(p,4);
            IO.WrCard(question[p].weight,4);
            WrStr(sep);
            WrStr(question[p].text);WrLn;
        END;
    END;

    score := 0;
    i:=firstQuestion;
    LOOP
        p:=question[i].index;
        WrStr(msgQuestion);IO.WrCard(i,3);
        WrStr(msgOutOf);IO.WrCard(lastQuestion,3);WrLn;
        WrLn;
        Str.Concat(para,question[p].text,msgChoice);
        dump(wi,FALSE,para);
        IF resume THEN
            ch := question[p].answer;
            CASE ch OF
            | undefined,reindexed: ch:=getchoice(legalchoices);
	    ELSE
	       ; (* //XDS silly requirement for CASE ! *)
            END;
        ELSE
            ch:=getchoice(legalchoices);
        END;
        video(msgChoice,FALSE);
        question[p].answer := ch;
        CASE ch OF
        | "Y":
            INC(score,question[p].weight);
            WrStr(msgYes);WrLn;
        | "N":
            WrStr(msgNo);WrLn;
        | "Q",CHR(27):
            question[p].answer := undefined; (* reset it ! *)
            WrStr(msgQuit);WrLn;
            WrLn;
            IF log THEN saveLog(DEBUG,logfile); WrLn;END;
            abort(errAborted,"");
        ELSE
            ; (* //XDS silly requirement for CASE ! *)
        END;
        WrLn;
        INC(i);
        IF i > lastQuestion THEN EXIT; END;
    END;
    WrStr(msgYourScore);
    IO.WrInt(score,4);WrLn;
    WrLn;
    p:=0;
    FOR i:=firstScoring TO lastScoring DO
        IF score <= scoring[i].upper THEN
            IF p=0 THEN
                dump(wi,TRUE,scoring[i].text);
                p:=MAX(CARDINAL);
            END;
        END;
    END;

    IF log THEN WrLn;saveLog(DEBUG,logfile);END;
    abort(errNone,"");
END QuizYN32.

