(* ---------------------------------------------------------------
Title         Q&D Base Converter
Overview
Notes         with p4 2.6MHz, 5 hours to check 0..60000000 in shadok !

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs
Wish List     a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 17 Oct 21 sync with v1.0g for DOS
PhG 22 Jul 17 an ugly really Q&D port from BASECONV v1.0f for DOS
--------------------------------------------------------------- *)

MODULE BaseConv32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)

TYPE
    str4          = ARRAY[0..3] OF CHAR; (* str3 was too short FOR "Meu," ! *)
CONST
    ProgEXEname   = "BASECONV32";
    ProgTitle     = "Q&D Base Converter (Win32)";
    ProgVersion   = "v0.9a (from 1.0g for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extBANG       = ".!!!";
    FORCESHADOKFILE= ProgEXEname+extBANG;
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyNumbers=3;
    errNoNumber     = 4;
    errBadNumber    = 5;
    errBadLC        = 6;
    errFmt          = 7;
    errAborted      = 255;

(* ------------------------------------------------------------ *)

CONST
    foundNowhere   = 0;
    foundInCurrdir = 1;
    foundInEXEdir  = 2;

PROCEDURE foundForceShadokFile (VAR where:CARDINAL;
                               F:ARRAY OF CHAR):BOOLEAN;
VAR
    ok:BOOLEAN;
    R:str128;
    p:CARDINAL;
BEGIN
    Lib.ParamStr(R,0);
    p:=Str.RCharPos(R,antislash); (* yes, we could just check extension *)
    IF p # MAX(CARDINAL) THEN R[p]:=charnull;END;
    fixDirectory(R);
    Str.Append(R,F);
    where:=foundInEXEdir;
    ok:=FIO.Exists(R);
    IF NOT(ok) THEN
        where:=foundInCurrdir;
        ok:=FIO.Exists(F);
        IF NOT(ok) THEN where:=foundNowhere;END;
    END;
    RETURN ok;
END foundForceShadokFile;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <[$|%|0x|_|!]number>... [option]..."+nl+
nl+
"This program displays LONGCARD numbers in bases 10, 16, 2, 8 and 4"+nl+
"(decimal, hexadecimal, binary, octal, Shadok numeration)."+nl+
nl+
"    -a[a]    dump each base value on its own line (-aa = -a -o)"+nl+
"    -o|-b    show octal (-a forced)"+nl+
"    -4[@]|-! show base 4 (-a forced)"+nl+
"    -@[4]    show Shadok numeration (-a forced)"+nl+
"    -x       shortcut for -o -4 -@"+nl+
"    -c       show DOS ASCII character"+nl+
"    -f[r]    increase values readability (French-style)"+nl+
"    -u[s]    increase values readability (English-style)"+nl+
"    -$|--|-/ show only decimal and Shadok (-a forced)"+nl+
"    -i       show maximum values"+nl+
nl+
"a) -i option ignores any parameter."+nl+
"b) -c option is ignored if number is out of [0..255] ([$00..$ff]) range."+nl+
'c) Inner "'+dot+'" and "'+coma+'" separators are ignored.'+nl+
'd) Although octal "_" and base 4 "!" prefixes are handled,'+nl+
"   octal and base 4 display still require -o or -4 options."+nl+
"e) Shadok numeration does not use any prefix :"+nl+
"   it is base 4 where 0 = Ga, 1 = Bu, 2 = Zo, 3 = Meu."+nl+
"   Alternate forms are 0 = G, 1 = B, 2 = Z, 3 = M."+nl+
"   Normal and alternate forms should not be mixed."+nl+
'f) -$ option is forced if "'+FORCESHADOKFILE+'" file exists'+nl+
"   in executable directory or in current directory."+nl+
"   Please note this file ^ found^."+nl+ (* //FIXME *)
"g) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+ProgEXEname+" %00.00.00.01 0x2 1.963 $13 _55 -o"+nl+
"           "+ProgEXEname+" -4 !3210"+nl+
"           "+ProgEXEname+" -@ MeuZoBuGa MZBG Meu.Zo.Bu.Ga 228"+nl+
"           "+ProgEXEname+" -@ -4 -f MeuZoBuGa 19630201"+nl+
"           "+ProgEXEname+" -$ meuzobuga 228"+nl;

VAR
    S : str256;
    Z : str2048; (* str1024 was too short *)
    rc: CARDINAL;
BEGIN
    CASE e OF
    | errHelp :
        Str.Copy(Z,helpmsg);
        IF foundForceShadokFile(rc,FORCESHADOKFILE) THEN
            Str.Subst(Z,"^","WAS");
            CASE rc OF
            | foundInCurrdir: Str.Subst(Z,"^"," in current directory");
            | foundInEXEdir : Str.Subst(Z,"^"," in executable directory");
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE
            Str.Subst(Z,"^","was NOT");
            Str.Subst(Z,"^","");
        END;
        WrStr(Z);
    | errOption :
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," option !");
    | errTooManyNumbers:
        S := "Too many numbers !";
    | errNoNumber:
        S := "No number was specified !";
    | errBadNumber:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" value !');
    | errBadLC:
        Str.Concat(S,'Illegal "',einfo);Str.Append(S,'" LONGCARD value !');
    | errFmt:
        S := "-f[r] and -u[s] options are mutually exclusive !";
    | errAborted:
        S := "Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp : ;
    ELSE
        WrStr(ProgEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    gremlin   = ".";
    hexprefix = "$"; (* hex *)
    binprefix = "%"; (* bin *)
    octprefix = "_"; (* octal *)
    quadprefix= "!"; (* base 4 *)
CONST
    bindigits = "01";
    decdigits = "0123456789";
    hexdigits = decdigits+"ABCDEF"; (* uppercase *)
    octdigits = "01234567";
    quaddigits= "0123";
CONST
    (* nice luck with letters here ! *)
    numShadokLong  = "Ga,Bu,Zo,Meu";
    numShadokShort = "G,B,Z,M";
    numShadok      = numShadokLong+','+numShadokShort;

CONST
    (* $ffffffff = 4294967295 = %11111111111111111111111111111111 *)
    wibin        = 32; (* $ffffffff x 4 *)
    wihex        = 8;  (* $ffffffff *)
    widec        = 10; (* 4.294.697.295 *)
    wioct        = 11; (* 37.777.777.777 *)
    wiquad       = 16; (* 3333.3333.3333.3333 *)
    wishadok     = 64; (* wiquad x 3 for Meu *)

PROCEDURE chkNumber (VAR R:ARRAY OF CHAR):BOOLEAN; (* note R may change *)
VAR
    rc:BOOLEAN;
    i,j:CARDINAL;
    str:str4;
    ch:CHAR;
    S:str128; (* oversized *)
BEGIN
    (* //V10G filter out FR AND US the Q&D way *)
    ReplaceChar(R,coma,"");
    ReplaceChar(R,dot,"");

    Str.Copy(S,R);
    IF Str.Match(S,"0X*") THEN (* case does not matter *)
        Str.Delete(S,0,2);
        Str.Prepend(S,hexprefix);
    END;

    CASE S[0] OF
    | hexprefix:
        Str.Delete(S,0,1);
        rc:=verifyString(S,hexdigits);
    | binprefix:
        Str.Delete(S,0,1);
        rc:=verifyString(S,bindigits);
    | octprefix:
        Str.Delete(S,0,1);
        rc:=verifyString(S,octdigits);
    | quadprefix:
        Str.Delete(S,0,1);
        rc:=verifyString(S,quaddigits);
    ELSE
        rc:=verifyString(S,decdigits);
        IF NOT(rc) THEN
            Str.Caps(S); (* safety *)
            FOR i:=0 TO 7 DO (* 0..3 AND 4..7 *)
                isoleItemS(str, numShadok,delim,i);
                Str.Caps(str); (* required ! and yes, just done earlier *)
                CASE i OF
                | 0..3 : j:=i;
                | 4..7 : j:=i-4;
                ELSE ; (* //ISO fixed silly requirement *) END;
                ch:=CHR ( ORD("0") + j );
                WHILE Str.Pos(S,str) # MAX(CARDINAL) DO
                    Str.Subst(S,str,ch);
                END;
            END;
            rc:=verifyString(S,quaddigits);
            IF rc THEN Str.Concat(R,quadprefix,S);END;
        END;
    END;
    rc := (rc AND (Str.Length(S) > 0) );
    RETURN rc;
END chkNumber;

PROCEDURE legalLC (VAR v:LONGCARD; S:ARRAY OF CHAR):BOOLEAN;
VAR
    base:CARDINAL;
    ok:BOOLEAN;
BEGIN
    IF Str.Match(S,"0X*") THEN (* case does not matter *)
        Str.Delete(S,0,2);
        Str.Prepend(S,hexprefix);
    END;

    CASE S[0] OF
    | hexprefix:
        Str.Delete(S,0,1);
        base:=16;
    | binprefix:
        Str.Delete(S,0,1);
        base:=2;
    | octprefix:
        Str.Delete(S,0,1);
        base:=8;
    | quadprefix:
        Str.Delete(S,0,1);
        base:=4;
    ELSE
        base:=10;
    END;
    v:=Str.StrToCard(S,base,ok);
    RETURN ok;
END legalLC;

PROCEDURE pad (padchar:CHAR;wi:CARDINAL;VAR R:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    FOR i:=(Str.Length(R)+1) TO wi DO
        Str.Prepend(R,padchar);
    END;
END pad;

PROCEDURE qdusing (padchar,sepch:CHAR;wi,wigroup:CARDINAL;VAR R:ARRAY OF CHAR);
VAR
    i,len:CARDINAL;
    R2:str80;
BEGIN
    IF padchar # blank THEN pad(padchar,wi,R); END;

    IF sepch # charnull THEN
        len:=Str.Length(R);
        Str.Copy(R2,"");
        FOR i := 1 TO len DO
            Str.Prepend(R2,R[len-i]);
            IF i < len THEN
                IF (i MOD wigroup) = 0 THEN
                    Str.Prepend(R2,sepch);
                END;
            END;
        END;
        Str.Copy(R,R2);
    END;

    IF padchar = " " THEN pad(padchar,wi+(wi DIV wigroup),R); END;
END qdusing;

PROCEDURE fmtNum (v:LONGCARD;base:CARDINAL;padchar,decfmt:CHAR; VAR R:ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
BEGIN
    CASE base OF
    | 2,10,16,8,4:
        Str.CardToStr(v,R,base,ok); (* ok should always be TRUE now *)
    ELSE
        Str.Copy(R,"???");
    END;
    CASE base OF
    | 2:  qdusing(padchar,decfmt,wibin,4,R);
          Str.Prepend(R,binprefix);
    | 10: qdusing(padchar,decfmt,widec,3,R);
    | 16: qdusing(padchar,decfmt,wihex,2,R);
          Str.Prepend(R,hexprefix);
          Str.Lows(R);
    | 8:  qdusing(padchar,decfmt,wioct,3,R);
          Str.Prepend(R,octprefix);
    | 4:  qdusing(padchar,decfmt,wiquad,4,R);
          Str.Prepend(R,quadprefix);
    ELSE ; (* //ISO fixed silly requirement *) END;

END fmtNum;

PROCEDURE fmtChar (v:LONGCARD;VAR R : ARRAY OF CHAR):BOOLEAN;
VAR
    code:CARDINAL;
BEGIN
    Str.Copy(R,"???"); (* safety *)
    IF v > MAX(SHORTCARD) THEN RETURN FALSE;END;
    code:=CARDINAL(v);
    Str.Copy(R,dquote+vbar+dquote);
    CASE code OF
    | 0..4, 7..0AH, 0DH, 1AH..1BH, 255 :
        Str.Subst(R,vbar,gremlin);
    | ORD(dquote)  :
        Str.Copy(R,quote+dquote+quote);
    ELSE
        Str.Subst(R,vbar,CHR(code));
    END;
    RETURN TRUE;
END fmtChar;

PROCEDURE fmtShadok (v:LONGCARD;base:CARDINAL;padchar,decfmt:CHAR;
                    VAR R:ARRAY OF CHAR);
VAR
    i:CARDINAL;
    ch:CHAR;
    str:str4;
    ok:BOOLEAN;
BEGIN
    CASE base OF
    | 4:
        Str.CardToStr(v,R,base,ok); (* ok should always be TRUE now *)
        qdusing(padchar,charnull,wiquad,4,R); (* no decfmt, no leading "0" *)
    ELSE
        Str.Copy(R,"???");
    END;

    FOR i:=0 TO 3 DO
        ch:=CHR ( ORD("0") + i );
        isoleItemS(str, numShadokLong,delim,i);
        IF decfmt # charnull THEN Str.Append(str,decfmt);END;
        WHILE Str.CharPos(R,ch) # MAX(CARDINAL) DO
            Str.Subst(R,ch,str);
        END;
    END;
    IF decfmt # charnull THEN
        i:=Str.Length(R);
        IF i # 0 THEN
            IF R[i-1] = decfmt THEN R[i-1]:=charnull;END;
        END;
    END;
    IF R[0] = quadprefix THEN Str.Delete(R,0,1);END;
END fmtShadok;

(* ------------------------------------------------------------ *)

PROCEDURE doChkShadok (decfmt:CHAR;first,last:LONGCARD):BOOLEAN;
CONST
    every = 100;
    sep   = " : ";
VAR
    i,v:LONGCARD;
    R:ARRAY[1..4] OF str128;
    ok:BOOLEAN;
    turn:CARDINAL;
    sGBZM:str128;
BEGIN
    ok:=TRUE;
    turn:=0;
    i:=first;
    LOOP
        fmtNum    (i,10,blank,  decfmt, R[1]);
        fmtNum    (i,4,"0",     decfmt, R[3]);
        fmtShadok (i,4,charnull,decfmt, R[4]);

        WrStr(R[1]);WrStr(sep);
        Str.Copy(R[2],R[4]);
        IF chkNumber( R[2] ) = FALSE THEN
            WrStr("--- chkNumber() ");WrStr(R[2]);WrLn;EXIT;
        END;
        IF legalLC( v, R[2] )=FALSE THEN
            WrStr("--- legalLC() ");WrStr(R[2]);WrLn;EXIT;
        END;
        IF v # i THEN
            WrStr("--- values !");WrLn;EXIT;
        END;
        WrStr(R[3]);WrStr(sep);
        WrStr(R[4]);WrLn;


        IF i = last THEN EXIT;END;
        INC(i);

        INC(turn);
        IF turn > every THEN
            IF ChkEscape() THEN ok:=FALSE;EXIT;END;
            turn:=0;
        END;
    END;
    RETURN ok;
END doChkShadok;

(* ------------------------------------------------------------ *)

CONST
    sepequ   = " = ";
    sep      = " : ";
    sDec     = "Decimal    "+sep; (* account for hex/bin one-char prefix ? bah... *)
    sHex     = "Hexadecimal"+sep;
    sBin     = "Binary     "+sep;
    sOct     = "Octal      "+sep;
    sQuad    = "Base 4     "+sep;
    sShadok  = "Shadok     "+sep;
    sChar    = "Character  "+sep;
    firstnum = 1;
    maxnum   = 20; (* more than enough *)
VAR
    snum : ARRAY [firstnum..maxnum] OF str80; (* oversized *)
    num  : ARRAY [firstnum..maxnum] OF LONGCARD;
    lastnum:CARDINAL;
    parmcount,i,opt:CARDINAL;
    S,R:str128;
    charok,oneline,showspecial:BOOLEAN;
    showoctal,showquad,showchar,showmax,showshadok,showniceshadok:BOOLEAN;
    decfmt:CHAR;
    sGBZM,sQ,sD,sH,sB,sO,sC:str128; (* oversized, str80 should DO but who cares ? *)
    v:LONGCARD;
BEGIN
    FIO.IOcheck:=FALSE;
    WrLn;

    parmcount := Lib.ParamCount();
    (* IF parmcount=0 THEN abort(errHelp,"");END; *)

    lastnum     := firstnum-1;
    oneline     := TRUE;
    showoctal   := FALSE;
    showquad    := FALSE;
    showshadok  := FALSE;
    showniceshadok:=FALSE;
    showmax     := FALSE;
    decfmt      := charnull;
    showchar    := FALSE;
    showspecial := FALSE;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "A"+delim+"ALTERNATE"+delim+
                                   "F"+delim+"FR"+delim+
                                   "U"+delim+"US"+delim+"UK"+delim+
                                   "O"+delim+"OCTAL"+delim+"B"+delim+
                                   "AA"+delim+
                                   "I"+delim+"LIMITS"+delim+"RANGES"+delim+
                                   "C"+delim+"CHARS"+delim+
                                   "4"+delim+"!"+delim+
                                   "@"+delim+"SHADOK"+delim+
                                   "X"+delim+
                                   "@@"+delim+"@4"+delim+"44"+delim+"4@"+delim+
                                   "$"+delim+"-"+delim+"/"
                               );
            CASE opt OF
            | 1,2,3 :    abort(errHelp,"");
            | 4,5   :    oneline:=FALSE;
            | 6,7   :    CASE decfmt OF
                         | charnull,dot:decfmt:=dot;
                         ELSE
                             abort(errFmt,"");
                         END;
            | 8,9,10:    CASE decfmt OF
                         | charnull,comma:decfmt:=comma;
                         ELSE
                             abort(errFmt,"");
                         END;
            | 11,12,13:  showoctal := TRUE; oneline := FALSE;
            | 14:        showoctal := TRUE; oneline := FALSE;
            | 15,16,17:  showmax   := TRUE;
            | 18,19:     showchar  := TRUE;
            | 20,21:     showquad  := TRUE; oneline := FALSE;
            | 22,23:     showshadok:= TRUE; oneline := FALSE;
            | 24:        showoctal := TRUE;
                         showquad  := TRUE;
                         showshadok:= TRUE; oneline := FALSE;
            | 25,26,27,28:
                         showshadok:= TRUE;
                         showquad  := TRUE;
                                            oneline := FALSE;
            | 29,30,31:  showspecial:=TRUE;

            (*
            | :
                         IF doChkShadok( decfmt,MIN(LONGCARD),MAX(LONGCARD)) THEN
                             abort(errNone,"");
                         ELSE
                             abort(errAborted,"");
                         END;
            *)

            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastnum);
            IF lastnum > maxnum THEN abort(errTooManyNumbers,"");END;
            Str.Copy(snum[lastnum],R); (* uppercased string *)
        END;
    END;

    IF foundForceShadokFile(i,FORCESHADOKFILE) THEN showspecial:=TRUE;END;
    IF showspecial THEN oneline:=FALSE;END;

    IF showmax THEN
        lastnum:=firstnum;
        num[lastnum]:=MAX(LONGCARD);
        INC(lastnum);
        num[lastnum]:=MAX(LONGINT);
        WrStr("::: Maximum values :");WrLn;
        WrLn;
    ELSE
        IF lastnum < firstnum THEN  abort(errNoNumber,"");END; (* won't happen *)

        FOR i:=firstnum TO lastnum DO
            IF chkNumber( snum[i] )=FALSE THEN abort(errBadNumber,snum[i]);END;
            IF legalLC( num[i],snum[i] )=FALSE THEN abort(errBadLC,snum[i]);END;
        END;
    END;

    FOR i:=firstnum TO lastnum DO
        v:=num[i];
        fmtNum    (v,10," ",decfmt,sD);
        fmtNum    (v,16,"0",decfmt,sH);
        fmtNum    (v, 2,"0",decfmt,sB);
        fmtNum    (v, 8,"0",decfmt,sO);
        fmtNum    (v, 4,"0",decfmt,sQ);
        fmtShadok (v, 4,"" ,decfmt,sGBZM); (* no leading "0" *)
        charok:=fmtChar(v,sC);

        IF oneline THEN
            WrStr(sD);WrStr(sepequ);WrStr(sH);WrStr(sepequ);WrStr(sB);
            IF showchar THEN
                IF charok THEN WrStr(sepequ);WrStr(sC);END;
            END;
            WrLn;
        ELSE
            IF showspecial THEN
                LtrimBlanks(sD);
                WrStr(sDec);WrStr(sD);WrLn;
                WrStr(sShadok);WrStr(sGBZM);WrLn;
            ELSE
                (* yes, it would be more elegant to have a flag for each display *)
                LtrimBlanks(sD);
                WrStr(sDec);WrStr(sD);WrLn;
                WrStr(sHex);WrStr(sH);WrLn;
                WrStr(sBin);WrStr(sB);WrLn;
                IF showoctal THEN
                WrStr(sOct);WrStr(sO);WrLn;
                END;
                IF showquad THEN
                WrStr(sQuad);WrStr(sQ);WrLn;
                END;
                IF showshadok THEN
                WrStr(sShadok);WrStr(sGBZM);WrLn;
                END;
                IF showchar THEN
                IF charok THEN WrStr(sChar);WrStr(sC);WrLn;END;
                END;
            END;

            IF i < lastnum THEN WrLn; END;
        END;
    END;

    IF showmax THEN
        WrLn;
        WrStr("::: MAX(LONGCARD) and MAX(LONGINT).");WrLn;
    END;

    abort(errNone,"");
END BaseConv32.

