(* ---------------------------------------------------------------
Title         Q&D Even Odd
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -v
	      -r

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs
Wish List     are you kidding ?
              more general a splitter ?
              replace missing bytes with random data in split files ?
              check for target AND split files paths ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 25 Apr 19 v1.0a keep in sync with DOS v1.1b
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 22 Jul 16 an ugly really Q&D port from EVENODD v1.1a for DOS
--------------------------------------------------------------- *)

MODULE EvenOdd32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

(* //FIXME *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

PROCEDURE UpperCaseAlt (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCaseAlt;

PROCEDURE LowerCaseAlt (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCaseAlt;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    progEXEname     = "EVENODD32";
    progTitle       = "Q&D EvenOdd (Win32)";
    progVersion     = "v1.0a (from v1.1b for DOS)";
    progCopyright   = "by PhG";
    banner          = progTitle+" "+progVersion+" "+progCopyright;
CONST
    ctrlz           = CHR(26);
CONST
    extEVEN         = ".0"; (* could be .EVN *)
    extODD          = ".1"; (* could be .ODD *)
CONST
    placeholder = dquote+vbar+dquote;

CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParmOverflow     = 3;
    errCmd              = 4;
    errMissingCommand   = 5;
    errMissingParms     = 6;
    errSplitSyntax      = 7;
    errNotFound         = 8;
    errReservedExt      = 9;
    errNoJoker          = 10;
    errCollision        = 11;
    errReadOnly         = 12;
    errExists           = 13;
    errNotEO            = 14;
    errNotEOeven        = 15;
    errNotEOodd         = 16;
    errDTmismatch       = 17;
    errNAMEmismatch     = 18;
    errRebuildSyntax    = 19;
    errBadDelta         = 20;
    errHeaderMismatch   = 21;
    errFsizeMismatch    = 22;
    errAboutSyntax      = 23;
    errHeaderRequired   = 24;

    errNoValidHeaderHere= 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
CONST errmsg =
banner+nl+
nl+
"Syntax 1 : "+progEXEname+" <-s> <source> [<evenfile> <oddfile>] [option]..."+nl+
"Syntax 2 : "+progEXEname+" <-c> <target> [<evenfile> <oddfile>] [option]..."+nl+
"Syntax 3 : "+progEXEname+" <-i> <file>"+nl+
nl+
"    -s[s] split (-ss = -so = -s -o)"+nl+
"    -c[c] create (-cc = -co = -c -o)"+nl+
"    -i    show split file header infos"+nl+
nl+
"    -o    overwrite"+nl+
"    -z    create headerless split files"+nl+
"    -y    ignore header check (-c[c] only)"+nl+
"    -a    alternate final display"+nl+
nl+
"This program saves <source> even and odd bytes to split files (syntax 1),"+nl+
"creates <target> merging even and odd bytes from split files (syntax 2),"+nl+
"or shows split file header infos if any (syntax 3)."+nl+
nl+
"a) Default split files are <source"+extEVEN+"> and <source"+extODD+"> (syntax 1),"+nl+
"   or <target"+extEVEN+"> and <target"+extODD+"> (syntax 2)."+nl+
"   If specified, <evenfile> and <oddfile> have "+extEVEN+" and "+extODD+" default extensions."+nl+
"b) <source> or <target> cannot be more than 2Gb long."+nl+
"c) This program is best used to process compressed and/or encrypted files"+nl+
"   for added security when sending data in two seperate operations."+nl+
"d) The same executable run to split file must be used in order to rebuild it !"+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" -s c:\z\foo.bin"+nl+
"           "+progEXEname+" -s foo.bin pair.dat impair.dat"+nl+
"           "+progEXEname+" -c foo.bin"+nl+
"           "+progEXEname+" -c foo.bin f:\tmp\pair f:\tmp\impair"+nl+
"           "+progEXEname+" -i odd.dat"+nl;

VAR
    S : str1024; (* in case we get a LFN *)
BEGIN
    CASE e OF
    | errHelp :
        WrStr(errmsg);
    | errOption:
        S:="Unknown "+placeholder+" option !";
    | errParmOverflow:
        S := placeholder+" is one parameter too many !";
    | errCmd:
        S := "-split, -create and -infos commands are mutually exclusive !";
    | errMissingCommand:
        S := "Any of -split, -create or -infos commands must be specified !";
    | errMissingParms:
        S := "No parameter was specified !";
    | errSplitSyntax:
        S := "Illegal syntax for -split command !";
    | errNotFound:
        S:=placeholder+" does not exist !";
    | errReservedExt:
        S:="Illegal reserved extension in "+placeholder+" <source> !";
    | errNoJoker:
        S:=placeholder+" should no contain any joker !";
    | errCollision:
        S := "Filenames cannot be identical !";
    | errReadOnly:
        S:=placeholder+" is read-only !";
    | errExists:
        S:=placeholder+" already exists !";
    | errNotEO :
        S:=placeholder+" is not in expected format !";
    | errNotEOeven:
        S:=placeholder+" does not contain data for even bytes !";
    | errNotEOodd :
        S:=placeholder+" does not contain data for odd bytes !";
    | errDTmismatch:
        S := "Date and time stamps for even and odd bytes do not match !";
    | errNAMEmismatch:
        S := "Filenames for even and odd bytes do not match !";
    | errRebuildSyntax:
        S := "Illegal syntax for -create command !";
    | errBadDelta:
        S := "Even split file should be same size as, or one byte larger than, odd split file !";
    | errHeaderMismatch:
        S := "Both even and odd split files must have a header or be headerless !";
    | errFsizeMismatch:
        S := "Filesize for even and odd bytes do not match !";
    | errAboutSyntax:
        S := "Illegal syntax for -infos command !";
    | errHeaderRequired:
        S :=placeholder+" does not have a header !";
    | errNoValidHeaderHere: (* never displayed *)
        S := placeholder+" does not contain any valid header !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    | errNoValidHeaderHere:
        ;
    ELSE
        Str.Subst(S,vbar,einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
VAR
    ioBuffer1 : ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
    ioBufferE : ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
    ioBufferO : ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
CONST
    dataBufferSize      = 256;
    firstDataBufferByte = 0;
    maxDataBufferByte   = dataBufferSize-1;
    maxBigDataBufferByte= (dataBufferSize*2)-1;
VAR
    databuffer  : ARRAY [firstDataBufferByte..maxBigDataBufferByte] OF SYSTEM.LOC;
    databufferE : ARRAY [firstDataBufferByte..maxDataBufferByte] OF SYSTEM.LOC;
    databufferO : ARRAY [firstDataBufferByte..maxDataBufferByte] OF SYSTEM.LOC;

(* ------------------------------------------------------------ *)

PROCEDURE zesame (S1,S2:ARRAY OF CHAR ):BOOLEAN;
BEGIN
    LowerCaseAlt(S1);
    LowerCaseAlt(S2);
    RETURN same(S1,S2);
END zesame;

PROCEDURE wrq (S:ARRAY OF CHAR);
BEGIN
    WrStr(dquote);WrStr(S);WrStr(dquote);
END wrq;

PROCEDURE dbg (DEBUG:BOOLEAN;S1,S2:ARRAY OF CHAR   );
CONST
    wi = 20;
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        IF same(S2,"") THEN
            WrStr("PROC ");
        ELSE
            WrStr("  // ");
        END;
        WrStr(S1);
        IF same(S2,"") THEN
            WrStr("()");
        ELSE
            FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
            WrStr(" = ");
            WrStr(S2);
        END;
        WrLn;
    END;
END dbg;

CONST
    sepcolon = " : ";

PROCEDURE dmpstr (enquote:BOOLEAN;S1,S2:ARRAY OF CHAR   );
BEGIN
    WrStr(S1); WrStr(sepcolon);
    IF enquote THEN
        wrq(S2);
    ELSE
        WrStr(S2);
    END;
    WrLn;
END dmpstr;

PROCEDURE dmpbool (tf:BOOLEAN;S,sTrue,sFalse:ARRAY OF CHAR );
BEGIN
    WrStr(S);
    WrStr(sepcolon);
    IF tf THEN
        WrStr(sTrue);
    ELSE
        WrStr(sFalse);
    END;
    WrLn;
END dmpbool;

PROCEDURE dmplc(v:LONGCARD;S:ARRAY OF CHAR);
BEGIN
    WrStr(S);WrStr(sepcolon);
    IO.WrLngCard(v,0);WrLn;
END dmplc;

(* ------------------------------------------------------------ *)

CONST
    kmagic = 01021963H;
    chDOS  = "D";
    chWin32= "w";
    chExpectedOS = chWin32; (* //WARNING ! chWin32 for XDS version ! *)
TYPE
    EOheaderType = RECORD
        aeof   : CHAR;
	os     : CHAR;           (* "D" = DOS, "w" = win32 *)
        magic  : LONGCARD;
        orgdt  : LONGCARD;
        orgfsize:LONGCARD;
        isEven : BOOLEAN;
        namelen: CARDINAL;
    END;
    (* original filename follows this structure *)

PROCEDURE getEOheader (VAR H : EOheaderType; VAR Hname:pathtype;
                      DEBUG:BOOLEAN;S:pathtype):BOOLEAN;
VAR
    hnd : FIO.File;
    pb,got : CARDINAL;
    Htmp:pathtype;
BEGIN
    dbg(DEBUG,"getEOheader","");
    pb:=0;
    H.aeof  := " ";
    H.os    := "?";
    H.magic := 0;
    hnd :=FIO.OpenRead(S);
    got:=FIO.RdBin(hnd,H,SIZE(H));
    IF got <> SIZE(H) THEN INC(pb);END;
    IF H.aeof <> ctrlz THEN INC(pb);END;
    IF H.os <> chExpectedOS THEN INC(pb);END; (* //WARNING *)
    IF H.magic <> kmagic THEN INC(pb);END;
    IF pb = 0 THEN
        got:=FIO.RdBin(hnd,Htmp,H.namelen);
        IF got # H.namelen THEN
            INC(pb);
            Str.Copy(Hname,"(* ERROR *)" );
        ELSE
            IF H.namelen < SIZE(pathtype) THEN Htmp[H.namelen]:=nullchar;END;
            Str.Copy(Hname,Htmp);
        END;
    END;
    FIO.Close(hnd);
    dbg(DEBUG,"Hname",Hname);
    RETURN (pb = 0);
END getEOheader;

PROCEDURE buildEOheader (VAR H:EOheaderType;
                        isEven:BOOLEAN;hnd:FIO.File;Hname:pathtype);
BEGIN
    H.aeof     := ctrlz;
    H.os       := chExpectedOS; (* //WARNING *)
    H.magic    := kmagic;
    H.orgdt    := FIO.GetFileDate(hnd);
    H.orgfsize := FIO.Size(hnd);
    H.isEven   := isEven;
    H.namelen  := Str.Length(Hname);
END buildEOheader;

(*
    because of offsets, if filesize is odd, data file for even bytes
    will always be larger than data file for odd bytes : .0 > .1 by one byte
          even odd
    a     a    nada
    ab    a    b
    abc   ac   b
    abcd  ac   bd
*)

PROCEDURE doSplitEO (DEBUG,useheader:BOOLEAN;
                     source,datafileEven,datafileOdd:pathtype);
CONST
    msg = "Splitting ";
VAR
    hndIn,hndE,hndO:FIO.File;
    H : EOheaderType;
    i,got,ndxE,ndxO : CARDINAL;
BEGIN
    dbg(DEBUG,"splitEO","");
    dbg(DEBUG,"Source",source);
    dbg(DEBUG,"datafileEven",datafileEven);
    dbg(DEBUG,"datafileOdd",datafileOdd);

    video(msg,TRUE);video(source,TRUE);

    hndIn:=FIO.OpenRead(source);
    FIO.AssignBuffer(hndIn,ioBuffer1);
    hndE :=FIO.Create(datafileEven);
    FIO.AssignBuffer(hndE,ioBufferE);
    hndO :=FIO.Create(datafileOdd);
    FIO.AssignBuffer(hndO,ioBufferO);

    IF useheader THEN
        buildEOheader(H,TRUE, hndIn,source);
        FIO.WrBin(hndE,H,SIZE(H));
        FIO.WrBin(hndE,source,Str.Length(source));

        buildEOheader(H,FALSE,hndIn,source);
        FIO.WrBin(hndO,H,SIZE(H));
        FIO.WrBin(hndO,source,Str.Length(source));
    END;

    FIO.EOF := FALSE;
    LOOP
        got:=FIO.RdBin(hndIn,databuffer,dataBufferSize);
        IF got = 0 THEN EXIT; END;
        ndxE:=firstDataBufferByte;
        ndxO:=firstDataBufferByte;
        FOR i:= firstDataBufferByte TO (got-1) DO (* always > 0 here *)
            IF ODD(i) THEN
                databufferO[ndxO]:=databuffer[i];
                INC(ndxO);
            ELSE
                databufferE[ndxE]:=databuffer[i];
                INC(ndxE);
            END;
        END;
        IF ndxE > firstDataBufferByte THEN
            FIO.WrBin(hndE,databufferE,ndxE);
        END;
        IF ndxO > firstDataBufferByte THEN
            FIO.WrBin(hndO,databufferO,ndxO);
        END;

        IF got # dataBufferSize THEN EXIT; END;
    END;

    FIO.Close(hndE);
    FIO.Close(hndO);
    FIO.Close(hndIn);

    video(source,FALSE);video(msg,FALSE);
END doSplitEO;

PROCEDURE doRebuildEO (DEBUG,useheader:BOOLEAN;
                       datafileEven,datafileOdd,target:pathtype);
CONST
    msg = "Building ";
VAR
    hndE,hndO,hndOut:FIO.File;
    H : EOheaderType;
    i,p,gotEv,gotOd : CARDINAL;
    Htmp,HEname,HOname:pathtype;
BEGIN
    dbg(DEBUG,"rebuildEO","");
    dbg(DEBUG,"Target",target);
    dbg(DEBUG,"datafileEven",datafileEven);
    dbg(DEBUG,"datafileOdd",datafileOdd);

    video(msg,TRUE);video(target,TRUE);

    hndOut:=FIO.Create(target);
    FIO.AssignBuffer(hndOut,ioBuffer1);
    hndE  :=FIO.OpenRead(datafileEven);
    FIO.AssignBuffer(hndE,ioBufferE);
    hndO  :=FIO.OpenRead(datafileOdd);
    FIO.AssignBuffer(hndO,ioBufferO);

    IF useheader THEN
        i := FIO.RdBin(hndE,H,SIZE(H));
        i := FIO.RdBin(hndE,Htmp,H.namelen);
        IF H.namelen < SIZE(pathtype) THEN Htmp[H.namelen]:=nullchar;END;
        Str.Copy(HEname,Htmp);

        i := FIO.RdBin(hndO,H,SIZE(H));
        i := FIO.RdBin(hndO,Htmp,H.namelen);
        IF H.namelen < SIZE(pathtype) THEN Htmp[H.namelen]:=nullchar;END;
        Str.Copy(HOname,Htmp);
    END;

    FIO.EOF := FALSE;
    LOOP

        gotEv:=FIO.RdBin(hndE,databufferE,dataBufferSize);
        IF gotEv = 0 THEN EXIT; END;
        gotOd:=FIO.RdBin(hndO,databufferO,dataBufferSize);
        IF gotOd = 0 THEN EXIT; END;

        p := firstDataBufferByte;
        FOR i:=0 TO (gotEv-1) DO
            databuffer[p]:=databufferE[i];
            INC(p,2);
        END;
        p := firstDataBufferByte;
        INC(p);
        FOR i:=0 TO (gotOd-1) DO
            databuffer[p]:=databufferO[i];
            INC(p,2);
        END;

        FIO.WrBin(hndOut,databuffer,gotEv+gotOd);

        IF gotEv # dataBufferSize THEN EXIT; END;
        IF gotOd # dataBufferSize THEN EXIT; END;
    END;
    (* there can be only one pending even byte now *)
    IF gotEv = 1 THEN FIO.WrBin(hndOut,databufferE[0],gotEv);END;

    FIO.Close(hndE);
    FIO.Close(hndO);
    FIO.Close(hndOut);

    IF useheader THEN
        hndOut := FIO.Open(target);
        FIO.SetFileDate(hndOut,H.orgdt);
        FIO.Close(hndOut);
    END;

    video(target,FALSE);video(msg,FALSE);
END doRebuildEO;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE getExtension (S:pathtype):pathtype;
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    RETURN e;
END getExtension;

CONST
    alwaysforceNEWEXT = 1;
    forceNEWEXTifNone = 2;

PROCEDURE buildnewfilename (VAR R:pathtype;
                           S:pathtype;ext:ARRAY OF CHAR; DEBUG:BOOLEAN;how:CARDINAL);
VAR
    u,d,n,e,ne:pathtype;
BEGIN
    dbg(DEBUG,"buildnewfilename","");
    dbg(DEBUG,"S",S);
    qdSplitAllPath(S,u,d,n,e);
    CASE how OF
    | alwaysforceNEWEXT:
        dbg(DEBUG,"how","alwaysforceNEWEXT");
        Lib.MakeAllPath(R,u,d,n,ext);
    | forceNEWEXTifNone:
        dbg(DEBUG,"how","forceNEWEXTifNone");
        Lib.MakeAllPath(ne,"","",n,e);
        IF Str.RCharPos(ne,dot)=MAX(CARDINAL) THEN (* no extension *)
            Lib.MakeAllPath(R,u,d,n,ext);
        ELSE
            Str.Copy(R,S);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    dbg(DEBUG,"R",R);
END buildnewfilename;

PROCEDURE chkFile (S:pathtype;OVERWRITE:BOOLEAN):CARDINAL ;
VAR
    rc : CARDINAL;
BEGIN
    rc := errNone;
    IF FIO.Exists(S) THEN
        IF OVERWRITE THEN
            IF fileIsRO(S) THEN
                rc := errReadOnly;
            ELSE
                FIO.Erase(S);
            END;
        ELSE
            rc := errExists;
        END;
    END;
    RETURN rc;
END chkFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (undefined,split,rebuild,about);

PROCEDURE newcmd (VAR cmd:cmdtype;wanted:cmdtype):BOOLEAN;
BEGIN
    IF cmd = wanted    THEN RETURN TRUE; END;
    IF cmd # undefined THEN RETURN FALSE;END;
    cmd:=wanted;
    RETURN TRUE;
END newcmd;

CONST
    minparm = 1;
    maxparm = 3;
CONST
    ndxfile = minparm;
    ndxeven = minparm+1;
    ndxodd  = minparm+2;
VAR
    lastparm,parmcount,i,opt,rc : CARDINAL;
    S,R                : pathtype;
    parm : ARRAY [minparm..maxparm] OF pathtype;
    cmd                : cmdtype;
    DEBUG,OVERWRITE,IGNOREHEADERCHECK,USEHEADER,altdisplay : BOOLEAN;
    source,datafileEven,datafileOdd,target:pathtype;
    H,HE,HO : EOheaderType;
    fname,HEname,HOname:pathtype;
    HEheader,HOheader:BOOLEAN;
    HEfsize,HOfsize:LONGCARD;
    Z:str1024;
BEGIN
    FIO.IOcheck := FALSE;

    WrLn;

    DEBUG     := FALSE;
    OVERWRITE := FALSE;
    USEHEADER := TRUE;
    IGNOREHEADERCHECK := FALSE;
    altdisplay:= FALSE;

    cmd       := undefined;

    lastparm := minparm-1;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S); cleanCLI(R); ReplaceChar(R,dquote,"");
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "S"+delim+"SPLIT"+delim+
                                   "B"+delim+"BUILD"+delim+
                                   "O"+delim+"OVERWRITE"+delim+
                                   "R"+delim+"READONLY"+delim+
                                   "OO"+delim+
                                   "V"+delim+"VERBOSE"+delim+
                                   "Z"+delim+"NOHEADER"+delim+
                                   "X"+delim+"LFN"+delim+
                                   "DEBUG"+delim+
				
                                   "C"+delim+"CREATE"+delim+
                                   "SS"+delim+"SO"+delim+
                                   "SSS"+delim+"SOR"+delim+"SOO"+delim+
                                   "CC"+delim+"CO"+delim+
                                   "CCC"+delim+"COR"+delim+"COO"+delim+
                                   "A"+delim+"ALTERNATE"+delim+
                                   "I"+delim+"INFOS"+delim+"ABOUT"+delim+
				   "Y"+delim+"HEADERLESS"
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5:
                IF newcmd(cmd,split)=FALSE THEN abort(errCmd,"");END;
            | 6,7:
                IF newcmd(cmd,rebuild )=FALSE THEN abort(errCmd,"");END;
            | 8,9:
                OVERWRITE := TRUE;
            | 10,11:
                ; (* IGNORERO *)
            | 12:
                OVERWRITE := TRUE;
                (* IGNORERO := TRUE; *)
            | 13,14:
                ; (* was EYECANDY *)
            | 15,16:
                USEHEADER := FALSE;
            | 17,18:
                ; (* was useLFN *)
            | 19:
                DEBUG := TRUE;
		
            | 20,21:
                IF newcmd(cmd,rebuild)=FALSE THEN abort(errCmd,"");END;
            | 22,23:
                IF newcmd(cmd,split)=FALSE THEN abort(errCmd,"");END;
                OVERWRITE := TRUE;
            | 24,25,26:
                IF newcmd(cmd,split)=FALSE THEN abort(errCmd,"");END;
                OVERWRITE := TRUE;
                (* IGNORERO := TRUE; *)
            | 27,28:
                IF newcmd(cmd,rebuild)=FALSE THEN abort(errCmd,"");END;
                OVERWRITE := TRUE;
            | 29,30,31:
                IF newcmd(cmd,rebuild )=FALSE THEN abort(errCmd,"");END;
                OVERWRITE := TRUE;
                (* IGNORERO := TRUE; *)
            | 32,33:
                altdisplay := TRUE;
            | 34,35,36:
                IF newcmd(cmd,about)=FALSE THEN abort(errCmd,"");END;
            | 37,38:
	        IGNOREHEADERCHECK := TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errParmOverflow,S);END;
            parm[lastparm]:=S;
        END;
    END;
    IF cmd   = undefined THEN abort(errMissingCommand,"");END;
    IF lastparm < minparm THEN abort(errMissingParms,"");END;

    CASE cmd OF
    | split:
        CASE lastparm OF
        | minparm+1:
            abort(errSplitSyntax,"");
        ELSE
            source:=parm[ndxfile];
            IF chkJoker(source) THEN abort(errNoJoker,source);END;
            S:=getExtension(source);
            IF (zesame(S,extEVEN) OR zesame(S,extODD)) THEN abort(errReservedExt,source);END;
            IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source);END;

            IF lastparm = minparm THEN
                buildnewfilename(datafileEven, source,extEVEN,DEBUG,alwaysforceNEWEXT);
                buildnewfilename(datafileOdd,  source,extODD,DEBUG,alwaysforceNEWEXT);
            ELSE
                buildnewfilename(datafileEven, parm[ndxeven],extEVEN,DEBUG,forceNEWEXTifNone);
                buildnewfilename(datafileOdd,  parm[ndxodd],extODD,DEBUG,forceNEWEXTifNone);
                IF chkJoker(datafileEven) THEN abort(errNoJoker,datafileEven);END;
                IF chkJoker(datafileOdd) THEN abort(errNoJoker,datafileOdd);END;
            END;
            IF zesame(source,datafileEven) THEN abort(errCollision,"");END;
            IF zesame(source,datafileOdd) THEN abort(errCollision,"");END;
            IF zesame(datafileEven,datafileOdd) THEN abort(errCollision,"");END;
        END;
        rc :=chkFile(datafileEven,OVERWRITE);
        IF rc # errNone THEN abort(rc,datafileEven);END;
        rc :=chkFile(datafileOdd,OVERWRITE);
        IF rc # errNone THEN abort(rc,datafileOdd);END;

        WrStr(banner);WrLn;
        WrLn;

        doSplitEO(DEBUG,USEHEADER,source,datafileEven,datafileOdd);

        IF altdisplay THEN
            Z:='+++ "|" was split to "|" and "|"';
            Str.Subst(Z,vbar,source);
            Str.Subst(Z,vbar,datafileEven);
            Str.Subst(Z,vbar,datafileOdd);
            WrStr(Z);WrLn;

            IF USEHEADER=FALSE THEN
                WrLn;
                WrStr("::: Note split files have been created headerless !");WrLn;
            END;
        ELSE
            dmpstr (TRUE,"::: Source    ",source);
            dmpstr (TRUE,"+++ Even bytes",datafileEven);
            dmpstr (TRUE,"+++ Odd bytes ",datafileOdd);
            dmpbool(USEHEADER,"::: Header    ","YES","no");
        END;

    | rebuild:
        CASE lastparm OF
        | minparm+1:
            abort(errRebuildSyntax,"");
        ELSE
            target:=parm[ndxfile];
            IF chkJoker(target) THEN abort(errNoJoker,target);END;
            (*
            S:=getExtension(S);
            IF (zesame(S,dot) OR zesame(S,"")) THEN
            ELSE
            END;
            *)
            IF lastparm = minparm THEN
                buildnewfilename(datafileEven, target,extEVEN,DEBUG,alwaysforceNEWEXT);
                buildnewfilename(datafileOdd, target,extODD,DEBUG,alwaysforceNEWEXT);
            ELSE
                buildnewfilename(datafileEven, parm[ndxeven],extEVEN,DEBUG,forceNEWEXTifNone);
                buildnewfilename(datafileOdd, parm[ndxodd],extODD,DEBUG,forceNEWEXTifNone);
                IF chkJoker(datafileEven) THEN abort(errNoJoker,datafileEven);END;
                IF chkJoker(datafileOdd) THEN abort(errNoJoker,datafileOdd);END;
            END;
            IF zesame(target,datafileEven) THEN abort(errCollision,"");END;
            IF zesame(target,datafileOdd) THEN abort(errCollision,"");END;
            IF zesame(datafileEven,datafileOdd) THEN abort(errCollision,"");END;
        END;

        IF FIO.Exists(datafileEven)=FALSE THEN abort(errNotFound,datafileEven);END;
        HEheader:= getEOheader(HE,HEname, DEBUG,datafileEven);
        IF HEheader THEN
            IF HE.isEven=FALSE THEN abort(errNotEOeven,datafileEven);END;
        ELSE
            IF NOT(IGNOREHEADERCHECK) THEN abort(errHeaderRequired,datafileEven);END;
        END;

        IF FIO.Exists(datafileOdd)=FALSE THEN abort(errNotFound,datafileOdd);END;
        HOheader:= getEOheader(HO,HOname, DEBUG,datafileOdd);
        IF HOheader THEN
            IF HO.isEven THEN abort(errNotEOodd,datafileOdd);END;
        ELSE
            IF NOT(IGNOREHEADERCHECK) THEN abort(errHeaderRequired,datafileOdd);END;
        END;

        HEfsize:=getFileSize(datafileEven);
        HOfsize:=getFileSize(datafileOdd);

        IF (HEfsize = (HOfsize+1)) OR (HEfsize = HOfsize) THEN
            ;
        ELSE
            abort(errBadDelta,"");
        END;

        IF HEheader # HOheader THEN abort(errHeaderMismatch,"");END;

        USEHEADER := (HEheader AND HOheader);
        IF USEHEADER THEN
            IF HE.orgdt # HO.orgdt THEN abort(errDTmismatch,"");END;
            IF HE.orgfsize # HO.orgfsize THEN abort(errFsizeMismatch,"");END;
            IF zesame(HEname,HOname)=FALSE THEN abort(errNAMEmismatch,"");END;

            buildnewfilename(target, target,getExtension(HEname),DEBUG,forceNEWEXTifNone);
        END;

        rc :=chkFile(target,OVERWRITE);
        IF rc # errNone THEN abort(rc,target);END;

        WrStr(banner);WrLn;
        WrLn;

        doRebuildEO(DEBUG,USEHEADER,datafileEven,datafileOdd,target);

        IF altdisplay THEN
            Z:='+++ "|" was created from "|" and "|"';
            Str.Subst(Z,vbar,target);
            Str.Subst(Z,vbar,datafileEven);
            Str.Subst(Z,vbar,datafileOdd);
            WrStr(Z);WrLn;
        ELSE
            dmpstr (TRUE,"::: Even bytes",datafileEven);
            dmpstr (TRUE,"::: Odd bytes ",datafileOdd);
            dmpstr (TRUE,"+++ Target    ",target);
        END;
        IF IGNOREHEADERCHECK THEN
            WrLn;
            WrStr("::: Please note header check was ignored.");WrLn;
        END;
    | about:
        CASE lastparm OF
        | minparm+1:
            abort(errAboutSyntax,"");
        ELSE
            source:=parm[ndxfile];
            IF chkJoker(source) THEN abort(errNoJoker,source);END;
        END;

        IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source);END;
        CASE getEOheader(H,fname, DEBUG,source) OF
        | FALSE:
            S:="--- No valid header in "+placeholder;
            Str.Subst(S,vbar,source);
            WrStr(S);WrLn;
            abort(errNoValidHeaderHere,source);
        | TRUE:
            CASE H.os OF
            | chDOS:   S:="DOS";
            | chWin32: S:="Win32";
	    ELSE
	        S:="Ternary BOOLEAN courtesy of silly ISO standard ! :-(";
            END;
            dmpstr            (TRUE, "::: O.S.           ",S);
            WrLn;
            dmpstr            (TRUE, "::: File name      ",source);
            dmpbool(H.isEven,        "::: File content   ","even bytes","odd bytes");
            WrLn;
            dmpstr            (TRUE, "::: Target name    ",fname);
            dmplc  (H.orgfsize,      "::: Target filesize");
            (* //FIXME dump decoded H.orgdt LONGCARD *)
        ELSE ; (* //ISO fixed silly requirement *) END;

    ELSE ; (* //ISO fixed silly requirement *) END;

    abort(errNone,"");
END EvenOdd32.



