(* ---------------------------------------------------------------
Title         see help
Overview      see help
Usage         see help
Notes         very, very, very quick & dirty... :-(
              minimal error messages and checking, etc.

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
Bugs
Wish List     a check for entries with wrong decimal sep ?
              enhanced directory reading ? bah...

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 29 Dev 22 an ugly really Q&D port from COLUMNS v1.1 for DOS
--------------------------------------------------------------- *)

MODULE Columns32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT SYSTEM;
IMPORT IO;

FROM IO IMPORT WrStr, WrLn;
FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    progEXEname     = "COLUMNS32";
    progTitle       = "Q&D Columns Processor (Win32)";
    progVersion     = "v0.9 (from v1.1 for DOS)";
    progCopyright   = "by PhG";
    banner          = progTitle+" "+progVersion+" "+progCopyright;
CONST
    EOLcmd          = "*";
    extBAK          = ".BK!";
    extCOM          = ".COM";
    extEXE          = ".EXE";
    extDLL          = ".DLL";
    extOVR          = ".OVR";
    extOVL          = ".OVL";
    extDRV          = ".DRV";
    extZIP          = ".ZIP";
    extARJ          = ".ARJ";
    extLZH          = ".LZH";
    ignoredextensions=extBAK+delim+extCOM+delim+extEXE+delim+
                      extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                      extZIP+delim+extARJ+delim+extLZH;
CONST
    doDelete = 1;
    doExtract= 2;
    doCard   = 3;
    doInt    = 4;
    doFloat  = 5;
CONST
    steps    = 10;
    chFiller = "."; (* because of vindoze ! *)
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errTooManyParms = 3;
    errBadCard      = 4;
    errTabRange     = 5;
    errConflict     = 6;
    errColumnRange  = 7;
    errSyntax       = 8;
    errMissingCmd   = 9;
    errNonsenseRange= 10;
    errJoker        = 11;
    errNotFound     = 12;
    errAlready      = 13;
    errSame         = 14;
    errTooMany      = 15;
    errNonsense     = 16;
    errAddToTarget  = 17;
    errRawUntab     = 18;
    errTotalMode    = 19;
    errSubMode      = 20;
    errBadSourceExt = 21;
    errBadTargetExt = 22;
    errSubMethod    = 23;
    errAborted      = 24;
    errRO           = 25;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

errmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <command> <first> <last|"+EOLcmd+"> <source> [target] [option]..."+nl+
nl+
"This program deletes or keeps text from <first> column to <last> column,"+nl+
"or it adds values found in specified column range after triming."+nl+
nl+
"  -d[t]   delete (-dt = -d -t)"+nl+
"  -k|e[t] keep (-kt = -k -t = -et = -e -t)"+nl+
"  -a      add decimal LONGCARD values"+nl+
"  -ai     add decimal LONGINT values"+nl+
"  -af[f]  add decimal LONGREAL values (-aff = -af -us)"+nl+
"  -s[g]   show each subtotal when <first..last> is empty (-sg = -s -g)"+nl+
"  -z[g]   show each subtotal when out of <first..last> changes (-zg = -z -g)"+nl+
"  -i      insert subtotals in <source> dumped to standard output"+nl+
"  -g      show grand total"+nl+
"  -c      see <last> value as a count, not as an absolute position (default)"+nl+
"  -t:#    tabulation width ([1..64], default is 8)"+nl+
"  -r      do not expand tab into spaces, interpreting it as a raw single space"+nl+
"  -t      test mode (dump result to screen without changing file)"+nl+
"  -o      overwrite existing <target>"+nl+
(* "  -v      verbose (slower)"+nl+ *)
'  -us     when adding, delimit fractional part with "'+dot+'" (default is "'+coma+'")'+nl+
"  -f[f]   when adding, format total (-ff = -f -us)"+nl+
nl+
"a) Maximum line length is 4096 characters."+nl+
'b) In command line, "'+EOLcmd+'" marker stands for End of line.'+nl+
"c) Without [target] specification, a "+extBAK+" backup will be created."+nl+
"d) Note program defaults to tab expansion, unless -r is specified."+nl+
"e) When adding, each substring is filtered to [0..9+-"+coma+dot+"] character set."+nl+
"f) With -a and -ai, any character from [ "+coma+dot+"] set is a valid cosmetic separator."+nl+
"g) "+ignoredextensions+" files will be ignored."+nl+
"h) Program will handle up to 2000 files."+nl+ (* //V11 *)
"i) Warning : when adding, invalid data will lead to weird and wrong results !"+nl+
"   With -af, double check decimal separators and cosmetic separators !"+nl+
"j) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;


VAR
    S : str256;
BEGIN
    CASE e OF
    | errHelp :        WrStr(errmsg);
    | errOption:       S := 'Unknown "~" option !';
    | errTooManyParms: S := '"~" parameter is one too many !';
    | errBadCard:      S := 'Illegal "~" value !';
    | errTabRange:     S := "Tabulation count must be in [1..64] range !";
    | errConflict:     S := "-d, -e, -a, -ai and -af commands are mutually exclusive !";
    | errColumnRange:  S := "Column must be in [1..4096] range !";
    | errSyntax:       S := "Syntax error !"; (* in fact, missing parms *)
    | errMissingCmd:   S := "Missing <command> !";
    | errNonsenseRange:S := "<last> column is smaller than <first> column !";
    | errJoker    :    S := 'At least one illegal joker in "~" !';
    | errNotFound :    S := 'No match (or ignored extensions) for "~" !';
    | errAlready  :    S := '"~" already exists !';
    | errSame:         S := "<source> and <target> are identical !";
    | errTooMany:      S := "Too many files match <source> !";
    | errNonsense:     S := "-t and -v commands are mutually exclusive !";
    | errAddToTarget:  S := "Target specification is a nonsense with any add command !";
    | errRawUntab:     S := "-r and -t:# options are mutually exclusive !";
    | errTotalMode:    S := "-g option requires -s option !";
    | errSubMode:      S := "-i option requires -s option !";
    | errBadSourceExt: S := 'Illegal extension in "~" <source> !';
    | errBadTargetExt: S := 'Illegal extension in "~" <target> !';
    | errSubMethod:    S := "-s[g] and -z[g] options are mutually exclusive !";
    | errAborted:      S := "Aborted by user !";
    | errRO:           S := '"~" is read-only !';
    ELSE
                       S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* //XDS Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn  : ioBufferType;
    bufferOut : ioBufferType;

(* ------------------------------------------------------------ *)

PROCEDURE detab (tabwidth:CARDINAL;S:ARRAY OF CHAR; VAR R : ARRAY OF CHAR  );
VAR
    i,j,add: CARDINAL;
    c : CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c := S[i-1];
        IF c = tabchar THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
END detab;

(* we already know test and verbose cannot be the same *)

PROCEDURE process (cmd,lower,upper,tabwidth:CARDINAL;
                  useLFN,test,verbose,expandtab:BOOLEAN;
                  source,target:pathtype );
VAR
    hin,hout : FIO.File;
    S,R      : str4096;
    pos,count    : CARDINAL;
    fsize,portion,lastportion,currportion,addr : LONGCARD;
BEGIN
    fsize := getFileSize(source);
    portion:=fsize DIV LONGCARD(steps); INC(portion); (* avoid DIV 0 ! *)
    lastportion := LONGCARD(steps+1);

    (* IF verbose THEN Work(cmdInit); END; *)
    (* IF verbose THEN animInit(steps, "[", "]", chFiller, "", "\/" ); END; *)

    pos   := lower -1;
    count := upper - lower + 1;

    hin := FIO.OpenRead(source);
    FIO.AssignBuffer(hin,bufferIn);
  IF NOT(test) THEN (* yes, yes, we could have used stdout or stderr handle *)
    hout:= FIO.Create(target);
    FIO.AssignBuffer(hout,bufferOut);
  END;

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        (* IF verbose THEN Work(cmdShow); END; *)
        IF verbose THEN
	    (*
            addr:=FIO.GetPos(hin);
            anim(animShow);
            currportion:=addr DIV portion;
            IF currportion # lastportion THEN
                anim(animAdvance);
                lastportion:=currportion;
            END;
	    *)
        END;

        FIO.RdStr(hin,S);
        IF FIO.EOF THEN EXIT; END;

        IF expandtab THEN detab(tabwidth,S,R); END;

        CASE cmd OF
        | doDelete:
            Str.Delete(R,pos,count);
            IF test THEN
                WrStr(R);WrLn;
            ELSE
                FIO.WrStr(hout,R);FIO.WrLn(hout);    (* R *)
            END;
        | doExtract:
            Str.Slice(S,  R,pos,count);
            IF test THEN
                WrStr(S);WrLn;
            ELSE
                FIO.WrStr(hout,S);FIO.WrLn(hout);    (* S ! *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;

    END;
  IF NOT(test) THEN
    FIO.Flush(hout);
    FIO.Close(hout);
  END;
    FIO.Close(hin);

    (* IF verbose THEN Work(cmdStop); END; *)
    (* IF verbose THEN anim(animEnd);anim(animClear); END; *)
END process;

(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v : LONGCARD; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtlc;

PROCEDURE fmtli (v : LONGINT; pad:CHAR; sep:CHAR; field:INTEGER) : str80;
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.IntToStr(v,S,10,ok);
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtli;

PROCEDURE fmthc (v : LONGREAL; pad:CHAR; sep,fracsep:CHAR; field,prec:INTEGER) : str80;
VAR
    S,SF,R   : str80;
    len,i,p : CARDINAL;
    ok,frachere  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.FixRealToStr( v,prec,S,ok);
    p:=Str.RCharPos(S,dot);
    IF p=MAX(CARDINAL) THEN
        frachere:=FALSE;
    ELSE
        Str.Copy(SF,S); Str.Delete(SF,0,p+1);
        S[p]:=CHR(0); (* brutal ! *)
        frachere:=(prec # 0);
    END;

    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;

    IF frachere THEN
        Str.Append(R,fracsep);Str.Append(R,SF);
    END;

    RETURN R;
END fmthc;

PROCEDURE dmptotal (beautify:BOOLEAN;errors,opcode:CARDINAL;
                    totalcard:LONGCARD;totalint:LONGINT;totalfloat:LONGREAL;
                    killfrac,fracsep:CHAR;fieldfmt,fracwi,field,lfield:CARDINAL;
                    prefix,suffix,source:ARRAY OF CHAR);
VAR
    ok:BOOLEAN;
    R:str128;
BEGIN
    IF errors = 0 THEN
        Str.Copy(R,"::: ");
    ELSE
        Str.Copy(R,"--- ");
    END;
    Str.Append(R,prefix);
    Str.Append(R," = ");
    WrStr(R);

    IF beautify THEN
        CASE opcode OF
        | doCard: Str.Copy(R,fmtlc (totalcard ," ",killfrac, fieldfmt ));
        | doInt:  Str.Copy(R,fmtli (totalint  ," ",killfrac, fieldfmt ));
        | doFloat:Str.Copy(R,fmthc (totalfloat," ",killfrac,fracsep, fieldfmt,fracwi));
        ELSE ; (* //ISO fixed silly requirement *) END;
        WrStr(R);
    ELSE
        CASE opcode OF
        | doCard: IO.WrLngCard(totalcard,field);
        | doInt:  IO.WrLngInt (totalint,field);
        | doFloat:Str.FixRealToStr(totalfloat,fracwi,R,ok);WrStr(R);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    WrStr(" (");WrStr(source);WrStr(")");
    IF errors = 0 THEN
        WrStr(suffix);
    ELSE
        WrStr(" --- ");
        IO.WrCard(errors,lfield);
        WrStr(" error(s)");
    END;
    WrLn;

END dmptotal;

(* ------------------------------------------------------------ *)

PROCEDURE DMPDBG ( prefix,S:ARRAY OF CHAR  );
BEGIN
    WrStr(prefix); WrStr('"'); WrStr(S); WrStr('"'); WrLn;
END DMPDBG;

PROCEDURE swap (VAR i,j:CARDINAL   );
VAR
    tmp:CARDINAL;
BEGIN
    tmp:=i;
    i:=j;
    j:=tmp;
END swap;

PROCEDURE addlines (opcode,lower,upper,tabwidth:CARDINAL;
                   useLFN,test,verbose,expandtab,beautify,
                   subtotals,smarttotals,insertmode,grandtotal,DEBUG:BOOLEAN;
                   fracsep:CHAR;source:pathtype);
CONST
    ndxfirst= 1;
    ndxlast = 2;
VAR
    orgS    :ARRAY [ndxfirst..ndxlast] OF str4096;
    category:ARRAY [ndxfirst..ndxlast] OF str4096;
CONST
    field    = 1+3*3+1;     (* " # ### ### ###" *)
    fieldfmt = 1+3*3+1+3;   (* "+#,###,###,###" *)
    lfield   = 5;           (* "#####" *)
    prefTotal      = "Total";
    prefGrandTotal = "Grand Total";
    prefSubTotal   = "Sub Total";
    prefSubGrand   = "Sub Total  ";
    remark         = " ; ";
VAR
    pos,count:CARDINAL;
    hin:FIO.File;
    S,R      : str4096;
    ndxcurr,ndxprev:CARDINAL;
VAR
    Z:str256;
    grandcard, vlc,totalcard : LONGCARD;
    grandint,  vli,totalint  : LONGINT;
    grandfloat,vlf,totalfloat: LONGREAL;
    fixvalue,reread,doswap,dmpsubtotal,dmpcurrline,ok:BOOLEAN;
    base:CARDINAL;
    currline,fracwi,p,wi,errors,granderrors:CARDINAL;
    killfrac:CHAR;
    prefix,suffix:str128;
    dmpmethod:(nothing,onlysubs,subsatsepempty,subsatsepchange);
    grabbing:(waiting,gotref,newref);
    fanchor:LONGCARD;
BEGIN
    IF DEBUG THEN verbose:=FALSE;END;

    CASE fracsep OF
    | coma: killfrac:=dot;   (* search "," decimal sep, thus remove "." *)
    | dot:  killfrac:=coma;  (* search "." decimal sep, thus remove "," *)
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF subtotals THEN
        IF insertmode THEN
            IF smarttotals THEN
                dmpmethod:=subsatsepchange;
            ELSE
                dmpmethod:=subsatsepempty;
            END;
        ELSE
            dmpmethod:=onlysubs;
        END;
    ELSE
        dmpmethod:=nothing;
    END;
IF DEBUG THEN
CASE dmpmethod OF
| nothing: S:="nothing;"
| onlysubs: S:="onlysubs";
|subsatsepempty: S:="subs at sep empty";
|subsatsepchange: S:="subs at sep change";
ELSE ; (* //ISO fixed silly requirement *) END;
DMPDBG("??? ",S);
END;

    IF subtotals THEN
        IF grandtotal THEN
           prefix:=prefSubGrand;
        ELSE
           prefix:=prefSubTotal;
        END;
    ELSE
        prefix:=prefTotal;
    END;

    granderrors := 0;
    grandcard   := 0;
    grandint    := 0;
    grandfloat  := 0.0;

    errors:=0;

    CASE opcode OF
    | doCard:  totalcard :=0;   Z:="LONGCARD";
    | doInt:   totalint  :=0;   Z:="LONGINT";
    | doFloat: totalfloat:=0.0; Z:="LONGREAL";
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Prepend(Z,"Adding "); Str.Append(Z,"s from "); Str.Append(Z,source);

    pos      := lower -1;
    count    := upper - lower + 1;

    base     := 10; (* for now *)
    currline := 0;
    fracwi   := 0;

    grabbing := waiting;
    ndxcurr  := ndxfirst;
    ndxprev  := ndxlast;
    FOR p:=ndxfirst TO ndxlast DO
         orgS[p]:="";
         category[p]:="";
    END;

    IF verbose THEN video(Z,TRUE); END;

    hin := FIO.OpenRead(source);
    FIO.AssignBuffer(hin,bufferIn);

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        IF dmpmethod = subsatsepchange THEN fanchor:=FIO.GetPos(hin);END;
        FIO.RdStr(hin,S);
IF DEBUG THEN DMPDBG("<<< ",S);END;
        IF FIO.EOF THEN EXIT; END;
        Str.Copy(orgS[ndxcurr],S);
        INC(currline);

        IF expandtab THEN
            detab(tabwidth,S,R);
        ELSE
            Str.Copy(R,S);
        END;
        Str.Slice(S,  R,pos,count);

IF DEBUG THEN DMPDBG("::: ",S);END;

        IF dmpmethod = subsatsepchange THEN
            Str.Copy(category[ndxcurr],R);
            Str.Delete(category[ndxcurr],pos,count);
            LtrimBlanks(category[ndxcurr]);
            RtrimBlanks(category[ndxcurr]);
            LowerCase(category[ndxcurr]);
        END;

        ReplaceChar(S,space,"");
        ReplaceChar(S,tabchar,"");
        IF S[0]="+" THEN Str.Delete(S,0,1);END;

        CASE opcode OF
        | doCard,doInt:
            ReplaceChar(S,dot,"");
            ReplaceChar(S,coma,"");
        | doFloat:
            ReplaceChar(S,killfrac,"");
            IF fracsep=coma THEN Str.Subst(S,coma,dot); END;
            p:=Str.RCharPos(S,dot);
            IF p # MAX(CARDINAL) THEN
                wi:=Str.Length(S)-(p+1);
                IF wi > fracwi THEN fracwi:=wi;END;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;

IF DEBUG THEN DMPDBG(">>> ",S);END; (* S is extracted number *)

        reread := FALSE;
        suffix:="";
        CASE dmpmethod OF
        | nothing:
             dmpsubtotal:=FALSE;
             dmpcurrline:=FALSE;
        | onlysubs:
             dmpsubtotal:=same(S,"");
             dmpcurrline:=FALSE;
        | subsatsepempty:
             dmpsubtotal:=same(orgS[ndxcurr],""); (* was S before fix v1.0l *)
             dmpcurrline:=NOT(dmpsubtotal);
        | subsatsepchange:

IF DEBUG THEN DMPDBG("PREV ",category[ndxprev]);END;
IF DEBUG THEN DMPDBG("CURR ",category[ndxcurr]);END;

            CASE grabbing OF
            | waiting: (* only once *)
                Str.Copy(orgS[ndxprev],orgS[ndxcurr]);
                Str.Copy(category[ndxprev],category[ndxcurr]);
                dmpsubtotal:=FALSE;
                dmpcurrline:=TRUE;
                grabbing:=gotref;
            | gotref:
                IF same(category[ndxcurr],category[ndxprev]) THEN
                    dmpsubtotal := FALSE;
                    dmpcurrline := TRUE;
                ELSE
                    dmpsubtotal := TRUE;
                    dmpcurrline := FALSE; (* not yet *)
                    grabbing:=newref;
                    reread  := TRUE; (* trick *)
                    Str.Concat(suffix,remark,category[ndxprev]); (* easier to read *)
                END;
            | newref : ; (* never here *)
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
IF DEBUG THEN
DMPDBG("+++ ",orgS[ndxcurr]);
END;
        IF dmpcurrline THEN
            IF verbose THEN video(Z,FALSE);END;
            WrStr(orgS[ndxcurr]);WrLn;
            IF verbose THEN video(Z,TRUE);END;
        END;

        IF reread THEN
            fixvalue:=TRUE; (* fake it... *)
        ELSE
            fixvalue:=same(S,"");
        END;
        IF fixvalue THEN Str.Copy(S,"0"); END; (* extract *)

        CASE opcode OF
        | doCard:
            IF S[0]="-" THEN
                ok:=FALSE;
            ELSE
                vlc:=Str.StrToCard(S,base,ok); IF ok THEN INC(totalcard,vlc);END;
            END;
        | doInt:
            vli:=Str.StrToInt(S,base,ok);  IF ok THEN INC(totalint,vli);END;
        | doFloat:
            vlf:=Str.StrToReal(S,ok); IF ok THEN totalfloat:=totalfloat+vlf;END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        IF NOT(ok) THEN
            IF verbose THEN video(Z,FALSE); END;
            WrStr("--- Problem at line ");
            IO.WrCard(currline,1);
            WrStr(' ("');WrStr(S);WrStr('")');WrLn;
            IF verbose THEN video(Z,TRUE); END;
            INC(errors);
        END;
        IF dmpsubtotal THEN

            IF verbose THEN video(Z,FALSE); END;
            dmptotal (beautify,errors,opcode,
                      totalcard,totalint,totalfloat,
                      killfrac,fracsep,fieldfmt,fracwi,field,lfield,
                      prefix,suffix,source);
            IF verbose THEN video(Z,TRUE); END;

            INC(granderrors,errors);
            INC(grandcard,totalcard);
            INC(grandint,totalint);
            grandfloat:=grandfloat+totalfloat;

            errors:=0;

            CASE opcode OF
            | doCard:  totalcard :=0;
            | doInt:   totalint  :=0;
            | doFloat: totalfloat:=0.0;
            ELSE ; (* //ISO fixed silly requirement *) END;

        END;

        doswap:=FALSE;
        CASE dmpmethod OF
        | nothing,onlysubs: ;
        | subsatsepempty:
            IF dmpcurrline THEN dmpcurrline:=FALSE;END;
        | subsatsepchange:

            dmpcurrline:=NOT(dmpcurrline);
            CASE grabbing OF
            | waiting: ; (* never here *)
            | gotref :
                dmpcurrline:= FALSE;
            | newref :
                dmpcurrline:=FALSE; (* we'll reread it *)
                grabbing:=gotref;   (* waiting works too *)
                doswap:=TRUE;
                FIO.Seek(hin,fanchor); (* be sure to reread current line *)
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        IF dmpcurrline THEN
            IF verbose THEN video(Z,FALSE);END;
            WrStr(orgS[ndxcurr]);WrLn;
            IF verbose THEN video(Z,TRUE);END;
        END;
        IF doswap THEN swap(ndxcurr,ndxprev);END;
    END;
    FIO.Close(hin);

    (* reread trick removes need to check subsatsepchange state *)

    IF dmpmethod = subsatsepchange THEN
        Str.Concat(suffix,remark,category[ndxcurr]);
    ELSE
        suffix:=""; (* useless safety *)
    END;

    IF verbose THEN video(Z,FALSE); END;

    dmptotal (beautify,errors,opcode,
              totalcard,totalint,totalfloat,
              killfrac,fracsep,fieldfmt,fracwi,field,lfield,
              prefix,suffix,source);

    INC(granderrors,errors);
    INC(grandcard,totalcard);
    INC(grandint,totalint);
    grandfloat:=grandfloat+totalfloat;

    suffix:="";
    IF grandtotal THEN
        dmptotal (beautify,granderrors,opcode,
                 grandcard,grandint,grandfloat,
                 killfrac,fracsep,fieldfmt,fracwi,field,lfield,
                 prefGrandTotal,suffix,source);
    END;

END addlines;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE isReservedExtension (S:pathtype):BOOLEAN;
VAR
    u,d,n,e:pathtype;
    e3 : str16;
    ndx:CARDINAL;
    rc:BOOLEAN;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Str.Caps(e);
    rc:=FALSE;
    ndx:=0;
    LOOP
        isoleItemS(e3, ignoredextensions,delim,ndx);
        IF same(e3,"") THEN EXIT; END;
        IF same(e3,e) THEN rc:=TRUE;EXIT; END;
        INC(ndx);
    END;
    RETURN rc;
END isReservedExtension;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    IF useLFN THEN
    	(*
        IF w9XshortToLong(current,rc,longform) THEN (* if error, keep DOS current *)
            Str.Copy(current,longform);
        END;
	*)
    END;
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (useLFN:BOOLEAN;spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(basepath,u,d,"","");
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(useLFN,drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

CONST
    firstfile = 1;
    maxfile   = 2000; (* was 2000 but out OF lazyness... *)
VAR
    filename  : ARRAY [firstfile..maxfile] OF pathtype;

(* yes, yes, we could have used our "clever" dynamic allocation but we don't care *)

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (useLFN,DEBUG :BOOLEAN;spec:pathtype):CARDINAL;
VAR
    last:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    excludeme,excludemetoo,gloups:BOOLEAN; (* ;-) *)
BEGIN
    last:=firstfile-1;
    found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        excludeme   := isReservedEntry    (entryname);  (* skip "." and ".." *)
        excludemetoo:= isReservedExtension(entryname);
        gloups:=(excludeme OR excludemetoo);
        IF NOT(gloups) THEN
            dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                INC(last);
                IF last > maxfile THEN
                    RETURN MAX(CARDINAL);
                END;
                Str.Copy(filename[last],entryname);
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN last;
END buildFileList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkRange (lc:LONGCARD;lower,upper:CARDINAL;VAR v:CARDINAL):BOOLEAN ;
BEGIN
    IF lc < LONGCARD (lower) THEN RETURN FALSE; END;
    IF lc > LONGCARD (upper) THEN RETURN FALSE; END;
    v := CARDINAL(lc);
    RETURN  TRUE;
END chkRange;

(* ------------------------------------------------------------ *)

CONST
    undefinedcard=MAX(CARDINAL);
    defaulttabwidth = 8;
    mintabwidth = 1;
    maxtabwidth = 64;
    mincolumn   = 1;
    maxcolumn   = 4096;
    ascmaxcol   = "4096";
VAR
    cmd         : (undefined,delete,extract,addcard,addint,addfloat);
    absolute    : BOOLEAN;
    tabwidth    : CARDINAL;
    test        : BOOLEAN;
    overwrite   : BOOLEAN;
    verbose     : BOOLEAN;
    fracsep     : CHAR;
    expandtab   : BOOLEAN;
    beautify    : BOOLEAN;
    subtotals   : BOOLEAN;
    smarttotals : BOOLEAN;
    insertmode  : BOOLEAN;
    grandtotal  : BOOLEAN;
    useLFN      : BOOLEAN;
    DEBUG       : BOOLEAN;
    firstcolumn : CARDINAL;
    lastcolumn  : CARDINAL;
    source,target,bakfile : pathtype;
    lastfile    : CARDINAL;
    opcode      : CARDINAL;
    u,path,f8,e3: pathtype; (* oversized just in case *)
    basepath    : pathtype;
    redirON     : BOOLEAN;
VAR
    parmcount,i,opt : CARDINAL;
    S,R             : pathtype;
    state           : (waiting,gotfirst,gotlast,gotsource,gottarget);
    v               : LONGCARD;
BEGIN
    (* Lib.DisableBreakCheck(); (* if enabled, Ctrl-C forces an ERRORINF.$$$ creation ! *) *)
    FIO.IOcheck := FALSE;
    WrLn;

    redirON := TRUE; (* //XDS IsRedirected(); *)

    cmd       := undefined;
    absolute  := TRUE;
    tabwidth  := undefinedcard;
    test      := FALSE;
    overwrite := FALSE;
    verbose   := FALSE;
    fracsep   := coma;
    expandtab := TRUE;
    beautify  := FALSE;
    subtotals := FALSE;
    smarttotals:=FALSE;
    insertmode:= FALSE;
    grandtotal:= FALSE;
    useLFN    := TRUE;
    DEBUG     := FALSE;

    state     := waiting;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleantabs(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "C"+delim+"COUNT"+delim+
                                   "T:"+delim+"TAB:"+delim+
                                   "O"+delim+"OVERWRITE"+delim+
                                   "D"+delim+"DELETE"+delim+
                                   "E"+delim+"EXTRACT"+delim+"X"+delim+
                                   "v"+delim+"verbose"+delim+
                                   "T"+delim+"TEST"+delim+
                                   "DT"+delim+
                                   "ET"+delim+"XT"+delim+
                                   "A"+delim+
                                   "AI"+delim+
                                   "AF"+delim+
                                   "AFF"+delim+
                                   "US"+delim+
                                   "R"+delim+"RAW"+delim+
                                   "F"+delim+"FORMAT"+delim+"BEAUTIFY"+delim+
                                   "S"+delim+"SUBTOTAL"+delim+
                                   "SG"+delim+
                                   "G"+delim+"GRANDTOTAL"+delim+
                                   "I"+delim+"INSERT"+delim+
                                   "Z"+delim+"SMARTSUBTOTAL"+delim+
                                   "ZG"+delim+
                                   "K"+delim+"KEEP"+delim+
                                   "KT"+delim+
                                   "FF"+delim+
                                   "l"+delim+"lfn"+delim+
                                   "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5   :
                absolute := FALSE;
            | 6,7   :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadCard,S);END;
                IF chkRange(v,mintabwidth,maxtabwidth,tabwidth)=FALSE THEN
                    abort(errTabRange,S);
                END;
            | 8,9   :
                overwrite := TRUE;
            | 10,11 :
                CASE cmd OF
                | undefined,delete: cmd:=delete;
                ELSE                abort(errConflict,"");END;
            | 12,13,14 :
                CASE cmd OF
                | undefined,extract:cmd:=extract;
                ELSE                abort(errConflict,"");END;
            | 15,16 :
                verbose := TRUE;
            | 17,18:
                test := TRUE;
            | 19:
                CASE cmd OF
                | undefined,delete: cmd:=delete; test:=TRUE;
                ELSE                abort(errConflict,"");END;
            | 20,21:
                CASE cmd OF
                | undefined,extract:cmd:=extract;test:=TRUE;
                ELSE                abort(errConflict,"");END;
            | 22:
                CASE cmd OF
                | undefined,addcard:cmd:=addcard;
                ELSE                abort(errConflict,"");END;
            | 23:
                CASE cmd OF
                | undefined,addint:cmd:=addint;
                ELSE                abort(errConflict,"");END;
            | 24:
                CASE cmd OF
                | undefined,addfloat:cmd:=addfloat;
                ELSE                abort(errConflict,"");END;
            | 25:
                CASE cmd OF
                | undefined,addfloat:cmd:=addfloat;fracsep:=dot;
                ELSE                abort(errConflict,"");END;
            | 26:       fracsep:=dot;
            | 27,28:    expandtab:=FALSE;
            | 29,30,31: beautify:=TRUE;
            | 32,33:    subtotals:=TRUE;
            | 34:       subtotals:=TRUE;grandtotal:=TRUE;
            | 35,36:    grandtotal:=TRUE;
            | 37,38:    insertmode:=TRUE;
            | 39,40:    smarttotals:=TRUE;
            | 41:       smarttotals:=TRUE;grandtotal:=TRUE;
            | 42,43 :
                CASE cmd OF
                | undefined,extract:cmd:=extract;
                ELSE                abort(errConflict,"");END;
            | 44:
                CASE cmd OF
                | undefined,extract:cmd:=extract;test:=TRUE;
                ELSE                abort(errConflict,"");END;
            | 45: beautify:=TRUE; fracsep:=dot; (* -ff = -f -us *)
            | 46,47:     useLFN:=FALSE;
            | 48:        DEBUG:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting :
                Str.Prepend(R,"=");
                IF GetLongCard(R,v)=FALSE THEN abort(errBadCard,S);END;
                IF chkRange(v,mincolumn,maxcolumn,firstcolumn)= FALSE THEN
                    abort(errColumnRange,S);
                END;
            | gotfirst:
                IF same(R,EOLcmd) THEN R:=ascmaxcol; END;
                Str.Prepend(R,"=");
                IF GetLongCard(R,v)=FALSE THEN abort(errBadCard,S);END;
                IF chkRange(v,mincolumn,maxcolumn,lastcolumn)= FALSE THEN
                    abort(errColumnRange,S);
                END;
            | gotlast:
                Str.Copy(source,S);
            | gotsource:
                Str.Copy(target,S);
            | gottarget:
                abort(errTooManyParms,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    (* check nonsense *)

    IF smarttotals THEN
        IF subtotals THEN abort(errSubMethod,"");END;
        subtotals:=TRUE;
    END;

    IF ( grandtotal AND (subtotals=FALSE) ) THEN abort(errTotalMode,"");END;
    IF ( insertmode AND (subtotals=FALSE) ) THEN abort(errSubMode,"");END;

    IF cmd = undefined THEN  abort(errMissingCmd,""); END;

    (* //XDS useLFN := ( useLFN AND fileSupportLFN() ); *)

    CASE state OF
    | gotsource: (* autobak *)
        IF same(source,dot) THEN Str.Copy(source,stardotstar);END;
        IF chkJoker(source)=FALSE THEN
            IF isReservedExtension(source) THEN abort(errBadSourceExt,source);END;
        END;
    | gottarget: (* "There can be only one !" *)
        CASE cmd OF
        | extract,delete: ;
        ELSE
            abort(errAddToTarget,"");
        END;
        IF same(source,dot) THEN Str.Copy(source,stardotstar);END;
        IF same(target,dot) THEN Str.Copy(target,stardotstar);END;

        IF isReservedExtension(source) THEN abort(errBadSourceExt,source);END;
        IF isReservedExtension(target) THEN abort(errBadTargetExt,target);END;

        Str.Copy(S,source); UpperCase(source); (* UpperCaseAlt *)
        Str.Copy(R,target); UpperCase(target); (* UpperCaseAlt *)
        IF same(S,R) THEN abort(errSame,"");END; (* well, minimum check *)
        IF chkJoker(source) THEN abort(errJoker,source);END;
        IF FIO.Exists(source)=FALSE THEN abort(errNotFound,source);END;
        IF chkJoker(target) THEN abort(errJoker,target);END;
        IF FIO.Exists(target) THEN
            IF overwrite THEN
                IF fileIsRO(target) THEN abort(errRO,target);END;
                FIO.Erase(target);
            ELSE
                abort(errAlready,target);
            END;
        END;
    ELSE
        abort(errSyntax,"");
    END;

    IF expandtab = FALSE THEN
        IF tabwidth # undefinedcard THEN abort(errRawUntab,"");END;
    END;
    IF tabwidth = undefinedcard THEN tabwidth:=defaulttabwidth; END;

    IF absolute=FALSE THEN lastcolumn := firstcolumn + lastcolumn -1; END;
    IF lastcolumn < firstcolumn THEN abort(errNonsenseRange,"");END;

    IF test THEN verbose:=FALSE; END; (* cancel -v *)

    makebase(useLFN,source,basepath);
    lastfile := buildFileList(useLFN,DEBUG,source);
    CASE lastfile OF
    | firstfile-1 :  abort(errNotFound,source);
    | MAX(CARDINAL): abort(errTooMany,source);
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE cmd OF
    | delete:  i:=doDelete;
    | extract: i:=doExtract;
    | addcard: i:=doCard;
    | addint:  i:=doInt;
    | addfloat:i:=doFloat;
    ELSE ; (* //ISO fixed silly requirement *) END;
    opcode:=i;

    qdSplitAllPath(source,u,path,f8,e3);
    Str.Concat(basepath,u,path);

    IF NOT (redirON) THEN
        WrStr(banner);WrLn;
        WrLn;
    END;

FOR i := firstfile TO lastfile DO
    Str.Concat(source,basepath,filename[i]);
    IF Str.CharPos(source,dot)=MAX(CARDINAL) THEN Str.Append(source,dot);END;
    CASE cmd OF
    | delete,extract:
        CASE state OF
        | gotsource:
            Str.Copy(target,source);
            qdSplitAllPath(source,u,path,f8,e3);
            Lib.MakeAllPath(bakfile,u,path,f8,extBAK);
            IF NOT(test) THEN
                IF FIO.Exists(bakfile) THEN
                    IF fileIsRO(bakfile) THEN abort(errRO,bakfile);END;
                    FIO.Erase(bakfile);
                END;
                FIO.Rename(source,bakfile);
                Str.Copy(source,bakfile);
            END;
            IF NOT(test) THEN
                WrStr("Processing ");WrStr(target);
            END;
        | gottarget:
            IF NOT(test) THEN
                WrStr("Creating ");WrStr(target);WrStr(" from ");WrStr(source);
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;

        WrStr(" "); (* gap between filename and animation *)

        process (opcode,firstcolumn,lastcolumn,tabwidth,
                useLFN,test,verbose,expandtab,
                source,target);
        IF NOT(test) THEN
            (* WrStr(": Done !"); *) WrLn;
        END;
    ELSE
        addlines (opcode,firstcolumn,lastcolumn,tabwidth,
                 useLFN,test,verbose,expandtab,beautify,
                 subtotals,smarttotals,insertmode,grandtotal,DEBUG,
                 fracsep,source);
        IF ChkEscape() THEN abort(errAborted,"");END;
    END;
END;

    abort(errNone,"");
END Columns32.

(*

//empty.txt : empty lines
//change.txt
1
2
        3

4
5
6

    7
    8
//parano batch to check successive revisions

set p=c:\bat\columns
set e=.old
%p% 1 10 -a -g -s     empty.txt  > a%e%
%p% 1 10 -a -g -s     change.txt > b%e%
%p% 1 10 -a -g -s -i  empty.txt  > c%e%
%p% 1 10 -a -g -s -i  change.txt > d%e%

set p=c:\modula\columns
set e=.new
%p% 1 10 -a -g -s     empty.txt  > a%e%
%p% 1 10 -a -g -s     change.txt > b%e%
%p% 1 10 -a -g -s -i  empty.txt  > c%e%
%p% 1 10 -a -g -s -i  change.txt > d%e%

set e=.z
%p% 1 10 -a -g -z     empty.txt  > a%e%
%p% 1 10 -a -g -z     change.txt > b%e%
%p% 1 10 -a -g -z -i  empty.txt  > c%e%
%p% 1 10 -a -g -z -i  change.txt > d%e%

set p=
set e=

*)



