(* ---------------------------------------------------------------
Title         see help !
Author        PhG
Overview      see help !
Usage         see help !
Notes
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          well, if we want to change data containing quotes...
              but after all, this program was written to change identifiers !
              metaproc should probably enforce fascist number parsing
              to avoid problems such as escape sequence not being parsed

Wish List     -query to confirm changes ? bah...
              allow $00 processing

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  5 Jun 22 v0.9a added -n:#
	      bugfix : replaced was not set to 0 for console
PhG  7 Feb 22 an ugly really Q&D port from OLDNEW v1.1h for DOS
--------------------------------------------------------------- *)

MODULE OldNew32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn,WrLngCard;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

FROM SYSTEM IMPORT ADR,BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)
CONST
    escChVisual	  = "";
    escSetVisual  = escChVisual+"-/'%";
    escCh         = 0260C;
    escSet        = escCh+"-/'%";

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;





(*
shame on you not to have thought of more than one value at a time !
shame on you for relying on an external library to parse a mere hex value !
really gone is your Apple ][ genius... :-(
bah, old age is coming faster than end of the world...
*)

(* assume : digits already filtered and uppercased, base = 10 or 16, hex=## *)

PROCEDURE charvalToStr (VAR R:ARRAY OF CHAR; base:CARDINAL; digits:ARRAY OF CHAR):BOOLEAN;

    MODULE hxhelper;

    EXPORT hx;

    PROCEDURE hx (ch:CHAR):CARDINAL;
    CONST
        val0 = ORD("0");
        valA = ORD("A");
    VAR
        v:CARDINAL;
    BEGIN
        v:=ORD(ch);
        IF v < valA THEN
            DEC(v, val0 );
        ELSE
            DEC(v, valA );
            INC(v, 10);
        END;
        RETURN v;
    END hx;

    END hxhelper;

CONST
    maxcharval = MAX(SHORTCARD);
VAR
    rc : BOOLEAN;
    i,len,v: CARDINAL;
BEGIN
    rc := TRUE;
    len:= Str.Length(digits);
    Str.Copy(R,"");
    CASE base OF
    | 10: (* filtered for 0..9 *)
        v:=0;
        i:=1;
        LOOP
            IF i > len THEN EXIT;END;
            v := (v * 10);
            INC( v , ( ORD( digits[i-1] ) - ORD("0") ) );
            rc := ( v <= maxcharval ); IF NOT(rc) THEN EXIT; END;
            INC(i);
        END;
        IF rc THEN rc := (v # 0); END;
        IF rc THEN Str.Copy( R, CHR(v) );END;
    | 16: (* filtered for 0..9 A..F *)
        (* IF len < 2 THEN Str.Prepend(digits,"0"); INC(len);END; done by caller *)
        IF ODD(len) THEN
            rc:=FALSE;
        ELSE
            i:=1;
            LOOP
                IF i > len THEN EXIT; END;
                v:=  ( hx(digits[i-1]) << 4 );
                INC(i);
                INC(v, hx(digits[i-1]) );
                INC(i);
                rc := (v # 0);
                IF NOT(rc) THEN EXIT; END;
                Str.Append(R, CHR(v) );
            END;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN rc;
END charvalToStr;

(*

n  p  q  -  /  '  

###    $##    x##

*)

PROCEDURE metaproc (VAR S : ARRAY OF CHAR):BOOLEAN;
VAR
    ch:CHAR;
    c2:str80; (* really oversized for safety *)
    len,i,base:CARDINAL;
    R,orgS:str128;
    str:str128; (* in case we overflow ! *)
    state : (waiting,gotesc,grabhex,grabdec);
    rc:BOOLEAN;
BEGIN
    Str.Copy(orgS,S); (* in case of an error, return original unmodified string *)
    len := Str.Length(S);
    R   := "";
    i   := 1;
    rc  := TRUE;
    state := waiting;
    LOOP
        IF i > len THEN EXIT; END;
        ch := S[i-1];
        CASE state OF
        | waiting:
            CASE ch OF
            | escCh :
                state := gotesc;
            ELSE
                Str.Append(R,ch);
            END;
        | gotesc:
            CASE ch OF
            | "x","X","$":Str.Copy(str,"");         state:=grabhex; base:=16;
            | "0".."9" :  Str.Copy(str,ch);         state:=grabdec; base:=10;
            | "n","N" :   Str.Append(R,nl);         state:=waiting;
            | "p","P" :   Str.Append(R,percent);    state:=waiting;
            | "q","Q" :   Str.Append(R,doublequote);state:=waiting;
            | "b","B" :   Str.Append(R,vbar);       state:=waiting;
            ELSE
                IF Str.CharPos(escSet,ch) = MAX(CARDINAL) THEN
                    DEC(i); (* esc+verbatim : go back to make verbatim the next *)
                ELSE
                    Str.Append(R,ch); (* esc+reserved char *)
                END;
                state:=waiting;
            END;
        | grabhex:
            CASE ch OF
            | "0".."9", "A".."F", "a".."f" :
                Str.Append(str, CAP(ch) ); (* uppercase ! *)
            | escCh:
                IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                state:=waiting; (* //FIX was gotesc *)
            ELSE
                IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                DEC(i); (* go back one char now to make it next *)
                state:=waiting;
            END;
        | grabdec:
            CASE ch OF
            | "0".."9" :
                Str.Append(str,ch);
            | escCh:
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                state:=waiting; (* //FIX was gotesc *)
            ELSE
                rc:=charvalToStr(c2,base,str); IF rc=FALSE THEN EXIT; END;
                Str.Append(R,c2);
                DEC(i); (* go back one char now to make it next *)
                state:=waiting;
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(i);
    END;
    CASE state OF
    | grabhex:
        IF Str.Length(str) < 2 THEN Str.Prepend(str,"0");END; (* one char fix *)
        rc:=charvalToStr(c2,base,str);
        IF rc THEN Str.Append(R,c2); END;
    | grabdec:
        rc:=charvalToStr(c2,base,str);
        IF rc THEN Str.Append(R,c2); END;
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF rc THEN
        Str.Copy(S,R);
    ELSE
        Str.Copy(S,orgS); (* restore original *)
    END;
    RETURN rc;
END metaproc;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    msgProcessing = " "; (* " is being processed, please wait..." *)
CONST
    extBAK        = ".BK!";
    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    skippedextensions = extBAK+delim+extCOM+delim+extEXE+delim+
                        extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                        extZIP+delim+extARJ+delim+extLZH;
CONST
    ProgEXEname   = "OLDNEW32";
    ProgTitle     = "Q&D identifier/word/sequence replacer (Win32)";
    ProgVersion   = "v0.9a (from v1.1i for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errBadExistingID    = 2;
    errBadReplacementID = 3;
    errTooMany          = 4;
    errNoMatch          = 5;
    errIn               = 6;
    errOut              = 7;
    errUnknownOption    = 8;
    errParmOverflow     = 9;
    errBadExistingWord  = 10;
    errBadReplacementWord=11;
    errConflict         = 12;
    errBadAlias         = 13;
    errBadJoker         = 14;
    errBadJokerSet      = 15;
    errJokerAlias       = 16;
    errBadMeta          = 17;
    errCmdConflict      = 18;
    errBadSpec          = 19;
    errStringSequence   = 20;
    errBadVal           = 21;
    errReplacements     = 22;
    errNotWithConsole   = 23;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
00000000011111111112222222222333333333344444444445555555555666666666677777777778
1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
nl+
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" [option]... existing replacement infile(s)"+nl+
"Syntax 2 : "+ProgEXEname+" [option]... existing replacement < infile > outfile"+nl+
"Syntax 3 : "+ProgEXEname+" <-delete> [option]... existing infile(s)"+nl+
"Syntax 4 : "+ProgEXEname+" <-delete> [option]... existing < infile > outfile"+nl+
"Syntax 5 : "+ProgEXEname+" <-ASCII|-OEM>"+nl+
nl+
"  -w    process words instead of identifiers"+nl+
"  -r    process raw sequences"+nl+
"  -e    process only exact (case-sensitive) sequence matches"+nl+
"  -s    do not process strings (delimited with either single or double quotes)"+nl+
"  -d    delete any sequence match"+nl+
"  -n:#  upper limit of replacements (default is no limit)"+nl+
"  -v    verbose"+nl+
'  -p:?  replace specified character with "'+percent+'" in existing and replacement'+nl+
"  -j:?  use joker (matching exactly one character) in existing string"+nl+
"  -f    process all files (default extension protection is ignored)"+nl+
"  -a[a] display ASCII reference set (-aa = decimal)"+nl+
"  -o[o] display Windows OEM reference set (-oo = decimal)"+nl+
(* "  -lfn  disable LFN support even if available"+nl+ *)
nl+
"a) This program replaces a sequence of characters with another one."+nl+
"b) An identifier starts with a letter, and contains only letters, numbers,"+nl+
"   or the underscore (" + '"_"' + ") character."+nl+
"c) A word is a sequence delimited by spaces, tabs, or control characters."+nl+
"d) -s option prevents strings content from being modified ;"+nl+
"   note -s and -r options are mutually exclusive."+nl+
"e) Here are supported escape sequences :"+nl+
'   "' + escChVisual + 'n" = $0d0a, "' +
         escChVisual + 'p" = "%", "' +
         escChVisual+ 'q" = double quote, "' +
         escChVisual + 'b" = vertical bar ($7c),' +nl+
'   "'+  escChVisual + '[' + escSetVisual + ']" = symbol, "' +
         escChVisual + "[$|x]#[" + escChVisual + ']" = (hexa)decimal value'+nl+
"f) Please note CHR(0) character ($00 value) CANNOT be processed :"+nl+
"   it is therefore NOT allowed. Remember this is a TEXT processing utility."+nl+
"g) For safety, all lines should end with a CRLF sequence."+nl+
"h) "+skippedextensions+" files are not processed,"+nl+
"   unless -f option is specified."+nl+
"i) Each original file will be backuped with "+extBAK+" extension."+nl+
"j) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+ProgEXEname+" i index *.MOD"+nl+
"           "+ProgEXEname+" -r -e Dummy$ bozo$"+nl+
"           "+ProgEXEname+" -r "+escChVisual+"$414243"+escChVisual+"d abcd"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errBadExistingID :
        Str.Concat(S,"Illegal existing identifier (",einfo);Str.Append(S,") !");
    | errBadReplacementID :
        Str.Concat(S,"Illegal replacement identifier (",einfo);Str.Append(S,") !");
    | errTooMany:
        Str.Concat(S,"Too many files match ",einfo);Str.Append(S," !");
    | errNoMatch:
        Str.Concat(S,"No valid file matches ",einfo);
        Str.Append(S," specification !");
    | errIn :
        S := "StandardInput error !";
    | errOut :
        S := "StandardOutput error !";
    | errUnknownOption :
        Str.Concat(S,"Unknown ",einfo);Str.Append(S," option !");
    | errParmOverflow :
        Str.Concat(S,"Uneeded ",einfo);Str.Append(S," parameter !");
    | errBadExistingWord :
        Str.Concat(S,"Illegal existing word (",einfo);Str.Append(S,") !");
    | errBadReplacementWord :
        Str.Concat(S,"Illegal replacement word (",einfo);Str.Append(S,") !");
    | errConflict:
        S := "-w and -r options are mutually exclusive !";
    | errBadAlias:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," percent alias !");
    | errBadJoker:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," joker !");
    | errBadJokerSet:
        S:="Joker cannot be in [A..Za..z] set !";
    | errJokerAlias:
        S := "-p:? and -j:? characters must be different from each other !";
    | errBadMeta:
        Str.Concat(S,"Illegal escape sequence (",einfo);Str.Append(S,") !");
    | errCmdConflict:
        S := "-a, -o, -aa and -oo options are mutually exclusive !";
    | errBadSpec:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," specification !");
    | errStringSequence:
        S := "-s and -r options are mutually exclusive !";
    | errBadVal:
        Str.Concat(S,"Illegal ",einfo);Str.Append(S," value !");
    | errReplacements:
        S := "Upper limit of replacements cannot be 0 !";
    | errNotWithConsole:
        S := "Console mode does not support upper limit of replacements !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        WrLn; (* here, in order to avoid useless crlf when redirecting *)
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* //XDS Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT(e);
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    (* //XDS IF Available(needed)=FALSE THEN RETURN FALSE; END; *)
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove( ADR(p^.str),ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        noskip,DEBUG :BOOLEAN;
                        spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
        found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
            Str.Copy(entryname,entry.name);
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        IF noskip THEN
            excludeme2 := FALSE;
        ELSE
            excludeme2 := isReservedPattern (entryname,skippedextensions );
        END;
        IF NOT(excludeme1 OR excludeme2) THEN
                dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                IF DEBUG THEN WrStr("Included : ");WrStr(entryname);WrLn; END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN MAX(CARDINAL); (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( ADR(entryname),ADR(pp^.str),len );
            ELSE
                IF DEBUG THEN WrStr("Ignored  : ");WrStr(entryname);WrLn;END;
            END;
        ELSE
            IF DEBUG THEN WrStr("Excluded : ");WrStr(entryname);WrLn;END;
        END;
            found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

(* ------------------------------------------------------------ *)

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
VAR
    u,d,n,e,current:pathtype;
    unit:str2;
    drive:SHORTCARD;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        drive:=FIO.GetDrive(); (* yes we could use 0 as default drive *)
        doGetCurrent(drive,  unit,current); (* "u:" and "\" or "\*\" *)
        Str.Concat(basepath, unit,current);
    END;
END makebase;

PROCEDURE WrQuoted (S:ARRAY OF CHAR);
BEGIN
    WrStr('"');
    WrStr(S);
    WrStr('"');
END WrQuoted;

PROCEDURE WrFname (S:pathtype );
BEGIN
        WrQuoted(S);
END WrFname;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    uppercase  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lowercase  = "abcdefghijklmnopqrstuvwxyz";
    allletters = lowercase+uppercase;
    legal      = allletters+digits+underscore;

PROCEDURE isValidID (usejoker:BOOLEAN;joker:CHAR;S:ARRAY OF CHAR) : BOOLEAN;
VAR
    i   : CARDINAL;
    len : CARDINAL;
    allowed:str128;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN FALSE; END; (* should NEVER happen *)

    Str.Copy(allowed,allletters);
    IF usejoker THEN Str.Append(allowed,joker);END;
    IF Belongs(allowed,S[0])=FALSE THEN RETURN FALSE; END; (* must begin with a letter *)

    Str.Copy(allowed,legal);
    IF usejoker THEN Str.Append(allowed,joker);END;
    FOR i := 1 TO (len-1) DO
        IF Belongs(allowed,S[i])=FALSE THEN RETURN FALSE; END;
    END;
    RETURN TRUE;
END isValidID;

PROCEDURE isBlank (c:CHAR):BOOLEAN;
BEGIN
    CASE c OF
    | CHR(0)..CHR(32):
        RETURN TRUE; (* all control characters including space *)
    ELSE
        RETURN FALSE;
    END;
END isBlank;

PROCEDURE isValidWord (S:ARRAY OF CHAR) : BOOLEAN;
VAR
    i   : CARDINAL;
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN FALSE; END; (* should NEVER happen *)
    FOR i := 0 TO (len-1) DO
        IF isBlank(S[i]) THEN RETURN FALSE; END;
    END;
    RETURN TRUE;
END isValidWord;

(* not pretty but effective : who cares about speed nowadays ? ;-) *)
(* S2 is existing, with possible jokers *)

PROCEDURE sameIDref (S1,S2:ARRAY OF CHAR;keepcase,usejoker:BOOLEAN;joker:CHAR):BOOLEAN;
VAR
    mismatch,i:CARDINAL;
    c:CHAR;
BEGIN
    IF keepcase=FALSE THEN (* uppercase instead ? *)
        Str.Caps(S1);
        Str.Caps(S2);
    END;
    IF usejoker THEN
        mismatch:=0;
        FOR i:=1 TO Str.Length(S2) DO
            c:=S2[i-1];
            IF c # joker THEN
                IF c # S1[i-1] THEN INC(mismatch);END;
            END;
        END;
        RETURN (mismatch=0);
    ELSE
        IF S1[0] # S2[0] THEN RETURN FALSE; END;
        RETURN same(S1,S2);
    END;
END sameIDref;

PROCEDURE isLegal (c:CHAR;wordmode:BOOLEAN):BOOLEAN;
BEGIN
    CASE wordmode OF
    | FALSE:  RETURN Belongs(legal,c);
    | TRUE:   RETURN NOT( isBlank(c));
    ELSE ; (* //ISO fixed silly requirement *) END;
END isLegal;

(* chref is char in existing *)

PROCEDURE samerawch (ch,chref:CHAR; usejoker:BOOLEAN;joker:CHAR):BOOLEAN;
BEGIN
     IF usejoker THEN
         IF chref=joker THEN RETURN TRUE; END;
     END;
     (* either no joker, or chref was not our joker *)
     RETURN (ch=chref);
END samerawch;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ripped and adapted from old PC2WIN v1.0a *)

TYPE
    chardef   = RECORD
                    Code    : BYTE;
                    Flag    : CHAR;
                    MapChar : BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

CONST
    TwinTOpc  = CharTable{
    chardef{000H, "=", 000H},
    chardef{001H, "=", 001H},
    chardef{002H, "=", 002H},
    chardef{003H, "=", 003H},
    chardef{004H, "=", 004H},
    chardef{005H, "=", 005H},
    chardef{006H, "=", 006H},
    chardef{007H, "=", 007H},
    chardef{008H, "=", 008H},
    chardef{009H, "!", 009H},
    chardef{00AH, "=", 00AH},
    chardef{00BH, "=", 00BH},
    chardef{00CH, "=", 00CH},
    chardef{00DH, "=", 00DH},
    chardef{00EH, "=", 00EH},
    chardef{00FH, "=", 00FH},
    chardef{010H, "=", 010H},
    chardef{011H, "=", 011H},
    chardef{012H, "=", 012H},
    chardef{013H, "=", 013H},
    chardef{014H, "=", 014H},
    chardef{015H, "=", 015H},
    chardef{016H, "=", 016H},
    chardef{017H, "=", 017H},
    chardef{018H, "=", 018H},
    chardef{019H, "=", 019H},
    chardef{01AH, "=", 01AH},
    chardef{01BH, "=", 01BH},
    chardef{01CH, "=", 01CH},
    chardef{01DH, "=", 01DH},
    chardef{01EH, "=", 01EH},
    chardef{01FH, "=", 01FH},
    chardef{020H, "=",  " "},
    chardef{021H, "=",  "!"},
    chardef{022H, "=",  '"'},
    chardef{023H, "=",  "#"},
    chardef{024H, "=",  "$"},
    chardef{025H, "=",  "%"},
    chardef{026H, "=",  "&"},
    chardef{027H, "=",  "'"},
    chardef{028H, "=",  "("},
    chardef{029H, "=",  ")"},
    chardef{02AH, "=",  "*"},
    chardef{02BH, "=",  "+"},
    chardef{02CH, "=",  ","},
    chardef{02DH, "=",  "-"},
    chardef{02EH, "=",  "."},
    chardef{02FH, "=",  "/"},
    chardef{030H, "=",  "0"},
    chardef{031H, "=",  "1"},
    chardef{032H, "=",  "2"},
    chardef{033H, "=",  "3"},
    chardef{034H, "=",  "4"},
    chardef{035H, "=",  "5"},
    chardef{036H, "=",  "6"},
    chardef{037H, "=",  "7"},
    chardef{038H, "=",  "8"},
    chardef{039H, "=",  "9"},
    chardef{03AH, "=",  ":"},
    chardef{03BH, "=",  ";"},
    chardef{03CH, "=",  "<"},
    chardef{03DH, "=",  "="},
    chardef{03EH, "=",  ">"},
    chardef{03FH, "=",  "?"},
    chardef{040H, "=",  "@"},
    chardef{041H, "=",  "A"},
    chardef{042H, "=",  "B"},
    chardef{043H, "=",  "C"},
    chardef{044H, "=",  "D"},
    chardef{045H, "=",  "E"},
    chardef{046H, "=",  "F"},
    chardef{047H, "=",  "G"},
    chardef{048H, "=",  "H"},
    chardef{049H, "=",  "I"},
    chardef{04AH, "=",  "J"},
    chardef{04BH, "=",  "K"},
    chardef{04CH, "=",  "L"},
    chardef{04DH, "=",  "M"},
    chardef{04EH, "=",  "N"},
    chardef{04FH, "=",  "O"},
    chardef{050H, "=",  "P"},
    chardef{051H, "=",  "Q"},
    chardef{052H, "=",  "R"},
    chardef{053H, "=",  "S"},
    chardef{054H, "=",  "T"},
    chardef{055H, "=",  "U"},
    chardef{056H, "=",  "V"},
    chardef{057H, "=",  "W"},
    chardef{058H, "=",  "X"},
    chardef{059H, "=",  "Y"},
    chardef{05AH, "=",  "Z"},
    chardef{05BH, "=",  "["},
    chardef{05CH, "=",  "\"},
    chardef{05DH, "=",  "]"},
    chardef{05EH, "=",  "^"},
    chardef{05FH, "=",  "_"},
    chardef{060H, "=",  "`"},
    chardef{061H, "=",  "a"},
    chardef{062H, "=",  "b"},
    chardef{063H, "=",  "c"},
    chardef{064H, "=",  "d"},
    chardef{065H, "=",  "e"},
    chardef{066H, "=",  "f"},
    chardef{067H, "=",  "g"},
    chardef{068H, "=",  "h"},
    chardef{069H, "=",  "i"},
    chardef{06AH, "=",  "j"},
    chardef{06BH, "=",  "k"},
    chardef{06CH, "=",  "l"},
    chardef{06DH, "=",  "m"},
    chardef{06EH, "=",  "n"},
    chardef{06FH, "=",  "o"},
    chardef{070H, "=",  "p"},
    chardef{071H, "=",  "q"},
    chardef{072H, "=",  "r"},
    chardef{073H, "=",  "s"},
    chardef{074H, "=",  "t"},
    chardef{075H, "=",  "u"},
    chardef{076H, "=",  "v"},
    chardef{077H, "=",  "w"},
    chardef{078H, "=",  "x"},
    chardef{079H, "=",  "y"},
    chardef{07AH, "=",  "z"},
    chardef{07BH, "=",  "{"},
    chardef{07CH, "=",  "|"},
    chardef{07DH, "=",  "}"},
    chardef{07EH, "=",  "~"},
    chardef{07FH, "x",  " "},
    chardef{080H, "x",  " "},
    chardef{081H, "x",  " "},
    chardef{082H, "x",  " "},
    chardef{083H, "x",  " "},
    chardef{084H, "x",  " "},
    chardef{085H, "x",  " "},
    chardef{086H, "x",  " "},
    chardef{087H, "x",  " "},
    chardef{088H, "x",  " "},
    chardef{089H, "x",  " "},
    chardef{08AH, "x",  " "},
    chardef{08BH, "x",  " "},
    chardef{08CH, "x",  " "},
    chardef{08DH, "x",  " "},
    chardef{08EH, "x",  " "},
    chardef{08FH, "x",  " "},
    chardef{090H, "x",  " "},
    chardef{091H, "=",  "'"},
    chardef{092H, "=",  "'"},
    chardef{093H, "x",  " "},
    chardef{094H, "x",  " "},
    chardef{095H, "x",  " "},
    chardef{096H, "x",  " "},
    chardef{097H, "x",  " "},
    chardef{098H, "x",  " "},
    chardef{099H, "x",  " "},
    chardef{09AH, "x",  " "},
    chardef{09BH, "x",  " "},
    chardef{09CH, "x",  " "},
    chardef{09DH, "x",  " "},
    chardef{09EH, "x",  " "},
    chardef{09FH, "x",  " "},
    chardef{0A0H, "=",  " "},
    chardef{0A1H, "=",  ""},
    chardef{0A2H, "=",  ""},
    chardef{0A3H, "=",  ""},
    chardef{0A4H, "=",  ""},
    chardef{0A5H, "=",  ""},
    chardef{0A6H, "=",  "|"},
    chardef{0A7H, "!", 015H},
    chardef{0A8H, "?",  " "},
    chardef{0A9H, "!",  ""},
    chardef{0AAH, "=",  ""},
    chardef{0ABH, "=",  ""},
    chardef{0ACH, "=",  ""},
    chardef{0ADH, "=",  "-"},
    chardef{0AEH, "!",  ""},
    chardef{0AFH, "!",  "-"},
    chardef{0B0H, "=",  ""},
    chardef{0B1H, "=",  ""},
    chardef{0B2H, "=",  ""},
    chardef{0B3H, "?",  " "},
    chardef{0B4H, "?",  " "},
    chardef{0B5H, "=",  ""},
    chardef{0B6H, "!", 014H},
    chardef{0B7H, "?",  " "},
    chardef{0B8H, "?",  " "},
    chardef{0B9H, "?",  " "},
    chardef{0BAH, "=",  ""},
    chardef{0BBH, "=",  ""},
    chardef{0BCH, "=",  ""},
    chardef{0BDH, "=",  ""},
    chardef{0BEH, "?",  " "},
    chardef{0BFH, "=",  ""},
    chardef{0C0H, "=",  "A"},
    chardef{0C1H, "=",  "A"},
    chardef{0C2H, "=",  "A"},
    chardef{0C3H, "=",  "A"},
    chardef{0C4H, "=",  ""},
    chardef{0C5H, "=",  ""},
    chardef{0C6H, "=",  ""},
    chardef{0C7H, "=",  ""},
    chardef{0C8H, "=",  "E"},
    chardef{0C9H, "=",  ""},
    chardef{0CAH, "=",  "E"},
    chardef{0CBH, "=",  "E"},
    chardef{0CCH, "=",  "I"},
    chardef{0CDH, "=",  "I"},
    chardef{0CEH, "=",  "I"},
    chardef{0CFH, "=",  "I"},
    chardef{0D0H, "?",  " "},
    chardef{0D1H, "=",  ""},
    chardef{0D2H, "=",  "O"},
    chardef{0D3H, "=",  "O"},
    chardef{0D4H, "=",  "O"},
    chardef{0D5H, "=",  "O"},
    chardef{0D6H, "=",  ""},
    chardef{0D7H, "=",  "X"},
    chardef{0D8H, "=",  "O"},
    chardef{0D9H, "=",  "U"},
    chardef{0DAH, "=",  "U"},
    chardef{0DBH, "=",  "U"},
    chardef{0DCH, "=",  ""},
    chardef{0DDH, "=",  "Y"},
    chardef{0DEH, "?",  " "},
    chardef{0DFH, "=",  ""},
    chardef{0E0H, "=",  ""},
    chardef{0E1H, "=",  ""},
    chardef{0E2H, "=",  ""},
    chardef{0E3H, "=",  "a"},
    chardef{0E4H, "=",  ""},
    chardef{0E5H, "=",  ""},
    chardef{0E6H, "=",  ""},
    chardef{0E7H, "=",  ""},
    chardef{0E8H, "=",  ""},
    chardef{0E9H, "=",  ""},
    chardef{0EAH, "=",  ""},
    chardef{0EBH, "=",  ""},
    chardef{0ECH, "=",  ""},
    chardef{0EDH, "=",  ""},
    chardef{0EEH, "=",  ""},
    chardef{0EFH, "=",  ""},
    chardef{0F0H, "?",  " "},
    chardef{0F1H, "=",  ""},
    chardef{0F2H, "=",  ""},
    chardef{0F3H, "=",  ""},
    chardef{0F4H, "=",  ""},
    chardef{0F5H, "=",  "o"},
    chardef{0F6H, "=",  ""},
    chardef{0F7H, "=",  ""},
    chardef{0F8H, "=",  "o"},
    chardef{0F9H, "=",  ""},
    chardef{0FAH, "=",  ""},
    chardef{0FBH, "=",  ""},
    chardef{0FCH, "=",  ""},
    chardef{0FDH, "=",  "y"},
    chardef{0FEH, "?",  " "},
    chardef{0FFH, "=",  ""}};

PROCEDURE num2str (n,base,wi:CARDINAL;padchar:CHAR):str16;
VAR
    R:str16;
    ok:BOOLEAN;
BEGIN
    Str.CardToStr( LONGCARD(n),R,base,ok );
    WHILE Str.Length(R) < wi DO
        Str.Prepend(R,padchar);
    END;
    IF base=16 THEN Str.Lows(R);Str.Prepend(R,dollar);END;
    RETURN R;
END num2str;

CONST
    ASCIIset = 1;
    OEMset   = 2;

PROCEDURE showset (what,base:CARDINAL);
CONST
    default = FALSE;
    (*%T default *)
    double = doublequote;
    single = quote;
    sep    = ":";
    (*%E *)
    (*%F default  *)
    double = " ";
    single = " ";
    sep    = " "; (* ":" *)
    (*%E  *)
VAR
    i,wi,last,v:CARDINAL;
    S,H:str128;
    V:str16;
    pad:CHAR;
BEGIN
    WrLn;

    CASE base OF
    | 10: wi:=3;pad:=" "; H:="   ";
    | 16: wi:=2;pad:="0"; H:="    ";
    ELSE ; (* //ISO fixed silly requirement *) END;
    FOR i:=1 TO base DO
        Str.Append(H," ");
        Str.Append(H,num2str(i-1,base,wi,pad));
    END;
    WrStr(H);WrLn;

    last:= ((255 DIV base)+1)*base;DEC(last);
    FOR i:=0 TO last DO
        IF (i MOD base) = 0 THEN
            Str.Copy(V,num2str(i,base,wi,pad));
            WrStr(V);WrStr(" ");
        END;
        WrStr(sep);
        CASE what OF
        | ASCIIset:
            CASE i OF
            | 0..4,7..0AH, 0DH, 1AH..1BH :
                S:="   ";
            | ORD(doublequote):
                Str.Concat(S,single,CHR(i));Str.Append(S,single);
            ELSE
                IF i > 255 THEN
                    v:=ORD(" ");
                ELSE
                    v:=i;
                END;
                Str.Concat(S,double,CHR(v));Str.Append(S,double);
            END;
        | OEMset:
            v :=  ORD( CHR(CARDINAL(TwinTOpc[i].MapChar)) ) ;
            CASE v OF
            | 0..4,7..0AH, 0DH, 1AH..1BH :
                S:="   ";
            | ORD(doublequote) :
                Str.Concat(S,single,CHR(v));Str.Append(S,single);
            ELSE
                Str.Concat(S,double,CHR(v));Str.Append(S,double);
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        WrStr(S);
        IF (i MOD base) = (base-1) THEN
            WrStr(sep+" ");WrStr(V);WrLn;
        END;
    END;
    WrStr(H);WrLn;
END showset;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkUD (S:pathtype):BOOLEAN ;
VAR
    u,d,n,e:pathtype;
    pb:CARDINAL;
BEGIN
    qdSplitAllPath(S , u,d,n,e);
    pb:=0;
    IF chkJoker(u) THEN INC(pb);END;
    IF chkJoker(d) THEN INC(pb);END;
    RETURN (pb=0);
END chkUD;

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn : ioBufferType;
    bufferOut: ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    wilc = 5; (* could be more *)
VAR
    opt,parmcount,offset  : CARDINAL;
    mode        : (console,diskfile);

    tmp : str128;

    S,R               : pathtype;
    parm1,parm2,parm3 : pathtype;
    filespec,basedir  : pathtype;
    backup,file       : pathtype;

    lookfor     : (identifiers,words,sequences);
    keepcase, wordmode,delete,verbose,usealias,usejoker    : BOOLEAN;
    ignorestring:BOOLEAN;
    noskip:BOOLEAN;
    strdelimiter:CHAR;
    percentalias,joker : CHAR;

    cmdstate    : (waitingcmd,gotParm1,gotParm2,gotParm3);

    existing,replacement,ID : str1024; (* //V11H was str128, still much more than necessary ! *)
    ptrID       : CARDINAL; (* try and avoid Str.Append function *)

    state       : (waiting,grabbing,filtering,instring,donereplacing);
    cmd         : (work,showASCIIhex,showOEMhex,showASCIIdec,showOEMdec);

    hin,hout    : FIO.File;

    countFile   : CARDINAL;
    i,p,got     : CARDINAL;
    c           : CHAR;

    sequ        : str4096; (* //V11H was str256, still more than possible existing sequence *)
    here        : CARDINAL;
    matchlen    : CARDINAL;
    ch          : CHAR;
    k           : CARDINAL;

    replaced,maxreplacements    : LONGCARD;  (* just in case ! *)
    addr        : LONGCARD;
    DEBUG       : BOOLEAN;
    ptr,anchor  : pFname;
BEGIN
    (* //XDS Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    lookfor     := identifiers;
    keepcase    := FALSE;  (* not case sensitive *)
    delete      := FALSE;  (* replace *)
    verbose     := FALSE;
    usealias    := FALSE;
    usejoker    := FALSE;
    cmd         := work;
    ignorestring:= FALSE;
    noskip:=FALSE;
    maxreplacements := MAX(LONGCARD);
    DEBUG       := FALSE;

    cmdstate := waitingcmd;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "E"+delim+"EXACT"+delim+
                                 "W"+delim+"WORD"+delim+
                                 "D"+delim+"DELETE"+delim+
                                 "R"+delim+"RAW"+delim+
                                 "V"+delim+"VERBOSE"+delim+
                                 "P:"+delim+"PERCENT:"+delim+
                                 "J:"+delim+"JOKER:"+delim+
                                 "A"+delim+"ASCII"+delim+
                                 "O"+delim+"OEM"+delim+"WINDOWS"+delim+
                                 "AA"+delim+
                                 "OO"+delim+
                                 "l"+delim+"lfn"+delim+
                                 "S"+delim+"STRING"+delim+
                                 "F"+delim+"ALLFILES"+delim+
				 "N:"+delim+"UPTO:"+delim+
                                 "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 :  abort(errHelp,"");
            | 4,5 :    keepcase := TRUE;
            | 6,7 :    IF lookfor = sequences THEN abort(errConflict,"");END;
                       lookfor := words;
            | 8,9 :    delete  := TRUE;
            | 10,11:   IF lookfor = words THEN abort(errConflict,"");END;
                       lookfor := sequences;
            | 12,13:   verbose := TRUE;
            | 14,15:   GetString(S,tmp);
                       IF Str.Length(tmp) # 1 THEN abort(errBadAlias,S);END;
                       IF tmp[0] = percent THEN abort(errBadAlias,S);END;
                       percentalias:=tmp[0];
                       usealias:=TRUE;
            | 16,17:   GetString(S,tmp);
                       IF Str.Length(tmp) # 1 THEN abort(errBadJoker,S);END;
                       joker:=tmp[0];
                       UpperCase(joker); (* thus, we'll skip accents too *)
                       IF Belongs(allletters,joker) THEN abort(errBadJokerSet,"");END;
                       joker:=tmp[0]; (* retrieve original *)
                       usejoker:=TRUE;
            | 18,19:   CASE cmd OF
                       | work,showASCIIhex : cmd:=showASCIIhex;
                       ELSE
                           abort(errCmdConflict,"");
                       END;
            | 20,21,22:CASE cmd OF
                       | work,showOEMhex : cmd:=showOEMhex;
                       ELSE
                           abort(errCmdConflict,"");
                       END;
            | 23:      CASE cmd OF
                       | work,showASCIIdec : cmd:=showASCIIdec;
                       ELSE
                           abort(errCmdConflict,"");
                       END;
            | 24:      CASE cmd OF
                       | work,showOEMdec : cmd:=showOEMdec;
                       ELSE
                           abort(errCmdConflict,"");
                       END;
            | 25,26:   (* useLFN:=FALSE; *) ;
            | 27,28:   ignorestring:=TRUE;
            | 29,30:   noskip:=TRUE;
            | 31,32:   IF GetLongCard(R,maxreplacements)=FALSE THEN abort(errBadVal,S);END;
	               IF maxreplacements = 0 THEN abort(errReplacements,"");END;
	    | 33:      DEBUG := TRUE;
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            CASE cmdstate OF
            | waitingcmd  : Str.Copy(parm1,S);
            | gotParm1    : Str.Copy(parm2,S);
            | gotParm2    : Str.Copy(parm3,S);
            | gotParm3    : abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(cmdstate);
        END;
    END;

    CASE cmd OF
    | showASCIIhex:  showset(ASCIIset,16);
    | showOEMhex:    showset(OEMset,16);
    | showASCIIdec:  showset(ASCIIset,10);
    | showOEMdec:    showset(OEMset,10);
    ELSE ; (* //ISO fixed silly requirement *) END;
    CASE cmd OF
    | work:
        ;
    ELSE
        abort(errNone,"");
    END;

    CASE delete OF
    | FALSE:
        CASE cmdstate OF
        | gotParm2 :
            mode := console;
        | gotParm3 :
            Str.Copy(filespec,parm3);
            mode := diskfile;
        ELSE
            abort(errHelp,"");
        END;
        Str.Copy(existing,parm1);
        Str.Copy(replacement,parm2);
    | TRUE:
        CASE cmdstate OF
        | gotParm1: (* existing *)
            mode := console;
        | gotParm2: (* existing infile *)
            Str.Copy(filespec,parm2);
            mode := diskfile;
        ELSE
            abort(errHelp,"");
        END;
        Str.Copy(existing,parm1);
        Str.Copy(replacement,"");
    ELSE ; (* //ISO fixed silly requirement *) END;
    IF mode = console THEN
        IF maxreplacements # MAX(LONGCARD) THEN abort(errNotWithConsole,"");END;
    END;

    (* //XDS useLFN:=( useLFN AND w9XsupportLFN() ); *)

    IF DEBUG THEN
        WrStr("1 - Existing    : ");WrQuoted(existing);WrLn;
        WrStr("1 - Replacement : ");WrQuoted(replacement);WrLn;
    END;

    IF usealias THEN
        IF usejoker THEN
            IF percentalias=joker THEN abort(errJokerAlias,"");END;
        END;
        ReplaceChar (existing,    percentalias, percent);
        ReplaceChar (replacement, percentalias, percent);
    END;
    IF usejoker THEN
        IF usealias THEN
            IF percentalias=joker THEN abort(errJokerAlias,"");END;
        END;
    END;

    IF DEBUG THEN
        WrStr("2 - Existing    : ");WrQuoted(existing);WrLn;
        WrStr("2 - Replacement : ");WrQuoted(replacement);WrLn;
    END;

    IF metaproc(existing)=FALSE THEN abort(errBadMeta,existing);END;
    IF metaproc(replacement)=FALSE THEN abort(errBadMeta,replacement);END;

    IF DEBUG THEN
        WrStr("3 - Existing    : ");WrQuoted(existing);WrLn;
        WrStr("3 - Replacement : ");WrQuoted(replacement);WrLn;
    END;

    CASE lookfor OF
    | identifiers :
        wordmode := FALSE;
        IF isValidID(usejoker,joker,existing)=FALSE THEN abort(errBadExistingID,existing);END;
        IF delete=FALSE THEN
            IF isValidID(FALSE,"",replacement)=FALSE THEN abort(errBadReplacementID,replacement);END;
        END;
    | words       :
        wordmode := TRUE;
        IF isValidWord(existing)=FALSE THEN abort(errBadExistingWord,existing);END;
        IF delete=FALSE THEN
            IF isValidWord(replacement)=FALSE THEN abort(errBadReplacementWord,replacement);END;
        END;
    | sequences   :
        IF keepcase = FALSE THEN UpperCase(existing); END;
        matchlen := Str.Length(existing); (* 1 or more... *)
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF ignorestring THEN
        IF lookfor = sequences THEN abort(errStringSequence,"");END;
    END;

    IF (verbose AND (DEBUG=FALSE)) THEN
        WrStr("Existing        : ");WrQuoted(existing);WrLn;
        WrStr("Replacement     : ");WrQuoted(replacement);WrLn;

        WrStr("Processing mode : ");
        CASE lookfor OF
        | identifiers: S:="identifiers";
        | words:       S:="words";
        | sequences:   S:="raw sequences";
        ELSE ; (* //ISO fixed silly requirement *) END;
        WrStr(S);WrLn;

        WrStr("Strings content : ");
        IF ignorestring THEN
            S:="ignored";
        ELSE
            S:="processed";
        END;
        WrStr(S);WrLn;

	WrStr("Upper limit     : ");
	IF maxreplacements = MAX(LONGCARD) THEN
	    WrStr("no limit");
	ELSE
	    WrLngCard(maxreplacements,wilc);
	END;
	WrLn;
    END;

    CASE mode OF
    | console:

            replaced := 0; (* //V09A *)
            hin  := FIO.StandardInput;
            hout := FIO.StandardOutput;

            IF lookfor = sequences THEN
                here  := 0;
                state := filtering;
            ELSE
                state := waiting;
            END;

            LOOP
                c := FIO.RdChar(hin);
                IF FIO.IOresult() # 0 THEN abort(errIn,""); END;
                IF FIO.EOF=TRUE THEN EXIT; END;

                CASE state OF
                | waiting:
                    IF isLegal(c,wordmode) THEN
                        ptrID := 0;
                        ID[ptrID]:=c;
                        INC(ptrID);
                        ID[ptrID]:=CHR(0);
                        state := grabbing;
                    ELSE
                        IF ignorestring THEN
                             CASE c OF
                             | singlequote,doublequote:
                                 strdelimiter:=c;
                                 state:=instring;
                             ELSE ; (* //ISO fixed silly requirement *) END;
                        END;
                        FIO.WrChar(hout,c);
                        (* IF FIO.IOresult()#0 THEN abort(errOut,"");END; *)
                    END;
                | instring: (* ignorestring ON *)
                     FIO.WrChar(hout,c);
                     IF c = strdelimiter THEN state:=waiting; END;
                | grabbing:
                    IF isLegal(c,wordmode) THEN
                        ID[ptrID]:=c;
                        INC(ptrID);
                        ID[ptrID]:=CHR(0);
                    ELSE
                        IF sameIDref(ID,existing,keepcase,usejoker,joker) THEN
                            Str.Copy(ID,replacement);
                        END;
                        FIO.WrStr(hout,ID); (* let function handle length of string *)
                        FIO.WrChar(hout,c);
                        state:=waiting;
                    END;
                | filtering:
                    ch := c;
                    IF keepcase=FALSE THEN UpperCase(ch);END;
                    IF here < matchlen THEN
                        IF samerawch(ch,existing[here],usejoker,joker) THEN
                            sequ[here]:=c;
                            INC(here);
                        ELSE
                            FOR k:= 1 TO here DO
                                FIO.WrChar(hout,sequ[k-1]);
                            END;
                            here := 0;
                            IF samerawch(ch,existing[here],usejoker,joker) THEN
                                sequ[here]:=c;
                                INC(here);
                            ELSE
                                FIO.WrChar(hout,c);
                            END;
                        END;
                    ELSE
                        FIO.WrStr(hout,replacement);
                        here := 0;
                        IF ch=existing[here] THEN
                            sequ[here]:=c;
                            INC(here);
                        ELSE
                            FIO.WrChar(hout,c);
                        END;
                    END;

                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
            CASE state OF
            | grabbing :
                IF ID[0]=existing[0] THEN (* a little speed *)
                    IF same(ID,existing) THEN
                        Str.Copy(ID,replacement);
                    END;
                END;
                FIO.WrStr(hout,ID);
            | filtering :
                IF here < matchlen THEN (* print aborted sequence *)
                    FOR k := 1 TO here DO
                        FIO.WrChar(hout,sequ[k-1]);
                    END;
                ELSE (* //V11G fix *)
                    FIO.WrStr(hout,replacement); (* eh eh, could use wrbin ! *)
                    INC(replaced);
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;

    | diskfile:

        (* a few q&d sanity checks *)

        IF DEBUG THEN WrStr("Filespec : ");WrFname(filespec);WrLn;END;
        IF chkUD(filespec)=FALSE THEN abort(errBadSpec,filespec);END;
        IF same(filespec,dot) THEN Str.Copy(filespec,stardotstar); END;
        IF same(filespec,star) THEN Str.Copy(filespec,stardotstar); END;
        IF Str.Match(filespec,"*"+antislash) THEN Str.Append(filespec,stardotstar); END;
        IF chkJoker(filespec)=FALSE THEN
            IF isDirectory ( filespec) THEN
                fixDirectory(filespec);
                Str.Append(filespec,stardotstar);
            END;
        END;
        IF DEBUG THEN WrStr("Filespec : ");WrFname(filespec);WrLn;END;
        makebase(filespec,basedir);
        IF DEBUG THEN WrStr("Basedir  : ");WrFname(basedir);WrLn;END;

        initList(anchor);
        countFile := buildFileList( anchor,noskip,DEBUG,filespec);
        CASE countFile OF
        | MAX(CARDINAL): abort(errTooMany,filespec);
        | 0 :            abort(errNoMatch,filespec);
        ELSE ; (* //ISO fixed silly requirement *) END;

        WrLn; (* prettier display, as now we're very likely to end with errNone *)

        ptr:=anchor;
        WHILE ptr # NIL DO
            getStr(filespec,ptr);
            Str.Concat(backup,basedir,filespec);

            p := Str.RCharPos(backup,dot);
            IF p # MAX(CARDINAL) THEN
                Str.Slice(S,backup,0,p);
                Str.Copy(backup,S);
            END;
            Str.Append(backup,extBAK);

            getStr(filespec,ptr);
            Str.Concat(file,basedir,filespec);
            IF FIO.Exists(backup) THEN FIO.Erase(backup); END; (* don't keep previous backup, whatever it was *)
            FIO.Rename( file,backup);

            video(file,TRUE);
            video(msgProcessing,TRUE);

            (* Work(cmdInit); *)
            (* completed(completedInit,fileGetFileSize(backup)); *)

            addr := 0;

            hin :=FIO.OpenRead(backup);
            FIO.AssignBuffer(hin,bufferIn);
            hout:=FIO.Create(file);
            FIO.AssignBuffer(hout,bufferOut);
            FIO.EOF:=FALSE;

            IF lookfor = sequences THEN
                here  := 0;
                state := filtering;
            ELSE
                state := waiting;
            END;
            replaced := 0;

            LOOP
                IF FIO.EOF=TRUE THEN EXIT; END; (* probably useless *)
                got:=FIO.RdBin(hin,c,1);
                IF got # 1 THEN EXIT; END;

                (* Work(cmdShow); *)
                (* completed(completedSHOW,addr); *)

                INC(addr);
                CASE state OF
                | waiting:
                     IF isLegal(c,wordmode) THEN
                         ptrID := 0;
                         ID[ptrID]:=c;
                         INC(ptrID);
                         ID[ptrID]:=CHR(0);
                         state := grabbing;
                     ELSE
                         IF ignorestring THEN
                             CASE c OF
                             | singlequote,doublequote:
                                 strdelimiter:=c;
                                 state:=instring;
                             ELSE ; (* //ISO fixed silly requirement *) END;
                         END;
                         FIO.WrBin(hout,c,1);
                     END;
                | instring: (* ignorestring ON *)
                     FIO.WrBin(hout,c,1);
                     IF c = strdelimiter THEN state:=waiting; END;
                | grabbing:
                    IF isLegal(c,wordmode) THEN
                        ID[ptrID]:=c;
                        INC(ptrID);
                        ID[ptrID]:=CHR(0);
                    ELSE
                        IF sameIDref(ID,existing,keepcase,usejoker,joker) THEN
                            Str.Copy(ID,replacement);
                            INC(replaced);
 			    IF replaced >= maxreplacements THEN state:=donereplacing; END;
                        END;
                        FIO.WrStr(hout,ID); (* eh eh, could use wrbin ! *)
                        FIO.WrBin(hout,c,1);
                        IF state # donereplacing THEN state:=waiting;END;
                    END;
                | filtering:

                    ch := c;
                    IF keepcase=FALSE THEN UpperCase(ch);END;
                    IF here < matchlen THEN
                        IF samerawch(ch,existing[here],usejoker,joker) THEN
                            sequ[here]:=c;
                            INC(here);
                        ELSE
                            FOR k:= 1 TO here DO
                                FIO.WrBin(hout,sequ[k-1],1);
                            END;
                            here := 0;
                            IF samerawch(ch,existing[here],usejoker,joker) THEN
                                sequ[here]:=c;
                                INC(here);
                            ELSE
                                FIO.WrBin(hout,c,1);
                            END;
                        END;
                    ELSE
                        FIO.WrStr(hout,replacement); (* eh eh, could use wrbin ! *)
                        INC(replaced);
                        IF replaced >= maxreplacements THEN state:=donereplacing;END;
                        here := 0;
                        IF ch=existing[here] THEN
                            sequ[here]:=c;
                            INC(here);
                        ELSE
                            FIO.WrBin(hout,c,1);
                        END;
                    END;
                | donereplacing:
		    FIO.WrBin(hout,c,1);
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
            CASE state OF
            | grabbing :
                IF ID[0]=existing[0] THEN (* a little speed *)
                    IF same(ID,existing) THEN
                        Str.Copy(ID,replacement);
                        INC(replaced);
			(* checking against maxreplacements useless now *)
                    END;
                END;
                FIO.WrStr(hout,ID);
            | filtering :
                IF here < matchlen THEN (* print aborted sequence *)
                    FOR k := 1 TO here DO
                        FIO.WrBin(hout,sequ[k-1],1);
                    END;
                ELSE (* //V11G fix *)
                    FIO.WrStr(hout,replacement); (* eh eh, could use wrbin ! *)
                    INC(replaced);
                    (* checking against maxreplacements useless now *)
                END;
            ELSE ; (* //ISO fixed silly requirement *) END;

            FIO.Flush(hout);
            FIO.Close(hout); (* yes, in fact, it's FIO.Close()  *)
            FIO.Close(hin);

            (* Work(cmdStop); *)
            (* completed(completedEnd,0); *)

            video(msgProcessing,FALSE);
            video(file,FALSE);

            IF replaced = 0 THEN (* backup was useless here *)
                FIO.Erase(file);
                FIO.Rename(backup,file);
            END;

            IF replaced >= maxreplacements THEN WrStr("First ");END;
            WrLngCard(replaced,wilc);
            (* WrStr(" replacement"); IF replaced > 1 THEN WrStr("s");END; *)
            WrStr(" replacement(s)");
            WrStr(" made in "); WrFname(file); WrLn;

            ptr:=ptr^.next;
        END;
        freeList(anchor);

    ELSE ; (* //ISO fixed silly requirement *) END;
    abort(errNone,"");
END OldNew32.


(*

set f=oldnew32.mod

set p=oldnew32
set e=32
rem set p=oldnew
rem set e=16

copy \xds\src\%f%

%p% end FIN %f%
copy %f% 1.%e%

%p% -e -r Directory REPERTOIRE %f%
copy %f% 2.%e%

%p% -d PROCedure %f%
copy %F% 3.%e%

%p% -r n $0A %f%
copy %f% 4.%e%

fix also metaproc newline32 and newname32

*)

(*

@echo off
set _p=oldnew
set _f=c:\modula\src\oldnew.mod
set _e=tst

if "%1" == "" goto help

copy /b %_f% org

copy org test
%_p% phg EGOEGOEGO test
copy test 1.%_e%

copy org test
%_p% -e phg EGOEGOEGO test
copy test 2.%_e%

copy org test
%_p% -e PhG EGOEGOEGO test
copy test 3.%_e%

copy org test
%_p% -e -s PhG EGOEGOEGO test
copy test 4.%_e%

pause

copy org test
%_p% -r end; FIN; test
copy test 5.%_e%

copy org test
%_p% -s phg EGOEGOEGO test
copy test 6.%_e%

copy org test
%_p% -s -e PhG EGOEGOEGO test
copy test 7.%_e%

pause

copy org test
%_p% -d -r end test
copy test 8.%_e%

copy org test
%_p% -d -e PhG test
copy test 9.%_e%

copy org test
%_p% -s -d -e PhG test
copy test 10.%_e%

pause


copy org test
%_p% -w phg EGOEGOEGO test
copy test 11.%_e%

copy org test
%_p% -w -e phg EGOEGOEGO test
copy test 12.%_e%

copy org test
%_p% -w -e PhG EGOEGOEGO test
copy test 13.%_e%

copy org test
%_p% -w -e -s PhG EGOEGOEGO test
copy test 14.%_e%

pause

copy org test
%_p% -r -e PhG EGOEGOEGO test
copy test 15.%_e%

copy org test
%_p% -r -e -d END test
copy test 16.%_e%

copy org test
%_p% -n:10 -r -e -d END test
copy test 17.%_e%

copy org test
%_p% -n:10 -r -e END FIN test
copy test 18.%_e%


goto end
:help
echo.
echo Syntax : %0 x
echo.
echo This batch tests "%_p%" using "%_f%"
echo Results have ".%_e%" extension.
echo.
goto end

:end
set _e=
set _f=
set _p=

*)



