(* ---------------------------------------------------------------
Title         see help !
Author        who cares ?
Overview      see help !
Usage         see help !
Notes         try and replace my old PowerBasic code : dupscrc, samecrc, idcrc
              filter out columns interval used to check for duplicate state ?

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
Bugs	      check //FIXME
Wish List
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  1 Dec 22 v0.9a from v1.0i for DOS
PhG  9 Nov 21 an ugly really Q&D port from DUPLINES v1.0h for DOS
--------------------------------------------------------------- *)

MODULE dupLines32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr,WrLn, WrLngCard;
FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)

CONST
    extLOG        = ".LOG";
    (*
    extRPT        = ".RPT";
    REPORT        = "DUPLINES"+extRPT;
    *)
    remark1       = semicolon;
    remark2       = pound;
    sEOL          = star;
    endOfString   = CHR(0);
    prefixKeep    = "# ";
    prefixKill    = "; ";
CONST
    progEXEname   = "DUPLINES32";
    progTitle     = "Q&D Duplicate Lines Finder (Win32)";
    progVersion   = "v0.9a (from v1.0i for DOS)";
    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParm             = 3;
    errExpected         = 4;
    errJoker            = 5;
    errNotFound         = 6;
    errRange            = 7;
    errAborted          = 8;
    errUseless          = 9;
    errNope             = 10;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
banner+nl+
nl+
"Syntax 1 : "+progEXEname+" <range> <list["+extLOG+"]> [-option]..."+nl+
"Syntax 2 : "+progEXEname+" <-d> <list["+extLOG+"]>"+nl+
nl+
"This program reads entries from previously sorted <list>,"+nl+
"filtering out duplicates using specified <range> columns interval."+nl+
nl+
"   -e keep case"+nl+
"   -p remove path indication from analyzed portion of line"+nl+
"   -a do not favor first duplicate"+nl+
"   -r reverse display, showing unique lines"+nl+
"   -t left-trim each line before processing"+nl+
"   -k alternate display (-a ignored, -d forbidden)"+nl+
"   -c deeper check using filesize and filename extension"+nl+
"   -d process DIRBAT (v1.2h or better) sorted listing built from DOS or /lfn"+nl+
"      (using date/time)"+nl+
nl+
"a) <range> is either <first[..last]> or <first[,count]> :"+nl+
'   <first> column is 1-based ; [last] or [count] may be "'+sEOL+'" for End Of Line.'+nl+
'b) Empty lines and lines beginning with either "'+remark1+'" or "'+remark2+'" are ignored.'+nl+
"c) Tabs are not expanded. Lines should not be greater than 4095 characters."+nl+
"d) Should comparison match, -c option performs a safety check outside <range> :"+nl+
"   it tries and locates a filesize (allowed characters : [0..9], dot, coma)"+nl+
"   and a filename extension so it can flag any mistmatch. The process is slow."+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" -p 23 cs.log"+nl+
"           "+progEXEname+" -a 31..43 chkdata.log"+nl+
"           "+progEXEname+" 31,13 chkdata.log"+nl+
"           "+progEXEname+" 1..* prenoms"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :     WrStr(helpmsg);
    | errOption :   S := 'Unknown "|" option !';
    | errParm :     S := 'Uneeded "|" parameter !';
    | errExpected:  S := 'Missing "|" parameter !';
    | errJoker:     S := '"|" should not contain any joker !';
    | errNotFound:  S := '"|" does not exist !';
    | errRange:     S := 'Illegal "|" range !';
    | errAborted:   S := "Aborted by user !";
    | errUseless:   S := "-d command does not require any option !";
    | errNope:      S := "-d command and -k option are mutually exclusive !";
    ELSE
                    S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        Str.Subst(S,"|",einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); //XDS *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF BYTE;
VAR
    bufferIn : ioBufferType;

(* ------------------------------------------------------------ *)

(*
legal :
      #
      #..#
      #,#
*)

PROCEDURE parserange (S:ARRAY OF CHAR;VAR firstcolumn,columncount:CARDINAL):BOOLEAN;
CONST
    MAXRANGE      = SIZE(str4096);
    sMAXRANGE     = "4096";
    delimcount    = ",";
    delimrange    = "..";
    delimrangealt = "-";
    trycount      = 1;
    tryrange      = 2;
    tryrangealt   = 3;
VAR
    j,p : CARDINAL;
    lc:LONGCARD;
    sep:str2; (* either a char or two chars *)
    pattern,snum:str128; (* snum could be str16 but "who knows what evil..." etc. *)
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    j:=trycount-1; (* sic ! *)
    LOOP
        INC(j);
        IF j > tryrangealt THEN (* no separator found *)
            Str.Concat(snum,"=",S); (* ugly trick *)
            IF GetLongCard(snum,lc)=FALSE THEN EXIT; END;
            IF ( (lc < 1) OR (lc > MAXRANGE) ) THEN EXIT; END;
            firstcolumn:=CARDINAL(lc)-1; (* remember : from 0 ! *)
            columncount:=MAXRANGE; (* always use maximum *)
            rc:=TRUE;
            EXIT;
        END;
        CASE j OF
        | trycount    : sep:=delimcount;
        | tryrange    : sep:=delimrange;
        | tryrangealt : sep:=delimrangealt;
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Concat(pattern,"*",sep); Str.Append(pattern,"*");
        IF Str.Match(S, pattern) THEN
            p:=Str.Pos(S,sep);
            IF p > 0 THEN
                Str.Slice(snum,S,0,p);
                Str.Delete(S,0,p);
            ELSE
                snum:="";
            END;
            Str.Subst(S,sep,"");
            (* after all, do not allow lazy default trailing "*" *)
            (* IF same(S,"") THEN Str.Copy(S,sEOL);END; *)

            Str.Prepend(snum,"="); (* ugly trick *)
            IF GetLongCard(snum,lc)=FALSE THEN EXIT; END;
            IF ( (lc < 1) OR (lc > MAXRANGE) ) THEN EXIT; END;
            firstcolumn:=CARDINAL(lc)-1; (* 0-based for Str functions *)

            IF same(S,sEOL) THEN
                columncount:=MAXRANGE; (* always use maximum *)
            ELSE
                Str.Concat(snum,"=",S);
                IF GetLongCard(snum,lc)=FALSE THEN EXIT; END;
                IF ( (lc < 1) OR (lc > MAXRANGE) ) THEN EXIT; END;
                CASE j OF
                | trycount :
                    columncount:=CARDINAL(lc);
                | tryrange,tryrangealt :
                    IF CARDINAL(lc) < (firstcolumn+1) THEN EXIT; END;
                    columncount:=CARDINAL(lc)-1-firstcolumn+1;
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;
            rc:=TRUE;
            EXIT;
        END;
    END;
    RETURN rc;
END parserange;

(* ------------------------------------------------------------ *)

PROCEDURE pad (VAR R:ARRAY OF CHAR;wi:INTEGER;ch:CHAR; S:ARRAY OF CHAR   );
BEGIN
    Str.Copy(R,S);
    WHILE Str.Length(R) < CARDINAL ( ABS(wi) ) DO
        IF wi < 0 THEN
            Str.Prepend(R,ch);
        ELSE
            Str.Append(R,ch);
        END;
    END;
END pad;

PROCEDURE numToStr (v:CARDINAL):str80;
VAR
    ok:BOOLEAN;
    R:str80;
BEGIN
    Str.CardToStr( LONGCARD(v), R, 10, ok);
    RETURN R;
END numToStr;

PROCEDURE wrboolean (wi:CARDINAL;flag:BOOLEAN;S:ARRAY OF CHAR);
VAR
    R:str128;
BEGIN
    pad(R,wi,blank,S);
    Str.Append(R," : ");
    IF flag THEN
        Str.Append(R,"yes");
    ELSE
        Str.Append(R,"no");
    END;
    WrStr(R);WrLn;
END wrboolean;

PROCEDURE wrvalue (wi:INTEGER;v:CARDINAL;S:ARRAY OF CHAR );
VAR
    R:str128;
BEGIN
    pad(R,wi,blank,S);
    Str.Append(R," : ");
    Str.Append(R,numToStr(v));
    WrStr(R);WrLn;
END wrvalue;

PROCEDURE dmpnum (wi:INTEGER;v:CARDINAL;S:ARRAY OF CHAR);
VAR
    R,Z:str16;
BEGIN
    IF S[0] = charnull THEN RETURN; END;
    Str.Copy(R, numToStr(v) );
    pad(Z, wi,blank,R);
    WrStr(Z);WrStr(" : ");WrStr(S);WrLn;
END dmpnum;

(* ------------------------------------------------------------ *)

(*
DIRBAT v1.2h /LFN
0        1         2         3         4         5         6         7
1...'....0....'....0....'....0....'....0....'....0....'....0.........0
srs     .rpt            4,230  09-Apr-2007  10:02:34    c:\mesdoc~1\street~1\
*)

CONST
    firstdup  = 1;
    maxdup    = 250; (* should do *)
VAR
    sdup      : ARRAY [firstdup..maxdup] OF str256;

PROCEDURE isLess (i,j:CARDINAL):BOOLEAN;
CONST
    dirbatDMY = 32-1;
    dirbatHMS = 45-1;
VAR
    d,t,stampi,stampj:str16;
    S:str256;
    R:str80; (* for numToStr *)
    ndx,m:CARDINAL;
BEGIN
    FOR ndx:=1 TO 2 DO
        CASE ndx OF
        | 1: S:=sdup[i];
        | 2: S:=sdup[j];
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Slice(d,S,dirbatDMY,11); (* dd-MMM-yyyy *)
        Str.Slice(t,S,dirbatHMS,8);  (* hh:mm:ss *)
        Str.Slice(R,d,4-1,3);   (* MMM *)
        Str.Caps(R);
        Str.Prepend(R,dash);
        m := GetOptIndex(R,"JAN"+delim+"JAN"+delim+
                           "FEB"+delim+"FEV"+delim+
                           "MAR"+delim+"MAR"+delim+
                           "APR"+delim+"AVR"+delim+
                           "MAY"+delim+"MAI"+delim+
                           "JUN"+delim+"JUN"+delim+
                           "JUL"+delim+"JUI"+delim+
                           "AUG"+delim+"AOU"+delim+
                           "SEP"+delim+"SEP"+delim+
                           "OCT"+delim+"OCT"+delim+
                           "NOV"+delim+"NOV"+delim+
                           "DEC"+delim+"DEC");
        (* assume month was legal, i.e. m is 1..24 *)
        m := (m+1) DIV 2;
        R := numToStr(m);
        IF m < 10 THEN Str.Prepend(R,"0");END;          (* mm *)
        Str.Slice(S,d,8-1,4);
        Str.Append(S,R);         (* yyyymm *)
        Str.Slice(R,d,1-1,2);
        Str.Append(S,R);         (* yyyymmdd *)
        Str.Append(S,t);         (* yyyymmddhh:mm:ss *)
        ReplaceChar(S," ","0");
        ReplaceChar(S,":","");

        CASE ndx OF
        | 1: Str.Copy(stampi,S);
        | 2: Str.Copy(stampj,S);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
(*WrLn;
WrStr("::: ");WrStr(stampi);WrStr(" ::: ");WrStr(sdup[i]);WrLn;
WrStr("::: ");WrStr(stampj);WrStr(" ::: ");WrStr(sdup[j]);WrLn;
*)
    RETURN (Str.Compare(stampi,stampj) < 0);
END isLess;

PROCEDURE doSwap (i,j:CARDINAL);
VAR
    tmp:str256;
BEGIN
    tmp:=sdup[i];
    sdup[i]:=sdup[j];
    sdup[j]:=tmp;
END doSwap;

(* should we check path too ? yes, but this may become complicated ! *)

PROCEDURE sortAndDump (count:CARDINAL  );
CONST
    dirbatF8E3 = 1-1;
VAR
    i:CARDINAL;
    S:str256;
    n:str16;
BEGIN
    Lib.QSort(count,isLess,doSwap);
    FOR i:=firstdup TO count DO
        Str.Slice(n, sdup[i], dirbatF8E3, 12); (* nnnnnnnn.eee *)
        ReplaceChar(n," ","");
        Str.Concat(S,sdup[i],n);
        IF i < count THEN
            WrStr(prefixKill);
        ELSE
            WrStr(prefixKeep);
        END;
        WrStr(S);WrLn;
    END;
    WrLn;
END sortAndDump;

(* ------------------------------------------------------------ *)

PROCEDURE doDeeper (VAR ZZ,foundfext:ARRAY OF CHAR;VAR foundfsize:LONGCARD;
                   firstcolumn,columncount:CARDINAL);
VAR
    p,i,lastarg:CARDINAL;
    R:str256;
    v:LONGCARD;
    ok:BOOLEAN;
BEGIN
    Str.Copy(foundfext,"");
    Str.Delete(ZZ,firstcolumn,columncount);

    lastarg:=argc(ZZ,FALSE);
    FOR i:= 1 TO lastarg DO
        argv (R, ZZ, i,FALSE);
        IF verifyString(R,digits+dot+coma) THEN
            ReplaceChar(R,dot,"");
            ReplaceChar(R,coma,"");
            v:=Str.StrToCard(R,10,ok);
            IF ok THEN
                IF foundfsize=MAX(LONGCARD) THEN foundfsize:=v; END;
            END;
        END;
        argv (R, ZZ, lastarg-i+1,FALSE); (* reverse *)
        p:= Str.RCharPos(R,dot);
        IF p # MAX(CARDINAL) THEN (* assume a dot is extension *)
            IF same(foundfext,"") THEN
                Str.Delete(R,0,p);
                Str.Copy(foundfext,R);UpperCase(foundfext); (* //UpperCaseAlt() ? *)
            END;
        END;
    END;
END doDeeper;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWorking  = "Working...";
    fix         = -5; (* should do *)
CONST
    wi        = 22; (* should do to format debug infos *)
    firstparm = 1;
    maxparm   = 2;
VAR
    lastparm  : CARDINAL;
    parm      : ARRAY [firstparm..maxparm] OF pathtype;
    parmcount,i,opt:CARDINAL;
    S,R:pathtype;
    DEBUG:BOOLEAN;
    altdisplay,keepcase,keeppath,keepfirst,deepercheck:BOOLEAN;
    reverse,dirbat,dotrim,LFNlist:BOOLEAN;
    infile:pathtype;
    hin:FIO.File;
    firstcolumn,columncount,dups,cmdopt:CARDINAL;
    SS,ZZ,oldSS,portion,oldportion : str4096;
    foundfsize,oldfoundfsize:LONGCARD;
    foundfext,oldfoundfext:str16; (* should do *)
    ok,alcatraz:BOOLEAN;
    errcode:CARDINAL;
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    keepcase := FALSE;
    keeppath := TRUE;
    keepfirst:= TRUE;
    reverse  := FALSE;
    dirbat   := FALSE;
    dotrim   := FALSE;
    altdisplay:=FALSE;
    deepercheck:=FALSE;
    DEBUG    := FALSE;
    lastparm := firstparm-1; (* 1.. *)

    cmdopt := 0;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "E"+delim+"EXACT"+delim+"KEEPCASE"+delim+
                                 "P"+delim+"PATH"+delim+
                                 "A"+delim+"ALL"+delim+
                                 "R"+delim+"REVERSE"+delim+
                                 "D"+delim+"DIRBAT"+delim+
                                 "T"+delim+"TRIM"+delim+"LEFTTRIM"+delim+
                                 "K"+delim+"COUNT"+delim+
				 "C"+delim+"CHECK"+delim+"DEEPCHECK"+delim+
                                 "x"+delim+"lfn"+delim+
                                 "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5,6 : keepcase  := TRUE;   INC(cmdopt);
            | 7,8   : keeppath  := FALSE;  INC(cmdopt);
            | 9,10  : keepfirst := FALSE;  INC(cmdopt);
            | 11,12 : reverse   := TRUE;   INC(cmdopt);
            | 13,14 : dirbat    := TRUE;   LFNlist:=FALSE;
            | 15,16,17 : dotrim := TRUE;
            | 18,19 : altdisplay:= TRUE;
            | 20,21,22 : deepercheck:=TRUE;
	    | 23,24 : ;
            | 25    : DEBUG     := TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            (* 1=range, 2=file *)
            INC(lastparm); IF lastparm > maxparm THEN abort(errParm,S);END;
            Str.Copy(parm[lastparm],S);
        END;
    END;


    IF dirbat THEN

        IF altdisplay THEN abort(errNope,"");END;

        IF cmdopt # 0 THEN abort(errUseless,"");END;
        CASE lastparm OF
        | firstparm-1:
            abort(errExpected,"<list>");
        | firstparm+1:
            abort(errParm,parm[firstparm+1]);
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Copy(S     ,"1..12");
        Str.Copy(infile,parm[firstparm]);
    ELSE

        IF altdisplay THEN keepfirst:=TRUE; END;

        CASE lastparm OF
        | firstparm-1 : (* complicated way to specify 0 ! *)
            abort(errExpected,"<range>");
        | firstparm   :
            abort(errExpected,"<list>");
        ELSE ; (* //ISO fixed silly requirement *) END;
        (* lastparm is maxparm *)
        Str.Copy(S     ,parm[firstparm]);
        Str.Copy(infile,parm[firstparm+1]);
    END;

    IF parserange(S,firstcolumn,columncount)=FALSE THEN abort(errRange,S);END;

    IF same(infile,".") THEN infile:="*.*";END;
    IF chkJoker(infile) THEN abort(errJoker,infile);END;
    IF Str.CharPos(infile,dot)=MAX(CARDINAL) THEN Str.Append(infile,extLOG);END;
    IF FIO.Exists(infile)=FALSE THEN abort(errNotFound,infile);END;

    IF DEBUG THEN
        wrboolean(wi,dirbat         ,"; DIRBAT mode");
        wrboolean(wi,reverse        ,"; Reverse mode");
        wrboolean(wi,keepcase       ,"; Case-sensitive");
        wrboolean(wi,NOT(keeppath)  ,"; Filter out path");
        wrboolean(wi,keepfirst      ,"; Flag first duplicate");
        wrboolean(wi,dotrim         ,"; Left-trim each line");
        wrboolean(wi,altdisplay     ,"; Alternate display");
	wrboolean(wi,deepercheck    ,"; Deeper check");
        wrvalue  (wi,firstcolumn+1  ,"; Column"); (* parserange() made it 0-based *)
        wrvalue  (wi,columncount    ,"; Count");
        WrLn;
    END;

    video(msgWorking,TRUE);

    hin:=FIO.OpenRead(infile);
    FIO.AssignBuffer(hin,bufferIn);

    oldSS      := "";
    oldportion      := ""; (* //V10I was "1..12" *)
    oldfoundfext    := "";
    oldfoundfsize   := MAX(LONGCARD);

    dups       :=1;
    alcatraz        := FALSE;

    WHILE NOT( FIO.EOF ) DO        (* ok to use it because it's the only file opened *)
        FIO.RdStr(hin,SS);
        IF NOT(dirbat) THEN
            IF dotrim THEN LtrimBlanks(SS); END;
        END;
        RtrimBlanks(SS);
        CASE SS[0] OF
        | remark1,remark2,endOfString:
            ;
        ELSE
            IF deepercheck THEN
                Str.Copy(ZZ,SS);
                doDeeper(ZZ,foundfext,foundfsize, firstcolumn,columncount);
            END;
            Str.Slice(portion,SS,firstcolumn,columncount); (* //V10I *)
            IF NOT(keeppath) THEN
                i:=Str.RCharPos(portion,backslash);
                IF i # MAX(CARDINAL) THEN
                    Str.Delete(portion,0,i+1);
                END;
            END;
            IF NOT(keepcase) THEN UpperCase(portion);END;

            ok:= same(portion,oldportion);
            IF ok THEN
                IF deepercheck THEN
                    ok:=same(foundfext,oldfoundfext);
                    IF ok THEN ok:=(foundfsize=oldfoundfsize);END;
                END;
            END;
            IF ok THEN
                IF dirbat THEN
                    Str.Copy(sdup[dups],oldSS);
                ELSE
                    CASE dups OF
                    | 1 :
                        IF keepfirst THEN
                            Str.Prepend(oldSS,prefixKeep);
                        ELSE
                            Str.Prepend(oldSS,prefixKill);
                        END;
                    ELSE
                        Str.Prepend(oldSS,prefixKill);
                    END;
                    IF NOT(reverse) THEN
                        IF NOT(altdisplay) THEN
                            video(msgWorking,FALSE);
                            WrStr(oldSS);WrLn;
                            video(msgWorking,TRUE);
                        END;
                    END;
                END;
                INC(dups);
            ELSE
                IF dirbat THEN
                    IF dups > 1 THEN
                        Str.Copy(sdup[dups],oldSS);
                        video(msgWorking,FALSE);
                        sortAndDump(dups);
                        video(msgWorking,TRUE);
                    END;
                    Str.Copy(sdup[firstdup],SS);
                ELSE
                    IF altdisplay THEN
                        dmpnum(fix,dups,oldSS);
                    ELSE
                        CASE dups OF
                        | 1 :
                            IF reverse THEN
                                video(msgWorking,FALSE);
                                WrStr(oldSS);WrLn;
                                video(msgWorking,TRUE);
                            END;
                        ELSE
                            IF NOT(reverse) THEN
                                Str.Prepend(oldSS,prefixKill);
                                video(msgWorking,FALSE);
                                WrStr(oldSS);WrLn;
                                WrLn;
                                video(msgWorking,TRUE);
                            END;
                        END;
                    END;
                END;
                oldfoundfext:=foundfext;
                oldfoundfsize:=foundfsize;
                oldportion:=portion;
                dups:=1;
            END;
            oldSS:=SS;
        END;
        IF ChkEscape() THEN alcatraz:=TRUE; FIO.EOF:=TRUE; END; (* force exit *)
    END;
    video(msgWorking,FALSE);

    IF NOT (alcatraz) THEN
        IF dirbat THEN
            IF dups > 1 THEN
                Str.Copy(sdup[dups],oldSS);
                sortAndDump(dups);
            END;
        ELSE
            IF altdisplay THEN
                dmpnum(fix,dups,oldSS);
            ELSE
                CASE dups OF
                | 1 :
                    IF reverse THEN
                        WrStr(oldSS);WrLn;
                    END;
                ELSE
                    IF NOT(reverse) THEN
                        Str.Prepend(oldSS,prefixKill);
                        WrStr(oldSS);WrLn;
                    END;
                END;
            END;
        END;
    END;

    FIO.Close(hin);

    IF alcatraz THEN abort(errAborted,"");END;

    abort(errNone,"");
END dupLines32.

