(* ---------------------------------------------------------------
Title         Q&D Make DEF
Author        PhG
Overview
Notes         model must be Compact or more
              general idea is :
              - reprer [implementation] module xxx
              - crer definition module xxx
              - reprer les squences mme sur plusieurs lignes de
                PROCEDURE ( [:;]-- ) [:]-- ;
              - prendre garde aux remarques, directives et chanes (bugs)

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


Bugs          cannot handle things like "PROCEDURE () ; IN lib;" but who cares ?
              still unable to parse itself anyway !
              can still overwrite src
	      not really a bug : an empty list gives "FROM $$$ IMPORT"
Wish List     rewrite the whole thing ? bah, it works, after all...
              flag procedures AND variables TO hide WITH (* HIDE/PRIVATE *) ?
              include global TYPEs

              could also keep TYPE and globerks ?

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  8 Nov 21 an ugly really Q&D port from MAKEDEF v1.1d for DOS
--------------------------------------------------------------- *)

MODULE MakeDEF32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;
FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


PROCEDURE Ltrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF S[i] # c THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END Ltrim;

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;


PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)

CONST
    debug         = FALSE;
    beta          = CHR(225);
    ProgEXEname   = "MAKEDEF32";
    ProgTitle     = "Q&D Make DEF file from MOD file (Win32)";
    ProgVersion   = "v0.9 (from v1.1d for DOS)"; (* +beta *)
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
    extDEF        = ".DEF";
    extMOD        = ".MOD";
    extIMP        = ".IMP";
    extBAK        = ".{";    (* "{" + "DE" or "IM" *)
CONST
    firstFile    = 1;
    maxFile      = 5000;    sMaxFile     = "5000";
    minWidth     = 20;
    maxWidth     = 254;    sRange       = "[20..254]";
    defaultwidth = 70;     sDefWidth    = "70";
CONST
    errNone         = 0;
    errHelp         = 1;
    errUnknown      = 2;
    errParmOverflow = 3;
    errTooManyFiles = 4;
    errNoMatchFile  = 5;
    errMissingSpec  = 6;
    errBadRange     = 7;
    errBadValue     = 8;

(* save and optimize _seems_ ok whether in or out of procedure *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
0        1         2         3         4         5         6         7         8
12345678901234567890123456789012345678901234567890123456789012345678901234567890
*)
    msgHelp = Banner+nl+
nl+
"Syntax : "+ProgEXEname+" <file(s)["+extMOD+"]> [option]..."+nl+
nl+
"This program builds "+extDEF+" and "+extIMP+" file(s) from "+extMOD+" file(s)."+nl+
nl+
"  -l|-i do not create "+extIMP+" importation list"+nl+
"  -r    keep remark just preceding PROCEDURE"+nl+
"  -p    pack lines (no CRLF between headers)"+nl+
"  -f    force program code to be parsed as if it was a module"+nl+
"  -w:#  specify IMPORT list width in characters (default is "+sDefWidth+")"+nl+
"  -v    verbose PROCEDURE listing while working"+nl+
nl+
"a) This program can process up to "+sMaxFile+" files at once"+nl+
"   (note files matching *"+extDEF+" and *"+extIMP+" are ignored)."+nl+
"b) Processing assumes each source file has correct Modula-2 syntax."+nl+
"c) This tool was written for TopSpeed J.P.I. Modula-2 source code :"+nl+
"   hand-editing will still be required for elements such as"+nl+
"   constants, types, global variables, private procedures."+nl+
"d) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str128;
BEGIN
    CASE e OF
    | errHelp :           WrStr(msgHelp);
    | errUnknown :        S:='Unknown "|" option !';
    | errParmOverflow:    S:='"|" is one parameter too many !';
    | errTooManyFiles :   S:='Too many files match "|" specification !';
    | errNoMatchFile :    S:='No file matches "|" specification !';
    | errMissingSpec :    S:="Missing <file(s) specification !";
    | errBadRange :       S:="-w:# option must belong to "+sRange+" !";
    | errBadValue:        S:='Illegal "|" value !';
    ELSE
        S := "How did you get THERE ?";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"|",einfo);
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); //XDS *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

PROCEDURE handlebak (VAR fi:ARRAY OF CHAR; orgfi,ext:ARRAY OF CHAR );
VAR
    unit,f8,e3,extbk:str16;
    bk,path:str128;
BEGIN
    Str.Slice(extbk,ext,1,2);  (* ".123" becomes "12" *)
    Str.Prepend(extbk,extBAK); (* ".{12" now  *)

    Str.Copy(fi,orgfi);
    Str.Copy(bk,orgfi);
    qdSplitAllPath(orgfi,unit,path,f8,e3);  (* e3 contains . so length is 4 *)
    Str.Subst(fi,e3,ext);
    Str.Subst(bk,e3,extbk);
    IF FIO.Exists(fi) THEN
        IF FIO.Exists(bk) THEN FIO.Erase(bk); END;
        FIO.Rename(fi,bk);
    END;
END handlebak;

(* ------------------------------------------------------------ *)

(* Str.Subst replaces only first occurrence *)

PROCEDURE Replace (VAR s:ARRAY OF CHAR; target:CHAR; new:CHAR );
(*
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(s,target);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        s[p] := new;
    END;
*)
BEGIN
    Str.Subst(s,target,new);
END Replace;

PROCEDURE DmpTTX (hnd:FIO.File;
                  VAR s:ARRAY OF CHAR;
                  maxcount:CARDINAL);     (* 79 *)
VAR
    begpos: CARDINAL;
    count : CARDINAL;
    advance:CARDINAL;
    t : str80; (* never more than 80 chars *)
    i : CARDINAL;
BEGIN
    begpos:=0;
    LOOP
       count:=maxcount;
       advance:=maxcount;
       IF (begpos+count) < Str.Length(s) THEN (* not the last line to print *)
            LOOP
                IF s[begpos+count]=blank THEN (* found first space backwards *)
                    advance:=count+1;   (*' position after space *)
                    EXIT;
                END;
                DEC(count);
                IF count= 0 THEN (* no space at all in line to print *)
                    count:=maxcount;
                    EXIT;
                END;
            END;
       END;
       Str.Slice (t,s,begpos,count); (* slice good portion *)
       FIO.WrStr(hnd,t);
       FIO.WrLn(hnd);
       INC(begpos,advance); (* skip space if any *)
       IF begpos >= Str.Length(s) THEN EXIT; END;
    END;
END DmpTTX;

(* ------------------------------------------------------------ *)

PROCEDURE GetCardinal (VAR v : CARDINAL; S : ARRAY OF CHAR) : BOOLEAN;
VAR
    p : CARDINAL;
    lc : LONGCARD;
    ok : BOOLEAN;
BEGIN
    Replace(S,equal,colon); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(S,colon); (* MAX(CARDINAL) already excluded! *)
    Str.Delete(S,0,p+1);
    lc:=Str.StrToCard(S,10,ok);
    IF ok = FALSE THEN RETURN FALSE;END;
    IF lc > MAX(CARDINAL) THEN RETURN FALSE;END;
    v:=CARDINAL(lc);
    RETURN TRUE;
END GetCardinal;

PROCEDURE Appears (string,what:ARRAY OF CHAR;VAR p : CARDINAL) : BOOLEAN;
BEGIN
    p := Str.Pos(string,what);
    RETURN ( p # MAX(CARDINAL) );
END Appears;

(* ------------------------------------------------------------ *)

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead; (* 4Kb is enough, 16Kb was oversized and useless *)
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
VAR
    IObufferIn : ARRAY [firstIObufferByte..lastIObufferByte] OF BYTE; (* for private M2 IO *)
    IObufferOut: ARRAY [firstIObufferByte..lastIObufferByte] OF BYTE; (* for private M2 IO *)

(* ------------------------------------------------------------ *)

CONST
    (*
       each word is delimited by any characters except
       a digit, a letter, an underbar or a '.'
       this filter only leaves keywords without attached delimiters
    *)
    Filter    = Str.CHARSET{ 0C..CHAR(255) } -
                Str.CHARSET{ 'A'..'Z','a'..'z','_','0'..'9','.' }; (* //FIXME what about "_" here ? *)

    (* this filter keeps keywords with attached delimiters *)
    FilterAlt = Str.CHARSET{ cr,lf,tabul,blank};

PROCEDURE TokenAppears (VAR line:ARRAY OF CHAR;lookedfor:ARRAY OF CHAR  ): BOOLEAN;
VAR
    wordpos:CARDINAL;
    word : str80; (* should be enough! *)
BEGIN
    wordpos := 0;
    LOOP
        Str.Item(word,line,Filter,wordpos);
        IF (word[0] = 0C) THEN
            RETURN FALSE;
        END; (* Check that there was a word *)
        IF Str.Compare(word,lookedfor)=0 THEN
            RETURN TRUE;
        END;
        INC(wordpos);
    END;
END TokenAppears;

(* ------------------------------------------------------------ *)

CONST
    openREM 	   = "(*";
    closeREM 	   = "*)";
    procedure 	   = "PROCEDURE";
    pragma1         = openREM+"%";
    pragma2         = openREM+"#";
CONST
    firstline = 1;
    lastline  = 32;
VAR
    kept : ARRAY [firstline..lastline] OF str256;
    nextline : CARDINAL;
    state : (waiting,inremark,after);

PROCEDURE InitStack ();
BEGIN
    nextline := firstline;
    state := waiting;
END InitStack;

PROCEDURE Push (VAR s:ARRAY OF CHAR); (* var is faster but do not touch! *)
BEGIN
    IF nextline <= lastline THEN (* could abort but... *)
        Str.Copy(kept[nextline],s);
        INC(nextline);
    ELSE
        nextline := firstline; (* lose every previous stacked lines *)
    END;
END Push;

PROCEDURE IsStackEmpty (  ) : BOOLEAN;
BEGIN
    IF nextline = firstline THEN
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END IsStackEmpty;

PROCEDURE Dump (hndo : FIO.File);
VAR
    i:CARDINAL ;
BEGIN
    IF IsStackEmpty()=FALSE THEN
        FOR i:=firstline TO (nextline-1) DO
            FIO.WrStr(hndo,kept[i]);
            FIO.WrLn(hndo);
        END;
    END;
    InitStack();
END Dump;

PROCEDURE ProcessREM (VAR s : ARRAY OF CHAR); (* var is faster but do not touch! *)
VAR
    pragmahere : BOOLEAN;
    beghere : BOOLEAN;
    endhere : BOOLEAN;
    p : CARDINAL;
BEGIN
    IF Appears(s,procedure,p) THEN
         Push(s);
         state := waiting;
         RETURN;
    END;
    pragmahere :=( Appears(s,pragma1,p) OR Appears(s,pragma2,p) );

    CASE pragmahere OF
    | TRUE :               (* force to false *)
        beghere := FALSE;
        endhere := FALSE;
    | FALSE :
        beghere := Appears(s,openREM,p);
        endhere := Appears(s,closeREM,p);
    ELSE ; (* //ISO fixed silly requirement *) END;
    CASE state OF
    | waiting :
         CASE beghere OF
         | TRUE :
             CASE endhere OF
             | TRUE :
                 InitStack();  (*    /* --- */     *)
                 Push(s);
                 state := after;
             | FALSE :         (*    /* ---        *)
                 Push(s);
                 state := inremark;
             ELSE ; (* //ISO fixed silly requirement *) END;
         | FALSE :
             CASE endhere OF   (*       --- */     ILLOGICAL! *)
             | TRUE :
             | FALSE :         (*       ---        *)
             ELSE ; (* //ISO fixed silly requirement *) END;
         ELSE ; (* //ISO fixed silly requirement *) END;
    | inremark :
         CASE beghere OF
         | TRUE :
             CASE endhere OF
             | TRUE :          (*    /* --- */     *)
                 Push(s);
             | FALSE :         (*    /* ---        *)
                 InitStack();
                 Push(s);
             ELSE ; (* //ISO fixed silly requirement *) END;
         | FALSE :
             CASE endhere OF
             | TRUE :          (*      --- */      *)
                 Push(s);
                 state := after;
             | FALSE :         (*      ---         *)
                 Push(s);
             ELSE ; (* //ISO fixed silly requirement *) END;
         ELSE ; (* //ISO fixed silly requirement *) END;
    | after :
         CASE beghere OF
         | TRUE :
             CASE endhere OF
             | TRUE :          (*    /* --- */     *)
                 InitStack();
                 Push(s);
                 state := after; (* keep same state! *)
             | FALSE :         (*    /* ---        *)
                 InitStack();
                 Push(s);
                 state := inremark;
             ELSE ; (* //ISO fixed silly requirement *) END;
         | FALSE :
             CASE endhere OF
             | TRUE :          (*       --- */     ILLOGICAL! *)
                 Push(s);
             | FALSE :         (*       ---        *)
                 Push(s);
             ELSE ; (* //ISO fixed silly requirement *) END;
         ELSE ; (* //ISO fixed silly requirement *) END;
    ELSE ; (* //ISO fixed silly requirement *) END;
END ProcessREM;

(* ------------------------------------------------------------ *)

PROCEDURE IsBlank (c : CHAR) : BOOLEAN;
CONST
    Blanks = cr+lf+tabul+blank;
BEGIN
    IF Str.CharPos(Blanks,c) = MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END IsBlank;

PROCEDURE IsDelimiter (c : CHAR) : BOOLEAN;
CONST
    Delimiters = "(),=+-*<>/\[]^:;."; (* //FIXED V11C removed "_" *)
BEGIN
    IF Str.CharPos(Delimiters,c) = MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END IsDelimiter;

(* filename is already in upper case *)
(* this is a VERY VERY VERY QUICK & DIRTY procedure *)

PROCEDURE Process (modfile : pathtype;
                   keepREM,skipCR,verbose,relax,genlist,dbg : BOOLEAN;
                   listwidth : CARDINAL);
CONST
    sImplementation= "IMPLEMENTATION";
    sModule 	   = "MODULE";
    openparen 	   = "(";
    closeparen 	   = ")";
    sDefinition    = "DEFINITION";
    enddef         = "END";
    frommod        = "FROM ";
    importproc     = " IMPORT";
VAR
    S:str256;
    deffile : pathtype;
    impfile : pathtype;
    line    : str256;
    procname : str256;
    token : str256;
    wordpos : CARDINAL;
    header : str256;
    p      : CARDINAL;
    flagIN : BOOLEAN;
    liste : str4096; (* //V11B was str1024, was not always enough ! *)
    msg:str128;
    hndi,hndo:FIO.File;
BEGIN

    Str.Concat(msg,"Processing ",modfile);
    video(msg,TRUE);

    Str.Copy(liste,"");

    handlebak(deffile,  modfile,extDEF);

    hndi := FIO.OpenRead(modfile);
    FIO.AssignBuffer(hndi,IObufferIn);
    hndo:= FIO.Create(deffile);
    FIO.AssignBuffer(hndo,IObufferOut);

    (* ------------------------------------------------------------ *)

    (*
    assume here very, very, very basic code structure!!! ;-)
    absolutely no error checking for bad structure!!!
    assume source file is relatively correct -- no systematic EOF check
    *)

    (* if relax TRUE, do not take implementation into account *)
    LOOP
        FIO.RdStr(hndi,header);
        IF FIO.EOF = TRUE THEN EXIT; END;
        (* find IMPLEMENTATION MODULE line *)
        IF Appears(header,sModule,p) THEN
            CASE relax OF
            | TRUE :
                 (* write DEFINITION MODULE line *)
                 Str.Prepend (header,sDefinition+blank);
                 FIO.WrStr(hndo,header);
                 FIO.WrLn(hndo);
                 FIO.WrLn(hndo);
                 EXIT;
            | FALSE :
                 IF Appears(header,sImplementation,p) THEN
                     (* write DEFINITION MODULE line *)
                     Str.Subst (header,sImplementation,sDefinition);
                     FIO.WrStr(hndo,header);
                     FIO.WrLn(hndo);
                     FIO.WrLn(hndo);
                     EXIT;
                 END;
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    IF keepREM = TRUE THEN InitStack(); END;
    LOOP
        FIO.RdStr(hndi,line);
        IF FIO.EOF = TRUE THEN EXIT; END;
        IF keepREM = TRUE THEN ProcessREM(line); END;
        (* find PROCEDURE line *)
        IF Appears(line,procedure,p) THEN
            Str.Copy(procname,line);
            IF keepREM = TRUE THEN
                 IF skipCR = TRUE THEN FIO.WrLn(hndo); END;
                 Dump(hndo); (* includes PROCEDURE line too *)
            ELSE
                 FIO.WrStr(hndo,line);
                 FIO.WrLn(hndo);
            END;
            Str.Subst(line,pragma1,""); (* avoid confusion! *)
            Str.Subst(line,pragma2,"");
            Str.Subst(line,openREM,""); (* q&d hack as not to confuse openREM with ( but not guaranteed! *)
            (* q&d check for procedures with parameters! *)
            IF Appears(line,openparen,p) THEN
                (* find next closeparen... and hope there's no comment in line! *)
                LOOP
                    Str.Subst(line,closeREM,""); (* q&d hack as not to confuse closeREM with ) but not guaranteed! *)
                    IF Appears(line,closeparen,p) THEN EXIT; END;
                    FIO.RdStr(hndi,line);
                    FIO.WrStr(hndo,line);
                    FIO.WrLn(hndo);
                END;
                (* last closeparen was found at p in line, now find last semicolon *)
                Str.Delete(line,0,p+1); (* 1 is ) len *)
                LOOP
                    IF Appears(line,semicolon,p) THEN EXIT; END;
                    FIO.RdStr(hndi,line);
                    FIO.WrStr(hndo,line);
                    FIO.WrLn(hndo);
                END;
            ELSE
                (* here, PROCEDURE without openparen, therefore find last semicolon *)
                (* assume logical layout!!! *)
                LOOP
                    IF Appears(line,semicolon,p) THEN EXIT; END;
                    FIO.RdStr(hndi,line);
                    FIO.WrStr(hndo,line);
                    FIO.WrLn(hndo);
                END;
            END;
            IF skipCR = FALSE THEN FIO.WrLn(hndo); END;

            (* here we should read till the end of the PROCEDURE *)
            (* but check first for special case of PROCEDURE IN *)

            flagIN := TokenAppears(procname,"IN");

            p:= Str.Pos(procname,procedure);
            Str.Delete(procname,0,p+Str.Length(procedure));
            (* retrieve token right after PROCEDURE *)
            Str.Item(procname,procname,Filter,0);
            (* add it to future import list *)
            Str.Append(liste,blank);
            Str.Append(liste,procname);
            Str.Append(liste,comma);
            IF verbose THEN
                video(msg,FALSE);
                WrStr("    "); WrStr(procname); WrLn;
                video(msg,TRUE);
            END;
            IF flagIN = FALSE THEN
                LOOP
                    FIO.RdStr(hndi,line);
                    IF FIO.EOF THEN EXIT; END;
                    Str.Item(token,line,Filter,0); (* try END *)
                    Str.Item(line,line,Filter,1); (* try procname *)
                    IF Str.Compare(token,enddef)=0 THEN
                       IF Str.Compare(line,procname)=0 THEN EXIT; END; (* end proc *)
                    END;
                END;
            END;
        END;
    END;
    IF skipCR = TRUE THEN FIO.WrLn(hndo); END;
    Str.Subst(header,sDefinition,"");
    Str.Subst(header,sModule,enddef);
    Str.Subst(header,semicolon,dot);
    Ltrim(header,blank);
    (* write END line *)
    FIO.WrStr(hndo,header);
    FIO.WrLn(hndo);
    FIO.WrLn(hndo);

    (* generate here in a comment the FROM module IMPORT procs *)

    Str.Subst(header,enddef,"");
    Str.Subst(header,dot,"");
    Ltrim(header,blank);
    Rtrim(header,blank);

    FIO.WrStr(hndo,openREM);
    FIO.WrLn(hndo);
    IF skipCR=FALSE THEN FIO.WrLn(hndo);END;

    (* reverse order *)
    Str.Prepend(liste,importproc);
    Str.Prepend(liste,header);
    Str.Prepend(liste,frommod);
    p:=Str.RCharPos(liste,comma);
    IF p # MAX(CARDINAL) THEN
        liste[p] := semicolon;
    END;
    DmpTTX(hndo,liste,listwidth);

    IF skipCR=FALSE THEN FIO.WrLn(hndo); END;
    FIO.WrStr(hndo,closeREM);
    FIO.WrLn(hndo);

    (* ------------------------------------------------------------ *)

    FIO.Flush(hndo);
    FIO.Close(hndi);
    FIO.Close(hndo);

    video(msg,FALSE);

    Str.Concat(S,"Created "+vbar+vbar+" from ",modfile);
    Str.Subst(S,vbar,deffile);
    IF genlist THEN
        handlebak (impfile, modfile,extIMP);

        hndo:= FIO.Create(impfile);
        FIO.AssignBuffer(hndo,IObufferOut);

        FIO.WrLn(hndo);
        DmpTTX(hndo,liste,listwidth);
        FIO.WrLn(hndo);

        FIO.Flush(hndo);
        FIO.Close(hndo);

        Str.Subst(S,vbar," and "+vbar);
        Str.Subst(S,vbar,impfile);
    ELSE
        Str.Subst(S,vbar,"");
    END;
    WrStr(S);WrLn;
END Process;

(* ------------------------------------------------------------ *)

VAR
    parmcount,i,opt   : CARDINAL;
    S           : pathtype;
    flagREM, flagPack, flagVerbose, flagForce, flagLIST : BOOLEAN;
    DEBUG    : BOOLEAN;
    filespec : pathtype;
    unit     : str16; (* 2 chars *)
    path     : str128;
    f8       : pathtype;
    e3       : str16; (* 4 chars *)
    tmpunit  : str16; (* 2 chars *)
    tmppath  : pathtype;
    zewidth  : CARDINAL;
    clistate : (waitingspec,gotspec);
VAR
    filename  : ARRAY [firstFile..maxFile] OF pathtype;
    fileCount : CARDINAL;
    found     : BOOLEAN;
    Entry     : FIO.DirEntry;
BEGIN
    FIO.IOcheck := FALSE;

    WrLn;

    flagREM     := FALSE;
    flagPack    := FALSE;
    flagVerbose := FALSE;
    flagForce   := FALSE;
    flagLIST    := TRUE;
    zewidth     := defaultwidth;
    DEBUG       := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort (errHelp,""); END;

    clistate := waitingspec;
    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        cleantabs(S);
        IF isOption(S) THEN
            UpperCase (S);
            opt := GetOptIndex (S,"?"+delim+"H"+delim+"HELP"+delim+
                                  "R"+delim+"REM"+delim+"REMARK"+delim+
                                  "P"+delim+"PACK"+delim+"NOCR"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "F"+delim+"FORCE"+delim+
                                  "W:"+delim+"WIDTH:"+delim+
                                  "L"+delim+"LIST"+delim+"I"+delim+"IMPORT"+delim+
                                  "DEBUG");
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5,6 : flagREM     := TRUE;
            | 7,8,9 : flagPack    := TRUE;
            | 10,11 : flagVerbose := TRUE;
            | 12,13 : flagForce   := TRUE;
            | 14,15 : IF GetCardinal(zewidth,S)=FALSE THEN abort(errBadValue,S);END;
                      IF (zewidth < minWidth) OR (zewidth > maxWidth) THEN abort(errBadRange,S); END;
            | 16,17,18,19:
                      flagLIST    := FALSE;
            | 20:     DEBUG       := TRUE;
            ELSE
                Lib.ParamStr(S,i); (* retrieve org parm *)
                abort(errUnknown,S);
            END;
        ELSE
            CASE clistate OF
            | waitingspec:
                UpperCase (S);
                IF same(S,"?") THEN abort(errHelp,"");END;
                IF same(S,".") THEN S:="*"+extMOD;END;
                Str.Copy (filespec, S);
                IF Str.CharPos(filespec,dot)=MAX(CARDINAL) THEN
                    Str.Append(filespec,extMOD);
                END;
                INC(clistate);
            | gotspec:
                abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
        END;
    END;
    IF clistate=waitingspec THEN abort(errMissingSpec,""); END;

    fileCount := 0;
    found := FIO.ReadFirstEntry(filespec,FIO.FileAttr{},Entry);
    WHILE found DO
        IF fileCount = maxFile THEN abort(errTooManyFiles,filespec); END;
        qdSplitAllPath(Entry.name,tmpunit,tmppath,f8,e3);
        i:=0;
        IF Str.Match(Entry.name,"*"+extDEF) THEN INC(i);END;
        IF Str.Match(Entry.name,"*"+extIMP) THEN INC(i);END;
        IF i = 0 THEN
            INC (fileCount);
            filename[fileCount]:=pathtype(Entry.name);
        END;
        found := FIO.ReadNextEntry(Entry);
    END;
    IF fileCount = 0 THEN abort (errNoMatchFile,filespec); END;

    FOR i := firstFile TO fileCount DO
        Str.Concat(S,unit,path);
        Str.Append(S,filename[i]);
        Process(S,flagREM,flagPack,flagVerbose,flagForce,flagLIST,DEBUG,zewidth);
    END;

    abort(errNone,"");
END MakeDEF32.


