@echo off

set _DMY_=1/2/2018
set _HMS_=19:45:00

set _DMY_=1/2/2019
set _HMS_=0:0:00

set _DMY_=1/2/2021
set _HMS_=19:45:00

set _DMY_=1/2/2024
set _HMS_=19:45:00

echo.
echo ::: Here is current directory :
echo.
CD
echo.
echo ::: Now, please hit (almost) any key to pack SRCXDS from here,
echo ::: or hit Ctrl-C or Ctrl-Break in order to abort installation.
echo.
pause
echo.

copy install.bat setup.bat

if exist procthem.bat del procthem.bat
if exist delthem.bat  del delthem.bat
if exist *.zip        del *.zip

rem note WITH requires F8E3 !

rem with -e -s -v *.exe       "$c /? > $u$d$n.doc"
dirbat      -s -v *.exe       "$c /? > $u$d$n.doc"
if exist procthem.bat call procthem
if exist procthem.bat del  procthem.bat

rem more help for programs supporting this feature

wipefilw\wipefile32 /??    > wipefilw\wipefile32.doc
gematr32\gematria32 /??    > gematr32\gematria32.doc

textgenw\textgen32  /???   > textgenw\textgen32.doc
dt32\dt32           /???   > dt32\dt32.doc

rem with -e -s -v *.doc "crlf /w $c"
dirbat      -s -v *.doc "crlf /w $c"
if exist procthem.bat call procthem
if exist procthem.bat del  procthem.bat

rem with -e -s -v -q *.bk! "del $u$d$f"
dirbat      -s -v    *.bk! "del $u$d$f"
if exist procthem.bat call procthem
if exist procthem.bat del  procthem.bat

touch *.* /s /d:%_DMY_% /t:%_HMS_%

REM DIRBAT *.* /d  "cd $n$_zip -r $n *.*$_move $n.zip ..$_cd.."

cd cs32
zip -r cs32 *.*
move cs32.zip ..
cd..
cd fcomp32
zip -r fcomp32 *.*
move fcomp32.zip ..
cd..
cd hdfree32
zip -r hdfree32 *.*
move hdfree32.zip ..
cd..
cd CONCAT32
zip -r CONCAT32 *.*
move CONCAT32.zip ..
cd..
cd crlf32
zip -r crlf32 *.*
move crlf32.zip ..
cd..
cd dt32
zip -r dt32 *.*
move dt32.zip ..
cd..
cd picdimsw
zip -r picdimsw *.*
move picdimsw.zip ..
cd..
cd PASPEEKW
zip -r PASPEEKW *.*
move PASPEEKW.zip ..
cd..
cd peek32
zip -r peek32 *.*
move peek32.zip ..
cd..
cd XTRACT32
zip -r XTRACT32 *.*
move XTRACT32.zip ..
cd..
cd fortunew
zip -r fortunew *.*
move fortunew.zip ..
cd..
cd QUIZYN32
zip -r QUIZYN32 *.*
move QUIZYN32.zip ..
cd..
cd textgenw
zip -r textgenw *.*
move textgenw.zip ..
cd..
cd mod2htmw
zip -r mod2htmw *.*
move mod2htmw.zip ..
cd..
cd ISOCASEW
zip -r ISOCASEW *.*
move ISOCASEW.zip ..
cd..
cd lcount32
zip -r lcount32 *.*
move lcount32.zip ..
cd..
cd remmod32
zip -r remmod32 *.*
move remmod32.zip ..
cd..
cd yinyan32
zip -r yinyan32 *.*
move yinyan32.zip ..
cd..
cd oclock32
zip -r oclock32 *.*
move oclock32.zip ..
cd..
cd cal32
zip -r cal32 *.*
move cal32.zip ..
cd..
cd RESERVEW
zip -r RESERVEW *.*
move RESERVEW.zip ..
cd..
cd wipefilw
zip -r wipefilw *.*
move wipefilw.zip ..
cd..
cd WCOUNT32
zip -r WCOUNT32 *.*
move WCOUNT32.zip ..
cd..
cd XLAT32
zip -r XLAT32 *.*
move XLAT32.zip ..
cd..
cd gematr32
zip -r gematr32 *.*
move gematr32.zip ..
cd..
cd evenoddw
zip -r evenoddw *.*
move evenoddw.zip ..
cd..
cd everyn32
zip -r everyn32 *.*
move everyn32.zip ..
cd..
cd fixpe32
zip -r fixpe32 *.*
move fixpe32.zip ..
cd..
cd factor32
zip -r factor32 *.*
move factor32.zip ..
cd..
cd conv32
zip -r conv32 *.*
move conv32.zip ..
cd..
cd showhdnw
zip -r showhdnw *.*
move showhdnw.zip ..
cd..
cd prephdnw
zip -r prephdnw *.*
move prephdnw.zip ..
cd..
cd findhdnw
zip -r findhdnw *.*
move findhdnw.zip ..
cd..
cd fbench32
zip -r fbench32 *.*
move fbench32.zip ..
cd..
cd daymnthw
zip -r daymnthw *.*
move daymnthw.zip ..
cd..
cd dd32
zip -r dd32 *.*
move dd32.zip ..
cd..
cd pcopy32
zip -r pcopy32 *.*
move pcopy32.zip ..
cd..
cd total32
zip -r total32 *.*
move total32.zip ..
cd..
cd newlinew
zip -r newlinew *.*
move newlinew.zip ..
cd..
cd msaber32
zip -r msaber32 *.*
move msaber32.zip ..
cd..
cd elapsedw
zip -r elapsedw *.*
move elapsedw.zip ..
cd..
cd solar32
zip -r solar32 *.*
move solar32.zip ..
cd..
cd chryzo32
zip -r chryzo32 *.*
move chryzo32.zip ..
cd..
cd splinesw
zip -r splinesw *.*
move splinesw.zip ..
cd..
cd chkfrd32
zip -r chkfrd32 *.*
move chkfrd32.zip ..
cd..
cd tstisa32
zip -r tstisa32 *.*
move tstisa32.zip ..
cd..
cd pmatch32
zip -r pmatch32 *.*
move pmatch32.zip ..
cd..
cd ssort32
zip -r ssort32 *.*
move ssort32.zip ..
cd..
cd flip32
zip -r flip32 *.*
move flip32.zip ..
cd..
cd fu32
zip -r fu32 *.*
move fu32.zip ..
cd..
cd newnamew
zip -r newnamew *.*
move newnamew.zip ..
cd..
cd txtfmt32
zip -r txtfmt32 *.*
move txtfmt32.zip ..
cd..
cd byteprow
zip -r byteprow *.*
move byteprow.zip ..
cd..
cd makedefw
zip -r makedefw *.*
move makedefw.zip ..
cd..
cd duplinew
zip -r duplinew *.*
move duplinew.zip ..
cd..
cd fent32
zip -r fent32 *.*
move fent32.zip ..
cd..
cd oldnew32
zip -r oldnew32 *.*
move oldnew32.zip ..
cd..
cd yt2srt32
zip -r yt2srt32 *.*
move yt2srt32.zip ..
cd..
cd columnsw
zip -r columnsw *.*
move columnsw.zip ..
cd..
cd eeval32
zip -r eeval32 *.*
move eeval32.zip ..
cd..
cd go2hellw
zip -r go2hellw *.*
move go2hellw.zip ..
cd..
cd wolfru32
zip -r wolfru32 *.*
move wolfru32.zip ..
cd..
cd hms32
zip -r hms32 *.*
move hms32.zip ..
cd..
cd roman32
zip -r roman32 *.*
move roman32.zip ..
cd..
cd xcsv32
zip -r xcsv32 *.*
move xcsv32.zip ..
cd..
cd delims32
zip -r delims32 *.*
move delims32.zip ..
cd..

cd qd32
zip -r qd32 *.*
move qd32.zip ..
cd..
cd qd32src
zip -r qd32src *.*
move qd32src.zip ..
cd..



pcopy *.doc /s /p /r
concat help.txt *.doc /c /a /d /ff

touch *.zip /d:%_DMY_% /t:%_HMS_%
touch *.txt /d:%_DMY_% /t:%_HMS_%

arj a srcxds *.zip *.bat *.txt

goto end


:end
set _DMY_=
set _HMS_=
