(* ---------------------------------------------------------------
Title         see help !
Author        who cares ?
Overview      see help !
Usage         see help !
Notes         yes, we know, this is merely an oversized
              "copy /b f1+f2+f3..." then rename and delete
              but who cares ? ;-)

              concatenate from list ?

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              yes, yes, we know a few int $13 calls
              could be replaced with Win32 API calls

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
              -o

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
Bugs          Yet Another TopSpeed Bug : FIO.Append does not like binary !
              (seems to reposition at last ctrl-Z ! too lazy to check in
              ugly TS library sources)
Wish List     a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  3 Jul 20 v0.9a bugfix : flagcr would not be set with addcr
              buildBakName() would assume name always had a dot
	      increased maxfile to 2000 instead of 250
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG 27 Nov 15 an ugly really Q&D port from CONCAT for DOS
--------------------------------------------------------------- *)

MODULE concat32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT SYSTEM;

IMPORT IO;

FROM IO IMPORT WrLn,WrStr;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
CONST
    (* stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *) *)
    (* stderr        = FIO.ErrorOutput; *)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


CONST
    slashslash    = slash+slash;
    M2line        = "(* //------------------------------------------------------------// *)";
    ctrlZ         = CHR(26); (* silly legacy ! *)
    msgCreated    = "::: Created   : ";
    msgUpdated    = "::: Updated   : ";
    msgProcessed  = "::: Processed : ";
    sINFO         = "::: ";
    sPLUS         = "+ ";
    extBAK        = ".BK!";
    extCOM        = ".COM";
    extEXE        = ".EXE";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extZIP        = ".ZIP";
    extARJ        = ".ARJ";
    extLZH        = ".LZH";
    binextensions = extBAK+delim+extCOM+delim+extEXE+delim+
                    extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                    extZIP+delim+extARJ+delim+extLZH;
CONST
    progEXEname   = "CONCAT32";
    progTitle     = "Q&D Concatenate files (Win32)";
    progVersion   = "v0.9a (from 1.0q for DOS)";
    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errParm             = 3;
    errExpected         = 4;
    errJoker            = 5;
    errNotFound         = 6;
    errExtension        = 7;
    errROmain           = 8;
    errRO               = 9;
    errBinaryNonsense   = 10;
    errTooManyMatches   = 11;
    errExtensionMatch   = 12;
    errNonsenseSeparator= 13;
    errBadNum           = 14;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
banner+nl+
nl+
"Syntax 1 : "+progEXEname+" <mainfile> <file>... [option]..."+nl+
"Syntax 2 : "+progEXEname+" <mainfile> <file_specification> [option]..."+nl+
nl+
"This program appends specified file(s) to <mainfile>."+nl+
nl+
'  -l[l]   separate individual files with "'+slashslash+'" (-ll = M2 form)'+nl+
'  -f[f]   separate individual files with "'+slashslash+'"+filename (-ff = M2 form)'+nl+
"  -n      do not add CR+LF separator after each concatenated file"+nl+
"  -k      do not create backup for existing <mainfile>"+nl+
"  -s      do not update existing <mainfile> date/time stamp"+nl+
"  -d      delete <file>... when copy is done"+nl+
"  -c      create a new <mainfile> instead of appending data to existing one"+nl+
"  -z      do not filter out Ctrl-Z (ASCII code 26 = $1A) from files"+nl+
"  -b      binary mode (forced : -n and -z ; ignored : -l[l], -f[f] and -k)"+nl+
"  -m      ignore missing file(s)"+nl+
"  -a      sort filenames alphabetically before processing"+nl+
'  -z:[$]# process only files # bytes long ("$" prefix for hexadecimal)'+nl+
"  -p|-t   preview matching files processing order (no action taken)"+nl+
nl+
"a) Unless -b option was specified, these extensions will not be processed :"+nl+
"   "+binextensions+nl+
"b) When filtering out Ctrl-Z, <mainfile> will lose its trailing Ctrl-Z only."+nl+
"c) -a option ignores both case and accentuation."+nl+
"d) Syntax 1 does not support jokers, while syntax 2 does."+nl+
"e) Syntax 2 will process files in directory order (unless -a was specified) ;"+nl+
"   it will not process more than 2000 matching files."+nl+
"f) Note program will not handle files longer than 4 Gb."+nl+
"g) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" -f -s -m all one.txt two.txt three.txt"+nl+
"           "+progEXEname+" -a all.txt *.asc"+nl+
"           "+progEXEname+" -b -d all.bin *.tex -z:295360"+nl;

VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOption :    S:="Unknown ~ option !";
    | errParm :      S:="Uneeded ~ parameter !";
    | errExpected:   S:="Missing ~ parameter !";
    | errJoker:      S:="~ should not contain any joker !";
    | errNotFound:   S:="~ does not exist !";
    | errExtension:  S:="Reserved extension in ~ !";
    | errROmain:     S:="~ <mainfile> is Read-Only !";
    | errRO:         S:="~ <file> is Read-Only !";
    | errBinaryNonsense:S:="~ is a nonsense with -binary !";
    | errTooManyMatches:S:="Too many files match ~ !";
    | errExtensionMatch:S:="Reserved extension in expanded ~ !";
    | errNonsenseSeparator:S := "-l[l] and -f[f] options are mutually exclusive !";
    | errBadNum:     S:="Illegal ~ value !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp :
        ; (* nada *)
    ELSE
        Str.Subst(S,tilde,einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC; (* //XDS BYTE *)
VAR
    ioBufferIn,ioBufferOut : ioBufferType;

(* ------------------------------------------------------------ *)

CONST
    dataBufferSize = 32*512;
    firstDataByte  = 1-1;
    lastDataByte   = dataBufferSize-1;
TYPE
    dataBufferType = ARRAY [firstDataByte..lastDataByte] OF SYSTEM.LOC; (* //XDS BYTE *)
VAR
    dataBuffer : dataBufferType;

(* ------------------------------------------------------------ *)

TYPE
    fileoptype = (opCopy,opAppend);

(* assume target already exists for append file operation *)

PROCEDURE doFileOp (cmd:fileoptype;
                   addcr,addsep,addfilesep,M2remark,filterEOF,DEBUG:BOOLEAN;
                   source,target:pathtype);
CONST
    msgWorking = "Processing, please wait...";
VAR
    hin,hout:FIO.File;
    got,count,p,mult:CARDINAL;
    curreof:BOOLEAN;
    hdr:pathtype; (* should do *)
    wanted:SYSTEM.LOC; (* //XDS BYTE *)
    whereto,wherefrom:SYSTEM.ADDRESS;
    verbose:BOOLEAN;
    fsize:LONGCARD;
    Z:str1024;
BEGIN
        mult:=0;
        verbose:=TRUE;
IF DEBUG THEN verbose:=FALSE;END;
        curreof:=FIO.EOF; (* almost certainly useless but cannot harm *)

        IF verbose THEN video(msgWorking,TRUE); END;

        hin:=FIO.OpenRead(source);
        FIO.AssignBuffer(hin,ioBufferIn);

        CASE cmd OF
        | opCopy:
            hout:=FIO.Create(target);
        | opAppend:
            hout:=FIO.Open(target);
        ELSE
            ; (* //XDS YASIR ! *)
        END;
        FIO.AssignBuffer(hout,ioBufferOut);

        (* v1.0g fix for FIO.Append and possibly FIO.Create ! *)
        fsize:=FIO.Size(hout);
        FIO.Seek(hout,fsize);

IF DEBUG THEN
WrStr("//target fpos            = ");IO.WrLngCard( FIO.GetPos(hout),0);WrLn;
WrStr("//source filesize        = ");IO.WrLngCard( FIO.Size(hin) ,0);WrLn;
END;

        (* allow another separator ? bah... *)
        (* -1 required to avoid trailing $00 ! we could use Str.Length, though *)
        IF addcr THEN FIO.WrBin(hout,nl,SIZE(nl)-1); END;
        IF addsep THEN
            IF M2remark THEN
                Str.Concat(Z,M2line,nl);
                FIO.WrBin(hout,Z,Str.Length(Z));
            ELSE
                Str.Concat(Z,slashslash,nl);
                FIO.WrBin(hout,Z,Str.Length(Z));
            END;
        END;
        (* //V10M addsep and addfilesep mutually exclusive and checked by caller *)
        IF addfilesep THEN
            IF M2remark THEN
                hdr:='(* // ---------- "|" ---------- // *)';
            ELSE
                hdr:=slashslash+' "|"';
            END;
            Str.Prepend(hdr,nl+nl);
            Str.Append(hdr,nl+nl);
            Str.Subst(hdr,"|",source);
            FIO.WrBin(hout,hdr,Str.Length(hdr));
        END;

        FIO.EOF:=FALSE;
        LOOP
            got:=FIO.RdBin(hin,dataBuffer,dataBufferSize);
            IF got = 0 THEN EXIT; END;

IF DEBUG THEN
IF got = dataBufferSize THEN
    INC(mult);
ELSE
    WrStr("//last got               = ");IO.WrCard(got,0);WrLn;
END;
END;

            IF filterEOF THEN
                (* we know buffer is not empty *)
                wanted:=ORD(ctrlZ);
(* IF DEBUG THEN WrStr("//wanted    = ");IO.WrShtCard(wanted,0);WrLn; END; *)
                count:=got;
                LOOP
                    wherefrom := SYSTEM.ADR(dataBuffer);
IF DEBUG THEN
WrStr("//wherefrom = $");IO.WrLngHex( LONGCARD(wherefrom),8);WrLn;
WrStr("//count     = ");IO.WrCard(count,0);WrLn;
END;
                    p:=Lib.ScanR( wherefrom,count,wanted);
IF DEBUG THEN WrStr("//p         = ");IO.WrCard(p,0);WrLn; END;
                    IF p = count THEN
IF DEBUG THEN WrStr("//no ctrlz, we quit loop");WrLn; END;
                         EXIT;
                    END;
                    whereto   := SYSTEM.ADR( dataBuffer[p]);
                    wherefrom := SYSTEM.ADR( dataBuffer[p+1]);
IF DEBUG THEN
WrStr("//whereto   = $");IO.WrLngHex( LONGCARD(whereto),8);WrLn;
WrStr("//wherefrom = $");IO.WrLngHex( LONGCARD(wherefrom),8);WrLn;
WrStr("//n         = ");IO.WrCard(count-(p+1),0);WrLn;
WrStr("//move n bytes from wherefrom to whereto");WrLn;
END;
                    Lib.Move(wherefrom,whereto,count-p);
                    DEC(count);
IF DEBUG THEN WrStr("//new count = ");IO.WrCard(count,0);WrLn; END;
                    IF count=0 THEN
IF DEBUG THEN WrStr("//empty buffer, we quit loop");WrLn; END;
                        EXIT;
                    END;
                END;
                FIO.WrBin(hout,dataBuffer,count);
            ELSE
                FIO.WrBin(hout,dataBuffer,got);
            END;

            IF got # dataBufferSize THEN EXIT; END;
        END;

IF DEBUG THEN
WrStr("//dataBufferSize multiple= ");IO.WrCard(mult,0);WrStr(" * ");IO.WrCard(dataBufferSize,0); WrLn;
WrStr("//target fpos now        = ");IO.WrLngCard( FIO.GetPos(hout),0);WrLn;
END;
        FIO.Flush(hout);
        FIO.Close(hout);
        FIO.Close(hin);

        IF verbose THEN video(msgWorking,FALSE); END;

        FIO.EOF := curreof;
END doFileOp;

(* ------------------------------------------------------------ *)

PROCEDURE fixTrailingEOF (filterEOF:BOOLEAN; S:pathtype);
VAR
    hin : FIO.File;
    curreof : BOOLEAN;
    fsize : LONGCARD;
    b : SHORTCARD; (* byte *)
    got:CARDINAL;
BEGIN
    IF NOT(filterEOF) THEN RETURN; END;

    curreof:=FIO.EOF; (* almost certainly useless but cannot harm *)

    hin:=FIO.Open(S);
    FIO.AssignBuffer(hin,ioBufferIn);
    fsize:=FIO.Size(hin);
    IF fsize # 0 THEN
        FIO.Seek(hin,fsize-1);
        got:=FIO.RdBin(hin,b,SIZE(b));
        IF b = ORD(ctrlZ) THEN
            FIO.Seek(hin,fsize-1);
            FIO.Truncate(hin);
        END;
    END;
    FIO.Close(hin);

    FIO.EOF := curreof;
END fixTrailingEOF;

(* ------------------------------------------------------------ *)

TYPE
    dtoptype = (dtget,dtset);

PROCEDURE doStampOp (VAR stamp:LONGCARD; cmd:dtoptype;S:pathtype);
VAR
    hnd:FIO.File;
BEGIN
    hnd:=FIO.OpenRead(S);
    CASE cmd OF
    | dtget:
        stamp:=FIO.GetFileDate(hnd);
    | dtset:
        FIO.SetFileDate(hnd,stamp);
    ELSE
        ; (* //XDS YASIR ! *)
    END;
    FIO.Close(hnd);
END doStampOp;

PROCEDURE createEmptyFile (S:pathtype);
VAR
    hnd:FIO.File;
BEGIN
    hnd:=FIO.Create(S);
    FIO.Close(hnd);
END createEmptyFile;

(* assume S is already uppercased and yes we know it's not bullet-proof *)

PROCEDURE legalextension (S:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN

    Str.Caps(S); (* ah, lowercase LFNs... *)

    rc:=TRUE;
    n:=0;
    LOOP
        isoleItemS(e3, binextensions,delim,n);
        IF same(e3,"") THEN EXIT; END;
        IF Str.Pos(S,e3) # MAX(CARDINAL) THEN rc:=FALSE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END legalextension;

(* return TRUE if no dot in \f8.e3 part -- overkill ! *)

PROCEDURE needTrailingDot (S:ARRAY OF CHAR):BOOLEAN;
VAR
    u,d,n,e,ne:str128;
BEGIN
    qdSplitAllPath(S,u,d,n,e);
    Lib.MakeAllPath(ne,"","",n,e);
    RETURN Str.CharPos(ne,dot)=MAX(CARDINAL);
END needTrailingDot;

PROCEDURE buildBakName (VAR newname:ARRAY OF CHAR;
                       currentname,ext:ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    Str.Copy(newname,currentname);
    p:=Str.RCharPos(newname,dot);
    IF p # MAX(CARDINAL) THEN newname[p]:=nullchar; END; (* brutal ! *)
    Str.Append(newname,ext);
END buildBakName;

PROCEDURE strToLC (VAR v:LONGCARD;S:ARRAY OF CHAR   ):BOOLEAN;
VAR
    base:CARDINAL;
    ok:BOOLEAN;
BEGIN
    IF S[0]=dollar THEN
        Str.Delete(S,0,1);
        base:=16;
        Str.Caps(S); (* safety *)
    ELSE
        base:=10;
    END;
    v:=Str.StrToCard(S,base,ok);
    RETURN ok;
END strToLC;

(* ------------------------------------------------------------ *)

CONST
    firstparm = 1;
    maxparm   = 2000; (* was 32 until v1.0k why not 28, 6, 11, 100, 127 ? eh eh... *)
VAR
    parm:   ARRAY [firstparm..maxparm] OF pathtype;
    triparm:ARRAY [firstparm..maxparm] OF pathtype;
    useme:ARRAY[firstparm..maxparm] OF BOOLEAN;

PROCEDURE isReservedEntry (S : ARRAY OF CHAR) : BOOLEAN; (* assume uppercase *)
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    IF same(S,dotdot) THEN RETURN TRUE; END;
    RETURN FALSE;
END isReservedEntry;

(* yet another buildMatchList() variation but using parm[] *)

CONST
    TOOMANYMATCHES     = MAX(CARDINAL);
    RESERVEDEXTENSION  = MAX(CARDINAL)-1;
    FALSErequiredfsize = MAX(LONGCARD);

PROCEDURE expandMe (VAR lastparm:CARDINAL;
                   DEBUG,binary:BOOLEAN;
                   requiredfsize:LONGCARD;spec:pathtype);
VAR
    S,dirbase,u,d,n,e:pathtype;
    ok,rc,found:BOOLEAN;
    errcode:CARDINAL;
    DOSentry     : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    fsize:LONGCARD;
BEGIN
    DEC(lastparm); (* required here ! *)

    qdSplitAllPath(spec,u,d,n,e);
    Lib.MakeAllPath(dirbase,u,d,"","");
    fixDirectory(dirbase);
    IF DEBUG THEN
        WrStr("//dirbase : ");WrStr(dirbase);WrLn;
        WrStr("//spec    : ");WrStr(spec);WrLn;
    END;
        IF DEBUG THEN WrStr("//f8e3");WrLn;END;
        found := FIO.ReadFirstEntry(spec,everything,DOSentry);
    IF DEBUG THEN
        IF found THEN WrStr("//first found");WrLn;END;
    END;
    WHILE found DO
        Str.Copy(S,DOSentry.name); (* //XDS it's Name, not name in JPI TS ! *)
        IF DEBUG THEN WrStr("//entry   : ");WrStr(S);WrLn;END;
        IF isReservedEntry(S) THEN (* skip "." ".." *)
            ; (* silently ignore this spec *)
        ELSE
            dosattr:=DOSentry.attr;
            fsize  :=DOSentry.sizeL;
            IF requiredfsize = FALSErequiredfsize THEN
                ok:=TRUE;
            ELSE
                ok:=(fsize = requiredfsize);
            END;
            ok:=( ok AND (NOT(aDD IN dosattr)) );
            IF ok THEN
                INC(lastparm);
                IF lastparm > maxparm THEN
                    lastparm:= TOOMANYMATCHES;
                    RETURN;
                END;
                IF binary=FALSE THEN
                     IF legalextension(S)=FALSE THEN
                         lastparm := RESERVEDEXTENSION;
                         RETURN;
                     END;
                END;
                Str.Prepend(S,dirbase);
                parm[lastparm]:=S;
            END;
        END;
        found :=FIO.ReadNextEntry(DOSentry);
    END;
END expandMe;

(* ------------------------------------------------------------ *)

PROCEDURE doswap (i,j:CARDINAL);
VAR
    SI,SJ:pathtype;
BEGIN
    SI:=triparm[i];
    SJ:=triparm[j];
    triparm[i]:=SJ;
    triparm[j]:=SI;
END doswap;

PROCEDURE dolessname (i,j:CARDINAL ):BOOLEAN ;
VAR
    SI,SJ: pathtype ;
BEGIN
    SI:=triparm[i];
    SJ:=triparm[j];
    LowerCase(SI); (* ignore accents when sorting *)
    LowerCase(SJ);
    IF Str.Compare(SI,SJ) < 0 THEN (* -1 is less *)
        RETURN TRUE;
    ELSE
        RETURN FALSE;
    END;
END dolessname;

PROCEDURE tri (lastparm:CARDINAL);
VAR
    i:CARDINAL;
BEGIN
    FOR i:=firstparm+1 TO lastparm DO
         triparm[i-1]:=parm[i];
    END;
    Lib.QSort(lastparm-1,dolessname,doswap);
    FOR i:=firstparm TO lastparm-1 DO
         parm[i+1]:=triparm[i];
    END;
END tri;

PROCEDURE showlist (lastparm:CARDINAL );
VAR
    i:CARDINAL;
BEGIN
    WrStr(sINFO+"File ");
    WrStr(parm[firstparm]);WrLn;
    WrStr(sINFO+"would be created from concatenating these files :");WrLn;
    WrLn;
    FOR i:=firstparm+1 TO lastparm DO
        WrStr(sPLUS);WrStr(parm[i]);WrLn;
    END;
    WrLn;
    WrStr(sINFO+"Because of preview mode, no file was modified.");WrLn;
END showlist;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    S,R : pathtype;
    i,opt,parmcount:CARDINAL;
    lastparm:CARDINAL;
    targetcreated,flagcr,flagsep,flagfilesep,M2remark,alphasort:BOOLEAN;
    verbose,addcr,keepbackup,keepstamp,killglued,binary,mustexist:BOOLEAN;
    useseparator,usefileseparator:BOOLEAN;
    recreatemain,bornagain,filterEOF,preview:BOOLEAN;
    requiredfsize:LONGCARD;
    sval:str16;
    DEBUG : BOOLEAN;
    optK:BOOLEAN;
    stamp:LONGCARD;
    target,backup:pathtype;
BEGIN
    FIO.IOcheck := FALSE;
    WrLn;

    keepbackup :=TRUE;  optK:=FALSE;
    keepstamp  :=FALSE;
    killglued  :=FALSE;
    addcr      :=TRUE;
    verbose    :=TRUE;
    useseparator :=FALSE;
    usefileseparator:=FALSE;
    M2remark     :=FALSE;
    targetcreated:=FALSE;
    recreatemain :=FALSE;
    binary       :=FALSE;
    mustexist    :=TRUE;
    filterEOF    :=TRUE;
    preview      :=FALSE;
    alphasort    :=FALSE;
    requiredfsize:=FALSErequiredfsize;
    DEBUG        :=FALSE; (* TRUE to check damn Lib.Scan/Lib.Move which doesn't like small model ! *)

    lastparm := firstparm-1; (* 1.. *)

    parmcount := Lib.ParamCount();

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "K"+delim+"BACKUP"+delim+
                                  "S"+delim+"STAMP"+delim+
                                  "D"+delim+"DELETE"+delim+
                                  "O"+delim+"OVERWRITE"+delim+
                                  "N"+delim+"CRLF"+delim+"NEWLINE"+delim+
                                  "Q"+delim+"QUIET"+delim+
                                  "L"+delim+"DASH"+delim+
                                  "C"+delim+"CREATE"+delim+
                                  "Z"+delim+"EOF"+delim+"CTRLZ"+delim+
                                  "B"+delim+"BINARY"+delim+
                                  "M"+delim+"MISSING"+delim+
                                  "X"+delim+"LFN"+delim+
                                  "LL"+delim+
                                  "P"+delim+"PREVIEW"+delim+
                                  "F"+delim+"REM"+delim+
                                  "FF"+delim+
                                  "A"+delim+"ALPHA"+delim+"SORT"+delim+
                                  "T"+delim+"TEST"+delim+
                                  "Z:"+delim+"SIZE:"+delim+"FILESIZE:"+delim+
                                  "DEBUG"
                              );
            CASE opt OF
            | 1,2,3:    abort(errHelp,"");
            | 4,5:      keepbackup   :=FALSE; (* -K *) optK:=TRUE;
            | 6,7:      keepstamp    :=TRUE;
            | 8,9:      killglued    :=TRUE;
            | 10,11:    ;
            | 12,13,14: addcr        :=FALSE; (* -N *)
            | 15,16:    verbose      :=FALSE;
            | 17,18:    useseparator :=TRUE;  (* -L[L] *)
            | 19,20:    recreatemain :=TRUE;
            | 21,22,23: filterEOF    :=FALSE; (* -Z *)
            | 24,25:    binary       :=TRUE;
            | 26,27:    mustexist    :=FALSE;
            | 28,29:    ;
            | 30:       useseparator :=TRUE;    M2remark:=TRUE; (* -LL *)
            | 31,32:    preview      :=TRUE;
            | 33,34:    usefileseparator:=TRUE;
            | 35:       usefileseparator:=TRUE; M2remark:=TRUE; (* -ff *)
            | 36,37,38: alphasort    :=TRUE;
            | 39,40:    preview      :=TRUE; (* -t = -p *)
            | 41,42,43: GetString(R,sval);
                        IF strToLC(requiredfsize,sval)=FALSE THEN abort(errBadNum,S);END;
            | 44:       DEBUG        :=TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            INC(lastparm); IF lastparm > maxparm THEN abort(errParm,S);END;
            IF same(S,dot) THEN S:=stardotstar;END;
            Str.Copy(parm[lastparm],S); (* keep original case *)
        END;
    END;

    CASE lastparm OF
    | firstparm-1 : abort(errHelp,"");
    | firstparm   : abort(errExpected,"<file>...");
    | firstparm+1 : Str.Copy(S,parm[lastparm]);
                    IF chkJoker (S) THEN
                        expandMe(lastparm,DEBUG,binary,requiredfsize,S);
                        CASE lastparm OF
                        | TOOMANYMATCHES : abort(errTooManyMatches,S);
                        | RESERVEDEXTENSION: abort(errExtensionMatch,S);
                        ELSE
                            ; (* //XDS YASIR ! *)
                        END;
                        IF alphasort THEN tri(lastparm);END;
                        IF preview THEN
                            showlist(lastparm);
                            abort(errNone,"");
                        END;
                    END;
    ELSE
        IF alphasort THEN tri(lastparm); END;
        IF preview THEN
            showlist(lastparm);
            abort(errNone,"");
        END;
    END;

    bornagain:=FALSE;
    FOR i:= firstparm TO lastparm DO
        useme[i]:=TRUE; (* default *)
        Str.Copy(S,parm[i]);
        IF needTrailingDot(S) THEN Str.Append(S,dot);END;
        IF chkJoker(S) THEN abort(errJoker,S);END;
        IF binary=FALSE THEN
            IF legalextension(S)=FALSE THEN abort(errExtension,S);END;
        END;
        CASE FIO.Exists(S) OF
        | TRUE:
            CASE i OF
            | firstparm:
                IF recreatemain THEN
                    IF fileIsRO(S) THEN abort(errROmain,S); END;
                    bornagain:=TRUE;
                END;
                fixTrailingEOF(filterEOF,S); (* v1.0j ugly fix *)
            ELSE
                ; (* //XDS YASIR ! *)
            END;
            IF fileIsRO(S) THEN
                CASE i OF
                | firstparm:
                    abort(errROmain,S);
                ELSE
                    IF killglued THEN
                        abort(errRO,S);
                    END;
                END;
            END;
            (* recheck for individual parms *)
            IF requiredfsize # FALSErequiredfsize THEN
                IF getFileSize(S) # requiredfsize THEN useme[i]:=FALSE;END;
            END;
        | FALSE:
            CASE i OF
            | firstparm :
                createEmptyFile(S); (* 0-length *)
                targetcreated := TRUE;
                keepbackup :=FALSE;
                keepstamp  :=FALSE;
            ELSE
                IF mustexist THEN
                    abort(errNotFound,S);
                ELSE
                    useme[i]:=FALSE;
                END;
            END;
        ELSE
            ; (* //XDS YASIR ! *)
        END;
    END;

    (* ok, let's go now *)

    IF (useseparator AND usefileseparator) THEN abort(errNonsenseSeparator,"");END;

    IF binary THEN
        IF optK        =TRUE THEN abort(errBinaryNonsense,"-k"); END;
        IF useseparator=TRUE THEN abort(errBinaryNonsense,"-l[l]"); END;
        IF usefileseparator=TRUE THEN abort(errBinaryNonsense,"-f[f]");END;

        keepbackup   := TRUE;       (* -K ignored *)
        addcr        := FALSE;      (* -N forced *)
        useseparator := FALSE;      (* -L[L] ignored *)
        usefileseparator:=FALSE;    (* -F[F] ignored *)
        M2remark     := FALSE;      (* useless *)
        filterEOF    := FALSE;      (* -Z forced *)
    END;

    Str.Copy(target,parm[firstparm]);

    IF (keepstamp OR keepbackup) THEN doStampOp(stamp,dtget,target);END;
    IF keepbackup THEN
        buildBakName(backup, target,extBAK);
        (* hard coded falses *)
        doFileOp(opCopy,FALSE,FALSE,FALSE,FALSE,FALSE,DEBUG,target, backup); (* backup must not change here ! *)
        doStampOp(stamp,dtset,backup);
    END;

    IF bornagain THEN
        createEmptyFile(target);
        targetcreated:=TRUE;
    END;

    FOR i:=firstparm+1 TO lastparm DO
        IF useme[i] THEN
            Str.Copy(S,parm[i]);

            CASE i OF
            | firstparm+1 :
                IF targetcreated THEN
                    flagcr :=FALSE; (* don't prepend first file with useless separator *)
                    flagsep:=FALSE;
                ELSE
                    flagcr :=addcr;
                    flagsep:=useseparator;
                END;
            ELSE
                flagcr :=addcr; (* //V10T //V09A *)		
                flagsep:=useseparator;
            END;
            (* //V1.0M this is ugly but conflict checked supra and who cares about elegance ? *)
            flagfilesep:=usefileseparator;
            IF flagfilesep THEN
                flagcr :=addcr;
                flagsep:=FALSE;
            END;

            doFileOp(opAppend,flagcr,flagsep,flagfilesep,M2remark,filterEOF,DEBUG,S, target);

            IF verbose THEN WrStr(msgProcessed);WrStr(S);WrLn; END;
            IF killglued THEN FIO.Erase(S); END; (* RO flag already cared for *)
        END;
    END;

    IF keepstamp THEN doStampOp(stamp,dtset,target);END;

    IF verbose THEN
        IF targetcreated THEN
            WrStr(msgCreated);
        ELSE
            WrStr(msgUpdated);
        END;
        WrStr(target);WrLn;
    END;

    abort(errNone,"");
END concat32.




