(* ---------------------------------------------------------------
Title         Q&D Fortune Cookie
Author        PhG
Overview      another useless program
Notes         minimal error messages and checking, etc.
              too many globerks... ;-)

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      	  -ww
	     	  -m
		      -i:#
		      -p:#
	    	  -b
              -s[s]
		      -s:#
		      -m:#
              -z
	    	  -r
		      -c
		      -y
              -lfn

              see XDS, //XDSTS and //FIXME
	    	  DOS limits left here as they are in DOS code

              thanks to ISOCASE !
		      now, we would need a tool able to check whether variables are used or not

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


Bugs          when building an index, cookies count is always count-1
              (eof is not seen as terminator)
              bah, who cares ? not even me, now...
              just warn about trailing separator needed ! check with -t[t]
	      	  (use CRLF[32] to fix such files)
              huge fortune files require more than a TS CARDINAL...
              but it's better to split them anyway

		  	  new XDS TopSpeed compatibility kit bugs !!!

		      trying to port FORTUNE v1.2 code was a nightmare
			  as well as a complete waste of time : XDS crap compiler does NOT read nor write
			  reliably a simple header structure, always randomly corrupting its last member :

			  TYPE
  			      indexHeaderType = RECORD
  		          magic             : ARRAY[0..6] OF CHAR; (* 7 bytes *)
		          TAGLINEMODE       : CARD8;  (* 1 byte *)
		          MOSTRECENTCOOKIE  : CARD16; (* 2 bytes -- can be NOCOOKIEYET *)
		          COUNTOFCOOKIES    : CARD32; (* 4 bytes -- cardinal would do but so we can easily update prev 1.2 indexes *)
 		      END;

			  even worse, it would always return 16 as SIZE() while it *is* 14 bytes !!!

			  I got fed up trying to find a hack in order to fix this !
			  eh, XDS guys, the TopSpeed Compatibility Kit was an inside private joke, wasn't it ?

			  no wonder no one uses Modula-2 nowadays... :-(



Wish List     are we kidding ? ah ah, only serious !

              run from readonly device ? bof...
              a more clever sentence concatenation ? bof... (bis)
              resist improving, for we'd rewrite the whole stuff !

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  3 Nov 17 v0.9b changed .NDX to .DEX so DOS and Win32 indexes are no longer compatible
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG  1 Apr 16 v0.9a changed default /f:# parameter from 0 to 2
              added -ww and -pp
PhG 16 Mar 16 an ugly really Q&D port from FORTUNE v1.1j for DOS
--------------------------------------------------------------- *)

MODULE Fortune32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT BiosIO;
IMPORT MsMouse;

IMPORT IO;

FROM IO IMPORT WrStr,WrLn,WrChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ProgEXEname   = "FORTUNE32";
    ProgTitle     = "Q&D Fortune Cookies (Win32)";
    ProgVersion   = "v0.9b (from v1.1j for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extEXE        = ".EXE";
    extTXT        = ".TXT";
    extNDX        = ".DEX"; (* no longer ".NDX" as of v0.9b *)
	extNDXDOS	  = ".NDX";

    extBAK        = ".BK!";
    extCOM        = ".COM";
    extDLL        = ".DLL";
    extOVR        = ".OVR";
    extOVL        = ".OVL";
    extDRV        = ".DRV";
    extSYS        = ".SYS";
    extBIN        = ".BIN";
    extBAT        = ".BAT";
    extensions    = extBAK+delim+extCOM+delim+extEXE+delim+extBAT+delim+
                    extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                    extSYS+delim+extBIN+delim+extNDXDOS+delim+extNDX;
CONST
    cmdANSI       = 033C+"["; (* CHR(27)+"["; (* ANSI.SYS command *) *)
CONST
    ALREADYDUMPEDCOOKIE        = MAX(LONGCARD);  (* impossible fpos will do for "already dumped" flag *)
    SHOWRANDOMCOOKIE   = MAX(CARDINAL);

    minCookie     = 0;              (* will contain count of cookies *)
    countCookie   = minCookie;      (* alias *)
    firstCookie   = minCookie+1;    (* 1.. *)
    maxCookie     = MAX(SYSTEM.CARD16)-2; (* -2 ..65533, was MAX(CARDINAL) DIV SIZE(LONGCARD)-2 *)

    sMAX          = "65533rd";
VAR
    (* YAUG -- Yet Another Ugly Globerk *)
    (* we split fpos LONGCARD to 4 bytes : yes, we're NOT proud of it *)
    (*
    entryA : ARRAY [minCookie..maxCookie] OF SHORTCARD;
    entryB : ARRAY [minCookie..maxCookie] OF SHORTCARD;
    entryC : ARRAY [minCookie..maxCookie] OF SHORTCARD;
    entryD : ARRAY [minCookie..maxCookie] OF SHORTCARD;
    *)
    entry  : ARRAY [minCookie..maxCookie] OF LONGCARD;
TYPE
    tricktype = RECORD
        CASE : BOOLEAN OF
        | TRUE:
            a,b,c,d:SHORTCARD; (* 4 bytes *)
        | FALSE:
            lc:LONGCARD;       (* 4 bytes too -- surprise ! *)
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    str144 = ARRAY [0..144-1] OF CHAR; (* 128+16 just in case *)
CONST
    firstline  = 1;
    maxline    = 100; (* was 64, should be more than enough *)
VAR
    (* globerk'em the BASIC way ! ;-) but avoid compiling crash too ! *)
    sline  : ARRAY [firstline..maxline] OF str144; (* was str128 *)
    slen   : ARRAY [firstline..maxline] OF CARDINAL;
    lastline  : CARDINAL;
    longest   : CARDINAL;
CONST
    frameNone   = 0;
    frameSingle = 1;
    frameDouble = 2;
    frameAscii  = 3;
    frameRaw    = 4;
    minframe    = frameNone;
    maxframe    = frameRaw;
    msgWait       = "Hit any key to continue... ";
    msgWaitFR     = "Appuyez sur une touche pour continuer... ";
CONST
    minpause     = 0;
    maxpause     = 30;
    defaultpause = 1;
    defaultalwayspause  = 10; (* always pause 1 seconds PLUS # s per line *)
CONST
    (*            012345    this looks fine with a DOS editor, eh eh *)
    sSingle    = "ڳ";
    sDouble    = "ɺͼ";
    sAscii     = "+!++-+";
    sNone      = "      ";
CONST
    wiHORIZ    = 4; (* bar, space, ... , space, bar *)
    wiVERTI    = 4; (* line, filler, ... , filler, line *)
    wiHORIZalt = 2; (* space, ... , space *)
    wiVERTIalt = 2; (* filler, ... , filler *)

(* ------------------------------------------------------------ *)

PROCEDURE colorhelp ();
BEGIN
END colorhelp;

PROCEDURE colortext (ink,paper:CARDINAL );
BEGIN
END colortext;

(* ------------------------------------------------------------ *)

CONST
    errNone           = 0;
    errHelp           = 1;
    errOption         = 2;
    errParameter      = 3;
    errNotFound       = 4;
    errBadNumber      = 5;
    errNotFoundReally = 6;
    errNotInNormalMode= 7;
    errWidthRange     = 8;
    errTabRange       = 9;
    errPauseRange     = 10;
    errTooManyFiles   = 11;
    errCookieVal      = 12;
    errCookieRange    = 13;
    errNotWithMultifile=14;
    errCmdConflict    = 15;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
00000000011111111112222222222333333333344444444445555555555666666666677777777778
1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg=nl+
Banner+nl+
nl+
"Syntax : "+ProgEXEname+" [file["+extTXT+"]] [option]..."+nl+
nl+
"  -n:#   display cookie or tagline number # whatever its state (updated anyway)"+nl+
"  -i     reinit *"+extNDX+" index file (no cookie will be displayed twice in a cycle)"+nl+
"  -x[x]  show index statistics (-xx = alternate display)"+nl+
"  -t[t]  test for single character separator at start and at end of file"+nl+
"  -f:#   frame type (0=none, 1=single, 2=double, 3=ascii, 4=raw), default is 2"+nl+
"  -w[w]  wait for keypress (-ww = -w -n)"+nl+
"  -p[p]  -w[w] with French prompt (-pp = -p -n)"+nl+
"  -n     add a newline (CR+LF) in order to beautify display (useful with PEXEC)"+nl+
"  -t:#   tab width [1..64], default is 8"+nl+
"  -o     reverse 8+3 format directory search sequence (current then executable)"+nl+
"  -w:#   set line width, default is 79"+nl+
"  -13    apply ROT13 to each line"+nl+
nl+
'a) Default data file is "'+ProgEXEname+extTXT+'".'+nl+
"   File specification should be unambiguous. Jokers are allowed."+nl+
'   "'+dot+'" and "'+star+'" specifications are replaced with "'+star+extTXT+'".'+nl+
"   If specified without path, data file is searched for"+nl+
"   first in executable directory, then in current directory."+nl+
"   If data file's first line is not a single character separator,"+nl+
"   tagline mode (single line entries) is assumed."+nl+
"   Data file's last line must be the single character separator"+nl+
"   (unless, of course, lines are taglines). Entries beyond "+sMAX+" are ignored."+nl+
"   If data file comes from *n*x world, it WILL require preprocessing :"+nl+
"   CRLF utility will change LF to CR+LF ; if file contains fortune cookies,"+nl+
"   the required single character separator can be prepended to file"+nl+
"   using CONCAT, WITH and USRBRAIN (!) DOS utilities."+nl+
"b) Program will handle up to 200 files, always excluding from processing files"+nl+
"   matching *<"+extensions+">."+nl+
"c) Please note DOS (*"+extNDXDOS+") and Win32 (*"+extNDX+") indexes have different formats."+nl+
"d) NEVER forget Murphy's Law : "+'"If anything CAN go wrong, it WILL !" ;-)'+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    S : str1024; (* was str256 *)
BEGIN
    colorhelp();
    CASE e OF
    | errHelp :
        WrStr(helpmsg);
    | errOption :
        S:='Illegal "~" option !';
    | errParameter :
        S:='"~" is one parameter too many !';
    | errNotFound:
        S:='No file matches "~" specification !';
    | errBadNumber:
        S:='Illegal value in "~" option !';
    | errNotFoundReally:
        S:='No file matches "~" specification anywhere !';
    | errNotInNormalMode:
        Str.Copy(S,einfo);
    | errWidthRange:
        S := "Illegal width !";
    | errTabRange:
        S := "Tab width range is [1..64] !";
    | errPauseRange   :
        S := "Pause range is [0..30] !";
    | errTooManyFiles:
        S:='Too many files match "~" specification !';
    | errCookieVal:
        S:='Illegal "~" cookie value !';
    | errCookieRange:
        Str.Copy(S,einfo);
    | errNotWithMultifile:
        S := "-n:# option requires only one datafile !";
    | errCmdConflict:
        S := "-i, -x[x] and -t[t] options are mutually exclusive !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp:
        ;
    ELSE
        WrLn;
        Str.Subst(S,"~",einfo);
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

CONST
    IObufferSize = (8 * 512) + FIO.BufferOverhead;
VAR
    IObuffer , IObufferx : ARRAY [1..IObufferSize] OF SYSTEM.LOC;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fmtbignum (v:LONGCARD; base:CARDINAL;wi:INTEGER; pad:CHAR ):str16;
VAR
    S:str16;
    ok:BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr( v, S, base,ok);
    FOR i:=Str.Length(S)+1 TO CARDINAL( ABS(wi)) DO
         IF wi < 0 THEN
             Str.Append(S,pad);
         ELSE
             Str.Prepend(S,pad);
         END;
    END;
    IF base=16 THEN Str.Lows(S);END;
    RETURN S;
END fmtbignum;

(* <s|g>etEntry require entry[A|B|C|D] globerks *)

PROCEDURE setEntry (i:CARDINAL; fpos:LONGCARD);
VAR
    trick : tricktype;
BEGIN
    (*
    trick.lc  := fpos;
    entryA[i] := trick.a;
    entryB[i] := trick.b;
    entryC[i] := trick.c;
    entryD[i] := trick.d;
    *)
    entry[i] := fpos;
END setEntry;

PROCEDURE getEntry (i:CARDINAL ):LONGCARD;
VAR
    trick : tricktype;
BEGIN
    (*
    trick.a := entryA[i];
    trick.b := entryB[i];
    trick.c := entryC[i];
    trick.d := entryD[i];
    RETURN trick.lc;
    *)
    RETURN entry[i];
END getEntry;

PROCEDURE retrieveEntries (hin:FIO.File;DEBUG:BOOLEAN);
VAR
    i,got,count:CARDINAL;
    trick:tricktype;
    lc:LONGCARD;
    fpos:LONGCARD;
BEGIN
    setEntry(countCookie,0); (* safety *)
    count:=CARDINAL ( FIO.Size(hin) >> 2 ); (* faster DIV 4 *)
    IF count=0 THEN RETURN; END; (* safety *)

    FOR i:= firstCookie-1 TO count DO (* 0.. will include count *)
        got:=FIO.RdBin(hin, trick, SIZE(trick));
        setEntry(i,trick.lc);
    END;

    IF DEBUG THEN
        lc := getEntry(countCookie);
        WrLn;
        WrStr(fmtbignum( lc,10,5,space));
        WrStr(" entr");
        IF count < 2 THEN
            WrStr("y");
        ELSE
            WrStr("ies");
        END;
        WrLn;
        WrLn;
        count := CARDINAL (lc);
        FOR i:=firstCookie TO count DO (* 1.. *)
            fpos:=getEntry(i);
            WrStr( fmtbignum(LONGCARD(i),10,5,space));
            WrStr(" -- $");
            WrStr( fmtbignum(fpos,16,8,"0"));
            IF fpos = ALREADYDUMPEDCOOKIE THEN WrStr(" (used)"); END;
            WrLn;
        END;
        WrLn;
    END;

END retrieveEntries;

CONST
    keyEscape  = 01B00H;
    keySpace   = 02000H;
    keyCR      = 00D00H;

PROCEDURE flushKeyboard (  );
VAR
    c : CHAR;
BEGIN
    LOOP
        IF BiosIO.KeyPressed()=FALSE THEN EXIT; END;
        c := BiosIO.RdKey();
        IF c = CHR(0) THEN c := BiosIO.RdKey(); END;
    END;
END flushKeyboard;

PROCEDURE getKeyboardCode (VAR keycode:CARDINAL):BOOLEAN;
VAR
    c1,c2:CHAR;
BEGIN
    IF BiosIO.KeyPressed()=FALSE THEN RETURN FALSE; END;
    c1 := BiosIO.RdKey();
    IF c1 = CHR(0) THEN
        c2 := BiosIO.RdKey();
    ELSE
        c2 := CHR(0);
    END;
    keycode := (ORD(c1) << 8) + ORD(c2);
    RETURN TRUE;
END getKeyboardCode;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE detab (tabwidth:CARDINAL;S:ARRAY OF CHAR; VAR R : ARRAY OF CHAR  );
VAR
    i,j,add: CARDINAL;
    c : CHAR;
BEGIN
    Str.Copy(R,"");
    j:=0; (* yes, 0 and not 1 ! *)
    FOR i:=1 TO Str.Length(S) DO
        c := S[i-1];
        IF c = tabul THEN
            add := tabwidth - (j MOD tabwidth);
            WHILE add > 0 DO
                Str.Append(R,space); INC(j);
                DEC(add);
            END;
        ELSE
            Str.Append(R,c); INC(j);
        END;
    END;
END detab;

PROCEDURE stripANSI (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.Pos(S,cmdANSI);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        S[p]:="["; (* neutralize ! *)
    END;
END stripANSI;

PROCEDURE stripchar (ch:CHAR;  VAR S : ARRAY OF CHAR   );
VAR
    p:CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,ch);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1);
    END;
END stripchar;

(* english only *)

PROCEDURE unrot13me (VAR S : ARRAY OF CHAR );
CONST
    k=13;
VAR
    ch:CHAR;
    i:CARDINAL;
BEGIN
    FOR i:= 1 TO Str.Length(S) DO
        ch:=S[i-1];
        CASE ch OF
        | "A".."M", "a".."m" : S[i-1]:=CHR( ORD(ch)+k );
        | "N".."Z", "n".."z" : S[i-1]:=CHR( ORD(ch)-k );
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
END unrot13me;

PROCEDURE isTaglineFile (hnd:FIO.File;VAR separator:CHAR):BOOLEAN ;
VAR
    rc : BOOLEAN;
    S  : str2048; (* oversized *)
BEGIN
    LOOP
        FIO.RdStr(hnd,S);
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE Str.Length(S) OF
        | 0 : ;
        | 1 :
            separator:=S[0];
            rc:=FALSE;
            EXIT;
        ELSE
            rc:=TRUE;
            EXIT;
        END;
        IF FIO.EOF THEN
            rc:=TRUE;
            EXIT;
        END;
    END;
    IF rc THEN FIO.Seek(hnd,0); END; (* not a fortune file : let's rewind ! *)
    RETURN rc;
END isTaglineFile;

(*
    data file structure :

    separator single character
    text
    separator single character
    text
    ...
    separator character

    or
    single line tagline
    single line tagline
    ...


    index file structure (all LONGCARDs)
    - number of entries
    - offset for tagline1
    - offset for tagline2...

    max(longcard) means already dumped

    if wantedcookie # SHOWRANDOMCOOKIE :
    - just update this cookie address in RAM ARRAY
    - lastCookie will be wrong

    eh eh, bug : last cookie is never counted nor displayed,
    because eof may happen without last separator
    yes, we could fake it but we don't care...
    if we begin, we'd rewrite everything !
*)

PROCEDURE buildIndex (datafile,indexfile:pathtype;
                     verbose:BOOLEAN;wantedcookie:CARDINAL;
                     VAR lastCookie:CARDINAL);
VAR
    S       : str2048; (* oversized *)
    pos     : LONGCARD;
    separator:CHAR;
    taglinemode:BOOLEAN;
    hnd,hndx:FIO.File;
BEGIN
    IF wantedcookie # SHOWRANDOMCOOKIE THEN verbose:=FALSE;END; (* added safety *)

    IF verbose THEN
        WrStr("Building "); WrStr(indexfile); WrStr(" index file... ");
    END;

    hnd := FIO.OpenRead(datafile);
    FIO.AssignBuffer(hnd,IObuffer);
    taglinemode := isTaglineFile(hnd,separator);

    lastCookie := 0;
    IF wantedcookie = SHOWRANDOMCOOKIE THEN
        hndx := FIO.Create(indexfile);
        FIO.AssignBuffer(hndx,IObufferx);
        FIO.WrBin(hndx,LONGCARD(lastCookie),SIZE(LONGCARD)); (* force first entry *)
    END;

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        pos := FIO.GetPos(hnd);
        LOOP
            FIO.RdStr(hnd,S);
            IF taglinemode THEN
                LtrimBlanks(S);
                RtrimBlanks(S);
                IF Str.Length(S) > 0 THEN EXIT; END; (* skip empty taglines *)
            ELSE
                LtrimBlanks(S);
                RtrimBlanks(S);
                IF Str.Length(S) = 1 THEN (* stricter *)
                    IF S[0]=separator THEN EXIT;END;
                END;
            END;
            IF FIO.EOF THEN EXIT;END; (* avoid infinite loop *)
        END;
        IF FIO.EOF THEN EXIT; END; (* avoid adding unecessary last entry *)

        IF wantedcookie = SHOWRANDOMCOOKIE THEN
            FIO.WrBin(hndx,pos,SIZE(LONGCARD));
        END;
        INC(lastCookie);

        IF wantedcookie # SHOWRANDOMCOOKIE THEN
            IF wantedcookie = lastCookie THEN
                setEntry(wantedcookie, pos);
                EXIT;
            END;
        END;

        IF lastCookie >= maxCookie THEN EXIT; END;

    END;

    IF wantedcookie = SHOWRANDOMCOOKIE THEN
        FIO.Seek(hndx,0);
        FIO.WrBin(hndx,LONGCARD(lastCookie),SIZE(LONGCARD));
        FIO.Flush(hndx);
        FIO.Close(hndx);
    END;

    FIO.Close(hnd);

    IF verbose THEN
        WrStr( fmtbignum( LONGCARD(lastCookie),10,1," " ) );
        IF taglinemode THEN
            WrStr(" tagline");
        ELSE
            WrStr(" cookie");
        END;
        IF lastCookie > 1 THEN WrChar("s"); END;
        WrStr(" found !"); WrLn;
    END;
END buildIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkFortune ( datafile:pathtype;terseTest:BOOLEAN  );
CONST
    msgWait     = "Checking, please wait...";
    msgTaglines = '::: Probably a tagline file : "~"';
    msgFortunes = '+++ Valid fortune file      : "~"';
    msgMissing  = '--- Missing final separator : "~"';
VAR
    S : str2048; (* oversized *)
    separator:CHAR;
    hnd:FIO.File;
    dmpme,wasSep : BOOLEAN;
BEGIN
    dmpme:=NOT(terseTest);
    video(msgWait,TRUE);

    hnd := FIO.OpenRead(datafile);
    FIO.AssignBuffer(hnd,IObuffer);

    wasSep:= NOT ( isTaglineFile(hnd,separator) ); (* init it *)
    IF NOT(wasSep) THEN
        S:=msgTaglines;
    ELSE
        FIO.EOF:=FALSE;
        LOOP
            IF FIO.EOF THEN EXIT; END;
            FIO.RdStr(hnd,S);
            LtrimBlanks(S);
            RtrimBlanks(S);
            CASE Str.Length(S) OF
            | 0 : ;
            | 1 : wasSep := ( S[0]=separator);
            ELSE
                  wasSep := FALSE;
            END;
            IF FIO.EOF THEN EXIT;END; (* avoid infinite loop *)
        END;

        IF wasSep THEN
            S:=msgFortunes;
        ELSE
            S:=msgMissing;
            dmpme:=TRUE;
        END;
    END;

    FIO.Close(hnd);

    video(msgWait,FALSE);

    Str.Subst(S,"~",datafile);
    IF dmpme THEN WrStr(S);WrLn; END;
END chkFortune;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* uses global sline[] and slen[] arrays, and lastline variable *)

PROCEDURE getCookie (datafile,indexfile:pathtype;
                     doframe, tabwidth, LineWidth, wantedcookie:CARDINAL;
                     rotor,DEBUG:BOOLEAN;
                     VAR lastcookie:CARDINAL):BOOLEAN;
CONST
    maxiter = LONGCARD(maxCookie) << 4;
VAR
    pos     : LONGCARD;
    cookid  : CARDINAL;
    separator:CHAR;
    freecookid:CARDINAL;
    iter:LONGCARD;
    S       : str2048; (* oversized *)
    R,R2    : str2048;

    splitagain : BOOLEAN;
    tmp        : str256;
    len        : CARDINAL;
    tmplen     : CARDINAL;
    stop       : BOOLEAN;
    taglinemode: BOOLEAN;
    hnd,hndx:FIO.File;
BEGIN
    CASE doframe OF
    | frameRaw : ;
    | frameNone:
        DEC(LineWidth,wiHORIZalt); (* sline string + 2 spaces *)
    ELSE
        DEC(LineWidth,wiHORIZ);    (* sline string + 2 spaces + 2 bars *)
    END;

    hnd := FIO.OpenRead(datafile);
    FIO.AssignBuffer(hnd,IObuffer);
    taglinemode := isTaglineFile(hnd,separator);

    IF wantedcookie # SHOWRANDOMCOOKIE THEN (* assume index already loaded *)
        pos:=getEntry(wantedcookie);
    END;

    hndx := FIO.Open(indexfile); (* RW because we'll update file *)
    FIO.AssignBuffer(hndx,IObufferx);
    retrieveEntries(hndx,DEBUG);
    lastcookie := CARDINAL( getEntry(countCookie) );

    IF wantedcookie = SHOWRANDOMCOOKIE THEN

        (* check all Cookies have not been displayed *)

        cookid:=1;
        LOOP
            pos:=getEntry(cookid);
            IF pos # ALREADYDUMPEDCOOKIE THEN freecookid:=cookid; EXIT; END;
            INC(cookid);
            IF cookid > lastcookie THEN
               FIO.Close(hndx);
               FIO.Close(hnd);
               RETURN FALSE;
            END;
        END;

        (* now find a not yet displayed Cookie, preventing impossible infinite loop *)

        iter:=0;
        LOOP
            cookid := GetRndCardRange(firstCookie,lastcookie);
            INC(iter);
            IF iter > maxiter THEN cookid:=freecookid; END; (* we're already waiting too long *)
            pos:=getEntry(cookid);
            IF pos # ALREADYDUMPEDCOOKIE THEN EXIT; END;
        END;

    END;

    (* get it *)

    FIO.EOF:=FALSE; (* force it *)
    FIO.Seek(hnd,pos);

    lastline  := 0;
    longest   := 0;
    LOOP
        FIO.RdStr(hnd,R);
        IF NOT(taglinemode) THEN
            Str.Copy(S,R);
            LtrimBlanks(S);
            RtrimBlanks(S);
            IF Str.Length(S) = 1 THEN (* stricter *)
                IF S[0]=separator THEN EXIT;END;
            END;
        END;

        stripANSI(R);
        stripchar(bs,R);
        IF rotor THEN unrot13me(R);END;

        detab (tabwidth,R,R2);
        Str.Copy(R,R2);
        len:=Str.Length(R);

        IF len > LineWidth THEN
            stop:=FALSE;
            splitagain:=dmpTTX(R,LineWidth,tmp,TRUE);
            WHILE splitagain DO
                Str.Copy( sline[firstline+lastline],tmp);
                tmplen:=Str.Length(tmp);
                slen[firstline+lastline]:=tmplen;
                IF tmplen > longest THEN longest := tmplen; END;
                INC(lastline);
                IF lastline >= maxline THEN stop:=TRUE; EXIT; END;
                splitagain:=dmpTTX(R,LineWidth,tmp,FALSE);
            END;
            IF stop THEN EXIT; END;
        ELSE
            Str.Copy( sline[firstline+lastline],R);
            slen[firstline+lastline]:=len;
            IF len > longest THEN longest := len; END;
            INC(lastline);
            IF lastline >= maxline THEN EXIT; END;
        END;

        IF taglinemode THEN EXIT; END;
        IF FIO.EOF THEN EXIT; END;
    END;

    (* mark it as used *)

    pos:=LONGCARD(cookid) * SIZE(LONGCARD);
    FIO.Seek(hndx,pos);

    pos:=ALREADYDUMPEDCOOKIE;
    FIO.WrBin(hndx,pos,SIZE(LONGCARD));

    FIO.Flush(hndx);
    FIO.Close(hndx);
    FIO.Close(hnd);
    RETURN TRUE;
END getCookie;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE newExtension (VAR index:pathtype ;ext:pathtype);
VAR
    u,d,n,e : pathtype;
BEGIN
    qdSplitAllPath(index,u,d,n,e);
    Lib.MakeAllPath(index,u,d,n,ext);
END newExtension;

(* uses global sline[] and slen[] arrays, and lastline variable *)

PROCEDURE dmpCookie (screenwidth,linewidth,doFrame:CARDINAL;doBeautify:BOOLEAN);
VAR
    len,plus   : CARDINAL;
    frameChars : str128;
    i,j,k      : CARDINAL;
    S          : str128;
    neednl     : BOOLEAN;
BEGIN
    neednl := TRUE;
    len := longest;
    (*
    IF doFrame # frameRaw THEN
        IF getWindowWidth() <= (len+wiHORIZ) THEN doFrame:=frameRaw; END; (* sline string + 2 spaces + 2 bars *) (* BUGFIX : was < *)
        IF getWindowWidth() <= (len+wiHORIZ+1) THEN doFrame:=frameRaw; END; (* sline string + 2 spaces + 2 bars + 1 for exactly 80 columns *) (* CAKE bugfix *)
    END;
    *)
    CASE doFrame OF
    | frameNone   : frameChars := sNone;   plus:=0;
    | frameSingle : frameChars := sSingle; plus:=2;
    | frameDouble : frameChars := sDouble; plus:=2;
    | frameAscii  : frameChars := sAscii;  plus:=2;
    ELSE ; (* //ISO fixed silly requirement *) END;

    CASE doFrame OF
    | frameRaw :
        WrLn;
        FOR j:=firstline TO lastline DO
            WrStr( sline[j]);
	    (*
            neednl :=( slen[j] < linewidth );
            neednl :=(neednl OR (linewidth < screenwidth) ); (* < *)
	    *)
            IF neednl THEN WrLn; END;
        END;

    ELSE
        (*
        neednl := ((1+len+plus+1) < linewidth );
        neednl := (neednl OR (linewidth < screenwidth) ); (* < *)
        *)
        WrLn;
        WrChar(frameChars[0]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[2]);
        IF neednl THEN WrLn; END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        FOR j:=firstline TO lastline DO
            WrChar(frameChars[1]);
            IF doFrame # frameNone THEN WrChar(space); END;
            WrStr( sline[j]);
            FOR k:=Str.Length( sline[j])+1 TO len DO
                WrChar(space);
            END;
            IF doFrame # frameNone THEN WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        WrChar(frameChars[3]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[5]);
        IF neednl THEN WrLn; END;
    END;
    IF doBeautify THEN WrLn; END;
END dmpCookie;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE showIndexStatistics (indexfile:pathtype; flagWide,DEBUG:BOOLEAN);
VAR
    total,used,unused   : CARDINAL;
VAR
    i       : CARDINAL;
    pos     : LONGCARD;
    count   : CARDINAL;
    percent : LONGREAL;
    S       : str128;
    ok      : BOOLEAN;
    hndx:FIO.File;
BEGIN
    hndx := FIO.OpenRead(indexfile); (* // was fileOpen() *)
    FIO.AssignBuffer(hndx,IObufferx);
    retrieveEntries(hndx,DEBUG);
    FIO.Close(hndx);
    total := CARDINAL( getEntry(countCookie) );

    used  := 0;
    unused:= 0;
    FOR i := firstCookie TO total DO
        pos:= getEntry(i);
        IF pos = ALREADYDUMPEDCOOKIE THEN
            INC(used);
        ELSE
            INC(unused);
        END;
    END;

    CASE flagWide OF
    | FALSE:
        WrLn;
        WrStr("Index file     : "); WrStr(indexfile); WrLn;
        WrStr("Total entries  : "); WrStr(fmtbignum( LONGCARD(total ),10,5,space));WrLn;
        WrStr("Used entries   : "); WrStr(fmtbignum( LONGCARD(used  ),10,5,space));WrLn;
        WrStr("Unused entries : "); WrStr(fmtbignum( LONGCARD(unused),10,5,space));WrLn;
        WrLn;
    | TRUE:
        IF total = 0 THEN
            percent := 0.0;
        ELSE
            (* warning ! here, we need to sync bios, dos and our crt ! *)
            percent := (LONGREAL(used) / LONGREAL(total) ) * 100.0;
        END;
        WrStr(fmtbignum( LONGCARD(used ),10,5,space));
        Str.FixRealToStr(percent,1,S,ok);
        FOR i := Str.Length(S)+1 TO 3+1+1 DO
            Str.Prepend(S," ");
        END;
        WrStr(" ("); WrStr(S); WrStr("%) used out of ");
        WrStr(fmtbignum( LONGCARD(total),10,5,space));
        WrStr(" in "); WrStr(indexfile); WrLn;
    ELSE ; (* //ISO fixed silly requirement *) END;
END showIndexStatistics;

(* ------------------------------------------------------------ *)

(* q&d check : any "\" or ":" means a path *)

PROCEDURE nopathhere (S:pathtype):BOOLEAN;
BEGIN
    IF Str.CharPos(S,backslash) # MAX(CARDINAL) THEN RETURN FALSE; END;
    RETURN ( Str.CharPos(S,colon)=MAX(CARDINAL) );
END nopathhere;

PROCEDURE prependexepath (exe:pathtype; VAR dat : pathtype);
VAR
    u,d,f8,e3:pathtype;
    uz,dz,f8z,e3z:pathtype;
BEGIN
    qdSplitAllPath(exe,u,d,f8,e3);
    qdSplitAllPath(dat,uz,dz,f8z,e3z);
    Lib.MakeAllPath(dat,u,d,f8z,e3z);
END prependexepath;

PROCEDURE initFileNames (VAR exe,dat:pathtype);
VAR
    tmpdat,u,d,f8,e3:pathtype;
    p:CARDINAL;
BEGIN
    Lib.ParamStr(exe,0);
    qdSplitAllPath(exe,u,d,f8,e3);
    Lib.MakeAllPath(tmpdat,"","",f8,e3);
    p:=Str.RCharPos(tmpdat,dot);
    IF p # MAX(CARDINAL) THEN tmpdat[p]:=CHR(0);END;
    Str.Concat(dat,tmpdat,extTXT);
END initFileNames;

(* ------------------------------------------------------------ *)

CONST
    firstfile = 1;
    maxfile   = 200; (* should be enough *)
VAR
    fileArray : ARRAY [firstfile..maxfile] OF pathtype;

PROCEDURE legalextension (S:pathtype):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN

    Str.Caps(S); (* ah, lowercase LFNs... *)

    rc:=TRUE;
    n:=0;
    LOOP
        isoleItemS(e3, extensions,delim,n);
        IF same(e3,"") THEN EXIT; END;
        IF Str.Pos(S,e3) # MAX(CARDINAL) THEN rc:=FALSE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END legalextension;

PROCEDURE makebase (spec:pathtype;VAR basepath:pathtype);
CONST
    defaultdrive = SHORTCARD(0);
VAR
    u,d,n,e:pathtype;
BEGIN
    qdSplitAllPath(spec,u,d,n,e);
    Str.Concat(basepath,u,d);
    IF same(basepath,"") THEN
        Str.Concat(basepath, CHAR( ORD("A")-1+ FIO.GetDrive()), ":");
        FIO.GetDir(defaultdrive,d);
        Str.Append(basepath,d);
        fixDirectory(basepath); (* in case *)
    END;
END makebase;

PROCEDURE isDirEntry (S : pathtype) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isDirEntry;

(* anyone storing more than 65536 files in a single directory is a madman ! *)

PROCEDURE readDirectory (DEBUG:BOOLEAN;orgspec:pathtype;
                         VAR basepath:pathtype) : CARDINAL;
CONST
    dbgSpec = "::: Filespec         : ";
    dbgYep  = "+++ Included [~] : ";
    dbgNope = "--- Excluded         : ";
VAR
    fentry    : FIO.DirEntry;
    last      : CARDINAL;
    found     : BOOLEAN;
    spec      : pathtype;
    w9Xhandle,errcode:CARDINAL;
    fname:pathtype;
    rc,includeme:BOOLEAN;
    S:str128;
BEGIN
    Str.Copy(spec,orgspec);
    makebase (spec,basepath); (* yes, we'll mix f83 and LFN *)

    IF DEBUG THEN WrStr(dbgSpec);WrStr(spec);WrLn;WrLn;END;

    last:=firstfile-1; (* 0 *)

    found := FIO.ReadFirstEntry(spec,everything,fentry);
    LOOP
        IF NOT(found) THEN EXIT; END;
        Str.Copy(fname,fentry.name);
        IF isDirEntry(fname)=FALSE THEN (* skip . AND .. *)
            includeme:=legalextension(fname);
            IF includeme THEN
                INC(last);
                IF last > maxfile THEN last:=MAX(CARDINAL);EXIT;END;
                Str.Copy(fileArray[last],fname);
            END;
            IF DEBUG THEN
                IF includeme THEN
                    S:=dbgYep;
                    Str.Subst(S,"~",fmtbignum(LONGCARD(last),10,5,space));
                ELSE
                    S:=dbgNope;
                END;
                WrStr(S);
                WrStr(dquote);
                WrStr(fname);
                WrStr(dquote);
                WrLn;
            END;
        END;
        found :=FIO.ReadNextEntry(fentry);
    END;

    RETURN last;
END readDirectory;

PROCEDURE getWindowWidth():CARDINAL;
BEGIN
    RETURN 80-1;
END getWindowWidth;
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    mincolumns  = 1+1+1+1+1;
    mintabwidth = 1;
    maxtabwidth = 64;
VAR
    parmcount,i,opt : CARDINAL;
    S,R             : pathtype;
    spec,basepath,exefile,datafile,indexfile : pathtype;
    terseTest,cmdTest, cmdIndex,doWait, doBeautify, cmdStats, doStatsWide : BOOLEAN;
    doFrame, tabwidth,maxcolumns,LineWidth,screenwidth:CARDINAL;
    tagcount  : LONGCARD;
    state     : (waiting,gotDatafile);
    v         : LONGCARD;
    c1,c2     : CHAR;
    lastcookie,wantedcookie,rc,filecount : CARDINAL;
    savermode,stopmouse,atrandompos,docls,FRprompt,rotor:BOOLEAN;
    usemouse,exedirfirst:BOOLEAN;
    pause,alwayspause:CARDINAL;
    ok,chk:BOOLEAN;
    keycode:CARDINAL;
    DEBUG:BOOLEAN;
BEGIN
    FIO.IOcheck:=FALSE;

    screenwidth := getWindowWidth();

    InitRnd();

    initFileNames(exefile,spec);

    cmdIndex   := FALSE;
    doFrame    := frameDouble;
    doWait     := FALSE;
    doBeautify := FALSE;
    tabwidth   := 8;
    cmdStats   := FALSE;
    doStatsWide:= FALSE;
    LineWidth  := screenwidth;
    wantedcookie:=SHOWRANDOMCOOKIE;
    FRprompt   := FALSE;
    exedirfirst:= TRUE;
    rotor      := FALSE;
    cmdTest    := FALSE;
    terseTest  := FALSE;
    maxcolumns := screenwidth;
    DEBUG      := FALSE;

    state      := waiting;
    parmcount  := Lib.ParamCount();

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleanCLI(R); ReplaceChar(R,dquote,"");
        IF isOption(R) THEN
            opt := GetOptIndex(R,"?"+delim+"H"+delim+"HELP"+delim+
                                 "I"+delim+"INIT"+delim+
                                 "F:"+delim+"FRAME:"+delim+
                                 "W"+delim+"WAIT"+delim+
                                 "N"+delim+"NEWLINE"+delim+"CR"+delim+"CRLF"+delim+
                                 "T:"+delim+"TAB:"+delim+
                                 "X"+delim+
                                 "XX"+delim+
                                 "W:"+delim+"WIDTH:"+delim+
                                 "N:"+delim+"NUMBER:"+delim+
                                 "P"+delim+
                                 "O"+delim+"ORDER"+delim+
                                 "13"+delim+"ROT13"+delim+
                                 "T"+delim+"TEST"+delim+
                                 "TT"+delim+"TESTQUIET"+delim+
                                 "DEBUG"+delim+
				 "WW"+delim+
				 "PP"
                              );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5 :
                cmdIndex := TRUE;
            | 6,7 :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minframe) OR (v > maxframe) ) THEN abort(errBadNumber,S); END;
                doFrame:=CARDINAL(v);
            | 8,9 :
                doWait  := TRUE;
            | 10,11,12,13:
                doBeautify  := TRUE;
            | 14,15:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mintabwidth) OR (v > maxtabwidth) ) THEN abort(errTabRange,"");END;
                tabwidth :=CARDINAL(v);
            | 16:
                cmdStats:=TRUE; doStatsWide := TRUE;
            | 17:
                cmdStats:=TRUE; doStatsWide := FALSE;
            | 18,19 :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolumns) OR (v > LONGCARD(maxcolumns)) ) THEN abort(errWidthRange,"");END;
                LineWidth:=CARDINAL(v);
            | 20,21:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < firstCookie) OR (v > maxCookie) ) THEN abort(errCookieVal,S);END;
                wantedcookie:=CARDINAL(v);
            | 22:
                doWait:=TRUE;                  FRprompt:=TRUE;
            | 23,24:
                exedirfirst:=FALSE;
            | 25,26:
                rotor := TRUE;
            | 27,28:
                cmdTest := TRUE;
            | 29,30:
                cmdTest := TRUE; terseTest := TRUE;
            | 31:
                DEBUG:=TRUE;
	    | 32:
	        doWait:=TRUE;                doBeautify:=TRUE;
	    | 33:
	        doWait:=TRUE; FRprompt:=TRUE;doBeautify:=TRUE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                IF same(R,"?") THEN abort(errHelp,""); END;
                Str.Copy(spec,S); (* keep original case here *)
            | gotDatafile :
                abort(errParameter,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;

    i:=0;
    IF cmdStats THEN INC(i);END;
    IF cmdIndex THEN INC(i);END;
    IF cmdTest  THEN INC(i);END;
    IF i > 1 THEN abort(errCmdConflict,"");END;

    IF isDirectory(spec) THEN
        IF chkJoker(spec)=FALSE THEN
            fixDirectory(spec);
            Str.Append(spec,star+extTXT);
        END;
    END;

    IF same(spec,dot) THEN Str.Copy(spec,star+extTXT);END;
    IF same(spec,star) THEN Str.Append(spec,extTXT);END;


    IF Str.CharPos(spec,dot)=MAX(CARDINAL) THEN Str.Append(spec,extTXT); END;

    IF nopathhere(spec) THEN (* try exe path *)
        Str.Copy(R,spec); (* R=original spec *)
        IF exedirfirst THEN prependexepath(exefile,spec); END;
        filecount := readDirectory(DEBUG,spec,basepath);
        CASE filecount OF
        | 0 :
            Str.Copy(spec,R);
            IF NOT(exedirfirst) THEN prependexepath(exefile,spec); END;
            filecount := readDirectory(DEBUG,spec,basepath);
            CASE filecount OF
            | 0 :
                abort(errNotFoundReally,spec);
            | MAX(CARDINAL) :
                abort(errTooManyFiles,spec);
            ELSE ; (* //ISO fixed silly requirement *) END;
        | MAX(CARDINAL) :
            abort(errTooManyFiles,spec);
        ELSE ; (* //ISO fixed silly requirement *) END;
    ELSE
        filecount := readDirectory(DEBUG,spec,basepath);
        CASE filecount OF
        | 0 :
            abort(errNotFound,spec); (* we had a full path *)
        | MAX(CARDINAL):
            abort(errTooManyFiles,spec);
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    (* ------------------------------------------------------------ *)

    IF cmdStats THEN
        WrLn;
        FOR i:=firstfile TO (firstfile+filecount-1) DO
            Str.Concat(datafile,basepath,fileArray[i]);
            Str.Copy(indexfile,datafile);
            newExtension(indexfile,extNDX);
            IF FIO.Exists(indexfile)=FALSE THEN
                Str.Concat(S,"--- Index not found : ",indexfile);
                WrStr(S);WrLn;
            ELSE
                showIndexStatistics(indexfile,doStatsWide,DEBUG);
            END;
        END;
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    IF cmdIndex THEN
        WrLn;
        FOR i:=firstfile TO (firstfile+filecount-1) DO
            Str.Concat(datafile,basepath,fileArray[i]);
            Str.Copy(indexfile,datafile);
            newExtension(indexfile,extNDX);
            IF fileIsRO(indexfile) THEN (* of course, RW if file does not exist *)
                (*
                Str.Concat(S,"--- Index is read-only : ",indexfile);
                WrStr(S);WrLn;
                *)
                fileSetRW(S);
            ELSE
                buildIndex(datafile,indexfile,TRUE,SHOWRANDOMCOOKIE,lastcookie);
            END;
        END;
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    IF cmdTest THEN
        WrLn;
        FOR i:=firstfile TO (firstfile+filecount-1) DO
            Str.Concat(datafile,basepath,fileArray[i]);
            chkFortune(datafile,terseTest);
        END;
        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)

    (* well, just serve us a cookie *)

    i:=GetRndCardRange(firstfile,firstfile+filecount-1);
    Str.Concat(datafile,basepath,fileArray[i]);
    Str.Copy(indexfile,datafile);
    newExtension(indexfile,extNDX);

    IF FIO.Exists(indexfile)=FALSE THEN
        buildIndex(datafile,indexfile,FALSE,SHOWRANDOMCOOKIE,lastcookie);
    ELSE
        IF fileIsRO(indexfile) THEN (* of course, RW if file does not exist *)
            (* abort(errReadOnlyIndex,indexfile); *)
            fileSetRW(indexfile);
        END;
    END;

        IF wantedcookie # SHOWRANDOMCOOKIE THEN
            IF filecount # 1 THEN abort(errNotWithMultifile,"");END;
            buildIndex(datafile,indexfile,FALSE,wantedcookie,lastcookie);
            IF ( (wantedcookie < firstCookie) OR (wantedcookie > lastcookie) ) THEN
                Str.Copy(S, fmtbignum( LONGCARD(lastcookie), 10,1," ") );
                Str.Prepend(S," valid range is [1..");
                Str.Append(S,"] !");
                Str.Prepend(S,datafile);
                abort(errCookieRange,S);
            END;
        END;
        IF getCookie(datafile,indexfile,doFrame,tabwidth,LineWidth,wantedcookie,rotor,DEBUG,lastcookie) = FALSE THEN
            (* tags' well is dry, ressource it ! *)
            buildIndex(datafile,indexfile,FALSE,SHOWRANDOMCOOKIE,lastcookie);
            ok:=getCookie(datafile,indexfile,doFrame,tabwidth,LineWidth,SHOWRANDOMCOOKIE,rotor,DEBUG,lastcookie); (* should always be TRUE *)
        END;

        dmpCookie(screenwidth,LineWidth,doFrame,doBeautify);
	IF doWait THEN
            IF FRprompt THEN
                S:=msgWaitFR;
            ELSE
                S:=msgWait;
            END;
            video(S,TRUE);
            (* BiosWaitkey(c1,c2); *)
            LOOP
                IF getKeyboardCode(keycode) THEN EXIT; END;
            END;
            video(S,FALSE);
        END;

    abort(errNone,"");
END Fortune32.
