(* ---------------------------------------------------------------
Title         Space Reserver
Notes
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
              -d
              -x

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

              we don't try and create anything greater than 2 Gb
              should free space be more than 2 Gb, use alternate syntaxes
Bugs
Wish List     several rnd generators such as ISAAC, Mersenne, Marsaglia ?
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 14 Oct 19 v0.9b from v1.2b for DOS
PhG  7 Apr 16 v0.9a from v1.2a for DOS
PhG 31 Mar 16 an ugly really Q&D port from v1.2 for DOS
--------------------------------------------------------------- *)

MODULE Reserve32;

IMPORT Lib;
IMPORT Str;
IMPORT SYSTEM;
IMPORT FIO;
IMPORT IO;
IMPORT WinBase;

FROM IO IMPORT WrLn,WrStr;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)
PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;


CONST
    (* we'll use hbar because DOS pipe symbol cannot belong to a filename *)
    msg           = "Filling, please wait...";
CONST
    HUGEMAXSIZE   = MAX(LONGINT);
    sMAXGB        = "2 Gb";
    sMAXBYTES     = "2147483647"; (* match HUGEMAXSIZE *)

CONST
    DECbase       = 10;
    HEXbase       = 16;
CONST
    MINFKOUNT     = 1;          sMINFKOUNT    = dot+"001";
    MAXFKOUNT     = 999;        sMAXFKOUNT    = dot+"999";
    sFkountRange  = "[1..999]";
    MINHEXFKOUNT  = 1;          sMINHEXFKOUNT = dot+"001";
    MAXHEXFKOUNT  = 0FFFH;      sMAXHEXFKOUNT = dot+"FFF";
    sHexFkountRange="[$1..$FFF]";
CONST
    ProgEXEname   = "RESERVE32";
    ProgTitle     = "Q&D Space Reserver (Win32)";
    ProgVersion   = "v0.9b (from v1.2b for DOS)";
    ProgCopyright = "by PhG";
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;

CONST
    errNone             = 0;
    errHelp             = 1;
    errOption           = 2;
    errSyntax           = 3;
    errFillerValue      = 4;
    errJoker            = 5;
    errUnit             = 6;
    errSizeValue        = 7;
    errExists           = 8;
    errGetFree          = 9;
    errCreate           = 10;
    errZeroLeft         = 11;
    errNoExtension      = 12;
    errBadVal           = 13;
    errFcountRange      = 14;
    errFcountRangeHex   = 15;
    errExhaustedDOS     = 16;
    errExhaustedDOShex  = 17;
    errNotHere          = 18;
    errNotEnoughFreeLeft =19;
    errExistsRO		= 20;
    errOSversion	= 21;
    errAborted          = 22; (* or 255 ? *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    msgHelp =
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" <size> <file> [value] [option]..."+nl+
"Syntax 2 : "+ProgEXEname+" <"+star+"> <file> [value] [option]..."+nl+
"Syntax 3 : "+ProgEXEname+" <["+dollar+"]"+exclam+"> <file> [value] [option]..."+nl+
nl+
"  -o      overwrite existing <file>"+nl+
"  -v      verbose"+nl+
"  -ts     TopSpeed random library (default)"+nl+
"  -qd     Q&D Tools random library"+nl+
"  -n:[$]# create # files ("+sFkountRange+" or "+sHexFkountRange+"), syntax 1 only)"+nl+
nl+
"With syntax 1, <file> is created with specified <size>."+nl+
"With syntax 2, <file> is created using free space size (up to "+sMAXGB+")."+nl+
"With syntax 3, program creates as many files as needed to fill free space"+nl+
'(extension will be incremented from "'+sMINFKOUNT+'" upwards, upper limit being'+nl+
'either "'+sMAXFKOUNT+'" for "'+exclam+'" command or "'+sMAXHEXFKOUNT+'" for "'+dollar+exclam+'" command).'+nl+
nl+
"a) Optional value specifies (hexa)decimal byte value filling created file(s),"+nl+
'   "'+star+'" or "'+question+'" specifying random values.'+nl+
"b) Unit is either default unit or unit specified in <file> name."+nl+
"c) Maximum filesize is limited to "+sMAXBYTES+" bytes ("+sMAXGB+")."+nl+
"   Note <size> may have any of <Kb|Mb|Gb> suffixes (multiples of 1024),"+nl+
"   or <K|M|G> (multiples of 1000)."+nl+
'd) With -n:[$]# option, extension will be incremented from "'+sMINFKOUNT+'".'+nl+
'   Upper limit is "'+sMAXFKOUNT+'" if # is a decimal number,'+nl+
'   or "'+sMAXHEXFKOUNT+'" if # is a hexadecimal number with "$" prefix.'+nl+
"e) With WinXP (and possibly others), file creation may be slow."+nl+
"f) Win95 and Win98 are not supported. Use RESERVE for DOS instead."+nl+
"g) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+ProgEXEname+" 2048 filler.dat ? -qd"+nl+
"           "+ProgEXEname+" $8000 filler.hex $aa"+nl+
"           "+ProgEXEname+" * filler.bin 255"+nl+
"           "+ProgEXEname+" ! filler $ff"+nl+
"           "+ProgEXEname+" 1963Mb filler.1"+nl+
"           "+ProgEXEname+" -v -o 1963M delme.2"+nl+
"           "+ProgEXEname+" 1024 delme -n:200"+nl+
"           "+ProgEXEname+" $! filler $aa"+nl;

VAR
    S : str128;
BEGIN
    CASE e OF
    | errHelp :      WrStr(msgHelp);
    | errOption :    S := 'Unknown "|" option !';
    | errSyntax:     S := "Syntax error, check help screen !";
    | errFillerValue:S := 'Illegal "|" filler byte value !';
    | errJoker:      S := 'At least one unexpected joker in "|" !';
    | errUnit:       S := 'Illegal unit in "|" !';
    | errSizeValue:  S := 'Illegal "|" size value !';
    | errExists:     S := '"|" already exists !';
    | errGetFree:    S := 'Could not get |: available free space !';
    | errCreate:
        (* name|got|wanted *)
        Str.Subst(einfo,hbar," is ");
        Str.Subst(einfo,hbar," byte(s) long while expected size is ");
        Str.Concat(S,einfo," !");
    | errZeroLeft:   S := "No free space left on |: unit !";
    | errNoExtension:S := "No extension allowed with | !";
    | errBadVal:     S := 'Illegal "|" value !';
    | errFcountRange:    S := "-n:# value must belong to | range !";
    | errFcountRangeHex: S := "-n:$# value must belong to | range !";
    | errExhaustedDOS   :S := "Extension has reached its "+sMAXFKOUNT+" upper limit !";
    | errExhaustedDOShex:S := "Extension has reached its "+sMAXHEXFKOUNT+" upper limit !";
    | errNotHere:    S := "-n:[$]# option and | are mutually exclusive !";
    | errNotEnoughFreeLeft:S:="Not enough free space left on |: unit !";
    | errExistsRO:   S := 'Read-only "|" already exists !';
    | errOSversion:  S := 'This program DOES require WinXP !';
    | errAborted:    S := "Aborted by user !";
    ELSE
                     S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"|",einfo);
        WrStr(ProgEXEname+" : "); WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

TYPE
    HUGECARD    = LONGREAL; (* it's useless but we fake > 4Gb support *)
CONST
    HUGEZERO    = LONGREAL(0.0);
    HUGEONE     = LONGREAL(1.0);

(* u should be UPPERCASE but we handle it anyway *)

PROCEDURE getUnitFreeTotal (u:CHAR;
                           VAR freebytes,totalbytes:HUGECARD):BOOLEAN;
CONST
    wiinfo = 9; (* was 5 for P233 2Gb drive, but with P4 15Gb... *)
VAR
    sectorsPerCluster, freeClusters, bytesPerSector, totalClusters,v : LONGCARD; (* DWORD *)
    ok:BOOLEAN;
    ustr : str16;
    (*
    winFreeBytesAvailableToCaller,winTotalNumberOfBytes,winTotalNumberOfFreeBytes:WinNT.ULARGE_INTEGER;
    *)
BEGIN
    u:=CAP(u);
    Str.Concat(ustr,u,colon+antislash);

    freebytes  :=HUGEZERO;
    totalbytes :=HUGEZERO; (* should NEVER happen ! *)

    ok:=WinBase.GetDiskFreeSpace (ustr,
    				 sectorsPerCluster,bytesPerSector,
				 freeClusters,totalClusters);

    freebytes  := HUGECARD(sectorsPerCluster) * HUGECARD(bytesPerSector);
    totalbytes := HUGECARD(sectorsPerCluster) * HUGECARD(bytesPerSector);
    freebytes  := freebytes  * HUGECARD(freeClusters);
    totalbytes := totalbytes * HUGECARD(totalClusters);

    (*
    nice try, hot shot !
    ok:=WinBase.GetDiskFreeSpaceEx (ustr,
                           winFreeBytesAvailableToCaller,winTotalNumberOfBytes,winTotalNumberOfFreeBytes);
    freebytes:=HUGECARD(winTotalNumberOfFreeBytes);
    totalbytes:= HUGECARD(winTotalNumberOfBytes);
    *)

    RETURN ok;
END getUnitFreeTotal;

(* ------------------------------------------------------------ *)

CONST
    IObufferSize      = (8 * 512) + FIO.BufferOverhead;
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
VAR
    IObuffer : ARRAY [firstIObufferByte..lastIObufferByte] OF SYSTEM.LOC;

CONST
    databuffersize  = 8 * 512;
    firstdatabuffer = 0;
    lastdatabuffer  = databuffersize-1;
VAR
    databuffer : ARRAY [firstdatabuffer..lastdatabuffer] OF SYSTEM.LOC;

(* ------------------------------------------------------------ *)

PROCEDURE strToByte (VAR filler:SYSTEM.LOC; S:ARRAY OF CHAR   ):BOOLEAN;
CONST
    MINBYTE = 0;
    MAXBYTE = 255;
VAR
    ok : BOOLEAN;
    base,len:CARDINAL;
    v:LONGCARD;
BEGIN
    len:=Str.Length(S); (* cannot be 0 *)
    IF S[0]="$" THEN
        base:=16; Str.Delete(S,0,1);
    ELSIF ( (S[0]="0") AND (S[1]="X") ) THEN
        base:=16; Str.Delete(S,0,2);
    ELSIF S[len-1]="H" THEN
        base:=16; Str.Delete(S,len-1,1);
    ELSE
        base:=10;
    END;
    v:=Str.StrToCard(S,base,ok);
    IF ( (ok = FALSE) OR (v < MINBYTE) OR (v > MAXBYTE) ) THEN
        ok:=FALSE;
    ELSE
        filler:=SYSTEM.LOC(v);
        ok:=TRUE;
    END;
    RETURN ok;
END strToByte;

PROCEDURE strToFsize (VAR fsize : LONGCARD;S:ARRAY OF CHAR ):BOOLEAN;
CONST
    bmul  = 1;
    Kbmul = 1024;
    Mbmul = Kbmul * Kbmul;
    Gbmul = Kbmul * Mbmul;
CONST
    rKmul = 1000;
    rMmul = rKmul * rKmul;
    rGmul = rKmul * rMmul;
CONST
    sMul  = "KB KO MB MO GB GO KK K MM M GG G"; (* uppercase, longest first, us and fr *)
VAR
    ok:BOOLEAN;
    i,base:CARDINAL;
    vmax,mul : LONGCARD;
    abrev:str16; (* oversized *)
BEGIN
    IF S[0]="$" THEN
        base:=16; Str.Delete(S,0,1);
    ELSE
        base:=10;
    END;
    Str.Caps(S); (* safety *)
    mul:=bmul;
    i:=0;
    LOOP
        isoleItemS(abrev, sMul,blank,i);
        IF same(abrev,"") THEN EXIT; END;
        IF Str.Pos(S,abrev) # MAX(CARDINAL) THEN
            Str.Subst(S,abrev,"");
            CASE i OF
            | 0,1:  mul:= Kbmul;
            | 2,3:  mul:= Mbmul;
            | 4,5:  mul:= Gbmul;
            | 6,7:  mul:= rKmul;
            | 8,9:  mul:= rMmul;
            |10,11: mul:= rGmul;
            ELSE ; (* //ISO fixed silly requirement *) END;
            EXIT;
        END;
        INC(i);
    END;
    fsize:=Str.StrToCard(S,base,ok);
    IF ok THEN
        IF mul # bmul THEN
            vmax:=LONGCARD(HUGEMAXSIZE) DIV mul;
            IF fsize > vmax THEN
                ok:=FALSE; (* too big *)
            ELSE
                fsize:=fsize * mul;
            END;
        END;
    END;
    RETURN ok;
END strToFsize;

PROCEDURE fmtval (v:LONGCARD;wi,base:CARDINAL;pad:CHAR):str16;
VAR
    ok:BOOLEAN;
    i:CARDINAL;
    R:str16;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:=(Str.Length(R)+1) TO wi DO Str.Prepend(R,pad);END;
    IF base=16 THEN Str.Lows(R);END;
    RETURN R;
END fmtval;

PROCEDURE buildname (VAR R:pathtype;base:CARDINAL;v:LONGCARD;S:pathtype);
CONST
    fix = 3;
BEGIN
    Str.Concat(R,S,dot);
    Str.Append(R,fmtval(v,fix,base,"0"));
END buildname;

PROCEDURE quoteme (S:ARRAY OF CHAR   ):str256; (* should do *)
VAR
    R:str256;
BEGIN
    Str.Copy(R,S);
       Str.Append(R,dquote);
       Str.Prepend(R,dquote);
    RETURN R;
END quoteme;

(* Win98se = 4.10, WinXPsp3 = 5.1 *)

PROCEDURE chkOSversion() : BOOLEAN;
CONST
    win95or98major = 4;
    winXPmajor     = 5;
VAR
    ok:BOOLEAN;
    v:LONGCARD; (* DWORD *)
    major,minor:LONGCARD;
BEGIN
    v:=WinBase.GetVersion();

    major := (v AND 0FFH);
    minor := (v AND 0FF00H) >> 8;


    ok := (major > win95or98major); (* don't care about NT *)
    RETURN ok;
END chkOSversion;

PROCEDURE getLC (VAR v:LONGCARD; VAR numbase:CARDINAL;
                S:ARRAY OF CHAR):BOOLEAN;
VAR
    ok:BOOLEAN;
    p:CARDINAL;
BEGIN
    CASE S[0] OF
    | dollar:
        Str.Delete(S,0,1);
        numbase:=HEXbase;
    ELSE
        numbase:=DECbase;
    END;
    v := Str.StrToCard(S,numbase,ok);
    RETURN ok;
END getLC;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWait = "Working, please wait... ";
VAR
    sname,basename:pathtype;
    slen,sbyte :str128; (* oversized *)
    hnd:FIO.File;
    renamed:BOOLEAN;
    forced,overwrite,verbose:BOOLEAN;
    fillmode:(nofill,randomfill,userfill);
    filler:SYSTEM.LOC;
    wantedfsize:LONGCARD;
    freespace,totalspace: HUGECARD;
    hugefsize:HUGECARD;
    unit:CHAR;
    currext:LONGCARD;
    fKount:CARDINAL;
    rndlib:(defaultrndlib,tsrndlib,qdrndlib);
    ok:BOOLEAN;
VAR
    parmcount,i,opt:CARDINAL;
    S,R:pathtype;
    state:(waiting,gotsize,gotfile,gotvalue);
    pos:LONGCARD;
    datacount:CARDINAL;
    N:str128;
    numbase:CARDINAL;
    opmode : (fixedsizeone,fixedsizemany,tryone,trymany); (* syntaxes 1, 1+n:#, 2, 3 *)
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    WrLn;

    rndlib    := defaultrndlib;
    fillmode  := nofill;
    overwrite := FALSE;
    verbose   := FALSE;
    fKount    := MAX(CARDINAL);
    currext   := MINFKOUNT; (* 1 *)
    numbase   := DECbase;

    state:=waiting;
    parmcount := Lib.ParamCount();
    IF parmcount=0 THEN abort(errHelp,"");END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        cleanCLI(R); ReplaceChar(R,dquote,"");
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "V"+delim+"VERBOSE"+delim+
                                  "O"+delim+"OVERWRITE"+delim+
                                  "x"+delim+"nofat32"+delim+
                                  "l"+delim+"lfn"+delim+
                                  "ll"+delim+"llfn"+delim+
                                  "d"+delim+"dos"+delim+
                                  "TS"+delim+"TOPSPEED"+delim+
                                  "QD"+delim+"QDTOOLS"+delim+
				  "N:"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5:    verbose     := TRUE;
            | 6,7:    overwrite   := TRUE;
            | 8,9 :   ;
            | 10,11:  ;
            | 12,13:  ;
            | 14,15:  ;
            | 16,17:  rndlib      := tsrndlib;
            | 18,19:  rndlib      := qdrndlib;
            | 20:     GetString(R, N); (* keep upper case *)
                      ok:=getLC(pos,numbase, N);
                      IF NOT(ok) THEN abort(errBadVal,S);END;
                      CASE numbase OF
                      | DECbase:
                          IF pos < MINFKOUNT THEN abort(errFcountRange,sFkountRange);END;
                          IF pos > MAXFKOUNT THEN abort(errFcountRange,sFkountRange);END;
                      | HEXbase:
                          IF pos < MINHEXFKOUNT THEN abort(errFcountRangeHex,sHexFkountRange);END;
                          IF pos > MAXHEXFKOUNT THEN abort(errFcountRangeHex,sHexFkountRange);END;
                      ELSE ; (* //ISO fixed silly requirement *) END;
                      fKount:=CARDINAL(pos);
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting:  Str.Copy(slen,R);
            | gotsize:  Str.Copy(sname,S);   (* keep case *)
            | gotfile:  Str.Copy(sbyte,R);
            | gotvalue: abort(errSyntax,"");
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting: abort(errHelp,"");
    | gotsize: abort(errSyntax,"");
    | gotfile: ; (* ok *)
    | gotvalue:
        IF same(sbyte,star) THEN
            fillmode:=randomfill;
        ELSIF same(sbyte,question) THEN
            fillmode:=randomfill;
        ELSE
            IF strToByte(filler,sbyte)=FALSE THEN abort(errFillerValue,sbyte); END;
            fillmode:=userfill;
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF chkJoker(sname) THEN abort(errJoker,sname);END;

    i:=Str.CharPos(sname,colon);
    CASE i OF
    | 1 :            unit:=sname[0];
    | MAX(CARDINAL): unit:=CHR(  FIO.GetDrive()-1+ORD("A") );
    ELSE
                     abort(errUnit,sname);
    END;

    (* possibly bad surprise, alas ! *)

    IF chkOSversion()=FALSE THEN abort(errOSversion,"");END;

    IF same(slen,star) THEN
        IF fKount # MAX(CARDINAL) THEN abort(errNotHere,"syntax 2");END;
        opmode:=tryone;            (* syntax 2 *)
    ELSIF ( same(slen,exclam) OR same(slen,dollar+exclam) ) THEN
        IF fKount # MAX(CARDINAL) THEN abort(errNotHere,"syntax 3");END;
        IF Str.RCharPos(sname,dot) # MAX(CARDINAL) THEN
            abort(errNoExtension,"syntax 3");
        END;
        Str.Copy(basename,sname);
        opmode:=trymany;           (* syntax 3 *)
        CASE slen[0] OF
        | dollar:numbase:=HEXbase;
        | exclam:numbase:=DECbase;
        ELSE ; (* //ISO fixed silly requirement *) END;
    ELSE
        IF strToFsize(wantedfsize,slen)=FALSE THEN abort(errSizeValue,slen);END;
        IF wantedfsize = 0 THEN abort(errSizeValue,slen);END;
        IF wantedfsize > HUGEMAXSIZE THEN
            wantedfsize:=HUGEMAXSIZE; forced:=TRUE;
        END;
        IF fKount = MAX(CARDINAL) THEN
            opmode:=fixedsizeone; (* syntax 1 *)
        ELSE
            IF Str.RCharPos(sname,dot) # MAX(CARDINAL) THEN
                abort(errNoExtension,"-n:# option");
            END;
            Str.Copy(basename,sname);
            opmode:=fixedsizemany; (* syntax 1 with -n:# *)
        END;
    END;

    forced:=FALSE;
    CASE opmode OF
    | fixedsizeone:
        ;
    | tryone,trymany:
        IF getUnitFreeTotal(unit, freespace,totalspace)=FALSE THEN
            abort(errGetFree,unit);
        END;
        IF freespace = HUGEZERO THEN abort(errZeroLeft,unit);END;
        IF freespace > HUGECARD(HUGEMAXSIZE) THEN
            wantedfsize:=HUGEMAXSIZE; forced:=TRUE;
        ELSE
            wantedfsize:=LONGCARD(freespace);
        END;
   | fixedsizemany:
        IF getUnitFreeTotal(unit, freespace,totalspace)=FALSE THEN
            abort(errGetFree,unit);
        END;
        IF freespace = HUGEZERO THEN abort(errZeroLeft,unit);END;
        IF freespace < HUGECARD(wantedfsize) THEN abort(errNotEnoughFreeLeft,unit);END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF fillmode = randomfill THEN
        CASE rndlib OF
        | defaultrndlib,tsrndlib: Lib.RANDOMIZE(); rndlib:=tsrndlib;
        | qdrndlib:               InitRnd();
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    LOOP
        CASE opmode OF
        | trymany,fixedsizemany : buildname(sname,numbase,currext,basename);
	ELSE
	   ; (* ISO I8U ! *)
        END;

        IF FIO.Exists(sname) THEN
            IF overwrite THEN             (* better safe than sorry *)
                IF fileIsRO(sname) THEN abort(errExistsRO,sname);END;
                FIO.Erase(sname);
            ELSE
                abort(errExists,sname);
            END;
        END;

        IF verbose THEN
            CASE opmode OF
            | trymany,fixedsizemany : IF currext > 1 THEN WrLn;END;
            ELSE ; (* //ISO fixed silly requirement *) END;
            WrStr("Unit   : "); WrStr(unit);WrStr(":");WrLn;
            WrStr("File   : "); WrStr(quoteme(sname));
                                IF renamed THEN WrStr(" (renamed)");END;
                                WrLn;
            WrStr("Size   : "); WrStr(fmtval(wantedfsize,1,10,"0"));
                                IF forced THEN WrStr(" (adjusted)");END;
                                WrLn;
            WrStr("Filler : ");
            CASE fillmode OF
            | nofill:     S:="unmodified disk data"; (* was "undefined" *)
            | randomfill: S:="random";
                CASE rndlib OF
                | tsrndlib  : Str.Append(S," (TopSpeed)");
                | qdrndlib  : Str.Append(S," (Q&D Tools)");
                ELSE ; (* //ISO fixed silly requirement *) END;
            | userfill:   Str.Concat(S,"$",fmtval(LONGCARD(filler),2,16,"0"));
            ELSE ; (* //ISO fixed silly requirement *) END;
            WrStr(S);WrLn;
            WrLn;
        END;

        video(msgWait,TRUE);
        hnd := FIO.Create(sname);
        FIO.Seek (hnd,1); (* try and fix DOS bug reported by intlist, probably useless with Win32 *)
        FIO.Truncate(hnd);
        FIO.Close(hnd);

        hnd := FIO.Open(sname);
        FIO.Seek (hnd,wantedfsize);
        FIO.Truncate (hnd);
        FIO.Close(hnd);
	video(msgWait,FALSE);

        pos:=getFileSize(sname);
        IF pos # wantedfsize THEN
            Str.Concat(S,hbar,fmtval(pos,1,10,"0"));
            Str.Prepend(S,sname);
            Str.Append(S,hbar);Str.Append(S,fmtval(wantedfsize,1,10,"0")); (* //V12A was slen ! *)
            abort(errCreate,S); (* "sname|got|wanted" *)
        END;

        Str.Concat(S,"::: ",quoteme(sname));
        Str.Append(S," has been created with ");
        Str.Append(S,fmtval(wantedfsize,1,10,"0"));
        Str.Append(S," byte");
        IF wantedfsize > 1 THEN Str.Append(S,"s");END;
        IF forced THEN Str.Append(S," (adjusted)"); END;
        Str.Append(S," size.");
        WrStr(S);WrLn;

        IF ( (fillmode # nofill) AND (wantedfsize # 0) ) THEN
            video(msg,TRUE);
            CASE fillmode OF
            | randomfill:
                FOR i:=firstdatabuffer TO lastdatabuffer DO
                    CASE rndlib OF
                    | tsrndlib : filler:=SYSTEM.LOC( Lib.RANDOM(256) ); (* 0..255 *)
                    | qdrndlib : filler:=SYSTEM.LOC( GetRndCardRange (0,255) );
                    ELSE ; (* //ISO fixed silly requirement *) END;
                    databuffer[i]:=filler;
                END;
            | userfill:
                Lib.Fill(SYSTEM.ADR(databuffer),databuffersize,filler);
            ELSE ; (* //ISO fixed silly requirement *) END;

            hnd := FIO.Open(sname);
            FIO.AssignBuffer(hnd,IObuffer);
            pos := 0;
            LOOP
                IF pos >= wantedfsize THEN EXIT; END;
                datacount := CARDINAL ( (wantedfsize-pos) MOD databuffersize );
                IF datacount = 0 THEN datacount := databuffersize; END;
                FIO.WrBin(hnd,databuffer,datacount);
                INC(pos,LONGCARD(datacount));
                IF fillmode=randomfill THEN
                    FOR i:=firstdatabuffer TO lastdatabuffer DO
                        CASE rndlib OF
                        | tsrndlib : filler:=SYSTEM.LOC( Lib.RANDOM(256) ); (* 0..255 *)
                        | qdrndlib : filler:=SYSTEM.LOC( GetRndCardRange (0,255) );
                        ELSE ; (* //ISO fixed silly requirement *) END;
                        databuffer[i]:=filler;
                    END;
                END;
            END;
            FIO.Flush(hnd);
            FIO.Close(hnd);
            video(msg,FALSE);
        END;

        CASE opmode OF
        | fixedsizeone,tryone:
            EXIT;
        | trymany:
            IF getUnitFreeTotal(unit, freespace,totalspace)=FALSE THEN
                abort(errGetFree,unit);
            END;
            IF freespace = HUGEZERO THEN EXIT; END; (* we're done *)
            IF freespace > HUGECARD(HUGEMAXSIZE) THEN
                wantedfsize:=HUGEMAXSIZE; forced:=TRUE;
            ELSE
                wantedfsize:=LONGCARD(freespace);
            END;

        | fixedsizemany:
            IF fKount <= MINFKOUNT THEN EXIT;END;
            DEC(fKount);

            IF getUnitFreeTotal(unit, freespace,totalspace)=FALSE THEN
                abort(errGetFree,unit);
            END;
            IF freespace = HUGEZERO THEN abort(errZeroLeft,unit);END;
            IF freespace < HUGECARD(wantedfsize) THEN abort(errNotEnoughFreeLeft,unit);END;
        ELSE ; (* //ISO fixed silly requirement *) END;

       CASE opmode OF
        | fixedsizemany,trymany:
            INC(currext);
                CASE numbase OF
                | DECbase: IF currext > MAXFKOUNT THEN abort(errExhaustedDOS,"");END;
                | HEXbase: IF currext > MAXHEXFKOUNT THEN abort(errExhaustedDOShex,"");END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            IF ChkEscape() THEN abort(errAborted,"");END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;

    abort(errNone,"");
END Reserve32.


