
(* ---------------------------------------------------------------
Title         Q&D Text Generator
Author        PhG
Overview      another useless program
Notes         minimal error messages and checking, etc.
              too many globerks... ;-)

	      note strHUGE should stay at 16Kb for program to run
	      from both Win98SE and WinXP : everything bigger is a no-no with Win98SE
	      go figure why !

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              many DOS-specific or Win32-unsupported options have been removed
		        -w[w]
		        -m
		        -p[p]
		        -i:#
		        -p:#
		        -b
		        -s
		        -s:#
		        -m:#
		        -z
		        -r
		        -c
		        -y
		        -x

              a few DOS-specific limits have been increased (string length)

              see //XDSTS and //FIXME

              - forced octal for character constants concatenation still sucks !
              - absence of AUTOCAP still sucks too !
	          - the editor is crap (and its non-standard keys are a pain) !
              - compiler does not catch problems before program is run : looks like C !
              - requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              - with so many warnings, the crap compiler is not even able
                to warn that a variable has never been defined ! (adventure in EditLand !)
              - note that XDS FIO.EOF support is weird
              - note that XDS character handling does not seem correct :
                French "" (a grave) in source becomes "a" with opposite accent !
		French texts to be processed should be in DOS ASCII
              - since AppleWriter on the Apple ][, I had not seen an editor quitting
                without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)


              rules format was inspired by a source found in a Usenet CD,
              SPEW.C, written in 1987 by a Greg Smith
              who himself had rewritten a source written by a "mark@pixar"
              in order to generate "National Enquirer" headlines.
              I liked the "rules" idea but I did not bother
              to try and understand the ugly unreadable C source :
              instead, I created TEXTGEN ex nihilo so it could
              parse SPEW companion rules file, then I added a few features
              and converted to TEXTGEN new rules format many data files
              found with similar (more specialized and often hard-coded)
              novelty programs.
              too bad : at the time I did not consider creating
              a real script language with variables and functions :
              TEXTGEN would have been the equal of the excellent
              "dada engine" without the stupid complication
              *nixians seem to love (FLEX, YACC and the like...)

              maybe I'll rewrite it someday so it can too process a file
              using programmed rules...

              a PROCTHEM.BAT test batch for *.TX scripts can be created with :

              dirbat *.Tx "echo :: $f$_textgen -mem $c$_pause"

Bugs          getSentence() is not bullet-proof (prevTag and Tag)
              crash if (#) seems too high a value...
              but no logical reason for it !
              (culprit is CRITIQUE.DAT with 15 and 45 count values)
              problem is not solved by large model nor by longcards count !

              well... quirk in fact :
              constant only works for literal strings but not for called class
              because we merely store and freeze an index...
              thus, a \classe entry in a $VAR will always create a new string
              we won't care for now

	      increasing strHuge from 16Kb to 24Kb makes program crash when run from Win98SE
	      while it worked perfectly before !!! thus, going back to 16Kb size

		  design bug : we did not think of \xxx between curlies :
              categories in variants are NOT supported by findvariant()
              (because escaped sequences are !)

Wish List     stop at 1.1a ! we really need a fully rewritten, more clever
              and not backwards-compatible version 2.0 of the whole thing !
              (operators, functions, better syntax, etc.)

              an operator to put a full word in CAPS ?
              allow change of separators ~ \ / |
              better support for French (ah ah, only serious !)
              read quoted string instead of trimmed verbatim ?
              a real two-passes interpreter with variables and classes ?
              functions such as grab unique token or token other than specified

              handle more French exceptions (/au, etc.) or add a special
              flag for French/English processing (" de le " --> " du ",
              "  le " --> " au ", etc.)
              un flag global avertissant que le texte est  prparer
              en fonction d'une langue (" de le " --> " du ", etc.)
              ou une section rserve avec les remplacements  faire, comme :
              " que  le avenir " --> " qu' l'avenir "

              support for the rather nice "net.charabia.generation"
              written in (yerk !) java by a (smart) Rodrigo Reyes

              support for (excellent) dada and/or scigen engines ?

              a full rewrite with vars and functions
              (so we can easily add markov ?)

              creating password.tx gave us a few ideas for new operators :
              - repeat # times             [#] or (((#)))
              - repeat random[1..#] times  [?#] or (((?#)))
              - grab initial from word     \=
              - choices (a|b|c)

              a better debug should show forward and undefined references

              another syntax clearly needed if we want enhancements

              variants should not be limited to one char ! use comma as delimiter

              allow another escape character such as degree ?
              passim : see //FIXME



              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

              handle categories in variants

Who When      What
--- --------- ----------------------------------------------------
PhG 21 Dec 17 v0.9g fixed never seen before IDCLASS instead of IDINVOKE in help
PhG 29 Nov 17 v0.9f added warning about categories in variants
PhG 13 Jan 17 recompiled in order to (hopefully) fix a JPI/XDS bug in Lib.SplitAllPath()
PhG  1 May 16 v0.9e added code from DOS TEXTGEN v1.1j
PhG 28 Apr 16 reset strHUGE to 16Kb so Win98SE still works as before
PhG 23 Apr 16 v0.9d changed strHUGE from 16Kb to 24Kb
              and then, no longer works with Win98SE !
PhG 10 Apr 16 v0.9c changed default frame from 0 to 2
PhG 12 Nov 15 v0.9b added warning about $constant quirk
PhG 15 Oct 15 v0.9a changed default screen width from 80 to 79
PhG 13 Oct 15 an ugly really Q&D port from TEXTGEN v1.1f for DOS
--------------------------------------------------------------- *)

MODULE TextGen32;

IMPORT Lib;
IMPORT Str;
IMPORT FIO;
IMPORT SYSTEM;
IMPORT BiosIO;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn,WrChar;

FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

CONST
    dotstar       = dot+star;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    CULPRIT = TRUE;

TYPE
    str32    = ARRAY [0..32-1] OF CHAR;
    strHUGE  = ARRAY [0..16384-1] OF CHAR; (* more than 16Kb = no Win98SE ! *)
CONST
    ProgEXEname   = "TEXTGEN32";
    ProgTitle     = "Q&D Text Generator (Win32)";
    ProgVersion   = "v0.9g (from v1.1j for DOS)";
(*%F CULPRIT *)
    ProgCopyright = "by PhG";
(*%E *)
(*%T CULPRIT  *)
    ProgCopyright = "by Philippe Guiochon";
(*%E  *)
    Banner        = ProgTitle+" "+ProgVersion+" "+ProgCopyright;
CONST
    extEXE        = ".EXE";
    extDAT        = ".TX"; (* was ".DAT" *)
    exclamation   = exclam;       (* "!" *)
    opencurly     = openbrace;    (* "{" *)
    closecurly    = closebrace;   (* "}" *)
    openparen     = "(";
    closeparen    = ")";
    commercial    = "&";
    arrobas       = "@";
    plus          = "+";
    (* british       = ""; *)
CONST
    IDCLASS       = tilde;      (* "~" *)
    IDVAR         = dollar;     (* "$" *)
    IDINVOKE      = backslash;  (* "\" : must be same as esc char //FIXME at full rewrite *)
    IDVARIANT     = slash;      (* "/" *)
    IDCALLER      = commercial; (* "&" *)
    IDSEPAR       = vbar;
    IDHERIT       = IDVARIANT+IDCALLER;   (* "/&" *)
    IDsuppress    = IDVARIANT+IDVARIANT;  (* "//" is an impossible tag *)
    EMPTYSTRING   = dquote+dquote;
CONST
    lenmarker     = 2; (* "\" plus one character not in [A..Z0..9] *)
    newlinemarker = backslash+exclamation;
    capmarker     = backslash+arrobas;
    lowmarker     = backslash+dollar;
    suffixmarker  = backslash+commercial; (* was +british *)
    elisionmarker = backslash+singlequote; (* in fact, we handle "?\' ?" sequence *)
    articlemarker = backslash+dash; (* in fact, we handle "a\- ?" sequence *)
    concatenatemarker = backslash+plus;
    packmarker    = backslash+equal;
CONST
    escbackslash  = backslash+backslash;
    escopencurly  = backslash+openparen;
    escclosecurly = backslash+closeparen;
CONST
    alphanum        = letters+digits; (* uppercase *)
    legalforcategory= alphanum+underscore; (* // was letters prior to v1.0d, alphanum prior to v1.0e *)
    legalfortag     = alphanum+IDCALLER;
CONST
    vowels          = "AEIOUY";
    elisionRequired = vowels+"H";
    possibleElision = "?"+elisionmarker+space+"?";
    lenpossibleElision = 1+lenmarker+1+1;
CONST
    articleRequired = "AEIOU";
    possibleArticle = "A"+articlemarker+space+"?";
    lenpossibleArticle = 1+lenmarker+1+1;
CONST
    minpause            = 0;
    maxpause            = 30;
    defaultpause        = 1;
    defaultalwayspause  = 2; (* always pause 1 seconds PLUS # s per line *)
CONST
    commentchar1 = semicolon;
    commentchar2 = pound;
    comment1     = "//";
    comment2     = ":::";
    comment3     = "(*";
    comment3a    = "*)";
    IDreserved    = IDCLASS+IDVAR+IDINVOKE+commentchar1+commentchar2+openparen;
CONST
    extBAK          = ".BK!";
    extCOM          = ".COM";
    (* extEXE          = ".EXE"; *)
    extDLL          = ".DLL";
    extOVR          = ".OVR";
    extOVL          = ".OVL";
    extDRV          = ".DRV";
    extZIP          = ".ZIP";
    extARJ          = ".ARJ";
    extLZH          = ".LZH";
    extOBJ          = ".OBJ";
    skippedextensions=extBAK+delim+extCOM+delim+extEXE+delim+
                      extDLL+delim+extOVR+delim+extOVL+delim+extDRV+delim+
                      extZIP+delim+extARJ+delim+extLZH+delim+
                      extOBJ;

CONST
    PBTOOMANY      = MAX(CARDINAL); (* buildfilelist() *)
    ISNOTVAR       = MAX(CARDINAL); (* normal "\class" for .varindex *)
    UNDEFINEDVAR   = 1-1;           (* uninitialized "$variable" for .varindex i.e. 0 *)
    NOWEIGHTHERE   = MAX(CARDINAL); (* isoleweight() *)
    UNDEFINEDCOUNT = MAX(CARDINAL); (* undefined .count *)
    STRNOTFOUND    = MAX(CARDINAL); (* char or string not found in Str. module *)

(* ------------------------------------------------------------ *)

CONST
    errNone           = 0;
    errHelp           = 1;
    errOption         = 2;
    errParameter      = 3;
    errBadNumber      = 4;
    errInkRange       = 5;
    errPaperRange     = 6;
    errCountRange     = 7;
    errMALLOC         = 8;
    errFormat         = 9;
    errSentenceTooBig = 10;
    errWidthRange     = 11;
    errJoker          = 12;
    errNotFound       = 13;
    errLoading        = 14;
    errReallyNotFound = 15;
    errVerboseHelp    = 16;
    errPauseRange     = 17;
    errNotInSaverMode = 18;
    errNotInNormalMode= 19;
    errTooManyFiles   = 20;
    errVerboserHelp   = 21;
    errBadJokers      = 22;
    errOnlyForList    = 23;
    errProcSpec       = 24;  (* base *)
    errNetwork        = errProcSpec+0;
    errColon          = errProcSpec+1;
    errUnit           = errProcSpec+2;
    errNoParent       = errProcSpec+3;
    errEmpty          = errProcSpec+4;
    errInnerParent    = errProcSpec+5;
    errDirJoker       = errProcSpec+6;

(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
    (*
    MODULE message;
    IMPORT Str;
    EXPORT msg3;

    PROCEDURE msg3 (VAR R:ARRAY OF CHAR;S1,S2,S3:ARRAY OF CHAR);
    BEGIN
        Str.Concat(R,S1,S2);Str.Append(R,S3);
    END msg3;

    END message;
    *)
CONST
    placeholder = vbar;
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
     helpmsg=
Banner+nl+
nl+
"Syntax 1 : "+ProgEXEname+" [datafile["+extDAT+"]] [option]..."+nl+
"Syntax 2 : "+ProgEXEname+" <-list> [datafile(s)["+extDAT+"]]"+nl+
nl+
'  -l     show first title line in datafile(s) (default pattern is "'+star+extDAT+'")'+nl+
"  -n:#   count"+nl+
"  -k     remove space from space+{"+semicolon+colon+exclamation+question+"} sequences"+nl+
"  -f:#   frame type (0=none, 1=single, 2=double, 3=raw), default is 2"+nl+
"  -n     add a newline (CR+LF) in order to beautify display (useful with PEXEC)"+nl+
"  -g     glue output data (no newline added if count > 1 and -f:0)"+nl+
"  -w:#   set screen width, default is 79"+nl+
"  -??[?] verbose(r) help, including file format and an example"+nl+
nl+
"a) Any file with any of the following extensions will be ignored :"+nl+
"   "+skippedextensions+nl+
"b) Unless it is specified with a path or with -list option,"+nl+
'   datafile (default is "'+ProgEXEname+extDAT+'") is searched for'+nl+
"   first in current directory, then in executable directory."+nl+
"   Note default character set is Windows OEM for this Win32 binary."+nl+
"c) This program does not handle all language exceptions."+nl+
'd) For syntax 2, a legal title line can be "'+commentchar1+" "+comment1+'", "'+
"  "+commentchar1+" "+comment2+'" or "'+commentchar1+" "+comment3+" ... "+comment3a+'".'+nl+
"   Note -list option only displays the first matching title line."+nl+
"e) Note this program was compiled for 16Kb maximum text output."+nl+
"f) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

(* less options than DOS original *)

    morehelpmsg=
"DATA FILE FORMAT :"+nl+
nl+
"   "+IDCLASS+"class{variant|...}"+nl+
"   {variant|...}entry{variant|...}"+nl+
nl+
'   Use "'+IDINVOKE+'class" to include a class in a class definition.'+nl+
'   Use "'+IDINVOKE+'class/?" to invoke a "\class" with a "/variant id letter".'+nl+
nl+
'a) A category is a unique string (up to 32 chars) beginning with a "'+IDCLASS+'" marker,'+nl+
'   with an optional suffix : a set of variants between "'+opencurly+closecurly+'",'+nl+
"   each variant being identified by a single letter. Case is ignored."+nl+
"   Last category defines the final output. Program can handle 500 categories."+nl+
'   A category beginning with "'+IDVAR+'" instead of "'+IDCLASS+'" defines a global variable'+nl+
"   whose value, once defined at first call, will remain constant. ;-)"+nl+
"b) Each category entry is on its own line, with optional variants specified"+nl+
'   between "'+opencurly+closecurly+'" and separated with inner "'+IDSEPAR+'"'+nl+
'   according to "{[0][|1][|#]...}" pattern (note first letter variant is 1 ;'+nl+
"   note, too, categories are NOT supported in variants)."+nl+
'   "('+pound+')" prefix duplicates the entry # times.'+nl+
"   Please remember each category entry is stored verbatim."+nl+
"   Should an empty string category entry be required, use "+EMPTYSTRING+" form."+nl+
"   Note a verbatim two double quotes entry, if needed, will have to be built."+nl+
'c) A long paragraph can be built from individual lines ending with "'+concatenatemarker+'" marker'+nl+
"   until a line without ending marker."+nl+
'd) "'+IDINVOKE+'" prefix includes a category, an optional variant being specified with "'+IDVARIANT+'"'+nl+
'   followed by its single letter ID ("'+IDHERIT+'" forces use of calling variant).'+nl+
"   Forward references are supported."+nl+
'e) "'+newlinemarker+'" forces a newline, "'+suffixmarker+'" glues together two text units verbatim,'+nl+
'   "'+capmarker+'" forces next word initial to upper case ("'+lowmarker+'" to lower case).'+nl+
'f) If last character of "'+possibleElision+'" sequence belongs to ['+elisionRequired+'] set,'+nl+
"   first character and space will be replaced with a single quote (French)."+nl+
'   Sequence " de'+packmarker+' le " becomes " du " and sequence " '+packmarker+' le " becomes " au ".'+nl+
'g) If last character of "'+possibleArticle+'" sequence belongs to ['+articleRequired+'] set,'+nl+
'   the article "a" will be replaced with the article "an" (English).'+nl+
"h) Should entry first character belong to ["+IDreserved+"] reserved set,"+nl+
'   prefix it with "(1)" ; should an inner character be "'+backslash+'", use "'+escbackslash+'" instead ;'+nl+
'   "'+escopencurly+'" and "'+escclosecurly+'" respectively stand for "'+opencurly+'" and "'+closecurly+'".'+nl+
"i) -dump, -steps and -chkmem options may be of some use for diagnostics."+nl+
"j) Check companion *.TX datafiles to see what can be done using TEXTGEN !"+nl; (* yes, yes, what's the use defining constants AND NOT using them ? ;-) *)

    evenmorehelpmsg =
"EXAMPLE 1 :"+nl+
nl+
"; // this is a mere test for Latin"+nl+
"; nominatif,vocatif,accusatif,gnitif,datif,ablatif SINGULIER = abcdef"+nl+
"; nominatif,vocatif,accusatif,gnitif,datif,ablatif PLURIEL   = ghijkl"+nl+
"~radixRosa"+nl+
"ros"+nl+
"poet"+nl+
"~radixDominus"+nl+
"domin"+nl+
"amic"+nl+
"~declRosa{abcdefghijkl}"+nl+
"{|a|a|am|ae|ae|a|ae|ae|as|arum|is|is}"+nl+
"~declDominus{abcdefghijkl}"+nl+
"{|us|e|um|i|o|o|i|i|os|orum|is|is}"+nl+
"~nom{abcdefghijkl}"+nl+
"\radixRosa\declRosa/&"+nl+
"\radixDominus\declDominus/&"+nl+
"~test"+nl+
"\@\nom/a amat \nom/c"+nl+
"(2)\@\nom/i \nom/g amant"+nl+
"\!\!\@this is a mere test for Latin\!\!"+nl+
nl+
"EXAMPLE 2 :"+nl+
nl+
"~doublequote"+nl+
'"'+nl+
nl+
"~emptystringVerbatim"+nl+
"\doublequote\doublequote"+nl+
nl+
"~emptystringSymbol"+nl+
EMPTYSTRING+nl+
nl+
"~rand"+nl+
"A"+nl+
"B"+nl+
"C"+nl+
"D"+nl+
nl+
"$varname"+nl+
"; will remain constant in script once defined at first call"+nl+
"; note only literal strings are allowed here :"+nl+
"; calling a class will not work"+nl+
"FOO"+nl+
"BAR"+nl+
"FOOBAR"+nl+
"FOOBARBAZ"+nl+
nl+
"$constant"+nl+
"\varname"+nl+
nl+
"# class definition                 : ~* or ~*{?|?|...}"+nl+
"# fixed variable definition        : $*"+nl+
nl+
"; entry count                      : (#)*"+nl+
nl+
"; comment1                         : ;"+nl+
"; comment2                         : #"+nl+
nl+
"; class call                       : \* or \*/? or \*/&"+nl+
nl+
"; escaped sequences"+nl+
"; antislash                        : \\"+nl+
"; newline                          : \!"+nl+
"; initial caps                     : \@"+nl+
"; initial lows                     : \$"+nl+
"; suffix                           : \&"+nl+
"; elision FR                       : \'"+nl+
"; elision US                       : \-"+nl+
"; concatenate                      : \+"+nl+
nl+
"~firstchars"+nl+
"(1)~ tilde"+nl+
"(1)$ dollar"+nl+
"(1)( open parenthesis"+nl+
"(1); comment"+nl+
"(1)# comment"+nl+
"(1)\ backslash"+nl+
nl+
"~anywhere"+nl+
"\\foo\\~$;#(/&\(|\)"+nl+
nl+
"~escaped"+nl+
"\@upper \$LOWER A\&B\!\+"+nl+
"-- ANTISLASH \\\+"+nl+
"-- FRENCH : la\' art la\' science -- ENGLISH : a\- letter a\- alien\+"+nl+
nl+
"~test"+nl+
'Char at first position : \firstchars "\~$;#("\!\+'+nl+
"Char anywhere          : \anywhere\!\+"+nl+
"Escaped chars          : \escaped\!\+"+nl+
"\!\+"+nl+
'If entry first char belongs to "~$(;#" then prefix entry with "(1)"\!\+'+nl+
'If "\" char is needed in an entry then use "\\\\"\!\+'+nl+
"\!\+"+nl+
"\varname = \varname = \varname = \constant\!\rand is not necessarily \rand"+nl+
nl+
'; note supra "\\\\" in source will become "\\" when displayed'+nl;

VAR
    S : strHUGE; (* was str256 but we may get a huge string here *)
BEGIN
    CASE e OF
    | errHelp,errVerboseHelp,errVerboserHelp :
        WrLn;
        WrStr(helpmsg);
        CASE e OF
        | errVerboseHelp,errVerboserHelp:
            WrLn;
            WrStr(morehelpmsg);
    	ELSE
	        ; (* //XDS *)
        END;
        IF e = errVerboserHelp THEN
            WrLn;
            WrStr(evenmorehelpmsg);
        END;
        e:=errHelp;
    | errOption :      S:='Illegal "'+placeholder+'" option !';
    | errParameter :   S:='"'+placeholder+'" is just one parameter too many !';
    | errBadNumber:    S:='Illegal value in "'+placeholder+'" option !';
    | errInkRange:     S:="Ink range is [0..15] !";
    | errPaperRange:   S:="Paper range is [0..15] !";
    | errCountRange:   S:="Count range is [1..1000] !";
    | errMALLOC:       S:="Storage.ALLOCATE() failed !";
    | errFormat:       S:='Illegal or undefined tilde command ("'+placeholder+'") !';
    | errSentenceTooBig:S:="Formatted sentence is too big !";
    | errWidthRange:   S:="Illegal line width !";
    | errJoker:        S:='At least one illegal joker in "'+placeholder+'" !';
    | errNotFound:     S:='No valid file matches "'+placeholder+'" specification !';
    | errLoading:      S:='Error while loading "'+placeholder+'" !';
    | errReallyNotFound:S:='No valid file matches "'+placeholder+'" specification !';
    | errPauseRange:   S:="Pause range is [0..30] !";
    | errNotInSaverMode: Str.Copy(S,einfo);
    | errNotInNormalMode:Str.Copy(S,einfo);
    | errTooManyFiles: S:='Too many files match "'+placeholder+'" specification !';
    | errBadJokers:    S:='At least one invalid joker in "'+placeholder+'" !';
    | errOnlyForList:  S:='-list option is required to process "'+placeholder+'" !'; (* containing at least one joker ! *)

    | errNetwork:      S:='Illegal network reference in "'+placeholder+'" !';
    | errColon:        S:='":" problem in "'+placeholder+'" !';
    | errUnit:         S:='Illegal unit in "'+placeholder+'" !';
    | errNoParent:     S:='"'+placeholder+'" has no parent directory !';
    | errEmpty:        S:='"'+placeholder+'" contains only unit part !';
    | errInnerParent:  S:='Illegal inner parent in "'+placeholder+'" !';
    | errDirJoker:     S:='At least one illegal joker in "'+placeholder+'" path !';
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp: ;
    ELSE
        Str.Subst(S,placeholder,einfo);
        WrLn;
        WrStr(ProgEXEname+" : "); WrStr(S); WrLn;
    END;
    HALT; (* ah, yes, they have added a silly extension to HALT; ! *)
END abort;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* taken almost verbatim from OLDNEW v1.1f and TRIM v1.1 code, out of weariness *)

TYPE
    pFname = POINTER TO fnameType;
    fnameType = RECORD
        next      : pFname;
        slen      : CARDINAL; (* a SHORTCARD could do but who knows ? *)
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pFname );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pFname);
VAR
    needed : CARDINAL;
    p      : pFname;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(fnameType) - SIZE(anchor^.str) + anchor^.slen;
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pFname; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(fnameType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pFname);
VAR
    len:CARDINAL;
BEGIN
    len := p^.slen;
    Lib.FastMove(  SYSTEM.ADR(p^.str)  , SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

(* ------------------------------------------------------------ *)

(* Str.Match is not case sensitive *)

PROCEDURE isReservedPattern (S,skipthem:ARRAY OF CHAR):BOOLEAN;
VAR
    e3 : str16;
    n:CARDINAL;
    rc:BOOLEAN;
BEGIN
    rc:=FALSE;
    n:=0;
    LOOP
        isoleItemS(e3, skipthem,delim,n);
        IF same(e3,"") THEN EXIT; END;
        Str.Prepend(e3,"*");
        IF Str.Match(S,e3) THEN rc:=TRUE;EXIT; END;
        INC(n);
    END;
    RETURN rc;
END isReservedPattern;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildFileList (VAR anchor:pFname;
                        noskip,DEBUG :BOOLEAN;
                        spec:pathtype):CARDINAL;
VAR
    count:CARDINAL; (* should do ! *)
    ok,found:BOOLEAN;
    entry : FIO.DirEntry;
    dosattr:FIO.FileAttr;
    entryname:pathtype;
    len : CARDINAL;
    pp:pFname;
    excludeme1,excludeme2:BOOLEAN;
BEGIN
    count:=0;
    found := FIO.ReadFirstEntry(spec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        excludeme1 := isReservedEntry   (entryname);  (* skip "." and ".." *)
        IF noskip THEN
            excludeme2 := FALSE;
        ELSE
            excludeme2 := isReservedPattern (entryname,skippedextensions );
        END;
        IF NOT(excludeme1 OR excludeme2) THEN
            dosattr:=entry.attr;
            IF NOT (aDD IN dosattr) THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=STRNOTFOUND THEN
                    Str.Append(entryname,".");
                END;
                IF DEBUG THEN WrStr("Included : ");WrStr(entryname);WrLn; END;
                len:=Str.Length(entryname);
                IF buildNewPtr(anchor,pp,len)=FALSE THEN
                    RETURN PBTOOMANY; (* errStorage *)
                END;
                INC(count);
                pp^.slen      := len;
                Lib.FastMove ( SYSTEM.ADR( entryname),SYSTEM.ADR( pp^.str ),len );
            ELSE
                IF DEBUG THEN WrStr("Ignored  : ");WrStr(entryname);WrLn;END;
            END;
        ELSE
            IF DEBUG THEN WrStr("Excluded : ");WrStr(entryname);WrLn;END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN count;
END buildFileList;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (8 * 512) + FIO.BufferOverhead;
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBuffer  = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC; (* //XDS a mere BYTE ! *)
VAR
    bufferIn  : ioBuffer;

CONST
    mincount    = 1;
    maxcount    = 10000; (* was 1000 *)
    frameNone   = 0;
    frameSingle = 1;
    frameDouble = 2;
    frameRaw    = 3;
    minframe    = frameNone;
    maxframe    = frameRaw;

(* ------------------------------------------------------------ *)

PROCEDURE pack (VAR S : ARRAY OF CHAR;dumb:BOOLEAN; older,newer:ARRAY OF CHAR);
VAR
    p,pold,lenold,lennew:CARDINAL;
BEGIN
    IF dumb THEN (* will pack repeatedly *)
        LOOP
            IF Str.Pos(S,older)=STRNOTFOUND THEN EXIT; END;
            Str.Subst(S,older,newer);
        END;
    ELSE (* won't eat "\\\\\" to "\" *)
        lenold:=Str.Length(older); (* normally 2 *)
        lennew:=Str.Length(newer); (* normally 1 *)
        p:=10;
        LOOP
            pold:=Str.NextPos(S,older,p);
            IF pold = STRNOTFOUND THEN EXIT; END;
            Str.Delete(S,pold,lenold);
            Str.Insert(S,newer,pold);
            INC(pold,lennew);
            p:=pold;
        END;
    END;
END pack;

(*
    almost useless, for data was already verified,
    but as our dmpTTX proc does not check punctuation marks...
*)

PROCEDURE cleanstring (fullclean:BOOLEAN; VAR S : ARRAY OF CHAR);
CONST
    dumb=TRUE;
BEGIN
    pack(S,dumb,space+space      ,space);
    pack(S,dumb,space+dot        ,dot);
    pack(S,dumb,space+comma      ,comma);
    IF fullclean THEN
    pack(S,dumb,space+semicolon  ,semicolon);
    pack(S,dumb,space+colon      ,colon);
    pack(S,dumb,space+exclamation,exclamation);
    pack(S,dumb,space+question   ,question);
    END;
END cleanstring;

CONST
    firstline = 1;
    maxline   = 2000; (* was 500 before was 50, already oversized ! *)
VAR
    sline  : ARRAY [firstline..maxline] OF str256; (* was str128, str144 would create too large an object *)
    slen   : ARRAY [firstline..maxline] OF CARDINAL;

CONST
    (*            012345     *)
    sSingle    = "ڳ"; (* XDS : these box chars look ok from DOS console *)
    sDouble    = "ɺͼ"; (* XDS : the same *)
    sNone      = "      ";
    wiHORIZ    = 4; (* bar, space, ... , space, bar *)
    wiVERTI    = 4; (* line, filler, ... , filler, line *)
    wiHORIZalt = 2; (* space, ... , space *)
    wiVERTIalt = 2; (* filler, ... , filler *)

(* uses global sline[] and slen[] arrays *)

PROCEDURE dmpSentence (screenwidth,linewidth,doFrame:CARDINAL;
                      doBeautify,glue:BOOLEAN;
                      lastline,longest:CARDINAL);
VAR
    plus,len,i,j,k    : CARDINAL;
    frameChars   : str16;
    S            : str128;
    neednl:BOOLEAN;
BEGIN
    len := longest;

    CASE doFrame OF
    | frameNone   : frameChars := sNone;   plus:=0;
    | frameSingle : frameChars := sSingle; plus:=2;
    | frameDouble : frameChars := sDouble; plus:=2;
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT ! *)
    END;

    CASE doFrame OF
    | frameRaw :
        IF NOT(glue) THEN WrLn;END;

        FOR j:=firstline TO lastline DO
            WrStr(sline[j]);
            neednl :=( slen[j] < linewidth );
            neednl :=(neednl OR (linewidth # screenwidth) ); (* < *)
            IF neednl THEN WrLn; END;
        END;

    ELSE
        neednl := ((1+len+plus+1) < linewidth );
        neednl := (neednl OR (linewidth # screenwidth)); (* < *)

        WrLn;
        WrChar(frameChars[0]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[2]);
        IF neednl THEN WrLn; END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        FOR j:=firstline TO lastline DO
            WrChar(frameChars[1]);
            IF doFrame # frameNone THEN WrChar(space); END;
            WrStr(sline[j]);
            FOR k:=Str.Length(sline[j])+1 TO len DO
                WrChar(space);
            END;
            IF doFrame # frameNone THEN WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        IF doFrame # frameNone THEN
            WrChar(frameChars[1]);
            FOR i:=1 TO (len+plus) DO WrChar(space); END;
            WrChar(frameChars[1]);
            IF neednl THEN WrLn; END;
        END;

        WrChar(frameChars[3]);
        FOR i:=1 TO (len+plus) DO WrChar(frameChars[4]); END;
        WrChar(frameChars[5]);
        IF neednl THEN WrLn; END;
    END;
    IF doBeautify THEN WrLn; END;
END dmpSentence;

(* ------------------------------------------------------------ *)

(* try not to recurse nor overlap *)

PROCEDURE oldnewX (VAR R:ARRAY OF CHAR;oldstr,newstr:str16);
VAR
    p,newp,oldlen,newlen:CARDINAL;
BEGIN
    IF same(oldstr,newstr) THEN RETURN; END; (* avoid nonsense *)

    oldlen:=Str.Length(oldstr);
    newlen:=Str.Length(newstr);
    p:=0;
    LOOP
        newp:=Str.NextPos(R,oldstr,p);
        IF newp = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(R,newp,oldlen);
        Str.Insert(R,newstr,newp);
        p:=newp+newlen;
        IF p >= Str.Length(R) THEN EXIT; END;
    END;
END oldnewX;

PROCEDURE cleanescaped (VAR S:ARRAY OF CHAR); (* //FIXME *)
CONST
    dumb = FALSE;
BEGIN
    pack(S,dumb,escbackslash        ,backslash);
    (* //FIXME handle other reserved chars too ? *)
    pack(S,dumb,escopencurly        ,opencurly);
    pack(S,dumb,escclosecurly       ,closecurly);
END cleanescaped;

PROCEDURE autocapitalize (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
    c : CHAR;
BEGIN
    LOOP
        p:=Str.Pos(S,capmarker);
        IF p=STRNOTFOUND THEN EXIT; END;
        Str.Subst(S,capmarker,"");
        c:=S[p];
        IF c # nullchar THEN
            UpperCase(c);
            S[p]:=c;
        END;
    END;
END autocapitalize;

PROCEDURE autolow (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
    c : CHAR;
BEGIN
    LOOP
        p:=Str.Pos(S,lowmarker);
        IF p=STRNOTFOUND THEN EXIT; END;
        Str.Subst(S,lowmarker,"");
        c:=S[p];
        IF c # nullchar THEN
            LowerCase(c);
            S[p]:=c;
        END;
    END;
END autolow;

(* identical to pack("\&","") ! *)

PROCEDURE autosuffix (VAR S : ARRAY OF CHAR);
VAR
    p : CARDINAL;
    c : CHAR;
BEGIN
    LOOP
        p:=Str.Pos(S,suffixmarker);
        IF p=STRNOTFOUND THEN EXIT; END;
        Str.Subst(S,suffixmarker,"");
    END;
END autosuffix;

PROCEDURE autoelision (n:CARDINAL; VAR S : ARRAY OF CHAR);
VAR
    prevp,p : CARDINAL;
    c       : CHAR;
    seq     : str16;
BEGIN
    IF Str.Length(S)=0 THEN RETURN; END; (* don't bother ! *)
  CASE n OF
  | 1:
    (*
    handle "?\' ?" sequence only, i.e. character, elision marker, space, character
            01234
    *)
    prevp:=1; (* ignore possible "\'" at the beginning of S *)
    LOOP
        p:=Str.NextPos(S,elisionmarker,prevp);
        IF p= STRNOTFOUND THEN EXIT; END;
        Str.Slice(seq, S, p-1, lenpossibleElision);
        IF Str.Match(seq,possibleElision) THEN
            c:=S[p-1+lenpossibleElision-1];
            UpperCase(c);
            IF Belongs(elisionRequired,c) THEN
                Str.Delete(S,p-1,lenpossibleElision-1);    (* remove "?\' " *)
                Str.Insert(S,singlequote,p-1); (* insert "'" *)
                prevp:=p;                      (* restart after the single quote we just inserted *)
            ELSE
                Str.Delete(S,p,lenmarker); (* just remove elision marker, leaving first character and space *)
                prevp:=p; (* yes, we could restart after last character...  *)
            END;
        ELSE
            prevp:=p+lenmarker; (* skip "\'" marker *)
        END;
    END;
  | 2:
         (*
         brutal and even kludgy for letter case
         does not handle all possible cases such as "\! le"
         (would require a "previous char not letter" operator)
         DOS and Vindoze accents : zut !
         we know it and we won't care until v2.0
         *)
         oldnewX(S," de"+packmarker+" le "," du ");
         oldnewX(S," De"+packmarker+" le "," Du ");
         oldnewX(S," DE"+packmarker+" LE "," DU ");

         oldnewX(S," "+packmarker+" le "," au ");
         oldnewX(S," A"+packmarker+" le "," Au ");
         oldnewX(S," A"+packmarker+" LE "," AU ");

         oldnewX(S,packmarker,"");

         (* handle " ce\' [aeiouyh]? " => " cet " *)

  ELSE
     ; (* //ISO silly requirement *)
  END;
END autoelision;

(*
   handle "A\- ?" sequence only, i.e. "a", article marker, space, character
           01234
*)

PROCEDURE autoarticle (VAR S : ARRAY OF CHAR);
VAR
    prevp,p : CARDINAL;
    c,ourA,ourN : CHAR;
    seq     : str16;
BEGIN
    IF Str.Length(S)=0 THEN RETURN; END; (* don't bother ! *)
    prevp:=1; (* ignore possible "\-" at the beginning of S *)
    LOOP
        p:=Str.NextPos(S,articlemarker,prevp);
        IF p= STRNOTFOUND THEN EXIT; END;
        Str.Slice(seq, S, p-1, lenpossibleArticle);
        UpperCase(seq);
        IF Str.Match(seq,possibleArticle) THEN
            c:=S[p-1+lenpossibleArticle-1];
            UpperCase(c);
            IF Belongs(articleRequired,c) THEN
                ourA := S[p-1];
                (* it's "A" or "a" *)
                IF ourA = "A" THEN
                    ourN := "n"; (* too smart ! *)
                ELSE
                    ourN := "n";
                END;
                Str.Delete(S,p,lenmarker);     (* remove "\-" *)
                Str.Insert(S,ourN,p);  (* insert "N" or "n" *)
                prevp:=p+1;            (* restart after the added letter *)
            ELSE
                Str.Delete(S,p,lenmarker); (* just remove article marker *)
                prevp:=p; (* yes, we could restart after last character...  *)
            END;
        ELSE
            prevp:=p+lenmarker; (* skip "\-" marker *)
        END;
    END;
END autoarticle;

(* uses global sline[] and slen[] arrays *)

PROCEDURE formatSentence (LineWidth,doFrame:CARDINAL;fullclean:BOOLEAN;
                          VAR lastline,longest:CARDINAL;S:ARRAY OF CHAR):BOOLEAN;
VAR
    tmplen  : CARDINAL;
    tmp               : str256;   (* could be str128 but... *)
    splitagain        : BOOLEAN;
    p                 : CARDINAL;
    Z                 : strHUGE;  (* just in case *)
BEGIN
    cleanstring(fullclean,S);
    cleanescaped(S);
    autocapitalize(S);
    autolow(S);
    autosuffix(S);
    autoelision(1,S); (* FR 1 *)
    autoelision(2,S); (* FR 2 *)
    autoarticle(S); (* US *)

    CASE doFrame OF
    | frameRaw : ;
    | frameNone:
        DEC(LineWidth,wiHORIZalt); (* string + 2 spaces *)
    ELSE
        DEC(LineWidth,wiHORIZ);    (* string + 2 spaces + 2 bars *)
    END;

    lastline  := firstline-1;
    longest   := 0;

    LOOP
        p:=Str.Pos(S,newlinemarker);
        IF p = STRNOTFOUND THEN EXIT; END;
        Str.Slice(Z,S,0,p);
        Str.Delete(S,0,p+lenmarker); (* "\!" CRLF marker takes two characters *)

        splitagain:=dmpTTX(Z,LineWidth,tmp,TRUE);
        WHILE splitagain DO
            Str.Copy(sline[firstline+lastline],tmp);
            tmplen:=Str.Length(tmp);
            slen[firstline+lastline]:=tmplen;
            IF tmplen > longest THEN longest := tmplen; END;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
            splitagain:=dmpTTX(Z,LineWidth,tmp,FALSE);
        END;
        IF Str.Pos(S,newlinemarker)=0 THEN
            Str.Copy(sline[firstline+lastline], "");
            slen[firstline+lastline]:=0;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
        END;
    END;

        splitagain:=dmpTTX(S,LineWidth,tmp,TRUE);
        WHILE splitagain DO
            Str.Copy(sline[firstline+lastline],tmp);
            tmplen:=Str.Length(tmp);
            slen[firstline+lastline]:=tmplen;
            IF tmplen > longest THEN longest := tmplen; END;
            INC(lastline);
            IF lastline >= maxline THEN RETURN FALSE; END;
            splitagain:=dmpTTX(S,LineWidth,tmp,FALSE);
        END;

    RETURN TRUE;
END formatSentence;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE wrlngcard (v:LONGCARD;wi:CARDINAL);
VAR
    S:str16;
    ok:BOOLEAN;
    i:CARDINAL;
BEGIN
    Str.CardToStr( v,S,10,ok);
    IF NOT(ok) THEN S:="ERROR !";END;
    FOR i:=Str.Length(S)+1 TO wi DO Str.Prepend(S,blank);END;
    WrStr(S);
END wrlngcard;

PROCEDURE wrcard (v,wi:CARDINAL);
BEGIN
    wrlngcard( LONGCARD(v),wi);
END wrcard;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    MAXHASH  = MAX(CARDINAL); (* 65535 *)
TYPE
    ptrEntry = POINTER TO entryType;
    entryType = RECORD
        next     : ptrEntry;
        len      : CARDINAL; (* was SHORTCARD but now we accept long sentences... *)
        string   : CHAR;       (* here, after other data, because variable length *)
    END;
TYPE
    categoryType = RECORD
        anchor      : ptrEntry;
        count       : CARDINAL; (* // LONGCARD is useless *)
        hash        : CARDINAL;
        varindex    : CARDINAL; (* 0=uninitialized index, max(cardinal)=not a var *)
        id          : str32;
        tags        : str32;
    END;
CONST
    firstcategory = 1;   (* must be 1 *)
    maxcategory   = 500;
VAR
    category     : ARRAY [firstcategory..maxcategory] OF categoryType;
    lastcategory : CARDINAL;

(* ------------------------------------------------------------ *)

(*
   0=first tag i.e. text between open curly and first vbar,
   1=2nd tag i.e. text between first vbar and next terminator (either vbar or close curly)
   //FIXME note findvariant handles escaped sequences thus not allowing calling categories !
*)

PROCEDURE findvariant (wanted:CARDINAL;VAR S : ARRAY OF CHAR);
VAR
    len,p:CARDINAL;
    R:strHUGE;
    state:(waiting,incurly,escaped);
    c:CHAR;
    currtag:CARDINAL;
BEGIN
    len:=Str.Length(S);
    IF len=0 THEN RETURN;END; (* should never happen *)
    Str.Copy(R,"");
    state:=waiting;
    p:=0;
    WHILE p < len DO
        c:=S[p];
        CASE state OF
        | waiting:
            CASE c OF
            | opencurly:
                state:=incurly; currtag:=0;
            ELSE
                Str.Append(R,c);
            END;
        | incurly:
            CASE c OF
            | backslash : Str.Append(R,c);state:=escaped;
            | closecurly: state:=waiting;
            | IDSEPAR   : INC(currtag);
            ELSE
                IF currtag=wanted THEN Str.Append(R,c);END;
            END;
        | escaped:
            Str.Append(R,c);
            state:=incurly;
	    ELSE
	        ; (* //XDS SILLY USELESS REQUIREMENT ! *)
        END;
        INC(p);
    END;
    CASE state OF
    | waiting: ; (* nada OR {*} *)
    | incurly: ; (* {* *)
    | escaped: ; (* never ! *)
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT ! *)
    END;
    Str.Copy(S, R);
END findvariant;

(* ------------------------------------------------------------ *)

PROCEDURE getnextkeywords (len:CARDINAL;S:ARRAY OF CHAR;
                           VAR p,basep,count:CARDINAL;
                           VAR W,T:ARRAY OF CHAR ):BOOLEAN ;
VAR
    state:(waiting,chkescaped,incategory,intag);
    c:CHAR;
    ok:BOOLEAN;
BEGIN
    (* "\xxx", "\xxx/x" *)

    basep:=p;
    count:=0;

    Str.Copy(W,"");
    Str.Copy(T,"");

    state:=waiting;
    LOOP
        IF NOT (p<len) THEN EXIT; END;
        c := S[p];
        UpperCase(c);
        CASE state OF
        | waiting:
            CASE c OF
            | backslash: Str.Copy(W,c);state:=chkescaped; (* IDINVOKE *)
            ELSE
                INC (count);
            END;
        | chkescaped:
            IF Belongs(legalforcategory,c) THEN (* // was alphanum *)
                Str.Append(W,c);
                state:=incategory;
            ELSE
                INC(count,lenmarker);    (* pass "\?" = 1+1 *)
                state:=waiting;
                Str.Copy(W,"");  (* just in case *)
            END;
        | incategory:
            IF Belongs(legalforcategory,c) THEN (* // was alphanum  *)
                Str.Append(W,c);
            ELSE
                CASE c OF
                | IDINVOKE:   RETURN TRUE; (* "\xx\" *)
                | IDVARIANT:  Str.Copy(T,c);state:=intag; (* "\xx/" *)
                ELSE
                    RETURN TRUE; (* "\xx?" *)
                END;
            END;
        | intag:
            IF Belongs(legalfortag,c) THEN (* // was alphanum+commercial *)
                Str.Append(T,c);
                INC(p); (* pass char *)
                RETURN TRUE; (* only one letter or digit or & after "/" i.e. "\xx/?" *)
            ELSE
                (* "\xx/?" assume empty tag *)
                RETURN TRUE;
            END;
    	ELSE
	        ; (* //XDS SILLY USELESS REQUIREMENT ! *)
        END;
        INC(p);
    END;
    CASE state OF
    | waiting    : ok:=FALSE; (* nothing was found *)
    | chkescaped : ok:=FALSE; (* "*\" *)
    | incategory : ok:=TRUE;  (* "*\x" *)
    | intag      : ok:=TRUE;  (* "\xx/" *)
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT ! *)
    END;
    RETURN ok;
END getnextkeywords;

PROCEDURE docapskeywords (VAR S:ARRAY OF CHAR  );
VAR
    R,TMP : strHUGE;
    len,p,basep,count : CARDINAL;
    W,T : str128;
BEGIN
    len:=Str.Length(S);
    IF len=0 THEN RETURN;END; (* should never happen *)

    Str.Copy(R,"");
    p:=0;
    WHILE getnextkeywords(len,S, p,basep,count, W,T) DO
        Str.Slice (TMP, S, basep,count);
        Str.Append(R,TMP);
        Str.Append(R,W);
        Str.Append(R,T);
    END;
    Str.Slice (TMP, S,basep,count);
    Str.Append(R,TMP);

    Str.Copy(S, R);
END docapskeywords;

(* ------------------------------------------------------------ *)

PROCEDURE isoleweight (VAR S : ARRAY OF CHAR):CARDINAL ;
VAR
    p,q,n:CARDINAL ;
    S2 : str32;
    v  : LONGCARD;
    ok: BOOLEAN;
BEGIN
    IF S[0]=openparen THEN
        p:=0;
        q:=Str.CharPos(S,closeparen);
        IF q = STRNOTFOUND THEN RETURN NOWEIGHTHERE;END; (* "(..." *)
        Str.Slice(S2,S,p+1,q-p-1);
        IF verifyString(S2,digits)=FALSE THEN RETURN NOWEIGHTHERE;END; (* we could return 1 but use (1)(...) trick instead *)
        Str.Delete(S,p,q-p+1); (* S[p]:=nullchar; *)
        v:=Str.StrToCard(S2,10,ok);
        IF ok = FALSE THEN RETURN NOWEIGHTHERE;END;
        IF v > MAX(SHORTCARD) THEN RETURN NOWEIGHTHERE;END; (* 1..255 *)
        n:=CARDINAL(v);
    ELSE
        n:=1;
    END;
    RETURN n;
END isoleweight;

PROCEDURE addData (VAR newInList:ptrEntry;VAR problems:CARDINAL;
                   doanchor:BOOLEAN; i:CARDINAL;
                   S:ARRAY OF CHAR);
VAR
    len,needed:CARDINAL;
    p : ptrEntry;
BEGIN
    IF same(S,EMPTYSTRING) THEN Str.Copy(S,"");END;
    problems:=0;
    len    := Str.Length(S);
    needed := SIZE(entryType)-SIZE(CHAR)+len;
    IF doanchor THEN
        ALLOCATE( p,needed);
        newInList := p;
        category[i].anchor := p;
    ELSE
        ALLOCATE(newInList^.next,needed);
        newInList :=newInList^.next;
    END;
    Lib.FastMove( SYSTEM.ADR( S ) ,SYSTEM.ADR( newInList^.string ),len);
    newInList^.len       := len;
    newInList^.next      := NIL;
    INC( category[i].count);
END addData;

(* S is category, S2 is tags between curlies *)

PROCEDURE isoletags (VAR S,S2:ARRAY OF CHAR ):BOOLEAN ;
VAR
    p,q:CARDINAL;
BEGIN
    Str.Copy(S2,""); (* default *)
    Str.Delete(S,0,1); (* remove tilde IDCLASS *)
    p:=Str.CharPos(S,opencurly);
    q:=Str.RCharPos(S,closecurly);
    IF p = STRNOTFOUND THEN
        IF q # STRNOTFOUND THEN RETURN FALSE;END; (* } alone *)
    ELSE
        IF q = STRNOTFOUND THEN RETURN FALSE;END; (* { alone *)
        IF p > q THEN RETURN FALSE; END; (* }*{ *)
        Str.Slice(S2,S,p+1,q-p-1);
        Str.Delete(S,p,q-p+1); (* S[p]:=nullchar; *)
    END;
    IF Str.Length(S)  > SIZE(str32) THEN RETURN FALSE; END;
    UpperCase(S);
    IF verifyString(S ,legalforcategory)=FALSE THEN RETURN FALSE;END; (* // was alphanum *)

    IF Str.Length(S2) > SIZE(str32) THEN RETURN FALSE; END;
    UpperCase(S2);
    IF verifyString(S2,legalfortag)=FALSE THEN RETURN FALSE;END; (* // was alphanum *)
    RETURN TRUE;
END isoletags;

PROCEDURE readScript (debug:BOOLEAN; datafile:pathtype) : BOOLEAN;
VAR
    hin : FIO.File;
    S,SPLUS   : strHUGE;  (* oversized just in CASE *)
    rc,ateof  : BOOLEAN;
    i,problems,j,weight,position,len: CARDINAL;
    p   : ptrEntry;
    S2  : str32;
    currline : CARDINAL;
    id:CHAR;
BEGIN
    FOR i := firstcategory TO maxcategory DO
        category[i].anchor   := NIL;
        category[i].count    := UNDEFINEDCOUNT;
    END;

    i:=firstcategory-1;
    p:=NIL;
    rc:=TRUE;
    currline := 0;

    hin := FIO.OpenRead(datafile);
    FIO.AssignBuffer(hin,bufferIn);

    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        (* IF FIO.EOF THEN EXIT; END; *)
        LtrimBlanks(S);
        RtrimBlanks(S);
        (* handle multiline here but we won't bother to check for 4096 chars limit ! *)
        position:=Str.Pos(S,concatenatemarker);
        len := Str.Length(S);
        IF ( (position # STRNOTFOUND) AND (len >= lenmarker) ) THEN
            (* do not test directly with len-2 ! it would confuse single character entry ! *)
            IF position=(len-lenmarker) THEN
                ateof := FALSE;
                LOOP
                    FIO.RdStr(hin,SPLUS);
                    IF FIO.EOF THEN ateof:=TRUE; EXIT; END;
                    LtrimBlanks(SPLUS);
                    RtrimBlanks(SPLUS);
                    Str.Subst(S,concatenatemarker,""); (* was space *)
                    Str.Append(S,SPLUS);
                    position:=Str.Pos(S,concatenatemarker);
                    len := Str.Length(S);
                    IF ( (position=STRNOTFOUND) OR (len<lenmarker) ) THEN EXIT; END;
                    IF position # (len-lenmarker) THEN EXIT; END;
                END;
                IF ateof THEN EXIT; END;
            END;
        END;

        (* resume normal operation *)
        INC(currline);
        IF debug THEN wrcard(currline,5);WrStr(" : ");WrStr(S);WrLn;END;
        id:=S[0];
        CASE id OF
        | nullchar, semicolon, pound: ; (* empty or comment *)
        | IDCLASS, IDVAR :
            INC(i);
            IF i > maxcategory THEN rc:=FALSE;EXIT;END;

            IF isoletags(S,S2)=FALSE THEN rc:=FALSE;EXIT;END;
            Str.Copy(category[i].id,S);
            Str.Copy(category[i].tags,S2);
            category[i].hash := Lib.HashString(S,MAXHASH);
            category[i].count:= 0;
            IF id = IDCLASS THEN
                j:=ISNOTVAR;
            ELSE
                j:=UNDEFINEDVAR;
            END;
            category[i].varindex:=j;

            (* //FIXME should we allow a fixed variable to have variant(s) ? nope *)
            (* //FIXME constant ok for string literals but not for called CLASS *)
	
        ELSE
            IF i >= firstcategory THEN (* handle illegal entry before any category is defined ! *)
	            (* // LONGCARD was useless *)
            	CASE category[i].count OF
            	| UNDEFINEDCOUNT: rc:=FALSE;EXIT;
            	| 0 :
                    weight:=isoleweight(S);
                    IF weight=NOWEIGHTHERE THEN rc:=FALSE;EXIT; END;
                    docapskeywords(S);
                    addData(p,problems,  TRUE,i,  S);
                ELSE
                    weight:=isoleweight(S);
                    IF weight=NOWEIGHTHERE THEN rc:=FALSE;EXIT; END;
                    docapskeywords(S);
                    addData(p,problems,  FALSE,i,  S);
                END;
                IF problems # 0 THEN rc:=FALSE;EXIT;END;
                FOR j:=1 TO weight-1 DO
                    IF problems=0 THEN addData(p,problems,  FALSE,i,  S); END;
                END;
	        END;
        END;
    END;
    FIO.Close(hin);
    IF debug THEN WrLn;END;
    lastcategory := i;
    RETURN rc;
END readScript;

(* ------------------------------------------------------------ *)

PROCEDURE dumpquoted (S:ARRAY OF CHAR   );
BEGIN
    WrStr('"');
    WrStr(S);
    WrStr('"');
END dumpquoted;

(* //FIXME we should improve debug : forward or unexistant references *)

PROCEDURE dumpit (i:CARDINAL;full:BOOLEAN);
CONST
    msgIndex    = "Index    : ";
    msgCount    = "Count    : ";
    msgVar      = "Variable : ";
    msgCategory = "Category : ";
    msgTags     = "Tags     : ";
    msgEntry    = "           ";
    msgTerseB   = "Category[";
    msgTerseE   = "] = ";

    localplaceholder = CHR(255); (* was vbar *)
VAR
    firstInList,newInList : ptrEntry;
    S     : strHUGE;  (* huge just in case ! *)
    len,p : CARDINAL;
    tags,Z: str128; (* should do *)
BEGIN
    IF NOT(full) THEN
        WrStr(msgTerseB);  wrcard(i,4);
        WrStr(msgTerseE);
        Str.Copy(Z,category[i].id);
        IF category[i].varindex = ISNOTVAR THEN
            Str.Prepend(Z,IDCLASS);
        ELSE
            Str.Prepend(Z,IDVAR);
        END;
        dumpquoted(Z);
        WrLn;
        RETURN;
    END;
    WrStr(msgIndex);wrcard(i,4);WrLn;
    WrStr(msgCount);wrcard(category[i].count,4);WrLn; (* // WrLngCard 8 *)
    WrStr(msgVar);
    p:=category[i].varindex;
    IF p = ISNOTVAR THEN
        Z:="no";
    ELSE
        Z:="yes"; (* index decided at runtime *)
    END;
    WrStr(Z);WrLn;
    WrStr(msgCategory);dumpquoted(category[i].id);WrLn;
    WrStr(msgTags);dumpquoted(category[i].tags);WrLn;
    WrLn;

    firstInList := category[i].anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
        firstInList := firstInList^.next;
        len         := CARDINAL(newInList^.len);
        Lib.FastMove( SYSTEM.ADR(  newInList^.string ),SYSTEM.ADR(S),len);
        S[len]      := nullchar; (* REQUIRED safety ! *)

        WrStr(msgEntry);dumpquoted(S);
        WrLn;

        newInList := firstInList;
    END;
    WrLn;

    Str.Copy(tags,category[i].tags);

    IF same(tags,"") THEN RETURN; END;

    FOR p:=0 TO Str.Length(tags) DO
        Str.Concat(Z,"::: Caller : ",IDINVOKE); (* //XDS silly compiler ! *)
	    Str.Append(Z,localplaceholder); (* //FIXME : was antislash ! *)
        CASE p OF
        | 0 :
            Str.Subst(Z,localplaceholder,category[i].id); (* calling without any tag *)
        ELSE
            Str.Append(Z,IDVARIANT);         (* //XDS silly compiler ! *)
	        Str.Append(Z,localplaceholder);
            Str.Subst(Z,localplaceholder,category[i].id);
            Str.Subst(Z,localplaceholder,category[i].tags[p-1]); (* \category/tagletter *)
        END;
        WrStr(msgEntry);dumpquoted(Z);WrLn;
        WrLn;

        firstInList := category[i].anchor;
        newInList := firstInList;
        WHILE newInList # NIL DO
            firstInList := firstInList^.next;
            len         := CARDINAL(newInList^.len);
            Lib.FastMove( SYSTEM.ADR( newInList^.string ),SYSTEM.ADR(S),len);
            S[len]      := nullchar; (* REQUIRED safety ! *)
            (* variant using p index *)
            findvariant (p,S);

            WrStr(msgEntry);dumpquoted(S);WrLn;

            newInList := firstInList;
        END;
        WrLn;
    END;

END dumpit;

PROCEDURE dumpall (  );
VAR
    i : CARDINAL;
BEGIN
    FOR i := firstcategory TO lastcategory DO
        dumpit(i,FALSE);
    END;
    WrLn;
    FOR i := firstcategory TO lastcategory DO
        dumpit(i,TRUE);
    END;
END dumpall;

PROCEDURE freeit ( i : CARDINAL);
VAR
    len,needed      : CARDINAL;
    firstInList,newInList   : ptrEntry;
BEGIN
    firstInList := category[i].anchor;
    newInList := firstInList;
    WHILE newInList # NIL DO
         len         := CARDINAL(newInList^.len);
         needed      := SIZE(entryType)-SIZE(CHAR)+len;
         firstInList := firstInList^.next;
         DEALLOCATE (newInList,needed);
         newInList := firstInList;
    END
END freeit;

PROCEDURE freeall ();
VAR
    i : CARDINAL;
BEGIN
    FOR i := firstcategory TO lastcategory DO
        freeit(i);
    END;
END freeall;

(* ------------------------------------------------------------ *)

(* assume there's enough room in R ! *)

PROCEDURE loadString (ndx:CARDINAL;VAR R:ARRAY OF CHAR);
VAR
    firstInList,newInList:ptrEntry;
    i,n, len:CARDINAL;
BEGIN
    IF category[ndx].count=0 THEN Str.Copy(R,"");RETURN;END; (* returning "???" was useless *)
    n := GetRndCardRange ( 1 ,category[ndx].count); (* 1=mincategory *)

    CASE category[ndx].varindex OF
    | UNDEFINEDVAR : category[ndx].varindex := n; (* define it now *)
    | ISNOTVAR     :  ;
    ELSE
        n:=category[ndx].varindex;
    END;

    (* n := GetRndLngCardRange (1,category[ndx].count); *)
    firstInList := category[ndx].anchor;
    newInList := firstInList;
    DEC(n); (* trick to force to anchor if 1, and locate correct string if > 1 *)
    FOR i:= 1 TO n DO
        firstInList := firstInList^.next;
        newInList := firstInList;
    END;
    len := CARDINAL(newInList^.len);
    Lib.FastMove( SYSTEM.ADR( newInList^.string ),SYSTEM.ADR( R ),len);
    R[len] := nullchar; (* REQUIRED safety ! *)
END loadString;

PROCEDURE findcategoryindex (VAR i : CARDINAL;W:ARRAY OF CHAR):BOOLEAN;
VAR
    hash:CARDINAL;
BEGIN
    Str.Delete(W,0,1); (* remove marker *)
    hash:=Lib.HashString(W,MAXHASH);
    i:=firstcategory;
    LOOP
        IF category[i].hash=hash THEN
            IF same(W,category[i].id) THEN RETURN TRUE; END;
        END;
        INC(i);
        IF i > lastcategory THEN RETURN FALSE;END;
    END;
END findcategoryindex;

PROCEDURE getVariant (i:CARDINAL;T:ARRAY OF CHAR;VAR R:ARRAY OF CHAR);
VAR
    wanted : CARDINAL;
BEGIN
    loadString(i,R);   (* \*, * or {*} *)
    Str.Delete(T,0,1); (* remove marker *)
    IF Str.Length(T)=0 THEN RETURN;END;
    wanted:=Str.CharPos(category[i].tags,T[0]);
    IF wanted = STRNOTFOUND THEN
        wanted:=0; (* keep "{*|" if any *)
    ELSE
        INC(wanted);
    END;
    findvariant(wanted,R);
END getVariant;

PROCEDURE getSentence (debug:BOOLEAN; VAR R : ARRAY OF CHAR):BOOLEAN;
VAR
    len,p,basep,count:CARDINAL;
    i:CARDINAL;
    msg : strHUGE;
    W,T,prevT : str128;
    rc : BOOLEAN;
BEGIN
    loadString(lastcategory,R); (* main string *)
    Str.Copy(prevT,"");
    rc:=TRUE;
    LOOP
        len:=Str.Length(R);
        p:=0;
        IF getnextkeywords(len,R, p,basep,count, W,T)=FALSE THEN EXIT;END;
        IF debug THEN
            WrStr("tag0: ");dumpquoted(prevT);WrLn;
            WrStr("str : ");dumpquoted(R);WrLn;
            WrStr("cat : ");dumpquoted(W);WrLn;
            WrStr("tag : ");dumpquoted(T);WrLn;
            WrLn;
        END;
        IF findcategoryindex(i,W)=FALSE THEN rc:=FALSE; EXIT; END;
        IF same(T,"") THEN
            getVariant(i,IDsuppress,msg); (* force an impossible tag to remove text between curlies *)
            Str.Subst(R,W,msg);
            (* Str.Copy(prevT,T); *)
        ELSIF same(T,IDHERIT) THEN (* "/&" *)
            IF same(prevT,"") THEN
                getVariant(i,IDsuppress,msg);
            ELSE
                getVariant(i,prevT,msg);
            END;
            Str.Subst(R,T,"");
            Str.Subst(R,W,msg);
        ELSE                       (* "/?" *)
            getVariant(i,T,msg);
            Str.Subst(R,T,"");
            Str.Subst(R,W,msg);
            Str.Copy(prevT,T);
        END;
    END;
    RETURN rc;
END getSentence;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE padstr (VAR S:ARRAY OF CHAR;alt:BOOLEAN;mini,maxi:CARDINAL);
VAR
    i:CARDINAL;
BEGIN
    FOR i := mini TO maxi DO
        IF alt THEN
            Str.Prepend(S,space);
        ELSE
            Str.Append(S,space);
        END;
    END;
END padstr;

CONST
              (* "fff.e       " *)
              (* "      ff.ee " *)
              (* "ffffffff.eee" if DOS f8e3 *)
    sBase      = "; Directory";
    sepabout   =  " : ";

PROCEDURE fmtFileName ( VAR R:pathtype;
                      useLFN,altdisplay:BOOLEAN; maxlenfilename:CARDINAL;
                      S : pathtype );
CONST
    f8len      = 8;
    e3len      = 3;
    rightalign = TRUE; (* prettier *)
VAR
    p:CARDINAL;
BEGIN
    Str.Copy(R,S);
    IF Str.RCharPos(R,dot)=STRNOTFOUND THEN Str.Append(R,dot);END;

    IF useLFN THEN
        padstr(R, rightalign,  Str.Length(R)+1, maxlenfilename);
    ELSE
        p:=Str.RCharPos(R,dot);
        padstr(R, rightalign,  p+1,f8len);
        p:=Str.RCharPos(R,dot);
        padstr(R, FALSE,       Str.Length(R)+1,f8len+1+e3len);
    END;
END fmtFileName;

(* assume file exists *)

PROCEDURE showtitle (maxlenfilename,linewidth:CARDINAL;
                    DEBUG:BOOLEAN;
                    zebase,zefile:pathtype);
CONST
    msgUndefined = "(undefined or not a "+ProgEXEname+" script)";
    msgMore      = "...";
    lenMsgMore   = 3;
    maxtryline   = 10;
VAR
    hin:FIO.File;
    S : strHUGE;
    state:(waiting,gottitle);
    F,F2:pathtype;
    remopen,remclose:str16;
    i,len,slen,currline:CARDINAL;
BEGIN
    fmtFileName(F, TRUE, TRUE,maxlenfilename,zefile); (* first TRUE is LFN *)
    Str.Append(F,sepabout);
    Str.Concat(F2,zebase,zefile);
    IF DEBUG THEN
        WrStr("F showtitle : ");WrStr(F);WrLn;
        WrStr("F2 showtitle: ");WrStr(F2);WrLn;
    END;

    hin := FIO.OpenRead(F2);
    FIO.AssignBuffer(hin,bufferIn);

    currline:=0;
    state:=waiting;
    FIO.EOF:=FALSE;
    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,S);
        (* IF FIO.EOF THEN EXIT; END; *)
        LtrimBlanks(S);
        RtrimBlanks(S);
        CASE S[0] OF
        | commentchar1,commentchar2:
            Str.Delete(S,0,1);
            LtrimBlanks(S);
            FOR i:=1 TO 3 DO
                CASE i OF
                | 1 : remopen:=comment1; remclose:="";        (* //  *)
                | 2 : remopen:=comment2; remclose:="";        (* ::: *)
                | 3 : remopen:=comment3; remclose:=comment3a; (*     *)
    		    ELSE
	    	        ; (* //XDS SILLY USELESS REQUIREMENT ! *)
                END;
                IF Str.Pos(S,remopen)=0 THEN
                    IF same(remclose,"") THEN
                        INC(state);
                    ELSE
                        slen:=Str.Length(S);
                        len :=Str.Length(remclose);
                        IF slen >= len THEN
                            Str.Slice(F2,S,slen-len,len);
                            IF same(F2,remclose) THEN
                                S[slen-len]:=nullchar;
                                RtrimBlanks(S);
                                INC(state);
                            END;
                        END;
                    END;
                END;
                IF state # waiting THEN EXIT; END;
            END;
    	ELSE
	        ; (* //XDS SILLY USELESS REQUIREMENT ! *)
        END;
        INC(currline);
        IF currline > maxtryline THEN EXIT; END;
    END;
    FIO.Close(hin);
    CASE state OF
    | waiting :
        F2:=msgUndefined;
    | gottitle:
        Str.Delete(S,0,Str.Length(remopen));
        LtrimBlanks(S);
        Str.Copy(F2,S);
    ELSE
        ; (* //XDS SILLY USELESS REQUIREMENT *)
    END;
    Str.Append(F,F2);
    (*
    IF redirected THEN
        WrStr(F);WrLn;
    *)
        slen:=Str.Length(F);
        IF slen >= linewidth THEN
            F[linewidth-lenMsgMore-1]:=nullchar; (* brutal *)
            Str.Append(F,msgMore);
        END;
        WrStr(F);WrLn;
END showtitle;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE initDefaultFilenames(VAR exedir,currdir,defaultdatfile:pathtype; ext:ARRAY OF CHAR);
VAR
    exe,u,d,f8,e3:str128; (* str128 was already oversized for DOS library used here *)
    currunit:SHORTCARD;
BEGIN
    Lib.ParamStr(exe,0);
    (* UpperCaseAlt(exe); (* useless but... *) *)
    qdSplitAllPath(exe,u,d,f8,e3);
    Lib.MakeAllPath(exedir,u,d,"","");
    Lib.MakeAllPath(defaultdatfile,"","",f8,ext);
    currunit:=FIO.GetDrive(); (* 1=A etc. *)
    FIO.GetDir(currunit,currdir); (* "\*" *)
    Str.Prepend(currdir,colon);
    Str.Prepend(currdir, CHR( CARDINAL(currunit)+ORD("A")-1) );
    fixDirectory(currdir); (* add trailing "\" *)
END initDefaultFilenames;

PROCEDURE dbg (DEBUG:BOOLEAN;varname,varcontent:ARRAY OF CHAR);
CONST
    wi = 25;
VAR
    i:CARDINAL;
BEGIN
    IF DEBUG THEN
        WrStr("// ");WrStr(varname);
        IF same(varcontent,"") = FALSE THEN
            FOR i:=Str.Length(varname)+1 TO wi DO WrStr(" ");END;
            WrStr(" = ");
            WrStr(dquote);
            WrStr(varcontent);
            WrStr(dquote);
        END;
        WrLn;
    END;
END dbg;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //BUGJPI : Lib SplitAllPath() eats extension in directory part if path is fixed with a trailing "\" ! *)

PROCEDURE splitFileExt (VAR f,e:pathtype;S:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    p:=Str.RCharPos(S,dot);
    CASE p OF
    | 0 :
        RETURN FALSE; (* nonsense : extension without file ! *)
    | STRNOTFOUND :
        Str.Copy(f,S);
        Str.Copy(e,"");
    ELSE
        Str.Slice(f,S,0,p);
        Str.Copy(e,S);
        Str.Delete(e,0,p+1);
    END;
    RETURN TRUE;
END splitFileExt;

(* currdir is "\" or "\*\" *)

PROCEDURE fileBuildParent (VAR parentdir:pathtype; currdir:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(currdir,antislash) THEN RETURN FALSE; END;
    unfixDirectory(currdir);
    p:=Str.RCharPos(currdir,antislash);
    Str.Slice(parentdir,currdir,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END fileBuildParent;

(* drive is never 0 i.e. default here  *)

PROCEDURE fileGetCurrdir (VAR sUnit:str2; VAR currdir:pathtype;
                         drive:SHORTCARD);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(sUnit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,currdir); (* "\path" without "u:" nor trailing "\" except at root *)
    IF currdir[1] # colon THEN Str.Prepend(currdir,sUnit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF currdir[1] = colon THEN Str.Delete(currdir,0,2);END; (* safety *)
    fixDirectory(currdir);
END fileGetCurrdir;

CONST
    rcNone            = 0;
    rcNetwork         = 1;
    rcColon           = 2;
    rcUnit            = 3;
    rcNoParent        = 4;
    rcEmpty           = 5;
    rcInnerParent     = 6;
    rcDirJoker        = 7;
    rcEntryIsFile     = 100; (* mere warning *)
    rcEntryNotFound   = 101; (* mere warning *)

PROCEDURE getErrcode (rc:CARDINAL  ):CARDINAL ;
VAR
    e:CARDINAL;
BEGIN
    CASE rc OF
    | rcNetwork       : e:=errNetwork;
    | rcColon         : e:=errColon;
    | rcUnit          : e:=errUnit;
    | rcNoParent      : e:=errNoParent;
    | rcEmpty         : e:=errEmpty;
    | rcInnerParent   : e:=errInnerParent;
    | rcDirJoker      : e:=errDirJoker;
    ELSE
                        e:=errNone;
    END;
    RETURN e;
END getErrcode;

(*
    remember dirs can have an extension, and LFNs can have inner dots
    we handle, whether u: or not

    *\\*                    network                     ok
    .                       current                     ok
    ..                      parent                      ok
    \                       root
    ""                      empty or u:                 ok

    .\xxx                   current\xxx   F/D           ok
    ..\xxx                  parent\xxx    F/D           ok

    xxx\                    current\xxx\                ok
    xxx\.                   current\xxx\                ok
    xxx\..                  parent                      ok
    xxx                     current\xxx   F/D           ok

    \xxx\                   \xxx\                       ok
    \xxx                    \xxx          F/D           ok

    *..*                    inner parent

*)

PROCEDURE fileFixSpec (VAR zebase,zespec:pathtype;
                      DEBUG:BOOLEAN;
                      raw,defaultspec,defaultext:pathtype):CARDINAL;
CONST
    netslash = antislash+antislash;
VAR
    drive:SHORTCARD;
    rc,len,p:CARDINAL;
    u:CHAR;
    S:pathtype;
    currdir:pathtype; (* "\" or "\*\" *)
    parentdir:pathtype;
    sUnit:str2; (* "u:" *)
    okparent:BOOLEAN;
BEGIN
    Str.Copy(S,raw);

    IF Str.Pos(S,netslash) # STRNOTFOUND THEN RETURN rcNetwork;END;
    rc:=rcNone;
    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                Str.Delete(S,0,2); (* remove u: *)
            ELSE
                rc:=rcUnit;
            END;
        ELSE
            rc:=rcUnit;
        END;
    ELSE
        rc:=rcColon;
    END;
    IF rc # rcNone THEN RETURN rc; END;
    dbg(DEBUG,"S without unit",S);

    IF same(S,"") THEN RETURN rcEmpty;END; (* should NEVER happen *)

    (* find current directory from (un)specified unit -- note S no longer has u: *)

    fileGetCurrdir(sUnit,currdir,  drive); (* "u:" and "\" or "\*\" *)
    dbg(DEBUG,"sUnit",sUnit);
    dbg(DEBUG,"currdir",currdir);
    okparent:=fileBuildParent(parentdir, currdir);
    IF okparent THEN
    dbg(DEBUG,"parentdir",parentdir);
    ELSE
    dbg(DEBUG,"no parent !","");
    END;

    (* handle classic cases : "."  ".."  ".\*"  "..\*"  "*"  "*\."  "*\.." *)

    IF same(S,dot) THEN Str.Copy(S,currdir);END;
    dbg(DEBUG,"S against .",S);

    IF same(S,dotdot) THEN
        IF NOT(okparent) THEN RETURN rcNoParent; END;
        Str.Copy(S,parentdir);
    END;
    dbg(DEBUG,"S against ..",S);

    IF Str.Match(S,dot+antislash+star) THEN Str.Subst(S,dot+antislash,currdir); END;
    dbg(DEBUG,"S against .\*",S);

    IF Str.Match(S,dotdot+antislash+star) THEN
        IF NOT(okparent) THEN RETURN rcNoParent; END;
        Str.Subst(S,dotdot+antislash,parentdir);
    END;
    dbg(DEBUG,"S against ..\*",S);

    IF Str.Match(S,antislash+star)=FALSE THEN Str.Prepend(S,currdir);END;
    dbg(DEBUG,"S against * not from root",S);

    IF Str.Match(S,star+antislash+dot) THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    dbg(DEBUG,"S against *\.",S);

    IF Str.Match(S,star+antislash+dotdot) THEN
        IF NOT(okparent) THEN RETURN rcNoParent;END;
        Str.Copy(S,parentdir);
    END;
    dbg(DEBUG,"S against *\..",S);

    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,dotdot) # STRNOTFOUND THEN RETURN rcInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    (* handle "*\" OR "* *)

    IF Str.Match(S,star+antislash) THEN
        Str.Concat(zebase,sUnit,S);
        Str.Copy(zespec,defaultspec);
        dbg(DEBUG,"zebase1",zebase);
        dbg(DEBUG,"zespec1",zespec);
        IF same(defaultext,"")=FALSE THEN
            IF Str.CharPos(zespec,dot)=STRNOTFOUND THEN Str.Append(zespec,defaultext);END;
        END;
        dbg(DEBUG,"zeSPEC1",zespec);
        IF chkJoker(zebase) THEN RETURN rcDirJoker; END;
    ELSE
        Str.Prepend(S,sUnit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,antislash);
        Str.Slice(zebase,S,0,p+1);
        Str.Slice(zespec,S,p+1,len-p);
        dbg(DEBUG,"zebase2",zebase);
        dbg(DEBUG,"zespec2",zespec);
        IF same(defaultext,"")=FALSE THEN
            IF Str.CharPos(zespec,dot)=STRNOTFOUND THEN Str.Append(zespec,defaultext);END;
        END;
        dbg(DEBUG,"zeSPEC2",zespec);
        IF chkJoker(zebase) THEN RETURN rcDirJoker; END;

        IF chkJoker(zespec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF isDirectory(S) THEN
                Str.Copy(zebase,S);
                fixDirectory(zebase); (* safety *)
                Str.Copy(zespec,defaultspec);
            ELSE
                (* either entry not found, or found a file *)
                IF FIO.Exists(S) THEN
                    IF Str.RCharPos(zespec,dot)=STRNOTFOUND THEN
                        Str.Append(zespec,dot); (* file extension *)
                    END;
                    RETURN rcEntryIsFile;
                ELSE
                    RETURN rcEntryNotFound;
                END;
            END;
            dbg(DEBUG,"zebase3",zebase);
            dbg(DEBUG,"zespec3",zespec);
        END;
    END;
    RETURN rcNone; (* OR rc *)
END fileFixSpec;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    defaultpat = star+extDAT; (* "*"+".TX" or "" ? *)
    mincolumns = 1+1+1+1+1;
    noskip     = FALSE; (* no reason FOR this TO be TRUE here *)
    defaultLineWidth = 80-1; (* was 80 *)
    maxcolumns = 132; (* should do *)
VAR
    parmcount,i,opt   : CARDINAL;
    S,R               : pathtype;
    state             : (waiting,gotparm1);
VAR
    doFrame : CARDINAL;
    doWait,doBeautify,doList : BOOLEAN;
    DODUMP,DOSTEPS,OUTPUTME : BOOLEAN;
    screenwidth,LineWidth:CARDINAL;
    exedir,currdir,defaultdatafile,datafile:pathtype;
    rawfilespec,zebase,zespec: pathtype;
    DEBUG,glue,fullclean:BOOLEAN;
    maxlenfilename,thislen,filecount:CARDINAL;
    anchor,ptr      : pFname;
    rc,lastpass:CARDINAL;
    clipok:BOOLEAN;
VAR
    v                 : LONGCARD;
    c1,c2             : CHAR;
    count   : CARDINAL;
    lastline,longest  : CARDINAL;
    hugestring        : strHUGE;  (* really huge sentence, just in case... *)
    chk               : BOOLEAN;
    keycode           : CARDINAL;
BEGIN
    FIO.IOcheck:=FALSE;

    (* handleVesa; *) (* useless, because we won't change video mode *)

    doFrame	:= frameDouble;
    doBeautify  := FALSE;
    LineWidth   := defaultLineWidth;
    count       := mincount;
    DODUMP      := FALSE;
    DOSTEPS     := FALSE;
    OUTPUTME    := TRUE;
    glue        := FALSE;
    doList      := FALSE;
    fullclean   := FALSE;

    state     := waiting;
    parmcount := Lib.ParamCount();

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S); cleanCLI(R); ReplaceChar(R,dquote,"");
        UpperCase(R);               (* seems ok for command line *)
        IF isOption(R) THEN
            opt := GetOptIndex (R, "?"+delim+"H"+delim+"HELP"+delim+
                                   "F:"+delim+"FRAME:"+delim+
                                   "N"+delim+"NEWLINE"+delim+"CR"+delim+"CRLF"+delim+
                                   "W:"+delim+"WIDTH:"+delim+
                                   "N:"+delim+"COUNT:"+delim+
                                   "DUMP"+delim+
                                   "STEPS"+delim+
                                   "??"+delim+"HH"+delim+"FORMAT"+delim+
                                   "G"+delim+"GLUE"+delim+
                                   "L"+delim+"LIST"+delim+
                                   "K"+delim+"CLEAN"+delim+
                                   "???"+delim+"HHH"+delim+
                                   "DEBUG"+delim+
				   "MEM"+delim+"CHKMEM"+delim+"TERSE" (* useless in fact *)
                               );
            CASE opt OF
            | 1,2,3 :
                abort(errHelp,"");
            | 4,5 :
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < minframe) OR (v > maxframe) ) THEN abort(errBadNumber,S); END;
                doFrame:=CARDINAL(v);
            | 6,7,8,9:
                doBeautify  := TRUE;
            | 10,11:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincolumns) OR (v > LONGCARD(maxcolumns)) ) THEN abort(errWidthRange,"");END;
                LineWidth:=CARDINAL(v);
            | 12,13:
                IF GetLongCard(S,v)=FALSE THEN abort(errBadNumber,S); END;
                IF ( (v < mincount) OR (v > maxcount) ) THEN abort(errCountRange,"");END;
                count:=CARDINAL(v);
            | 14: DODUMP:=TRUE;
            | 15: DOSTEPS:=TRUE;
            | 16,17,18:
                abort(errVerboseHelp,"");
            | 19,20:
                glue:=TRUE;
            | 21,22:
                doList:=TRUE;
            | 23,24:
                fullclean := TRUE;
            | 25,26:
                abort(errVerboserHelp,"");
            | 27:
                DEBUG := TRUE;
	    | 28,29,30:
	        OUTPUTME := FALSE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            CASE state OF
            | waiting :
                (*
                IF same(R,"?") THEN abort(errHelp,""); END;
                IF same(R,"??") THEN abort(errVerboseHelp,"");END;
                *)
                Str.Copy(rawfilespec,S); (* keep org case *)
            | gotparm1 :
                abort(errParameter,S);
	        ELSE
	            ; (* //XDS SILLY USELESS REQUIREMENT *)
            END;
            INC(state);
        END;
    END;

    initDefaultFilenames(exedir,currdir,defaultdatafile, extDAT);

    dbg(DEBUG,"exedir",exedir);
    dbg(DEBUG,"currdir",currdir);
    dbg(DEBUG,"defaultdatafile",defaultdatafile);

    IF state = waiting THEN
        IF doList THEN
            rawfilespec:=star;
        ELSE
            rawfilespec:=defaultdatafile;
        END;
    END;
    dbg(DEBUG,"rawfilespec 1",rawfilespec);

    rc:=fileFixSpec(zebase,zespec,DEBUG,rawfilespec,defaultpat,extDAT);
    dbg(DEBUG,"ZEbase",zebase);
    dbg(DEBUG,"ZEspec",zespec);
    rc:=getErrcode(rc);
    IF rc # errNone THEN abort(rc,rawfilespec);END;

    IF Str.CharPos(rawfilespec,antislash)=STRNOTFOUND THEN (* filename without path *)
        IF Str.Match(currdir,exedir) THEN (* case-insensitive *)
            lastpass:=1;
        ELSE
            lastpass:=2; (* we'll try exe dir *)
        END;
    ELSE
        lastpass:=1;
    END;

    initList(anchor);
    i:=1;
    LOOP
        CASE i OF
        | 1:
            IF DEBUG THEN WrStr("// step1"+nl);END;
        | 2:
            IF DEBUG THEN WrStr("// step2"+nl);END;
            freeList(anchor);
            initList(anchor);
            Str.Copy(zebase,exedir); (* try exe dir as base now *)
    	ELSE
	        ; (* //XDS SILLY USELESS REQUIREMENT *)
        END;
        Str.Concat(datafile,zebase,zespec);
        dbg(DEBUG,"full datafile",datafile);

        filecount := buildFileList(anchor,noskip,DEBUG,datafile);
        CASE filecount OF
        | 0 :
            IF i = lastpass THEN abort(errNotFound,datafile); END;
        | 1:
            getStr(zespec,anchor);
            Str.Concat(datafile,zebase,zespec);
            dbg(DEBUG,"single file",datafile);
            EXIT;
        | PBTOOMANY :
            abort(errTooManyFiles,datafile);
        ELSE
            IF doList THEN
                EXIT;
            ELSE
                abort(errOnlyForList,datafile);
            END;
        END;
        INC(i);
        IF i > lastpass THEN EXIT; END;
    END;

    (* ------------------------------------------------------------ *)
    (* handle -list command *)
    (* ------------------------------------------------------------ *)

    IF doList THEN
        WrLn;
        WrStr(sBase+sepabout);
        WrStr(dquote);
        WrStr(zebase);
        WrStr(dquote);
        WrLn;

        WrLn;
        maxlenfilename:=0;
        FOR i:=1 TO 2 DO
            ptr:=anchor;
            WHILE ptr # NIL DO
                getStr(datafile,ptr);
                CASE i OF
                | 1 :
                    thislen:=Str.Length(datafile);
                    IF thislen > maxlenfilename THEN maxlenfilename:=thislen;END;
                | 2 :
                    showtitle (maxlenfilename,LineWidth,
                              DEBUG,zebase,datafile);
                ELSE
		            ; (* //XDS SILLY USELESS REQUIREMENT *)
        		END;
                ptr:=ptr^.next;
            END;
        END;
        freeList(anchor);

        abort(errNone,"");
    END;

    (* ------------------------------------------------------------ *)
    (* -list command has been handled : handle single file *)
    (* ------------------------------------------------------------ *)

    getStr(zespec,anchor);
    Str.Concat(datafile,zebase,zespec);

    IF readScript(DODUMP,datafile)=FALSE THEN abort(errLoading,datafile); END; (* was errMALLOC *)
    IF DODUMP THEN dumpall(); END;

    InitRnd();

        IF count = mincount THEN glue:=FALSE;END;
        IF glue THEN WrLn;END;
        FOR i := mincount TO count DO
            IF getSentence(DOSTEPS,hugestring)=FALSE THEN
                abort(errFormat,hugestring);
            END;
            IF formatSentence(LineWidth,doFrame,fullclean,lastline,longest,hugestring)=FALSE THEN
                abort(errSentenceTooBig,"");
            END;
	    IF OUTPUTME THEN
	        dmpSentence (screenwidth,LineWidth,
                            doFrame,doBeautify,glue,lastline,longest);
	    END;

        END;

    (* useless but good practice *)

    freeall();

    abort(errNone,"");
END TextGen32.





