(* ---------------------------------------------------------------
Title         Q&D Wipe File
Overview      see help
Usage         see help
Notes
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn
	      -yes
	      -doc
	      -w (default here)
	      -mem

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
	      ah, they don't support conditional directives : why am I not surprised ?
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

              debug display is ugly but informative
              note we're limited to <= 4Gb files
              yes, yes, many functions should be in external libs...

              safety third, eh eh :
              nope, seriously, -apply is required in order to
              protect user from him/her/it-self

              file not found is not betrayed but silently ignored

              this is a subset of WIPEDATA
Bugs
Wish List     other random generators ?
              overwriting free space by creating files
              until no free space is left ?
	      a quieter mode ? bah...

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 30 Mar 16 an ugly really Q&D port from v1.0 for DOS
--------------------------------------------------------------- *)

MODULE WipeFile32;

IMPORT Lib;
IMPORT FIO;
IMPORT Str;
IMPORT IO;
IMPORT SYSTEM;


FROM IO IMPORT WrStr, WrLn;

FROM Storage IMPORT ALLOCATE, DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

PROCEDURE LowerCaseAlt (VAR S : ARRAY OF CHAR);
BEGIN
    (* Str.Lows(S); *) (* //FIXME !!! *)
END LowerCaseAlt;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)


PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)
PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);

    fixEquate(S); (* command line option xxx= becomes xxx: *)
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;


PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    fixEquate(s); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)
    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE fileSetRO(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRO;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    databuffersize      = 16384;
    sDATABUFFERSIZE     = "16384";
    firstdatabuffer     = 0;
    maxdatabuffer       = databuffersize-1;
CONST
    sOK                 = "+++ ";
    sPROBLEM            = "--- ";
    sINFO               = "::: ";
    sCANCELLED          = "--- ";  (* not a problem but show nothing was done *)
    sWARN               = "*** ";
    sNOTICE             = "    ";  (* question to user *)
    sFAKE               = " ;-)";  (* suffix *)
    sDBG                = "// ";
CONST
    sRANDBYTE           = "??";
    sRANDBUFFER         = "**";
    sRANDBUFFERREGEN    = "@@"; (* will be slower, much slower *)
    sDefaultBytePattern = "$00";
    sPassesRange        = "[1..48]"; (* insane upper value for paranoiacs ! *)
CONST
    flagPATBYTE         = 0; (* $## *)
    flagPATRNDBYTE      = 1; (* ?? *)
    flagPATRNDBUFF      = 2; (* ** *)
    flagPATRNDBUFFREGEN = 3; (* @@ *)
CONST
    allitemsperpass  = 0; (* all items for each pass step : default *)
    allpassesperitem = 1; (* all passes one item at a time *)
CONST
    extDOC              = dot+"DOC";
    extEXE              = dot+"EXE";
    extINI              = dot+"INI";
CONST
    (* lowercasealt *)
    fSwapWin92    = "386spart.par";
    fSwapWin98    = "win386.swp";
    fSwapWinXP    = "pagefile.sys";
    patSwapWin92  = "*\"+fSwapWin92;
    patSwapWin98  = "*\"+fSwapWin98;
    patSwapWinXP  = "*\"+fSwapWinXP;
CONST
    minProtected    = 1;
    maxProtected    = 64; (* at least 3 ! *)
    strMaxProtected = "64";

(* ------------------------------------------------------------ *)

CONST
    progEXEname      = "WIPEFILE32";
    progTitle        = "Q&D Zero File Data (Win32)";
    progVersion      = "v0.9 (from v1.0 for DOS)";


    progCopyright    = "by PhG";
    progBanner       = progTitle+" "+progVersion+" "+progCopyright;

CONST
    errNone            = 0;
    errHelp            = 1;
    errMissingParm     = 2;
    errOption          = 3;
    errTooManyParms    = 4;
    errBadBytePattern  = 5;
    errNoMatch         = 6;
    errProtection      = 7;
    errStorage         = 8;
    errNetSlash        = 9;
    errPhantomUnit     = 10;
    errBadUnit         = 11;
    errColon           = 12;
    errNoParent        = 13;
    errInnerParent     = 14;
    errDirJoker        = 15;
    errEntryIsFile     = 16;
    errEntryNotFound   = 17;
    errMoreHelp        = 18;

    errDoc             = 19;
    errRedirected      = 20;

    errCancelled       = 192;

    errAborted         = 255;

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    placeholder     = "|";
    helpplaceholder = "~"; (* vbar is used in text *)
    msgBEWARE =
"BE SURE TO KNOW WHAT YOU ARE DOING ! USE THIS OPTION AT YOUR OWN RISK !";
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

msgHelp =
progBanner+nl+
nl+
"Syntax : "+progEXEname+" <file(s)> [option]..."+nl+
nl+
"This program overwrites file(s) data using specified byte pattern"+nl+
'(one byte per pass, default pattern is "'+sDefaultBytePattern+'").'+nl+
nl+
"-apply REALLY apply any requested modification to existing data"+nl+
'       (default is to fake requested modification, as shown by "'+sFAKE+'" trailer)'+nl+
"       "+msgBEWARE+nl+
'-b:$   byte pattern (default is "'+sDefaultBytePattern+'")'+nl+
"-p     perform all passes one file at a time"+nl+
"-a     use alternate random number generator"+nl+
"-esc   disable ESCape polling (unwise but may be necessary with Win9X/WinXP)"+nl+
"-s     recurse subdirectories"+nl+
"-x     ignore existing "+progEXEname+extINI+nl+
"-swaps do not default to swapfiles protection"+nl+
'       ("'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'")'+nl+
"-k     delete file once its data have been overwritten"+nl+
"-j     filter files using operating system jokers (read note infra)"+nl+
"-??    more help (to be read at least once !)"+nl+
nl+
"a) For safety, program does NOT really overwrite data"+nl+
"   unless any of -apply, -doit or -really options is specified."+nl+
"b) For safety, program will assume read-only files are to be left untouched,"+nl+
"   and thus it will not process any read-only file."+nl+
"   ATTRIB command line tool may be used in order to change read-only status."+nl+
"c) -b:$ option accepts a string with one hexadecimal value per pass :"+nl+
'   first "$" is mandatory as a reminder whatever data follows ;'+nl+
'   values can be either concatenated or separated with "'+space+'", "'+dot+'" or "'+coma+'" ;'+nl+
'   "'+sRANDBYTE+'" = one random byte, "'+sRANDBUFFER+'" = a '+sDATABUFFERSIZE+"-bytes repeated random buffer,"+nl+
'   "'+sRANDBUFFERREGEN+'" = a '+sDATABUFFERSIZE+"-bytes unique random buffer (slower). "+
"Passes range is "+sPassesRange+"."+nl+
"d) Without -e option, program allows the ESCape key to abort."+nl+
"   Overwriting is not reversible : data already overwritten is lost forever !"+nl+
'e) Without -j option, "?" and "*" jokers do NOT work the DOS or Win9X way :'+nl+
'   "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"f) -esc and -x options should NOT be used and are NOT recommended."+nl+
"g) -yesIdo and -dwIm options are alternates for -really : use with caution."+nl+
"h) Data overwriting takes very long a time, especially with multiple passes :"+nl+
"   program may be best left unattended for hours while working."+nl+
'   Note "'+sRANDBUFFERREGEN+'" regularly recreates random buffer and is therefore very slow.'+nl;

msgMoreHelp =
"i) Up to "+strMaxProtected+" entries (M2 jokers supported) may be protected against overwriting,"+nl+
"   if specified in "+progEXEname+extINI+" file located in executable directory."+nl+
"   If such a file does not exist, these entries are protected by default :"+nl+
'   "'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'".'+nl+
"   Note this safety is not required if program is run from an alternate OS."+nl+
"j) "+helpplaceholder+nl+
"   "+helpplaceholder+nl+
"k) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Example : "+progEXEname+' -s -e c:\SRC\*.cpp -b:"$de ad BE EF"'+nl+
nl+
"Here is an example of "+progEXEname+extINI+" file :"+nl+
nl+
"   ;"+nl+
"   ; Entries matching these patterns will NOT be overwritten."+nl+
"   ; M2 jokers are allowed :"+nl+
'   ; "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"   ; Entries may be enclosed with double quotes if necessary."+nl+
"   ;"+nl+
"   ; Vindoze swap files should always be protected in this INI file,"+nl+
"   ; unless program is run from another OS such as a DOS boot disk."+nl+
"   ;"+nl+
"   *\386spart.par"+nl+
"   *\win386.swp"+nl+
"   *\pagefile.sys"+nl+
"   ;"+nl+
'   "*\index.dat"'+nl+
"   *\desktop.ini"+nl;

VAR
    S : str1024; (* oversized for possible LFN *)
    ok : BOOLEAN;
    SS : str4096; (* should DO *)
    p:CARDINAL;
BEGIN
    CASE e OF
    | errHelp,errMoreHelp :
        WrStr(msgHelp);
        IF e # errHelp THEN
            Str.Copy(SS,msgMoreHelp);

            (* now tell user about WIPEFILE.INI *)

            Lib.ParamStr(S,0); (* retrieve executable location : yes, we assume it ! *)
            p:=Str.RCharPos(S,dot);
            IF p # MAX(CARDINAL) THEN S[p]:=charnull;END;
            Str.Append(S,extINI);

            IF FIO.Exists(S) THEN
                S:=progEXEname+extINI+" was found in executable directory :";
                Str.Subst(SS,helpplaceholder,S);
                S:="protection against overwriting is available for its entries (unless -x).";
            ELSE
                S:=progEXEname+extINI+" was NOT found in executable directory :";
                Str.Subst(SS,helpplaceholder,S);
                S:="protection against overwriting is limited to swapfiles (unless -swaps).";
            END;
            Str.Subst(SS,helpplaceholder,S);
            WrStr(SS);
        END;
        e:=errHelp;
    | errMissingParm:   S := "<file(s)> expected !";
    | errOption:        S := 'Unknown "|" option !';
    | errTooManyParms:  S := '"|" is one parameter too many !';
    | errBadBytePattern:S := 'Illegal "|" pattern !';
    | errNoMatch:       S := 'No legal match for "|" specification !';
    | errProtection:    S := progEXEname+extINI+" should be checked for problems !";
    | errStorage :      S := 'Storage.ALLOCATE() failure while processing "|" specification !';
    | errNetSlash :     S := 'Illegal server "\\" in "|" specification !';
    | errPhantomUnit :  S := 'Unavailable unit in "|" specification !';
    | errBadUnit :      S := 'Illegal unit in "|" specification !';
    | errColon :        S := 'Unexpected ":" in "|" specification !';
    | errNoParent :     S := 'Unresolvable ".." in "|" specification !';
    | errInnerParent :  S := 'Illegal ".." in "|" specification !';
    | errDirJoker :     S := 'Illegal "|" directory joker(s) !';
    (* next two are never displayed *)
    | errEntryIsFile:   S := '"|" specification is not a directory !';
    | errEntryNotFound: S := '"|" specification does not exist !';

    | errDoc:           S := progEXEname+extDOC+" was not found !";
    | errRedirected:    S := "Redirection is not allowed with | command !";
                        Str.Subst(S,placeholder,einfo);
                        video(progEXEname+" : ",TRUE);video(S,TRUE); (* send message to screen anyway ! *)

    | errCancelled:     S:="Cancelled by user !"; (* never displayed *)

    | errAborted  :     S:="Aborted by user !";
    ELSE
        S := "This is illogical, Captain !";
    END;

    CASE e OF
    | errNone, errHelp, errCancelled :
        ;
    ELSE
        Str.Subst(S,placeholder,einfo);
        WrStr(progEXEname+" : "); WrStr(S); WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* ------------------------------------------------------------ *)

CONST
    ioBufferSize    = (16 * 512) + FIO.BufferOverhead; (* was 8 *)
    firstBufferByte = 1;
    lastBufferByte  = ioBufferSize;
TYPE
    ioBufferType = ARRAY [firstBufferByte..lastBufferByte] OF SYSTEM.LOC;
VAR
    ioBufferIn  : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE dmp (S1:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrLn;
END dmp;

PROCEDURE dmp2 (S1,S2:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrStr(S2);WrLn;
END dmp2;

PROCEDURE dmp3 (S1,S2,S3:ARRAY OF CHAR   );
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrLn;
END dmp3;

PROCEDURE dmp5 (S1,S2,S3,S4,S5:ARRAY OF CHAR);
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrStr(S4);WrStr(S5);WrLn;
END dmp5;

PROCEDURE dmp6 (S1,S2,S3,S4,S5,S6:ARRAY OF CHAR);
BEGIN
    WrStr(S1);WrStr(S2);WrStr(S3);WrStr(S4);WrStr(S5);WrStr(S6);WrLn;
END dmp6;

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO CARDINAL( ABS(wi) ) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmtcard (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmtcard;

PROCEDURE fmtbignum (base,wi:CARDINAL;v:LONGCARD):str16;
VAR
    i : CARDINAL;
    R:str16;
    ok,lo:BOOLEAN;
    pad,prefix,suffix:CHAR;
BEGIN
    CASE base OF
    | 16: pad:="0";prefix:="$"; suffix:=""; lo:=TRUE;
    ELSE
          pad:=" ";prefix:= ""; suffix:=""; lo:=FALSE;
    END;
    Str.CardToStr ( v, R, base, ok);
    FOR i:=Str.Length(R)+1 TO wi DO Str.Prepend(R,pad);END;
    IF lo THEN Str.Lows(R); END;
    Str.Prepend(R,prefix);Str.Append(R,suffix);
    RETURN R;
END fmtbignum;

PROCEDURE fmtnum (base,wi:CARDINAL;v:CARDINAL):str16;
BEGIN
    RETURN fmtbignum(base,wi,LONGCARD(v));
END fmtnum;

(* ------------------------------------------------------------ *)

PROCEDURE dbg (DEBUG,enquote:BOOLEAN;S1,S2:ARRAY OF CHAR );
CONST
    wi = 25-3-1;
VAR
    i:CARDINAL;
BEGIN
    IF NOT(DEBUG) THEN RETURN; END;
    WrStr(sDBG);
    WrStr(S1);
    FOR i:=Str.Length(S1)+1 TO wi DO WrStr(" ");END;
    WrStr(' : ');
    IF enquote THEN WrStr('"');END;
    WrStr(S2);
    IF enquote THEN WrStr('"');END;
    WrLn;
END dbg;

PROCEDURE dbgbool (DEBUG,TF:BOOLEAN;S1,ST,SF:ARRAY OF CHAR   );
BEGIN
    IF TF THEN
        dbg(DEBUG,FALSE,S1,ST);
    ELSE
        dbg(DEBUG,FALSE,S1,SF);
    END;
END dbgbool;

PROCEDURE dbgc (DEBUG:BOOLEAN;S1:ARRAY OF CHAR;v:CARDINAL);
BEGIN
    dbg(DEBUG,FALSE,S1,fmtcard(v,10,1,"",""));
END dbgc;

PROCEDURE dbglc (DEBUG:BOOLEAN;S1:ARRAY OF CHAR;v:LONGCARD);
BEGIN
    dbg(DEBUG,FALSE,S1,fmtlc(v,10,1,"",""));
END dbglc;

PROCEDURE dbgpat (DEBUG:BOOLEAN;i,flag:CARDINAL;b:SYSTEM.LOC);
VAR
    S:str16;
BEGIN
    IF NOT(DEBUG) THEN RETURN; END;
    WrStr(sDBG);
    WrStr(fmtcard(i,10,2,"",""));
    WrStr(" : ");
    CASE flag OF
    | flagPATBYTE:
                          S:="byte (|)";
                          Str.Subst(S,"|",fmtcard(CARDINAL(b),16,2,"0","$"));
    | flagPATRNDBYTE:     S:="random byte";
    | flagPATRNDBUFF:     S:="random buffer";
    | flagPATRNDBUFFREGEN:S:="RANDOM buffer";
    ELSE ; (* //ISO fixed silly requirement *) END;
    WrStr(S);WrLn;
END dbgpat;

CONST
    CHKEVERY9X = 64; (* let's call chkEscape every CHKEVERY LOOP *)
    CHKEVERYDOS= 4;  (* safety *)

PROCEDURE pollEscape (VAR chkrounds:CARDINAL; ignoreESC:BOOLEAN):BOOLEAN;
VAR
    alcatraz:BOOLEAN;
    every:CARDINAL;
BEGIN
    (*
    9x really does NOT like ChkEscape() and randomly hangs till a keypress
    Flushkey() does NOT help
    *)
    IF ignoreESC THEN RETURN FALSE;END;
    every:=CHKEVERY9X;
    INC(chkrounds);
    IF (chkrounds MOD every) = 0 THEN
        chkrounds:=0;
        alcatraz:=ChkEscape();
    ELSE
        alcatraz:=FALSE;
    END;
    RETURN alcatraz;
END pollEscape;

PROCEDURE runningManager (  ):BOOLEAN;
BEGIN
    ;
    RETURN FALSE; (* //FIXME *)
END runningManager;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* clever is not always faster : dynamic string allocation is much slower here -- and yes, we've tried it *)

VAR
    entryprotected      : ARRAY [minProtected..maxProtected] OF pathtype;

PROCEDURE preprocessLine (VAR S:pathtype);
VAR
    len:CARDINAL;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    (* we could use Str.Match(S,dquote+"*"+dquote) but... *)
    len:=Str.Length(S);
    IF len < 2 THEN RETURN; END; (* at least 1+1 for possible dquote+dquote *)
    IF S[len-1] # dquote THEN RETURN; END;
    IF S[0] # dquote THEN RETURN; END;
    S[len-1]:=charnull;
    Str.Delete(S,0,1);
    (* just in case *)
    LtrimBlanks(S);
    RtrimBlanks(S);
END preprocessLine;

(*
             ignoreini    forceswapfilesprotection
default      FALSE        TRUE
-swap        ?            FALSE
-x           TRUE         ?

if ini exists, its content override default protection unless -x was specified
if no ini, swapfiles protected unless -swaps
*)

PROCEDURE swapfilesprotectionFIX (forceswapfilesprotection,inihere,ignoreini:BOOLEAN):BOOLEAN;
BEGIN
    IF inihere THEN
        IF NOT(ignoreini) THEN
            forceswapfilesprotection:=FALSE; (* override possible default : user is responsible for ini entries *)
        END;
    END;
    RETURN forceswapfilesprotection;
END swapfilesprotectionFIX;

PROCEDURE initProtected (VAR lastprotected:CARDINAL;
                        ignoreini,forceswapfilesprotection,DEBUG:BOOLEAN):BOOLEAN;
VAR
    ini,fpat : pathtype;
    hin:FIO.File;
    p,i,pb:CARDINAL;
    S:str1024;
    inihere:BOOLEAN;
BEGIN
    Lib.ParamStr(ini,0);
    p:=Str.RCharPos(ini,dot);
    IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
    Str.Append(ini,extINI);
    inihere:=FIO.Exists(ini);

    forceswapfilesprotection:=swapfilesprotectionFIX(forceswapfilesprotection, inihere,ignoreini);
    dbgbool(DEBUG,forceswapfilesprotection,"force swapfiles protection","yes","no");

    lastprotected := minProtected-1;

    IF forceswapfilesprotection THEN
        FOR i:= 1 TO 3 DO
            CASE i OF
            | 1: S:=patSwapWin92;
            | 2: S:=patSwapWin98;
            | 3: S:=patSwapWinXP;
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(lastprotected);
            Str.Copy(entryprotected[lastprotected],S);
            IF DEBUG THEN
                WrStr("forced protected entry : ");WrStr(S);WrLn;
            END;
        END;
    END;

    IF ignoreini THEN RETURN TRUE; END;
    IF NOT(inihere) THEN RETURN TRUE; END;

    hin:=FIO.OpenRead(ini);
    FIO.AssignBuffer(hin,ioBufferIn);

    pb:=0;

    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,fpat);
        IF FIO.EOF THEN EXIT; END;

        preprocessLine (fpat);

        CASE fpat[0] OF
        | CHR(0), semicolon,pound :
            ;
        ELSE
            LowerCaseAlt(fpat); (* keep accents *)

            INC(lastprotected);
            IF lastprotected > maxProtected THEN INC(pb);EXIT;END;
            entryprotected[lastprotected]:=fpat;
            IF DEBUG THEN
                S:="Protected entry | : |";
                Str.Subst(S,"|",fmtnum(10,2,lastprotected));
                Str.Subst(S,"|",'"|"');
                Str.Subst(S,"|",fpat);
                WrStr(S);WrLn;
            END;
        END;
    END;
    FIO.Close(hin);
    RETURN (pb=0);
END initProtected;

PROCEDURE processMe (lastentry:CARDINAL;S:pathtype):BOOLEAN; (* ok=process it *)
VAR
    i:CARDINAL;
    rc,ok:BOOLEAN;
BEGIN
    rc:=TRUE;
    IF lastentry < minProtected THEN RETURN rc; END;
    LowerCaseAlt(S);
    i:=minProtected-1;
    LOOP
        INC(i);
        IF i > lastentry THEN EXIT; END;
        ok:=Str.Match(S,entryprotected[i]);
        IF ok THEN
            rc:=FALSE;
            EXIT;
        END;
    END;
    RETURN rc;
END processMe;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* code adapted from NEWLINE *)

PROCEDURE doGetDir (currdrive:SHORTCARD;
                   VAR currdir: pathtype);
VAR
    longform:pathtype;
    rc:CARDINAL;
BEGIN
    FIO.GetDir(currdrive,currdir); (* we could use 0 for default drive *)
END doGetDir;

(* u, "\*\", "u:\*\" *)

PROCEDURE getAnchor (VAR currdrive:SHORTCARD;
                     VAR currdir,currpath:pathtype);
VAR
    driveletter:CHAR;
BEGIN
    currdrive := FIO.GetDrive(); (* 1=A, etc. *)
    doGetDir(currdrive, currdir);
    fixDirectory(currdir);
    driveletter := CHAR (currdrive+ORD("A")-1);
    Str.Concat(currpath, driveletter,colon);
    Str.Append(currpath, currdir);
END getAnchor;

(* code adapted from FCOMP v1.3c *)

(* minimalist *)

PROCEDURE buildParent (VAR parent:pathtype; current:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(current,"\") THEN RETURN FALSE; END;
    unfixDirectory(current);
    p:=Str.RCharPos(current,"\");
    Str.Slice(parent,current,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END buildParent;

PROCEDURE doGetCurrent (drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(*
    remember dirs can have an extension, and LFNs can have inner dots !
    we handle (whether u: or not) :

    .        current
    ..       parent
    .\xxx    current\xxx       F/D
    ..\xxx   parent\xxx        F/D

    xxx\     current\xxx\
    xxx\.    current\xxx\
    xxx      current\xxx       F/D

    \xxx\    \xxx\
    \xxx     \xxx              F/D
*)

PROCEDURE chkfixSpec (VAR base,spec:pathtype;
                     orgS:pathtype):CARDINAL;
VAR
    p,len,rc:CARDINAL;
    drive:SHORTCARD;
    u:CHAR;
    unit:str2;
    current,parent,S:pathtype;
    ok:BOOLEAN;
BEGIN
    Str.Copy(S,orgS);
    IF Str.Pos(S,"\\") # MAX(CARDINAL) THEN RETURN errNetSlash;END;

    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
        rc:=errNone;
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                    drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                    Str.Delete(S,0,2); (* remove u: *)
                    rc:=errNone;
            ELSE
                rc:=errBadUnit;
            END;
        ELSE
            rc:=errColon;
        END;
    ELSE
        rc:=errColon;
    END;
    IF rc # errNone THEN RETURN rc; END;

    (* note S no longer has u: *)

    doGetCurrent(drive, unit,current); (* "u:" and "\" or "\*\" *)
    ok:=buildParent(parent, current);

    IF same(S,".") THEN Str.Copy(S,current);END;
    IF same(S,"..") THEN
        IF ok THEN Str.Copy(S,parent) ELSE RETURN errNoParent; END;
    END;
    IF Str.Match(S,".\*") THEN Str.Subst(S,".\",current); END;
    IF Str.Match(S,"..\*") THEN
        IF ok THEN Str.Subst(S,"..\",parent) ELSE RETURN errNoParent;END;
    END;
    IF Str.Match(S,"\*")=FALSE THEN Str.Prepend(S,current);END;
    IF Str.Match(S,"*\.") THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,"..") # MAX(CARDINAL) THEN RETURN errInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    IF Str.Match(S,"*\") THEN
        Str.Concat(base,unit,S);
        Str.Copy(spec,"*.*");
    ELSE
        Str.Prepend(S,unit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,"\");
        Str.Slice(base,S,0,p+1);
        Str.Slice(spec,S,p+1,len-p);
        IF chkJoker(spec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF isDirectory(S) THEN
                Str.Copy(base,S);
                fixDirectory(base); (* safety *)
                Str.Copy(spec,"*.*");
            ELSE
                (* //FIXED hopefully : either entry not found, or found a file *)
                IF FIO.Exists(S) THEN
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,"."); (* file extension *)
                    END;
                    RETURN errEntryIsFile;
                ELSE
(* T FIXCHKFIXSPEC *)
                    IF Str.RCharPos(spec,".")=MAX(CARDINAL) THEN
                        Str.Append(spec,".*");
                        Str.Append(S   ,".*");
                    END;
                    IF FIO.Exists(S) THEN
                        RETURN errEntryIsFile;
                    ELSE
                        RETURN errEntryNotFound;
                    END;
(* E  *)
(* F FIXCHKFIXSPEC
                    RETURN errEntryNotFound;
   E  *)
                END;
            END;
        END;
    END;
    IF chkJoker(base) THEN RETURN errDirJoker; END;
    (* //FIXED hopefully *)
    IF Str.Length(base) > 3 THEN (* "u:\" is assumed to always exist *)
        unfixDirectory(base);
        IF FIO.Exists(base)=FALSE THEN RETURN errEntryNotFound;END;
        fixDirectory(base);
    END;
    RETURN errNone;
END chkfixSpec;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstindex = 1; (* because we'll need 1-1 *)
TYPE
    pEntry = POINTER TO entryType;
    entryType = RECORD
        next      : pEntry;
        index     : CARDINAL;  (* [1.. is ID of base dir for files *)
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pEntry );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pEntry);
VAR
    needed : CARDINAL;
    p      : pEntry;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(entryType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pEntry; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(entryType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* ------------------------------------------------------------ *)

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pEntry);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

PROCEDURE findByIndex(wanted:CARDINAL;anchor:pEntry) : pEntry;
VAR
    p:pEntry;
BEGIN
    p := anchor;
    LOOP
        IF p = NIL THEN EXIT;END; (* gloups ! should NEVER happen ! *)
        IF p^.index = wanted THEN EXIT; END;
        p := p^.next;
    END;
    RETURN p;
END findByIndex;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildDirList (VAR lastdir:CARDINAL; VAR anchor:pEntry;
                       recurse:BOOLEAN;base:pathtype):CARDINAL;
VAR
    p: pEntry;
    len : CARDINAL;
    root,rootspec,entryname,newroot : pathtype;
    entry : FIO.DirEntry;
    ok,found : BOOLEAN;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    rc : CARDINAL;
BEGIN
    Str.Copy(root,base);
    fixDirectory(root); (* safety *)

    (* assume base exists ! *)

    len:=Str.Length(root);
    IF buildNewPtr(anchor,p,len)=FALSE THEN RETURN errStorage; END;
    INC(lastdir);
    p^.index     := lastdir;
    p^.slen      := SHORTCARD(len);
    Lib.FastMove ( SYSTEM.ADR(root),SYSTEM.ADR(p^.str),len );

    IF NOT(recurse) THEN RETURN errNone; END;

    Str.Concat(rootspec,root,"*.*");
    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;
            IF (aDD IN dosattr) THEN
                Str.Concat(newroot,root,entryname); (* u:\xx\ + xxx *)
                fixDirectory(newroot);
                rc:= buildDirList (lastdir,anchor,
                                  recurse,newroot);
                IF rc # errNone THEN
                    RETURN rc;
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END buildDirList;

PROCEDURE dmpDirs (anchor:pEntry);
CONST
    sInfo = 'DIR  index= ~  "~"'; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=anchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);  Str.Subst(S,"~",fmtcard(p^.index,10,5," ",""));
        Str.Subst(S,"~", R);
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpDirs;

PROCEDURE dmpFiles (fileanchor,diranchor:pEntry;dirindex:CARDINAL);
CONST
    sInfo = 'File index= ~  "~"'; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    base,R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=findByIndex(dirindex,diranchor);
    getStr(base,p);

    p:=fileanchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);
        Str.Subst(S,"~",fmtcard(p^.index,10,5," ",""));
        Str.Prepend(R,base);
        Str.Subst(S,"~", R);
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpFiles;

(* modified DD v1.0h sub *)

PROCEDURE storeFiles (VAR lastfile:CARDINAL;
                     VAR fileanchor : pEntry;
                     OSJOKERS:BOOLEAN; base,spec:pathtype):CARDINAL;
VAR
    matchspec,rootspec,entryname : pathtype;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    ok,keepit,found : BOOLEAN;
    len:CARDINAL;
    pp:pEntry;
BEGIN
    lastfile     := firstindex-1; (* 0 *)
    initList(fileanchor);

    IF OSJOKERS THEN
        Str.Concat(rootspec,base,spec);
        Str.Copy(matchspec,"*");         (* match everything *)
    ELSE
        Str.Concat(rootspec,base,"*.*"); (* was spec before osjoker option *)
        Str.Copy(matchspec,spec);
    END;

    (* allfiles is a better choice than everything here *)
    found := FIO.ReadFirstEntry(rootspec,allfiles,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;

            ok := NOT (aDD IN dosattr); (* was valid when we used everything attribute *)

            IF ok THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                ok:=Str.Match(entryname,matchspec); (* was spec *)
                IF ok THEN
                    len:=Str.Length(entryname);
                    IF buildNewPtr(fileanchor,pp,len)=FALSE THEN
                        RETURN errStorage;
                    END;
                    INC(lastfile);
                    pp^.index     := lastfile;
                    pp^.slen      := SHORTCARD(len);
                    Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END storeFiles;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* code adapted from UCLONE *)

PROCEDURE getvallc (VAR v : LONGCARD;
                   allowsepcosmetic:BOOLEAN;sepcosmetic:CHAR;
                   S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc   : LONGCARD;
    base : CARDINAL;
    ok   : BOOLEAN;
BEGIN
    IF S[0]="$" THEN
        Str.Delete(S,0,1);
        base := 16;
    ELSE
        base := 10;
    END;
    IF sepcosmetic = "" THEN allowsepcosmetic:=FALSE;END; (* better safe than sorry *)
    IF allowsepcosmetic THEN ReplaceChar(S,sepcosmetic,"");END; (* clean cosmetic separators *)
    lc:=Str.StrToCard(S,base,ok);
    IF NOT(ok) THEN RETURN FALSE; END;
    IF lc > MAX(LONGCARD) THEN RETURN FALSE; END; (* gloups... how could such a thing be ? ;-) *)
    v := lc;
    RETURN TRUE;
END getvallc;

PROCEDURE getval (VAR v : CARDINAL;
                 allowsepcosmetic:BOOLEAN;sepcosmetic:CHAR;
                 S:ARRAY OF CHAR):BOOLEAN;
VAR
    lc:LONGCARD;
BEGIN
    lc := LONGCARD(v);
    IF getvallc(lc,allowsepcosmetic,sepcosmetic,S) THEN
        IF lc > MAX(CARDINAL) THEN
            RETURN FALSE;
        ELSE
            v := CARDINAL(lc);
            RETURN TRUE;
        END;
    ELSE
        RETURN FALSE;
    END;
END getval;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstpass = 1;
    maxpass   = 48;
VAR (* globerks *)
    bytepat    : ARRAY[firstpass..maxpass] OF SYSTEM.LOC;
    flagpat    : ARRAY[firstpass..maxpass] OF CARDINAL;
    databuffer : ARRAY[firstdatabuffer..maxdatabuffer] OF SYSTEM.LOC;

CONST
    MINBYTE = 0; (* //XDS MIN(SYSTEM.LOC); *)
    MAXBYTE = 255; (* //XDS MAX(SYSTEM.LOC); *)
CONST
    TSRAND = 0;
    QDRAND = 1;

PROCEDURE getRndByte ( randmethod:CARDINAL ):SYSTEM.LOC;
VAR
    v:CARDINAL;
BEGIN
    CASE randmethod OF
    | TSRAND:  v:=Lib.RANDOM(MAXBYTE+1);
    | QDRAND:  v:=GetRndCardRange(MINBYTE,MAXBYTE);
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN SYSTEM.LOC(v);
END getRndByte;

PROCEDURE initRandom ( randmethod:CARDINAL  );
BEGIN
    CASE randmethod OF
    | TSRAND : Lib.RANDOMIZE();
    | QDRAND : InitRnd;
    ELSE ; (* //ISO fixed silly requirement *) END;
END initRandom;

PROCEDURE initDataBuffer (pass,randmethod:CARDINAL);
VAR
    i:CARDINAL;
    b:SYSTEM.LOC;
BEGIN
    CASE flagpat[pass] OF
    | flagPATBYTE  :
        b:=bytepat[pass];
        Lib.Fill(SYSTEM.ADR(databuffer),databuffersize,b);
    | flagPATRNDBYTE   :
        b:=getRndByte(randmethod);
        Lib.Fill(SYSTEM.ADR(databuffer),databuffersize,b);
    | flagPATRNDBUFF,flagPATRNDBUFFREGEN:
        FOR i:=firstdatabuffer TO maxdatabuffer DO
            databuffer[i]:=getRndByte(randmethod);
        END;
    ELSE ; (* //ISO fixed silly requirement *) END;
END initDataBuffer;

(* "$" + hexvalues either ## concatenated or separated with [ ,.] "??" "**" *)
(* assume S is already uppercased *)

CONST
    SEPCOSMETICFORBIDDEN = FALSE;
    SEPCOSMETICALLOWED   = TRUE;

PROCEDURE goodBytePattern (VAR lastpass:CARDINAL;
                          DEBUG:BOOLEAN;S:ARRAY OF CHAR):BOOLEAN;
CONST
    wihex = 2; (* "##", "??", "**" *)
VAR
    v,i:CARDINAL;
    useblank:BOOLEAN;
    N:str16;
    b:SYSTEM.LOC;
    flag:CARDINAL;
BEGIN
    dbg(DEBUG,TRUE,"byte pattern string",S);
    CASE S[0] OF
    | charnull: RETURN FALSE;
    | dollar:   Str.Delete(S,0,1);
    ELSE
                RETURN FALSE;
    END;
    ReplaceChar(S,coma,blank);
    ReplaceChar(S,dot ,blank);
    useblank:=( Str.CharPos(S,blank) # MAX(CARDINAL) );
    IF useblank THEN
        lastpass:=argc (S,FALSE);
    ELSE
        v:=Str.Length(S);
        lastpass:= v DIV wihex;
        IF (lastpass * wihex) # v THEN RETURN FALSE;END; (* don't get mad, get EVEN *)
    END;
    IF lastpass > maxpass THEN RETURN FALSE;END;

    flag:=flagPATBYTE;
    b   :=0;
    FOR i:=firstpass TO maxpass DO
        flagpat[i]:=flag;
        bytepat[i]:=b;
    END;

    FOR i:=firstpass TO lastpass DO
        IF useblank THEN
            argv(N, S,i,FALSE);
            IF same(N,sRANDBYTE[0]) THEN (* quietly fix lazy user *)
                N:=sRANDBYTE;
            ELSIF same(N,sRANDBUFFER[0]) THEN (* the same *)
                N:=sRANDBUFFER;
            ELSIF same(N,sRANDBUFFERREGEN[0]) THEN (* the same *)
                N:=sRANDBUFFERREGEN;
            ELSE
                IF Str.Length(N) < wihex THEN Str.Prepend(N,"0");END;
            END;
        ELSE
            Str.Slice(N, S,(i-1)*wihex,wihex);
        END;
        dbg(DEBUG,TRUE,"hexstr",N);
        IF same(N,sRANDBYTE) THEN
            flag:=flagPATRNDBYTE;
            b   := 0;
        ELSIF same(N,sRANDBUFFER) THEN
            flag:=flagPATRNDBUFF;
            b   := 0;
        ELSIF same(N,sRANDBUFFERREGEN) THEN
            flag:=flagPATRNDBUFFREGEN;
            b   := 0;
        ELSE
            Str.Prepend(N,dollar); (* uppercase "$##" *)
            IF getval (v, SEPCOSMETICFORBIDDEN,"",N)=FALSE THEN RETURN FALSE;END;
            IF v > MAXBYTE THEN RETURN FALSE;END; (* $00..$FF only of course *)
            flag:=flagPATBYTE;
            b:=SYSTEM.LOC(v);
        END;
        flagpat[i]:=flag;
        bytepat[i]:=b;

        dbgpat(DEBUG,i,flag,b);

    END;
    RETURN TRUE;
END goodBytePattern;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE wipefile (ndx,randmethod:CARDINAL;
                   REALLY,forceNEWRND:BOOLEAN;source:pathtype  );
CONST
    msg = "Overwriting, please wait... ";
VAR
    hnd:FIO.File;
    count:LONGCARD;
    remaining:LONGCARD;
BEGIN
    video(msg,TRUE);

    hnd :=FIO.Open(source);
    FIO.AssignBuffer(hnd,ioBufferIn);
    FIO.EOF:=FALSE; (* useless safety *)

    count := FIO.Size(hnd);

    remaining := count;
    LOOP
        IF forceNEWRND THEN initDataBuffer(ndx,randmethod);END;
        IF remaining <= LONGCARD(databuffersize) THEN
            IF REALLY THEN
                FIO.WrBin(hnd,databuffer, CARDINAL(remaining) );
            END;
            EXIT;
        END;
        IF REALLY THEN
            FIO.WrBin(hnd,databuffer,CARDINAL(databuffersize));
        END;
        DEC(remaining,LONGCARD(databuffersize));
    END;
    FIO.Close(hnd);
    video(msg,FALSE);
END wipefile;

PROCEDURE procWipeFile (lastprotected,ndx,lastndx,randmethod:CARDINAL;
                       DEBUG,SKIPRO,KILL,REALLY:BOOLEAN;
                       source:pathtype  );
VAR
    header,trailer,sval : str16;
    msg1,msg2:str80;
    forceNEWRND,wasRO,ok:BOOLEAN;
    v:CARDINAL;
BEGIN
    (* dbg(DEBUG,TRUE,"file",source); *)
    IF REALLY THEN
        trailer:="";
    ELSE
        trailer:=sFAKE;
    END;

    IF processMe(lastprotected,source)=FALSE THEN
        header:=sINFO;
        msg1:="Ignoring "+dquote;
        msg2:=dquote;
        dmp5(header,msg1,source,msg2,trailer);
        RETURN;
    END;

    ok:=TRUE;
    wasRO:=fileIsRO(source);

    IF wasRO THEN
        IF SKIPRO THEN (* ignore it *)
            header:=sINFO;
            msg1:="Skipping RO "+dquote;
            msg2:=dquote;
            ok:=FALSE;
        ELSE
            header:=sOK;
            msg1:="Overwriting RO "+dquote;
            msg2:=dquote+" with |, pass |";

            fileSetRW(source);

        END;
    ELSE
        header:=sOK;
        msg1:="Overwriting "+dquote;
        msg2:=dquote+" with |, pass |";
    END;
    forceNEWRND := FALSE;
    CASE flagpat[ndx] OF
    | flagPATBYTE :
        v:= CARDINAL( databuffer[ndx] );
        Str.Copy(sval,   fmtcard( v,16,2,"0","$") );
    | flagPATRNDBYTE:
        v:= CARDINAL( databuffer[ndx] );
        Str.Concat(sval, fmtcard( v,16,2,"0","$") , " (random)");
    | flagPATRNDBUFF:
        sval:="random bytes";
    | flagPATRNDBUFFREGEN:
        forceNEWRND := TRUE;
        sval:="RANDOM bytes";
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Subst(msg2,"|",sval);
    Str.Subst(msg2,"|",fmtcard(ndx,10,1,"",""));

    dmp5(header,msg1,source,msg2,trailer);
    IF ok THEN
        wipefile(ndx,randmethod,REALLY,forceNEWRND,source);
        IF ndx=lastndx THEN
            IF KILL THEN
                IF REALLY THEN
                    FIO.Erase(source);
                END;
                header:=sOK;
                IF wasRO THEN
                    msg1:='Deleted RO "';
                ELSE
                    msg1:='Deleted "';
                END;
                msg2:='"';
                dmp5(header,msg1,source,msg2,trailer);
            ELSE
                IF wasRO THEN fileSetRO(source);END; (* reset RO attribute *)
            END;
        END;
    END;
END procWipeFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    cmdtype = (cmdnone,
               cmdfiles);

PROCEDURE newcmd (VAR cmd:cmdtype;wanted:cmdtype):BOOLEAN;
VAR
    ok:BOOLEAN;
BEGIN
    ok:=TRUE;
    IF cmd = cmdnone THEN
        cmd:=wanted;
    ELSIF cmd = wanted THEN
        ;
    ELSE
        ok:=FALSE;
    END;
    RETURN ok;
END newcmd;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    msgWait    = "Please wait... ";
    sWARN_FILES= sWARN+"About to wipe FILE(S) data";
CONST
    firstparm       = 1;
    maxparm         = 1;
VAR
    parm : ARRAY[firstparm..maxparm] OF pathtype;
    parmcount,i,opt,lastparm:CARDINAL;
    S,R:pathtype;
VAR
    currdrive:SHORTCARD;
    currdir,currpath,specbase,orgspec,spec,rootspec,basepath,zefile:pathtype;
    pdir,diranchor,pf,fileanchor:pEntry;
    rc,lastdir,dirindex,lastfile,fileindex:CARDINAL;
VAR
    bye,ok,DEBUG: BOOLEAN;
    RECURSE,SKIPRO,OSJOKERS,KILL:BOOLEAN;
    flagIGNOREINI,flagFORCESWAPFILESPROTECTION : BOOLEAN;
    REALLY,IGNOREESCAPE,AUTOCONFIRM:BOOLEAN;
    cSEPCOUNT,cSEPCOSMETIC:CHAR;
    chkrounds,pass,passcount,subpass : CARDINAL;
    cmd:cmdtype;
    sBytePattern:str128;
    lc:LONGCARD;
    lastprotected,processmethod,randmethod,lastpass:CARDINAL;
BEGIN
    (* Lib.DisableBreakCheck(); *)
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)
    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    cmd               := cmdfiles;
    REALLY            := FALSE;
    SKIPRO            := TRUE;
    RECURSE           := FALSE;
    OSJOKERS          := FALSE;
    sBytePattern      := sDefaultBytePattern; (* "$00" *)
    randmethod        := QDRAND;
    processmethod     := allitemsperpass;
    IGNOREESCAPE      := FALSE;
    AUTOCONFIRM       := TRUE;
    chkrounds         := 0;
    KILL              := FALSE;
    cSEPCOUNT         := coma;
    cSEPCOSMETIC      := dot;
    flagIGNOREINI     := FALSE; (* -x will force existing ini to be ignored *)
    flagFORCESWAPFILESPROTECTION := TRUE;
    DEBUG             := FALSE;

    lastparm          := firstparm-1;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R, "?"+delim+"H"+delim+"HELP"+delim+
                                  "DEBUG"+delim+
                                  "A"+delim+"ALTERNATE"+delim+
                                  "B:"+delim+"BYTES:"+delim+
                                  "l"+delim+"lfn"+delim+

                                  "APPLY"+delim+"REALLY"+delim+"DOIT"+delim+
                                  "UPDATE"+delim+"WRITE"+delim+
                                  "w"+delim+"skipro"+delim+"ignorero"+delim+
                                  "S"+delim+"RECURSE"+delim+"SUBDIRS"+delim+

                                  "J"+delim+"JOKERS"+delim+"OS"+delim+
                                  "??"+delim+
                                  "mem"+delim+"fake"+delim+
                                  "E"+delim+"ESC"+delim+"ESCAPE"+delim+
                                  "P"+delim+"ALLPASSES"+delim+"PERITEM"+delim+
                                  "K"+delim+"KILL"+delim+

                                  "yes"+delim+"oui"+delim+"autoconfirm"+delim+
                                  "YESIDO"+delim+"DWIM"+delim+
                                  "X"+delim+"INI"+delim+"IGNOREINI"+delim+
                                  "SF"+delim+"SWAPS"+delim+"SWAPFILES"+delim+
                                  "doc"+delim+"man"
                              );
            CASE opt OF
            | 1,2,3 :   abort(errHelp,"");
            | 4:        DEBUG             := TRUE;
            | 5,6:      randmethod        := TSRAND;
            | 7,8:      GetString(R,sBytePattern); (* too late now to fix silly parms order ! *)
                        ok:= goodBytePattern(lastpass, DEBUG,sBytePattern);
                        IF NOT(ok) THEN abort(errBadBytePattern,S); END;
            | 9,10:     ;

            | 11,12,13: REALLY            := TRUE;
            | 14,15   : REALLY            := TRUE;
            | 16,17,18: ;
            | 19,20,21: RECURSE           := TRUE;

            | 22,23,24: OSJOKERS          := TRUE;
            | 25:       abort(errMoreHelp,"");
            | 26,27:    ;
            | 28,29,30: IGNOREESCAPE      := TRUE;
            | 31,32,33: processmethod     := allpassesperitem;
            | 34,35:    KILL              := TRUE;

            | 36,37,38: ;
            | 39,40:    REALLY            := TRUE;
            | 41,42,43: flagIGNOREINI     := TRUE;
            | 44,45,46: flagFORCESWAPFILESPROTECTION := FALSE;
            ELSE
                abort(errOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;
    CASE lastparm OF
    | firstparm-1:
        abort(errMissingParm,"");
    | firstparm:   (* spec *)
        (* cmd:=cmdfiles; *)
        Str.Copy(orgspec,parm[firstparm]);
    ELSE ; (* //ISO fixed silly requirement *) END;

    initRandom(randmethod);

    CASE cmd OF
    | cmdfiles:

        dbg  (DEBUG,TRUE,"cmd","FILES");
        dbg  (DEBUG,TRUE,"orgspec",orgspec);
        ok:=goodBytePattern(lastpass, DEBUG,sBytePattern);

        IF initProtected (lastprotected,
                         flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                         DEBUG)=FALSE THEN
            abort(errProtection,"");
        END;

        getAnchor(currdrive,currdir, currpath); (* u, "\*\", "u:\*\" *)

        rc:= chkfixSpec( specbase,spec, orgspec );
        CASE rc OF
        | errNone,errEntryIsFile,errEntryNotFound:
            ;
        ELSE
            abort(rc,orgspec);
        END;

        dbg  (DEBUG,TRUE,"specbase",specbase);
        dbg  (DEBUG,TRUE,"spec",spec);


        initList(diranchor); (* global *)
        lastdir            := firstindex-1; (* we can't init count in recursive buildDirList() *)

        video(msgWait,TRUE);
        rc:= buildDirList (lastdir, diranchor,  RECURSE, specbase);
        video(msgWait,FALSE);

        IF DEBUG THEN dmpDirs(diranchor); END;
        (* first minimalist "no match" check *)
        IF lastdir < firstindex THEN abort(errNoMatch,orgspec);END;

        S:=sWARN_FILES;

        CASE processmethod OF
        | allitemsperpass:  passcount:=lastpass;
        | allpassesperitem: passcount:=firstpass;
        ELSE ; (* //ISO fixed silly requirement *) END;

        FOR pass:=firstpass TO passcount DO
            pdir:=findByIndex(firstindex,diranchor); (* we know we've got at least one dir now *)
            getStr(rootspec,pdir);

            dirindex:=firstindex;
            LOOP
                IF dirindex > lastdir THEN EXIT; END;
                pdir:=findByIndex(dirindex,diranchor);
                getStr(basepath,pdir);

                rc:= storeFiles (lastfile, fileanchor,
                                OSJOKERS, basepath,spec);

                IF DEBUG THEN dmpFiles(fileanchor,diranchor,dirindex); END;

                fileindex:=firstindex;
                LOOP
                    IF fileindex > lastfile THEN EXIT; END;
                    pf := findByIndex(fileindex,fileanchor);

                    getStr(zefile,pf);
                    Str.Prepend(zefile,basepath);

                    CASE processmethod OF
                    | allitemsperpass:
                        initDataBuffer(pass,randmethod);
                        procWipeFile (lastprotected,pass,lastpass,randmethod,
                                     DEBUG,SKIPRO,KILL,REALLY,zefile);
                        bye:=pollEscape (chkrounds, IGNOREESCAPE);
                        IF bye THEN abort(errAborted,"");END;
                    | allpassesperitem:
                        FOR subpass:=firstpass TO lastpass DO
                            initDataBuffer(subpass,randmethod);
                            procWipeFile (lastprotected,subpass,lastpass,randmethod,
                                         DEBUG,SKIPRO,KILL,REALLY,zefile);
                            bye:=pollEscape (chkrounds, IGNOREESCAPE);
                            IF bye THEN abort(errAborted,"");END;
                        END;
                    ELSE ; (* //ISO fixed silly requirement *) END;

                    INC(fileindex);
                END;
                freeList(fileanchor);
                INC(dirindex);
            END;
        END;

        (* // yes, we know we let good old DOS handle this with earlier abort() calls *)
        freeList(diranchor); (* yes we can NOW ! *)


    ELSE ; (* //ISO fixed silly requirement *) END;

    abort(errNone,"");
END WipeFile32.

