(* ---------------------------------------------------------------
Title         Q&D Pattern Match
Overview      self-explanatory !
Notes         Brute Force and Ignorance do rule ;-)
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              as DRI used to say "Nobody DOS it better" !

              see XDS, //XDSTS and //FIXME
	      removed -f[f[f]], -x, -lfn

              we won't sync this code with DOS v1.0d

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
Bugs
Wish List     check entries are valid [A..Z]
              tokenize dictionary
              check for Escape while dumping ?
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 16 May 21 v1.0c added /v[:$]
PhG 13 Mar 20 v1.0b bugfix /e: would prepend progEXEname instead of defaultDicBase
PhG  3 Mar 20 v1.0a now matching v1.0c for DOS
              added -cga and -vga because we can't use BIOS to get rowcount
PhG 11 Feb 20 an ugly really Q&D port from PATMATCH v1.0a for DOS

--------------------------------------------------------------- *)

MODULE patMatch32;

IMPORT Str;
IMPORT Lib;
IMPORT FIO;
IMPORT IO;

FROM IO IMPORT WrStr,WrLn;

FROM SYSTEM IMPORT BYTE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;
*)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

CONST

    ignore = " ";
    (*
    //FIXME : these tables have not been fully checked yet
    *)

Tupper =  "                "+
          "                "+
	  "                "+
          "                "+
          " ABCDEFGHIJKLMNO"+
          "PQRSTUVWXYZ     "+
          " ABCDEFGHIJKLMNO"+
          "PQRSTUVWXYZ     "+
          "                "+
          "                "+
          "               "+
          "                "+
          "AAAAAAEEEEIIII"+
          " NOOOOO OUUUUY  "+
          "AAAAAAEEEEIIII"+
          " NOOOOO OUUUUY  ";



Tlower =  "                "+
          "                "+
	  "                "+
          "                "+
          " abcdefghijklmno"+
          "pqrstuvwxyz     "+
          " abcdefghijklmno"+
          "pqrstuvwxyz     "+
          "                "+
          "                "+
          "               "+
          "                "+
          "aaaaaaeeeeiiii"+
          " nooooo ouuuuy  "+
          "aaaaaaeeeeiiii"+
          " nooooo ouuuuy  ";



TupperA=  "                "+
          "                "+
	  "                "+
          "                "+
          " ABCDEFGHIJKLMNO"+
          "PQRSTUVWXYZ     "+
          " ABCDEFGHIJKLMNO"+
          "PQRSTUVWXYZ     "+
          "                "+
          "                "+
          "               "+
          "                "+
          "AAAII"+
          " NOOO OUY  "+
          "AAAII"+
          " NOOO OUY  ";


TlowerA = "                "+
          "                "+
	  "                "+
          "                "+
          " abcdefghijklmno"+
          "pqrstuvwxyz     "+
          " abcdefghijklmno"+
          "pqrstuvwxyz     "+
          "                "+
          "                "+
          "               "+
          "                "+
          "aaaii"+
          " nooo ouy  "+
          "aaaii"+
          " nooo ouy  ";


TupperFR= "                "+
          "                "+
	  "                "+
          "                "+
          " ABCDEFGHIJKLMNO"+
          "PQRSTUVWXYZ     "+
          " ABCDEFGHIJKLMNO"+
          "PQRSTUVWXYZ     "+
          "                "+
          "                "+
          "               "+
          "                "+
          "AAAII"+
          " NOOO OUY  "+
          "AAAII"+
          " NOOO OUY  ";

TlowerFR= "                "+
          "                "+
	  "                "+
          "                "+
          " abcdefghijklmno"+
          "pqrstuvwxyz     "+
          " abcdefghijklmno"+
          "pqrstuvwxyz     "+
          "                "+
          "                "+
          "               "+
          "                "+
          "aaaii"+
          " nooo ouy  "+
          "aaaii"+
          " nooo ouy  ";




(* ------------------------------------------------------------ *)

(*
PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tupper);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Tlower);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCase;

*)

PROCEDURE UpperCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperA);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END UpperCaseAlt;

PROCEDURE LowerCaseAlt (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerA);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCaseAlt;

PROCEDURE UpperCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TupperFR);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END UpperCaseFR;

PROCEDURE LowerCaseFR (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,TlowerFR);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END LowerCaseFR;

(*
PROCEDURE ASCIIonly (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
    i   : CARDINAL;
    c   : CHAR;
    ch  : CHAR;
BEGIN
    len := Str.Length(S);
    IF len = 0 THEN RETURN; END;         (* this WAS a problem ! *)
    FOR i := 0 TO (len - 1) DO
        c  := S[i];
        ch := map(c,Taz);
        IF ch # ignore THEN S[i] := ch; END;
    END;
END ASCIIonly;
*)

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    chardef   = RECORD
                    Code    : BYTE;
                    Flag    : CHAR;
                    MapChar : BYTE;
                END;
    CharTable = ARRAY [0..255] OF chardef;

CONST
    TwinTOpc  = CharTable{
    chardef{000H, "=", 000H},
    chardef{001H, "=", 001H},
    chardef{002H, "=", 002H},
    chardef{003H, "=", 003H},
    chardef{004H, "=", 004H},
    chardef{005H, "=", 005H},
    chardef{006H, "=", 006H},
    chardef{007H, "=", 007H},
    chardef{008H, "=", 008H},
    chardef{009H, "!", 009H},
    chardef{00AH, "=", 00AH},
    chardef{00BH, "=", 00BH},
    chardef{00CH, "=", 00CH},
    chardef{00DH, "=", 00DH},
    chardef{00EH, "=", 00EH},
    chardef{00FH, "=", 00FH},
    chardef{010H, "=", 010H},
    chardef{011H, "=", 011H},
    chardef{012H, "=", 012H},
    chardef{013H, "=", 013H},
    chardef{014H, "=", 014H},
    chardef{015H, "=", 015H},
    chardef{016H, "=", 016H},
    chardef{017H, "=", 017H},
    chardef{018H, "=", 018H},
    chardef{019H, "=", 019H},
    chardef{01AH, "=", 01AH},
    chardef{01BH, "=", 01BH},
    chardef{01CH, "=", 01CH},
    chardef{01DH, "=", 01DH},
    chardef{01EH, "=", 01EH},
    chardef{01FH, "=", 01FH},
    chardef{020H, "=",  " "},
    chardef{021H, "=",  "!"},
    chardef{022H, "=",  '"'},
    chardef{023H, "=",  "#"},
    chardef{024H, "=",  "$"},
    chardef{025H, "=",  "%"},
    chardef{026H, "=",  "&"},
    chardef{027H, "=",  "'"},
    chardef{028H, "=",  "("},
    chardef{029H, "=",  ")"},
    chardef{02AH, "=",  "*"},
    chardef{02BH, "=",  "+"},
    chardef{02CH, "=",  ","},
    chardef{02DH, "=",  "-"},
    chardef{02EH, "=",  "."},
    chardef{02FH, "=",  "/"},
    chardef{030H, "=",  "0"},
    chardef{031H, "=",  "1"},
    chardef{032H, "=",  "2"},
    chardef{033H, "=",  "3"},
    chardef{034H, "=",  "4"},
    chardef{035H, "=",  "5"},
    chardef{036H, "=",  "6"},
    chardef{037H, "=",  "7"},
    chardef{038H, "=",  "8"},
    chardef{039H, "=",  "9"},
    chardef{03AH, "=",  ":"},
    chardef{03BH, "=",  ";"},
    chardef{03CH, "=",  "<"},
    chardef{03DH, "=",  "="},
    chardef{03EH, "=",  ">"},
    chardef{03FH, "=",  "?"},
    chardef{040H, "=",  "@"},
    chardef{041H, "=",  "A"},
    chardef{042H, "=",  "B"},
    chardef{043H, "=",  "C"},
    chardef{044H, "=",  "D"},
    chardef{045H, "=",  "E"},
    chardef{046H, "=",  "F"},
    chardef{047H, "=",  "G"},
    chardef{048H, "=",  "H"},
    chardef{049H, "=",  "I"},
    chardef{04AH, "=",  "J"},
    chardef{04BH, "=",  "K"},
    chardef{04CH, "=",  "L"},
    chardef{04DH, "=",  "M"},
    chardef{04EH, "=",  "N"},
    chardef{04FH, "=",  "O"},
    chardef{050H, "=",  "P"},
    chardef{051H, "=",  "Q"},
    chardef{052H, "=",  "R"},
    chardef{053H, "=",  "S"},
    chardef{054H, "=",  "T"},
    chardef{055H, "=",  "U"},
    chardef{056H, "=",  "V"},
    chardef{057H, "=",  "W"},
    chardef{058H, "=",  "X"},
    chardef{059H, "=",  "Y"},
    chardef{05AH, "=",  "Z"},
    chardef{05BH, "=",  "["},
    chardef{05CH, "=",  "\"},
    chardef{05DH, "=",  "]"},
    chardef{05EH, "=",  "^"},
    chardef{05FH, "=",  "_"},
    chardef{060H, "=",  "`"},
    chardef{061H, "=",  "a"},
    chardef{062H, "=",  "b"},
    chardef{063H, "=",  "c"},
    chardef{064H, "=",  "d"},
    chardef{065H, "=",  "e"},
    chardef{066H, "=",  "f"},
    chardef{067H, "=",  "g"},
    chardef{068H, "=",  "h"},
    chardef{069H, "=",  "i"},
    chardef{06AH, "=",  "j"},
    chardef{06BH, "=",  "k"},
    chardef{06CH, "=",  "l"},
    chardef{06DH, "=",  "m"},
    chardef{06EH, "=",  "n"},
    chardef{06FH, "=",  "o"},
    chardef{070H, "=",  "p"},
    chardef{071H, "=",  "q"},
    chardef{072H, "=",  "r"},
    chardef{073H, "=",  "s"},
    chardef{074H, "=",  "t"},
    chardef{075H, "=",  "u"},
    chardef{076H, "=",  "v"},
    chardef{077H, "=",  "w"},
    chardef{078H, "=",  "x"},
    chardef{079H, "=",  "y"},
    chardef{07AH, "=",  "z"},
    chardef{07BH, "=",  "{"},
    chardef{07CH, "=",  "|"},
    chardef{07DH, "=",  "}"},
    chardef{07EH, "=",  "~"},
    chardef{07FH, "x",  " "},
    chardef{080H, "x",  " "},
    chardef{081H, "x",  " "},
    chardef{082H, "x",  " "},
    chardef{083H, "x",  " "},
    chardef{084H, "x",  " "},
    chardef{085H, "x",  " "},
    chardef{086H, "x",  " "},
    chardef{087H, "x",  " "},
    chardef{088H, "x",  " "},
    chardef{089H, "x",  " "},
    chardef{08AH, "x",  " "},
    chardef{08BH, "x",  " "},
    chardef{08CH, "x",  " "},
    chardef{08DH, "x",  " "},
    chardef{08EH, "x",  " "},
    chardef{08FH, "x",  " "},
    chardef{090H, "x",  " "},
    chardef{091H, "=",  "'"},
    chardef{092H, "=",  "'"},
    chardef{093H, "x",  " "},
    chardef{094H, "x",  " "},
    chardef{095H, "x",  " "},
    chardef{096H, "x",  " "},
    chardef{097H, "x",  " "},
    chardef{098H, "x",  " "},
    chardef{099H, "x",  " "},
    chardef{09AH, "x",  " "},
    chardef{09BH, "x",  " "},
    chardef{09CH, "x",  " "},
    chardef{09DH, "x",  " "},
    chardef{09EH, "x",  " "},
    chardef{09FH, "x",  " "},
    chardef{0A0H, "=",  " "},
    chardef{0A1H, "=",  ""},
    chardef{0A2H, "=",  ""},
    chardef{0A3H, "=",  ""},
    chardef{0A4H, "=",  ""},
    chardef{0A5H, "=",  ""},
    chardef{0A6H, "=",  "|"},
    chardef{0A7H, "!", 015H},
    chardef{0A8H, "?",  " "},
    chardef{0A9H, "!",  ""},
    chardef{0AAH, "=",  ""},
    chardef{0ABH, "=",  ""},
    chardef{0ACH, "=",  ""},
    chardef{0ADH, "=",  "-"},
    chardef{0AEH, "!",  ""},
    chardef{0AFH, "!",  "-"},
    chardef{0B0H, "=",  ""},
    chardef{0B1H, "=",  ""},
    chardef{0B2H, "=",  ""},
    chardef{0B3H, "?",  " "},
    chardef{0B4H, "?",  " "},
    chardef{0B5H, "=",  ""},
    chardef{0B6H, "!", 014H},
    chardef{0B7H, "?",  " "},
    chardef{0B8H, "?",  " "},
    chardef{0B9H, "?",  " "},
    chardef{0BAH, "=",  ""},
    chardef{0BBH, "=",  ""},
    chardef{0BCH, "=",  ""},
    chardef{0BDH, "=",  ""},
    chardef{0BEH, "?",  " "},
    chardef{0BFH, "=",  ""},
    chardef{0C0H, "=",  "A"},
    chardef{0C1H, "=",  "A"},
    chardef{0C2H, "=",  "A"},
    chardef{0C3H, "=",  "A"},
    chardef{0C4H, "=",  ""},
    chardef{0C5H, "=",  ""},
    chardef{0C6H, "=",  ""},
    chardef{0C7H, "=",  ""},
    chardef{0C8H, "=",  "E"},
    chardef{0C9H, "=",  ""},
    chardef{0CAH, "=",  "E"},
    chardef{0CBH, "=",  "E"},
    chardef{0CCH, "=",  "I"},
    chardef{0CDH, "=",  "I"},
    chardef{0CEH, "=",  "I"},
    chardef{0CFH, "=",  "I"},
    chardef{0D0H, "?",  " "},
    chardef{0D1H, "=",  ""},
    chardef{0D2H, "=",  "O"},
    chardef{0D3H, "=",  "O"},
    chardef{0D4H, "=",  "O"},
    chardef{0D5H, "=",  "O"},
    chardef{0D6H, "=",  ""},
    chardef{0D7H, "=",  "X"},
    chardef{0D8H, "=",  "O"},
    chardef{0D9H, "=",  "U"},
    chardef{0DAH, "=",  "U"},
    chardef{0DBH, "=",  "U"},
    chardef{0DCH, "=",  ""},
    chardef{0DDH, "=",  "Y"},
    chardef{0DEH, "?",  " "},
    chardef{0DFH, "=",  ""},
    chardef{0E0H, "=",  ""},
    chardef{0E1H, "=",  ""},
    chardef{0E2H, "=",  ""},
    chardef{0E3H, "=",  "a"},
    chardef{0E4H, "=",  ""},
    chardef{0E5H, "=",  ""},
    chardef{0E6H, "=",  ""},
    chardef{0E7H, "=",  ""},
    chardef{0E8H, "=",  ""},
    chardef{0E9H, "=",  ""},
    chardef{0EAH, "=",  ""},
    chardef{0EBH, "=",  ""},
    chardef{0ECH, "=",  ""},
    chardef{0EDH, "=",  ""},
    chardef{0EEH, "=",  ""},
    chardef{0EFH, "=",  ""},
    chardef{0F0H, "?",  " "},
    chardef{0F1H, "=",  ""},
    chardef{0F2H, "=",  ""},
    chardef{0F3H, "=",  ""},
    chardef{0F4H, "=",  ""},
    chardef{0F5H, "=",  "o"},
    chardef{0F6H, "=",  ""},
    chardef{0F7H, "=",  ""},
    chardef{0F8H, "=",  "o"},
    chardef{0F9H, "=",  ""},
    chardef{0FAH, "=",  ""},
    chardef{0FBH, "=",  ""},
    chardef{0FCH, "=",  ""},
    chardef{0FDH, "=",  "y"},
    chardef{0FEH, "?",  " "},
    chardef{0FFH, "=",  ""}};

(* we don't care about flag here *)

PROCEDURE remap2ascii (ch:CHAR):CHAR;
BEGIN
    RETURN TwinTOpc[ ORD(ch) ].MapChar;
END remap2ascii;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    progEXEname     = "PATMATCH32";
    progTitle       = "Q&D Pattern Match (Win32)";
    progVersion     = "v1.0c (from v1.0e for DOS)";
    progCopyright   = "by PhG";
    banner          = progTitle+" "+progVersion+" "+progCopyright;
CONST
    errNone         = 0;
    errHelp         = 1;
    errOption       = 2;
    errParmOverflow = 3;
    errExpected     = 4;
    errNotFound     = 5;
    errNotFile      = 6;
    errJoker        = 7;
    errPat          = 8;
    errNum          = 9;
    errCard         = 10;
    errNonsenseWithSoundex = 11;
    errNoJokerSoundex=12;
CONST
    extFRA          = ".FRA";
    onechar         = "?.-=_";
    onesequence     = "*!$&";
    verbatimsymbols = "-'.";
    (* defaultDic      = progEXEname+extFRA; *)
    defaultDicBase  = "PATMATCH";
    defaultDic      = defaultDicBase+extFRA; (* // *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)
    helpmsg =
banner+nl+
nl+
"Syntax : "+progEXEname+" <pattern> [[minimum_]length [maximum_length]] [option]..."+nl+
nl+
"  -v[:$]   keep accents, ignore symbols, ignore case (-v:$ = -r -d:$)"+nl+
'  -e:$     alternate dictionary extension (default is "'+extFRA+'")'+nl+
"  -d:$     alternate dictionary"+nl+
"  -u       display matches in uppercase instead of default lowercase"+nl+
"  -s       display matches statistics"+nl+
"  -p[p]    paging (-p = default 25 lines, -pp = 50 lines, -s ignored)"+nl+
(* "  -w|-pp   paging dividing count of rows by 2 (-s ignored)"+nl+ *)
(* "  -f[f[f]] display matches according to approximate phonetics"+nl+ *)
(* "  -x       disable LFN support even if available"+nl+ *)
nl+
"This program scans dictionary entries as to find specified text pattern."+nl+
nl+
'a) Any character of "'+onechar+'" set matches exactly one single character,'+nl+
'   while any character of "'+onesequence+'" set matches any sequence of characters'+nl+
"   (including none at all)."+nl+
"b) Trimmed dictionary entries must use [A..Z] character set only."+nl+
"c) With any of -v or -v:$ options, dictionary must be DOS ASCII ;"+nl+
'   allowed symbols are "'+verbatimsymbols+'" ; allowed characters may be accentuated.'+nl+
"d) Unless specified with a path, dictionary is searched for"+nl+
"   first in current directory then in executable directory."+nl+
'   "'+defaultDic+'" is default dictionary.'+nl+
"e) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" -p ad*tion 2 12"+nl+
"           "+progEXEname+" -u ad*t?on 14 -d:english.dic"+nl+
"           "+progEXEname+" -f etre"+nl;
VAR
    S : str1024;
BEGIN
    CASE e OF
    | errHelp :        WrStr(helpmsg);
    | errOption :      S:='Illegal "~" option !';
    | errParmOverflow: S:='"~" is one parameter too many !';
    | errExpected:     S:='"~" expected !';
    | errNotFound:     S:='"~" does not exist !';
    | errNotFile:      S:='"~" is not a file !';
    | errJoker:        S:='"~" should not contain any joker !';
    | errPat:          S:='Illegal "~" pattern !';
    | errNum:          S:='Illegal "~" number !';
    | errCard:         S:='Illegal "~" value !';
    | errNonsenseWithSoundex:S:="-f[f[f]] option requires <pattern> only !";
    | errNoJokerSoundex:S:="-f[f[f]] option does not support jokers in <pattern> !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone, errHelp :
        ;
    ELSE
        Str.Subst(S,"~",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* //XDS Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

(* as usual, buffers must be outside procedure, else program bombs ! *)

CONST
    IObufferSize      = (16 * 512) + FIO.BufferOverhead;
    firstIObufferByte = 1;
    lastIObufferByte  = IObufferSize;
TYPE
    ioBufferType      = ARRAY [firstIObufferByte..lastIObufferByte] OF BYTE; (* for private M2 IO *)
VAR
    ioBufferIn        : ioBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkpat (VAR R:ARRAY OF CHAR;relaxed:BOOLEAN;S:ARRAY OF CHAR ):BOOLEAN;
CONST
    allowed = lettersUpp+onechar+onesequence;
VAR
    pb,i:CARDINAL;
BEGIN
    Str.Copy(R, S);
    (* yes, they may have different lengths *)
    FOR i:=2 TO Str.Length(onechar) DO
        ReplaceChar(R,onechar[i-1],onechar[0]);
    END;
    FOR i:=2 TO Str.Length(onesequence) DO
        ReplaceChar(R,onesequence[i-1],onesequence[0]);
    END;
    pb:=0;
    IF relaxed THEN
        LowerCaseFR(R);
	  FOR i:= 1 TO Str.Length(R) DO
            R[i-1]:=remap2ascii(R[i-1]);
	  END;
    ELSE
        UpperCase(R); (* //V10F before, was done at cli parsing *)
        FOR i:=1 TO Str.Length(R) DO
            IF Str.CharPos(allowed,R[i-1])=MAX(CARDINAL) THEN INC(pb);END;
        END;
    END;
    RETURN (pb=0);
END chkpat;

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO CARDINAL( ABS(wi) ) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmt (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmt;

PROCEDURE haspath (S:pathtype  ):BOOLEAN;
VAR
    pb:CARDINAL;
BEGIN
    pb:=0;
    IF Str.CharPos(S,":") # MAX(CARDINAL) THEN INC(pb);END;
    IF Str.CharPos(S,"\") # MAX(CARDINAL) THEN INC(pb);END;
    IF Str.CharPos(S,"/") # MAX(CARDINAL) THEN INC(pb);END;
    RETURN (pb # 0);
END haspath;

PROCEDURE dmp (msg,str:ARRAY OF CHAR);
CONST
    wi=20;
    separ = " : ";
VAR
    i:CARDINAL;
BEGIN
    WrStr(msg);
    FOR i:=Str.Length(msg)+1 TO wi DO WrStr(" ");END;
    WrStr(separ);WrStr(str);WrLn;
END dmp;

PROCEDURE dmpbool (tf:BOOLEAN; msg,sTrue,sFalse:ARRAY OF CHAR);
CONST
    wi=20;
    separ = " : ";
VAR
    i:CARDINAL;
BEGIN
    WrStr(msg);
    FOR i:=Str.Length(msg)+1 TO wi DO WrStr(" ");END;
    WrStr(separ);
    IF tf THEN
        WrStr(sTrue);
    ELSE
        WrStr(sFalse);
    END;
    WrLn;
END dmpbool;

CONST
    msgWorking = "Working, please wait... ";
    msgprompt  = "Hit (almost) any key to continue or Escape to abort listing : ";
    msgaborted = "Search aborted by user !";
CONST
    initpagingcounter = 1; (* take msg into account *)

PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;

PROCEDURE waitAndSee (VAR rowcount:CARDINAL; lastrow:CARDINAL;msg:BOOLEAN):BOOLEAN;
(* //XDS
CONST
    keyEsc = str2(CHR(27));
*)
VAR
    zekey:str2;
BEGIN
    INC(rowcount);
    IF rowcount >= lastrow THEN (* = is enough but who knows what evil lurks in the heart of BIOS *)
        rowcount := initpagingcounter;
        IF msg THEN video(msgWorking,FALSE);END;
	video(msgprompt,TRUE);
        Flushkey;
        zekey:=Waitkey();
	video(msgprompt,FALSE);
        IF msg THEN video(msgWorking,TRUE); END;
        IF same(zekey,str2(CHR(27)) ) THEN RETURN FALSE; END;
    END;
    RETURN TRUE;
END waitAndSee;

(* ------------------------------------------------------------ *)

(* //FIXME to DO later ! *)

CONST
    PLAINDIC = 0;

PROCEDURE isTokenizedFile (S:pathtype):LONGCARD; (* fpos *)
BEGIN
    RETURN PLAINDIC;
END isTokenizedFile;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pagingmode = (pagingnone,pagingfull,paginghalf);
    workmode   = (motif,verbatim);

(*
PROCEDURE getCode (VAR R:ARRAY OF CHAR;
                  whatwork:workmode;S:ARRAY OF CHAR);
BEGIN
    LowerCase(S); (* required -- see QD_BOX source *)
    CASE whatwork OF
    | fonetic:    CodePhonetic  (S, R);
    | soundexalt: CodeSoundex   (S, R);
    | soundexorg: CodeSoundexOrg(S, R);
    ELSE ; (* //ISO fixed silly requirement *) END;
END getCode;
*)

(* completely useless ! *)

PROCEDURE samepat (S1,S2:ARRAY OF CHAR  ):BOOLEAN ;
BEGIN
    Str.Prepend(S1,"*");
    Str.Append(S1,"*");
    Str.Prepend(S2,"*");
    Str.Append(S2,"*");
    RETURN Str.Match(S1,S2);
END samepat;

PROCEDURE showmatches (useLFN,showstats,shoutmode:BOOLEAN;
                      whatwork:workmode; paging:pagingmode;
                      startfpos:LONGCARD;
                      minmatchlen,maxmatchlen:CARDINAL;
                      strpat:ARRAY OF CHAR;dicfile:pathtype  );
CONST
    msg = TRUE;
CONST
    wilen  = 3;
    wilc   = 9;
    minlen = 1;
    maxlen = 128;
(* //XDS
CONST
    sb = 040H; (* segBiosData *)
VAR
    biosCurrentRows       [sb:084H]  : BYTE;     (* add 1 *)
*)
VAR
    matchlen  : ARRAY[minlen..maxlen] OF LONGCARD;
    undefined,matchcount: LONGCARD;
    i,len,symlen:CARDINAL;
    tokenized,ok:BOOLEAN;
    rowcount,lastrow:CARDINAL;
    refsoundexcode:str128;
VAR
    S,R,Z:str128;
    hin:FIO.File;
BEGIN
    tokenized := (startfpos # PLAINDIC);
    IF paging # pagingnone THEN
        showstats:=FALSE;
        CASE paging OF
        | pagingfull: lastrow := 50;
        | paginghalf: lastrow := 25;
        ELSE ; (* //ISO fixed silly requirement *) END;
        rowcount:=initpagingcounter;
    END;

    (* //XDS getCode(refsoundexcode,whatwork,strpat); *)

    symlen:=Str.Length(verbatimsymbols);
    matchcount:=0;
    FOR i:=minlen TO maxlen DO matchlen[i]:=0;END;
    undefined:=0;

    IF msg THEN video(msgWorking,TRUE); END;
    FIO.EOF:=FALSE;
    hin:=FIO.OpenRead(dicfile);
    FIO.AssignBuffer(hin,ioBufferIn);
    FIO.Seek(hin,startfpos);
    LOOP
        FIO.RdStr(hin,S);
        len:= Str.Length(S);
        IF len # 0 THEN
            CASE whatwork OF
            | motif:
                ok:=Str.Match(S,strpat);
            | verbatim:
                Str.Copy(Z,S);
                FOR i:=1 TO symlen DO
                    ReplaceChar(Z,verbatimsymbols[i-1],"");
                END;
                ok:=Str.Match(Z,strpat);
            ELSE (* //XDS cannot happen now *)
	        (*
                getCode(R,whatwork,S);
                ok:=same(R,refsoundexcode);
                (* ok:=samepat(R,refsoundexcode); *)
		*)
            END;
            IF ok THEN
                ok:= ( (len >= minmatchlen) AND (len <= maxmatchlen) );
                IF ok THEN
                    INC(matchcount);
                    IF len <= maxlen THEN
                        INC(matchlen[len]);

                        IF paging # pagingnone THEN
                            IF waitAndSee(rowcount,lastrow,msg) = FALSE THEN
                                IF msg THEN video(msgWorking,FALSE); END;
                                WrStr(msgaborted);WrLn;
                                IF msg THEN video(msgWorking,TRUE); END;
                                EXIT;
                            END;
                        END;
                        IF shoutmode THEN
                            IF whatwork = verbatim THEN
                                UpperCaseFR(S);
                            ELSE
                                UpperCaseAlt(S);
                            END;
                        ELSE
                            IF whatwork = verbatim THEN
                                LowerCaseFR(S);
                            ELSE
                                LowerCaseAlt(S);
                            END;
                        END;
                        IF msg THEN video(msgWorking,FALSE); END;
                        WrStr(S);WrLn;
                        IF msg THEN video(msgWorking,TRUE); END;
                    ELSE
                        INC(undefined);
                    END;
                END;
            END;
        END;
        IF FIO.EOF THEN EXIT;END;
    END;
    FIO.Close(hin);
    IF msg THEN video(msgWorking,FALSE); END;

    IF showstats THEN
        WrLn;
        FOR i:=minlen TO maxlen DO
            IF matchlen[i] # 0 THEN
                S:="Length = ~ -- count = ~";
                Str.Subst(S,"~",fmt(i,10,wilen," ",""));
                Str.Subst(S,"~",fmtlc(matchlen[i],10,wilc," ",""));
                WrStr(S);WrLn;
            END;
        END;
        IF undefined # 0 THEN
                S:="Length = ??? -- count = ~";
                Str.Subst(S,"~",fmtlc(undefined,10,wilc," ",""));
                WrStr(S);WrLn;
        END;
        WrLn;
        S:="Total matches         = ~";
        Str.Subst(S,"~",fmtlc(matchcount,10,wilc," ",""));
        WrStr(S);WrLn;
    END;

END showmatches;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

VAR
    S,R:pathtype;
    i,opt,parmcount:CARDINAL;
    useLFN,showstats,shoutmode,DEBUG:BOOLEAN;
    paging:pagingmode;
    whatwork:workmode;
    startfpos:LONGCARD;
    dicfile:pathtype;
    state:(waiting,gotpat,gotwordlen,gotmaxwordlen);
    strpat,orgpat:str128;
    N:str16;
    v:LONGCARD;
    minmatchlen,maxmatchlen:CARDINAL;
BEGIN
    WrLn;
    FIO.IOcheck:=FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)

    useLFN       := TRUE;
    dicfile      := defaultDic;
    showstats    := FALSE;
    shoutmode    := FALSE;
    whatwork     := motif;
    paging       := pagingnone;
    minmatchlen  := 0;
    maxmatchlen  := MAX(CARDINAL);
    DEBUG        := FALSE;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

    state:=waiting;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleantabs(S);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex (R,"?"+delim+"H"+delim+"HELP"+delim+
                                  "D:"+delim+"DIC:"+delim+"DICO:"+delim+
                                  "S"+delim+"STATS"+delim+
                                  "E:"+delim+"EXT:"+delim+
                                  "X"+delim+"LFN"+delim+
                                  "U"+delim+"UPPER"+delim+"UPPERCASE"+delim+
                                  "P"+delim+"PAGING"+delim+"PAUSE"+delim+
                                  "PP"+delim+"PAGING50"+delim+"VGA"+delim+
                                  "f"+delim+
                                  "ff"+delim+
                                  "fff"+delim+
                                  "V"+delim+"VERBATIM"+delim+
                                  "V:"+delim+"VERBATIM:"+delim+
                                  "DEBUG"
                               );
            CASE opt OF
            | 1,2,3 :   abort(errHelp,"");
            | 4,5,6 :   GetString(S,dicfile);
            | 7,8   :   showstats := TRUE;
            | 9,10  :   GetString(S,N);
                        IF Str.Match(N,dot+"*")=FALSE THEN Str.Prepend(N,dot);END;
                        Str.Concat(dicfile,progEXEname,N);
            | 11,12 :   ; (* //XDS useLFN := FALSE; *)
            | 13,14,15: shoutmode := TRUE;
            | 16,17,18: paging := paginghalf;
            | 19,20,21: paging := pagingfull;
            | 22    :   ;
            | 23    :   ;
            | 24    :   ;
            | 25,26 :   whatwork := verbatim;
            | 27,28 :   whatwork := verbatim;
                        GetString(S,dicfile);
            | 29    :   DEBUG:=TRUE;
            ELSE
                abort(errOption,S); (* could be errHelp, eh eh ! *)
            END;
        ELSE
            CASE state OF
            | waiting:       Str.Copy(orgpat,S);
                             (* IF chkpat(strpat,orgpat)=FALSE THEN abort(errPat,orgpat);END; *)
            | gotpat:        IF verifyString (R,digits)=FALSE THEN abort(errNum,S);END;
                             Str.Prepend(R,":"); (* fake option *)
                             IF GetLongCard(R,v)=FALSE THEN abort(errNum,S);END;
                             IF v > MAX(CARDINAL) THEN abort(errCard,S);END; (* //FIXME maxlen *)
                             minmatchlen:=CARDINAL(v);
                             maxmatchlen:=CARDINAL(v);
            | gotwordlen:    IF verifyString (R,digits)=FALSE THEN abort(errNum,S);END;
                             Str.Prepend(R,":"); (* fake option *)
                             IF GetLongCard(R,v)=FALSE THEN abort(errNum,S);END;
                             IF v > MAX(CARDINAL) THEN abort(errCard,S);END; (* //FIXME maxlen *)
                             maxmatchlen:=CARDINAL(v);
            | gotmaxwordlen: abort(errParmOverflow,S);
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(state);
        END;
    END;
    CASE state OF
    | waiting: abort(errExpected,"<pattern>");
    ELSE
               IF maxmatchlen < minmatchlen THEN
                   i:=minmatchlen;
                   minmatchlen:=maxmatchlen;
                   maxmatchlen:=i;
               END;
               IF chkpat(strpat,(whatwork=verbatim),orgpat)=FALSE THEN abort(errPat,orgpat);END;
    END;

    CASE whatwork OF
    | motif,verbatim:
        ;
    ELSE
        IF state # gotpat THEN abort(errNonsenseWithSoundex,"");END;
        IF verifyString(strpat,lettersUpp)=FALSE THEN
            abort(errNoJokerSoundex,strpat);
        END;
    END;

    (* //XDS useLFN := (useLFN AND fileSupportLFN() ); *)

    IF chkJoker(dicfile) THEN abort(errJoker,dicfile);END;
    IF FIO.Exists(dicfile)=FALSE THEN
        IF haspath(dicfile) THEN abort(errNotFound,dicfile); END;
        Lib.ParamStr(S,0);
        i:=Str.RCharPos(S,"\");
        IF i = MAX(CARDINAL) THEN (* never *)
            R:="";
        ELSE
            Str.Slice(R,S,0,i+1);
        END;
        Str.Prepend(dicfile,R);
        IF FIO.Exists(dicfile)=FALSE THEN abort(errNotFound,dicfile);END;
    END;

    IF isDirectory(dicfile) THEN abort(errNotFile,dicfile);END;

    IF DEBUG THEN
        dmp    ("Dictionary",dicfile);

        isoleItemS (R,
                   "pattern,verbatim,French phonetics,tweaked Soundex,original Soundex",
                   coma,ORD(whatwork));
        dmp    ("Mode",R);

        dmp    ("Raw pattern",orgpat);
        dmp    ("Cooked pattern",strpat);

        CASE whatwork OF
        | motif,verbatim :
            R:="irrelevant";
        ELSE
            ; (* //XDS getCode(R,whatwork,strpat); *)
        END;
        dmp    ("Mode dependant code ",R);

        dmpbool(shoutmode,"Display","uppercase","lowercase");
        isoleItemS (R,"none,50 lines,25 lines",coma,ORD(paging));
        dmp    ("Paging",R);

        dmp    ("Minimum match length",fmt (minmatchlen,10,1,"",""));
        dmp    ("Maximum match length",fmt (maxmatchlen,10,1,"",""));

        WrLn;
    END;

    startfpos:=isTokenizedFile(dicfile);
    showmatches (useLFN,showstats,shoutmode,
                whatwork, paging, startfpos,
                minmatchlen,maxmatchlen,strpat,dicfile);

    abort(errNone,"");
END patMatch32.