(* ---------------------------------------------------------------
Title         Q&D Path Copy
Overview      tsk tsk...
Usage         see help
Notes         I'm probably the only programmer in the world
              (well, at least among the very (un)happy few)
              still writing little utilities for Good Old DOS
              using Good Old (DR-Novell) DOS itself.. ;-)

              serious (or more exactly : weird) potential problem :
              while testing P4 *.exe copying from Win98,
              Maxtor 80Gb hard disk suddenly made weird clicks
              as if heads were blocked or recalibrating
              when program was run again, the problem occurred again !
              yet, when we splitted list, it did not reoccur... go figure !

              this never happened from good old Novell DOS 7
              nothing in code can explain. M$ against command line again ?
              possible random hd failure ?

              UPDATE ABOUT THAT POINT :
              darn, good/bad news : it seems related to hd problems after all
              and it's NOT the program. ouf !

              if told to process a shortform, target will be this very shortform
              and not original LFN possibly associated to this f8e3

              Yet Another JPI gag :
              Lib.SplitAllPath eats extension in directory part if path is fixed with trailing "\" !
              ("\foo.bar\" becomes "foo" and ".bar" gets lost in space !)

              -mem -fake is UNWISE and should therefore be UNDOCUMENTED ;-)

              v1.1m has not yet been fully checked
              (obsolete : it has, now, as of v1.2n)

              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)

Bugs          what bugs ? ;-)
              darn... under 9x, deep paths may lead to silent unexpected rename failure

              seen once : program aborted leaving msgBusy visible

              not a bug but an unwise design decision :
              we assume target unit will always have room enough
              move operation thus become VERY dangerous for lower user

              should user be lunatic enough to perform, say,
              @uc. when uc. list contains \uc\* files,
              wrong message about disk space (code 03) will occur
              thanks to operating system : just be cautious about such nonsense

              @..\x won't add .LST because "." was found : harmless quirk !

              guess what happens if filelist name is also first subdir to create ?
              yes, a false "not enough room" message ! just avoid the situation ! ;-)

              another XDS gag : we have to manually force FIO.EOF to FALSE
			  before opening filelist to be read !
			  not only they have changed a few names, a few structures,
			  not only they have kept a few TS bugs...
			  but they can't even correctly emulate JPI libraries !

              yet another XDS gag : their Lib.ParamStr() DOES corrupt last CLI parm !
              example : last quoted parm with a slash such as
			  "c:\z\"
              becomes, once retrieved by Lib.ParamStr(), this corrupt data
			  c:\z"

              BRAVO, GUYS !!! I'll NEVER touch XDS again !
              You should be ASHAMED of yourselves !!!


Wish List     better directory check...
              bargraph while copying long files ?
              error log .ERR ? bah, let redirection handle this...
              check source is not a directory ? bah, it should be done by caller !

              with LFNs, prepend dirpath to name ?

              see //FIXME for cosmetic quirk

              an ini to avoid any dangerous MOVE or even COPY (swap etc.)
              (source = c:\ , c:\windows , c:\dos , target = c:\ etc.)
              done for source, but what about target ?
              let's protect user against his will, the m$ way ! ;-) bill's code kiddies know best !

              interactive mode could ask about erasing source when moving
              logically, -n should ignore -i but it's safer for user

              strPrompt could use a "rename target" method (interactive)

              errFileNotFound could make a difference between "no match" and "protected" errors ?

              we could abort at first freespace room problem,
              but it's probably better to go on for possible smaller files
              we could too create/reserve fsize target before copying

              copy with SIZE condition (bigger OR smaller OR same,
              WITH percentage tolerance)

              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG  7 May 23 v0.9f bugfix parseFileSizeRange() would fail on very special cases
PhG 11 Feb 22 quirkfix : hard-coded EXE name was still DOS "PCOPY"
              but fortunately, we built INI from Lib.ParamStr(0)
PhG 19 Mar 21 v0.9e possible fix for crash with heap size at 8000000 in project
PhG 25 Nov 19 v0.9d parseDateRange() now handles *:$ and $:*
PhG 17 Mar 18 v0.9c bugfixes : max9X was too small for a LFN and useLFN was not initialized
PhG  7 Feb 18 v0.9b would not read a filelist because XDS TSCK does not correctly emulate JPI !
			  (we have here to reset FIO.EOF to FALSE before opening filelist for reading !)
PhG 29 Jan 18 v0.9a parseSizeRange() now handles *:#  #:* and cosmetic separators
PhG 17 Jan 18 an ugly really Q&D port from PCOPY v1.3 for DOS
--------------------------------------------------------------- *)

MODULE pCopy32;

IMPORT Str;
IMPORT Lib;
IMPORT IO;
IMPORT FIO;
IMPORT SYSTEM;

FROM IO IMPORT WrStr, WrLn,  WrCard,WrBool;
FROM Storage IMPORT ALLOCATE,DEALLOCATE;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

PROCEDURE UpperCaseAlt (VAR S : ARRAY OF CHAR); (* //FIXME *)
BEGIN
    Str.Caps(S);
END UpperCaseAlt;

PROCEDURE LowerCaseAlt (VAR S : ARRAY OF CHAR); (* //FIXME *)
BEGIN
    Str.Lows(S);
END LowerCaseAlt;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleanCLI (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleanCLI;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE getFileStamp (S:ARRAY OF CHAR):LONGCARD;
VAR
    h:FIO.File;
    stamp:LONGCARD;
BEGIN
    h:= FIO.OpenRead (S);
    stamp:=FIO.GetFileDate(h); (* packed DOS format *)
    FIO.Close(h);
    RETURN stamp;
END getFileStamp;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;



PROCEDURE Waitkey () : str2;
VAR
    ch : str2;
BEGIN
    Str.Copy (ch,IO.RdKey());
    IF ch = str2(CHR(0)) THEN
        (* appending to CHR(0) is NOT a good idea if we need functions keys *)
        (* change special char to CHR(255) instead *)
        ch:=str2(CHR(255));
        Str.Append (ch,IO.RdKey());
        RETURN ch;
    ELSE
        RETURN ch;
    END;
END Waitkey;

PROCEDURE Flushkey ();
VAR
    ch : str2;
BEGIN
    WHILE ( IO.KeyPressed()=TRUE ) DO
        ch := Waitkey();
    END;
END Flushkey;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;



(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(* ------------------------------------------------------------ *)

CONST
    USEFLOATSTAMP = FALSE; (* false = compare filestamps using longcards instead of longreals *)

CONST
    (* tmpTARGET     = "$DEL_ME$.TMP"; (* 8+3 reserved tmpname used by doFileCopy() when processing LFNs *) *)
    (* lowercasealt *)
    fSwapWin92    = "386spart.par";
    fSwapWin98    = "win386.swp";
    fSwapWinXP    = "pagefile.sys";
    patSwapWin92  = "*\"+fSwapWin92;
    patSwapWin98  = "*\"+fSwapWin98;
    patSwapWinXP  = "*\"+fSwapWinXP;
CONST
    extLST      = ".LST";
    extEXE      = ".EXE";
    extINI      = ".INI";
CONST
    sOKDONE         = "==> "; (* success copied to *)
    sPREFIX         = "    "; (* was "" *)
    sPREVIEW        = ";-) ";
    sOK             = "+++ ";
    sPB             = "--- ";
    sINFO           = "::: ";
    pathplaceholder = "~|~"; (* was "~~~", avoid nasty 9x tildes now : anyway file should always be last with such a placeholder *)
    dosrenmask      = "(#";
    lfnrenmask      = "(#)";
    lfnrenmasklong  = "(####)";
    renfixdefault   = 0;
    renfixLFN       = 4;
CONST
    pbNone        = 0; msgOK            = sOK;
    pbJoker       = 1; msgJoker         = sPB+"Jokers are not allowed in source";
    pbNotFound    = 2; msgNotFound      = sPB+"Source does not exist";
    pbTargetExists= 3; msgTargetExists  = sPB+"Target already exists";
    pbTargetRO    = 4; msgTargetRO      = sPB+"Read-only target already exists";
(*  pbTargetNewer = 5; msgTargetNewer   = sPB+"Source is older than or same date as target"; (* was "not newer" *) //V12R FIX *)
    pbTargetNewer = 5; msgTargetNewer   = sPB+'Newer target "'+pathplaceholder+'"';
    pbRenameFailure=6; msgRenameFailure = sPB+"New target name could not be created";
    pbRoomCopy    = 7; msgRoomCopy      = sPB+"Not enough room for target";
    pbRoomMove    = 8; msgRoomMove      = sPB+"Not enough room for target (source was not deleted)";
    pbSourceRO    = 9; msgSourceRO      = sPB+"Source is read-only";
    pbCollision   =10; msgCollision     = sPB+"Source would overwrite itself";
    pbRenamed     =11; msgRenamed       = sINFO+'Target renamed to "'+pathplaceholder+'"';

    (*
    pbMovedRO     =12; msgMovedRO       = sINFO+'Read-only source moved to "'+pathplaceholder+'"';
    pbMoved       =13; msgMoved         = sINFO+'Source moved to "'+pathplaceholder+'"';
    *)
    pbMovedRO     =12; msgMovedRO       = sOKDONE+'Read-only source moved to "'+pathplaceholder+'"';
    pbMoved       =13; msgMoved         = sOKDONE+'Source moved to "'+pathplaceholder+'"';

    pbFreshen     =14; msgFreshen       = sINFO+'No existing target to freshen';
    pbUnexpected  =15; msgUnexpected    = "??? Unexpected problem !";
(*  pbTargetNewerOrSame = 16; msgTargetNewerOrSame = sPB+"Source is older than target"; //V12 FIX *)
    pbTargetSameDate= 16; msgTargetSameDate = sPB+'Same date target "'+pathplaceholder+'"';
    pbTargetOlder =17; msgTargetOlder   = sPB+'Older target "'+pathplaceholder+'"';
CONST
    sProtectedDir  = sINFO+"PROTECTED "; (* uppercase for dirs *)
    sProtectedFile = sINFO+"Protected ";
    msgBusy        = "Working, please wait... "; (* trailing space for possible msgCopying *)
    msgDone        = sINFO+"~ file(s) processed successfully, ~ warning(s).";
CONST
    minProtected    = 1;
    maxProtected    = 64; (* at least 3 ! *)
    strMaxProtected = "64";
CONST
    progEXEname   = "PCOPY32";
    progTitle     = "Q&D Path Copy (Win32)";
    progVersion   = "v0.9f (from v1.3b for DOS)";
    progCopyright = "by PhG";
    banner        = progTitle+" "+progVersion+" "+progCopyright;
    sPCOPYenv     = progEXEname;
    (* errLogfile    = progEXEname+".ERR"; *)
CONST
    errNone            = 0;
    errHelp            = 1;
    errUnknownOption   = 2;
    errTooManyParms    = 3;
    errNonsense        = 4;
    errNonsenseStamp   = 5;
    errUserAbort       = 6;
    errMissingSource   = 7;
    errJokerTarget     = 8;
    errBase            = 9;
    errNotFile         = 10;
    errNotFound        = 11;
    errNonsenseShow    = 12;
    errNetSlash        = 13;
    errPhantomUnit     = 14;
    errDirCollision    = 15;
    errBadUnit         = 16;
    errColon           = 17;
    errNoParent        = 18;
    errInnerParent     = 19;
    errDirJoker        = 20;
    errStorage         = 21;
    errFileNotFound    = 22;
    errNotWithList     = 23;
    errBadEnv          = 24;
    errProtection      = 25;
    errMoreHelp        = 26;
    errDateRange       = 27;
    errSizeRange       = 28;
    errFilteredFileNotFound=29;
    errJokerList       = 30;
    errTargetIsFile    = 31;
    errRequiredOption  = 32;
    errRenFixLFN       = 33;
    errEvenMoreHelp    = 34;
    errNoneAlt         = 128;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE enclose (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Prepend(S,dquote);
    Str.Append(S,dquote);
END enclose;

PROCEDURE preprocessLine (VAR S:pathtype);
VAR
    len:CARDINAL;
BEGIN
    LtrimBlanks(S);
    RtrimBlanks(S);
    (* we could use Str.Match(S,dquote+"*"+dquote) but... *)
    len:=Str.Length(S);
    IF len < 2 THEN RETURN; END; (* at least 1+1 for possible dquote+dquote *)
    IF S[len-1] # dquote THEN RETURN; END;
    IF S[0] # dquote THEN RETURN; END;
    S[len-1]:=charnull;
    Str.Delete(S,0,1);
    (* just in case *)
    LtrimBlanks(S);
    RtrimBlanks(S);
END preprocessLine;

CONST
    widmp = 27; (* Win<92|98|XP> forced us to use 30 *)

PROCEDURE padinf (n:INTEGER;S:ARRAY OF CHAR):str80;
VAR
    i:CARDINAL;
    R:str80;
BEGIN
    R:="";
    IF n > 0 THEN Str.Append(R,S);END;
    FOR i:=Str.Length(S)+1 TO CARDINAL( ABS(n) ) DO Str.Append(R," ");END;
    IF n < 0 THEN Str.Append(R,S);END;
    Str.Append(R," : ");
    RETURN R;
END padinf;

PROCEDURE wF (S1,S2:ARRAY OF CHAR;useLFN:BOOLEAN);
BEGIN
    WrStr( padinf(widmp,S1));
    IF useLFN THEN enclose(S2);END;
    WrStr(S2);WrLn;
END wF;

PROCEDURE wB (S1:ARRAY OF CHAR;b:BOOLEAN; t,f:ARRAY OF CHAR);
BEGIN
    WrStr( padinf(widmp,S1));
    IF b THEN
        WrStr(t);
    ELSE
        WrStr(f);
    END;
    WrLn;
END wB;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE abort (e : CARDINAL; einfo : ARRAY OF CHAR);
CONST
    placeholder = "~";
(*
 00000000011111111112222222222333333333344444444445555555555666666666677777777778
 1...'....0....'....0....'....0....'....0....'....0....'....0....'....0....'....0
*)

helpmsg =
banner+nl+
nl+
"Syntax 1 : "+progEXEname+" <spec> [targetdir] [option]..."+nl+
"Syntax 2 : "+progEXEname+" <-@> <@list["+extLST+"]> [targetdir] [option]..."+nl+
nl+
"-@        force list mode (thus assuming first parameter is a list)"+nl+
"-s[p|s]   recurse subdirectories (-ss = -sp = -s -p)"+nl+
"-t        test mode"+nl+
"-y|-t-    disable preview/test mode"+nl+
"-o[n]     overwrite existing target if any"+nl+
"-f[n]     freshen existing target only (-fn = -f -n)"+nl+
'-n[o]     do not overwrite target if source is "older or same date" (-o forced)'+nl+ (* was "not newer" *)
'-j        force -n to check for "older only" instead of "older or same date"'+nl+
'-r[r]     try and automagically rename existing target if any (see infra)'+nl+
"-p[r|p]   do not recreate paths on target (-pp = -pr = -p -r)"+nl+
"-m        move mode, erasing source at copy completion"+nl+
"-mo[n]    shortcut combining -m, -o and -n (-mo, -mon)"+nl+
"-i[o|i]   ask user to confirm target overwriting (-ii = -io = -i -o)"+nl+
'-d:$      filter according to specified "lower[:|..]upper" date range'+nl+
'          ("*"=today, "$"=same date, "[*]:$"=before or on, "$:[*]"=on or after)'+nl+
'-z:$      filter according to specified "lower[-|:|..]upper" size range'+nl+
'          ("#"=same, "[*]:#"=smaller or equal, "#:[*]"=greater or equal)'+nl+
"-g        do not show copy percentage"+nl+
"-q        alternate display (do not report successful operations)"+nl+
"-u        alternate display (report successful operations only)"+nl+
"-w        list source entries found protected and therefore skipped"+nl+
"-x        ignore existing "+progEXEname+extINI+nl+
"-swaps    do not default to swapfiles protection"+nl+
'          ("'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'")'+nl+
"-v[v]     show parameters (-vv = show parameters and terminate)"+nl+
"-!        filter files using operating system jokers (see infra)"+nl+
"-e        disable ESCape polling (may be necessary with Win9X/WinXP)"+nl+
"-copy     shortcut for -i -o -p"+nl+
"-move|mv  shortcut for -i -o -m"+nl+
"-cp       shortcut for -n -p"+nl+
"-xcp      shortcut for -n -s"+nl+
"-??[?]    (even) more help (to be read at least once !)"+nl;

    msgmorehelp = nl+
"a) With syntax 1, this program is SIMILAR to COPY/MOVE/XCOPY/REPLACE."+nl+
"   However, note that renaming source(s) using joker(s) is NOT supported :"+nl+
"   target destination MUST be a DIRECTORY (automatically created if necessary)."+nl+
"   Moreover, empty source subdirectories are NOT recreated."+nl+
"   Note source RHS attributes, if any, will not be copied to target."+nl+
"b) With syntax 2, this program copies each canonical file found in <list>"+nl+
"   (jokers and directories not allowed) preserving path information"+nl+
"   (unless -p was specified) but obviously ignoring unit."+nl+
"c) -p option (required for COPY-like mode) does NOT force -r automatically."+nl+
'd) By design, -j option still requires -n option.'+nl+
'e) Without -! option, "?" and "*" jokers do NOT work the DOS or Win9X way :'+nl+
'   "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"f) Note joker matching includes extension if extension is omitted."+nl+
"g) Up to "+strMaxProtected+" entries (M2 jokers supported) may be protected against access,"+nl+
"   if they are specified in "+progEXEname+extINI+" file located in executable directory."+nl+
"   If such a file does not exist, these entries are protected by default :"+nl+
'   "'+patSwapWin92+'", "'+patSwapWin98+'" and "'+patSwapWinXP+'".'+nl+
"   Note protection applies to sources ONLY : targets are NOT protected."+nl+
"h) Default display enables both -q and -u options."+nl+
'i) -t option can be set as default with '+sPCOPYenv+'=T environment variable ;'+nl+
"   default mode can still be reset from command line with -y or -t- options."+nl+
    (* '?) Error checking is limited : -test rulez ! "Caveat utilisator" ! ;-)'+nl+ *)
'j) -r option tries and appends "'+lfnrenmask+'" (LFN),'+nl+
'   where "#" is in the [1..9999] range.'+nl+
'   Note -rr option is LFN-specific and appends "'+lfnrenmasklong+'" when renaming.'+nl+
"k) -z:# supports multiples of 1024 (Kb, Mb, Gb) and of 1000 (K, M, G)."+nl+
"   Lower and upper range values will be swapped if necessary."+nl+
"l) "+placeholder+nl+
"   "+placeholder+nl+
"m) The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
"   to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
"   Although successful compiling required (too) many modifications in source,"+nl+
"   results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl+
nl+
"Examples : "+progEXEname+" /oon /u @backup.lst f:\backup"+nl+
"           "+progEXEname+" c:\tools\*.exe c:\z /s /k /v /q /x"+nl+
"           "+progEXEname+" c:\txt\*.w51 g:\z\ /o /n /j"+nl;

    msgevenmorehelp = nl+
"Here is an example of "+progEXEname+extINI+" file :"+nl+
nl+
"   ;"+nl+
"   ; Entries matching these patterns will be ignored by Copy and Move."+nl+
"   ; Note protection applies to sources ONLY : targets are NOT protected."+nl+
"   ; M2 jokers are allowed :"+nl+
'   ; "?" matches exactly one character, "*" matches any sequence of characters.'+nl+
"   ; Entries may be enclosed with double quotes if necessary."+nl+
"   ;"+nl+
"   ; Swap files should always be protected in this INI file :"+nl+
"   ; the One and Golden Rule of Indifference should always rule."+nl+
"   ;"+nl+
"   "+patSwapWin92+nl+
"   "+patSwapWin98+nl+
"   "+patSwapWinXP+nl+
"   ;"+nl+
"   ?:\"+nl+
"   c:\dos\*"+nl+
'   "c:\windows\*"'+nl+
'   "*\index.dat"'+nl+
"   *\desktop.ini"+nl;

VAR
    S  : str1024; (* was str256 *)
    SS : str4096; (* should DO *)
    p:CARDINAL;
BEGIN
    CASE e OF
    | errHelp,errMoreHelp,errEvenMoreHelp :
        WrStr(helpmsg);
        IF e # errHelp THEN
            Str.Copy(SS,msgmorehelp);

            (* now tell user about PCOPY.INI *)

            Lib.ParamStr(S,0); (* retrieve executable location : yes, we assume it ! *)
            p:=Str.RCharPos(S,dot);
            IF p # MAX(CARDINAL) THEN S[p]:=charnull;END;
            Str.Append(S,extINI);

            IF FIO.Exists(S) THEN
                S:=progEXEname+extINI+" was found in executable directory :";
                Str.Subst(SS,placeholder,S);
                S:="protection against access is available for its entries (unless -x).";
            ELSE
                S:=progEXEname+extINI+" was NOT found in executable directory :";
                Str.Subst(SS,placeholder,S);
                S:="protection against access is limited to swapfiles (unless -swaps).";
            END;
            Str.Subst(SS,placeholder,S);
            IF e = errEvenMoreHelp THEN Str.Append(SS,msgevenmorehelp);END;
            WrStr(SS);
        END;
        e:=errHelp;
    | errUnknownOption:
        S:="Unknown | option !";
    | errTooManyParms:
        S:="| is one parameter too many !";
    | errNonsense:
        S:="| and -r options are mutually exclusive !";
    | errNonsenseStamp:
        S:="-n option is a nonsense without -o[o] option !";
    | errUserAbort:
        S := "Aborted by user !";
    | errMissingSource :
        S := "<spec> or <@list> expected !";
    | errJokerTarget:
        S:='"|" target cannot contain any joker !';
    | errBase:
        S:='Illegal "|" base directory !';
    | errNotFile:
        S:='"|" is not a file !';
    | errNotFound:
        S:='"|" list does not exist !';
    | errNonsenseShow:
        S:="-q and -u options are mutually exclusive !";
    | errNetSlash:
        S:='Illegal server "\\" in "|" specification !';
    | errPhantomUnit:
        S:='Unavailable or read-only unit in "|" specification !';
    | errDirCollision:
        S:= "Source files would overwrite themselves !";
    | errBadUnit:
        S:='Illegal unit in "|" specification !';
    | errColon:
        S:='Unexpected ":" in "|" specification !';
    | errNoParent:
        S:='Unresolvable ".." in "|" specification !';
    | errInnerParent:
        S:='Illegal ".." in "|" specification !';
    | errDirJoker:
        S:='Illegal "|" directory joker(s) !';
    | errStorage:
        S:='Storage.ALLOCATE() failure while processing "|" specification !';
    | errFileNotFound:
        S:='No match (or protection set) for "|" !';
    | errNotWithList:
        S:="| and -@ options are mutually exclusive !";
    | errBadEnv:
        S:='Illegal value in "|" environment variable !';
    | errProtection:
        S:=progEXEname+extINI+" should be checked for problems !";
    | errSizeRange  :
        S:="Illegal | size range !";
    | errDateRange  :
        S:="Illegal | date range !";
    | errFilteredFileNotFound:
        S:='No filtered match for "|" !';
    | errJokerList:
        S:='"|" list cannot contain any joker !';
    | errTargetIsFile:
        S:='Specified "|" target is an existing file !';
    | errRequiredOption:
        S:="-j option requires | option !";
    | errRenFixLFN:
        S:="-rr option requires LFN support to be enabled !";
    ELSE
        S := "This is illogical, Captain !";
    END;
    CASE e OF
    | errNone,errHelp,errNoneAlt :
        ;
    ELSE
        Str.Subst(S,"|",einfo);
        WrStr(progEXEname+" : ");WrStr(S);WrLn;
    END;
    (* Lib.SetReturnCode(SHORTCARD(e)); *)
    HALT (e);
END abort;

PROCEDURE dbg (S1,S2:ARRAY OF CHAR);
VAR
    i:CARDINAL;
BEGIN
    WrStr("// ");
    WrStr(S1);
    FOR i:=Str.Length(S1) TO 20 DO WrStr(" ");END;
    WrStr(" : ");
    WrStr(S2);
    WrLn;
END dbg;

PROCEDURE dbgbool (S1:ARRAY OF CHAR ; ok:BOOLEAN );
BEGIN
    IF ok THEN
        dbg(S1,"success");
    ELSE
        dbg(S1,"failure");
    END;
END dbgbool;

PROCEDURE dbgcard (S1:ARRAY OF CHAR; v:CARDINAL  );
VAR
    i:CARDINAL;
BEGIN
    WrStr("// ");
    WrStr(S1);
    FOR i:=Str.Length(S1) TO 20 DO WrStr(" ");END;
    WrStr(" : ");
    WrCard(v,1);
    WrLn;
END dbgcard;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    ioBufferSize      = (8 * 512) + FIO.BufferOverhead;
    firstioBufferByte = 1;
    lastioBufferByte  = ioBufferSize;
TYPE
    ioBufferType  = ARRAY [firstioBufferByte..lastioBufferByte] OF SYSTEM.LOC;
VAR
    ioBufferIn,ioBufferOut : ioBufferType;

CONST
    firstDataByte = 0;
    lastDataByte  = 32*512-1;
    dataBufferSize= lastDataByte - firstDataByte + 1;
TYPE
    dataBufferType = ARRAY [firstDataByte..lastDataByte] OF SYSTEM.LOC;
VAR
    dataBuffer : dataBufferType;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE fmtlc (v:LONGCARD;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
VAR
    R : str80;
    ok: BOOLEAN;
    i : CARDINAL;
BEGIN
    Str.CardToStr(v,R,base,ok);
    FOR i:= Str.Length(R)+1 TO CARDINAL( ABS(wi) ) DO
        IF wi < 0 THEN
            Str.Append(R,ch);
        ELSE
            Str.Prepend(R,ch);
        END;
    END;
    IF base=16 THEN Str.Lows(R);END;
    Str.Prepend(R,prefix);
    RETURN R;
END fmtlc;

PROCEDURE fmt (v:CARDINAL;base:CARDINAL;wi:INTEGER;ch,prefix:CHAR) : str80;
BEGIN
    RETURN fmtlc(LONGCARD(v),base,wi,ch,prefix);
END fmt;

PROCEDURE nice (useLFN:BOOLEAN;S:pathtype):pathtype;
VAR
    R:pathtype;
BEGIN
    IF useLFN THEN
        Str.Concat(R,dquote,S);
        Str.Append(R,dquote);
    ELSE
        Str.Copy(R,S);
    END;
    RETURN R;
END nice;

PROCEDURE wrfi (useLFN: BOOLEAN;S1:ARRAY OF CHAR;S2:pathtype);
BEGIN
    WrStr(S1); WrStr( nice (useLFN, S2)); WrLn;
END wrfi;

PROCEDURE busy (showbusy,state:BOOLEAN);
BEGIN
    IF showbusy THEN
        video(msgBusy,state);
    END;
END busy;

(* ------------------------------------------------------------ *)

(* clever is not always faster : dynamic string allocation is much slower here -- and yes, we've tried it *)

VAR
    entryprotected      : ARRAY [minProtected..maxProtected] OF pathtype;
    lastEntryProtected  : CARDINAL; (* globerk *)

(* note SBASE should be an empty string if S is not a file *)

PROCEDURE chkNoProtection (notice,showbusy,isdir:BOOLEAN;SBASE,S:pathtype):BOOLEAN; (* ok=store it *)
VAR
    last,i:CARDINAL;
    rc,ok:BOOLEAN;
    msg:str16;
BEGIN
    last:=lastEntryProtected;
    IF isdir THEN
        msg:=sProtectedDir;
    ELSE
        msg:=sProtectedFile;
    END;
    rc:=TRUE;
    IF last < minProtected THEN RETURN rc; END;
    Str.Prepend(S,SBASE); (* //V13 *)
    LowerCaseAlt(S);
    i:=minProtected-1;
    LOOP
        INC(i);
        IF i > last THEN EXIT; END;
        ok:=Str.Match(S,entryprotected[i]);
        IF ok THEN
            IF notice THEN
                busy(showbusy,FALSE);
                WrStr(msg); WrStr(S); WrLn;
                busy(showbusy,TRUE);
            END;
            rc:=FALSE;
            EXIT;
        END;
    END;
    RETURN rc;
END chkNoProtection;

(*
             ignoreini    forceswapfilesprotection
default      FALSE        TRUE
-swap        ?            FALSE
-x           TRUE         ?

if ini exists, its content override default protection unless -x was specified
if no ini, swapfiles protected unless -swaps
*)

PROCEDURE swapfilesprotectionFIX (forceswapfilesprotection,inihere,ignoreini:BOOLEAN):BOOLEAN;
BEGIN
    IF inihere THEN
        IF NOT(ignoreini) THEN
            forceswapfilesprotection:=FALSE; (* override possible default : user is responsible for ini entries *)
        END;
    END;
    RETURN forceswapfilesprotection;
END swapfilesprotectionFIX;

PROCEDURE initProtected (VAR lastentry:CARDINAL;
                        ignoreini,forceswapfilesprotection,useLFN,DEBUG:BOOLEAN):BOOLEAN;
VAR
    ini,udne : pathtype;
    hin:FIO.File;
    p,i,pb:CARDINAL;
    S:str1024;
    inihere:BOOLEAN;
BEGIN
    Lib.ParamStr(ini,0);
    p:=Str.RCharPos(ini,dot);
    IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
    Str.Append(ini,extINI);
    inihere:=FIO.Exists(ini);

    forceswapfilesprotection:=swapfilesprotectionFIX(forceswapfilesprotection, inihere,ignoreini);

    lastentry := minProtected-1;

    IF forceswapfilesprotection THEN
        FOR i:= 1 TO 3 DO
            CASE i OF
            | 1: S:=patSwapWin92;
            | 2: S:=patSwapWin98;
            | 3: S:=patSwapWinXP;
            ELSE ; (* //ISO fixed silly requirement *) END;
            INC(lastentry);
            Str.Copy(entryprotected[lastentry],S);
        END;
    END;

    IF ignoreini THEN RETURN TRUE; END;
    IF NOT(inihere) THEN RETURN TRUE; END;

    hin:=FIO.OpenRead(ini);
    FIO.AssignBuffer(hin,ioBufferIn);

    pb:=0;

    LOOP
        IF FIO.EOF THEN EXIT; END;
        FIO.RdStr(hin,udne);
        IF FIO.EOF THEN EXIT; END;

        preprocessLine (udne);

        CASE udne[0] OF
        | CHR(0), semicolon,pound :
            ;
        ELSE
            (* IF chkJoker(udne) THEN INC(pb); EXIT; END; *)

            LowerCaseAlt(udne); (* keep accents *)

            S:="Protected ~ ~ : ~";
            INC(lastentry);
            IF lastentry > maxProtected THEN INC(pb);EXIT;END;
            entryprotected[lastentry]:=udne;
            IF DEBUG THEN
                Str.Subst(S,"~","entry");
                i:=lastentry;
            END;
            IF DEBUG THEN
                Str.Subst(S,"~",fmt(i,10,2," ",""));
                Str.Subst(S,"~",nice(useLFN,udne));
                WrStr(S);WrLn;
            END;
        END;
    END;
    FIO.Close(hin);
    RETURN (pb=0);
END initProtected;

PROCEDURE dmpProtected (useLFN,cr:BOOLEAN;lastentry:CARDINAL );
VAR
    last,i:CARDINAL;
    R:str16;
    S:pathtype;
BEGIN
    IF lastentry < minProtected THEN RETURN; END;
    IF cr THEN WrLn;END;
        last:=lastentry;  R:="entry ";
        i:=minProtected;
        LOOP
            IF i > last THEN EXIT; END;
            S:=entryprotected[i];
            WrStr("Protected ");WrStr(R);
            WrStr(fmt(i,10,2," ","") );WrStr(" ");
            WrStr( nice(useLFN,S));WrLn;
            INC(i);
        END;
END dmpProtected;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    attrstatetype = (dontcare,required,unwanted);
    masktype = RECORD (* D R H S A *)
        stateD,stateR,stateH,stateS,stateA : attrstatetype;
    END;
CONST
    firstattr      = 1;
    lastattr       = 5;
    allowedAttr    = "DRHSA"; (* 1..5 *)
CONST
    fakeoption     = "QD=";
    showfilesonly  = fakeoption+"D-";

(* see GetLongCard() in QD_Box *)

PROCEDURE removeOption (VAR R:ARRAY OF CHAR);
VAR
    p:CARDINAL;
BEGIN
    Str.Subst(R,equal,colon); (* command line option xxx= becomes xxx: *)
    p := Str.CharPos(R,colon);
    IF p # MAX(CARDINAL) THEN Str.Delete(R,0,p+1); END;
END removeOption;

PROCEDURE parseMask (S:ARRAY OF CHAR; VAR m:masktype):BOOLEAN;
VAR
    included,excluded,indifferent:str16;
    i,len:CARDINAL;
    ch,keepch:CHAR;
    state:(wait,grab);
    rc:BOOLEAN;
    attrstate:attrstatetype;
BEGIN
    removeOption(S);

    (* accept ?+, ?-, ?x, ? (assuming ?+) : exemple A+R-H+ *)

    len:=Str.Length(S);
    FOR i:= 1 TO len DO
        ch:=S[i-1];
        IF Belongs(allowedAttr,ch) THEN
            IF CharCount(S,ch) > 1 THEN RETURN FALSE; END; (* avoid repeated or contradictory *)
        END;
    END;
    included := "";
    excluded := "";
    indifferent:="";
    i:=1;
    rc:=FALSE;
    state:=wait;
    LOOP
        IF i > len THEN rc:=TRUE; EXIT; END;
        ch:=S[i-1];
        CASE state OF
        | wait:
            CASE ch OF
            | "D","R","H","S","A" : keepch:=ch;
                IF (i+1) > len THEN Str.Append(included,keepch);END;
            ELSE
                EXIT;
            END;
            state:=grab;
        | grab:
            CASE ch OF
            | "+"         : Str.Append(included,keepch);
            | "-"         : Str.Append(excluded,keepch);
            | "?","!","X" : Str.Append(indifferent,keepch);
            | "D","R","H","S","A": Str.Append(included,keepch); (* fake "+" for previous flag *)
                DEC(i); (* but cancel next advance *)
            ELSE
                EXIT;
            END;
            state:=wait;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(i);
    END;
    (* included and excluded don't share any attribute *)
    FOR i:=firstattr TO lastattr DO
        ch:=allowedAttr[i-1];
        IF Belongs(included,ch) THEN
            attrstate:=required;
        ELSIF Belongs(excluded,ch) THEN
            attrstate:=unwanted;
        ELSIF Belongs(indifferent,ch) THEN
            attrstate:=dontcare;
        ELSE
            attrstate:=dontcare;
        END;
        CASE ch OF
        | "D" : m.stateD := attrstate;
        | "R" : m.stateR := attrstate;
        | "H" : m.stateH := attrstate;
        | "S" : m.stateS := attrstate;
        | "A" : m.stateA := attrstate;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    RETURN rc;
END parseMask;

(*
    attrstatetype = (dontcare,required,unwanted);
    masktype = RECORD (* D R H S A *)
        stateD,stateR,stateH,stateS,stateA : attrstatetype;
    END;
*)

PROCEDURE matchMask (attr:FIO.FileAttr ; m:masktype):BOOLEAN ;
VAR
    i,pb:CARDINAL;
    here:BOOLEAN;
    status:attrstatetype;
BEGIN
    pb:=0;
    FOR i:=firstattr TO lastattr DO
        CASE i OF
        | 1 : here:=( aDD IN attr ); status := m.stateD;
        | 2 : here:=( aR IN attr ); status := m.stateR;
        | 3 : here:=( aH IN attr ); status := m.stateH;
        | 4 : here:=( aS IN attr ); status := m.stateS;
        | 5 : here:=( aA IN attr ); status := m.stateA;
        ELSE ; (* //ISO fixed silly requirement *) END;
        CASE status OF
        | dontcare: ;
        | required: IF NOT(here) THEN INC(pb); END;
        | unwanted: IF here      THEN INC(pb); END;
        ELSE ; (* //ISO fixed silly requirement *) END;
    END;
    RETURN (pb=0);
END matchMask;

(*
Year stored relative to 1980 (ex. 1988 stores as 8)
    year      month    day   

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

CONST
    yyMask=BITSET{9..15};
    yyShft=9;
    mmMask=BITSET{5..8};
    mmShft=5;
    ddMask=BITSET{0..4};
    ddShft=0;
    mindd=1;
    maxdd=31;
    minmm=1;
    maxmm=12;
    minyy=1980; (* base year for messdos *)
    maxyy=minyy+127; (* was 2099 *)
    baseyear=minyy;  (* 1980 *)

PROCEDURE PackDMY (d,m,y : CARDINAL  ) : CARDINAL;
BEGIN
    IF y < baseyear THEN
        y:=baseyear;
    END;
    DEC(y,baseyear);
    IF y > 127 THEN y:=127; END; (* %1111111 i.e. $7f max *)
    y := y << yyShft;
    m := m << mmShft;
    RETURN (y + m + d);
END PackDMY;

PROCEDURE UnpackDMY (dmy:CARDINAL;VAR d,m,y:CARDINAL);
BEGIN
    y := CARDINAL(BITSET(dmy) * yyMask) >> yyShft;
    m := CARDINAL(BITSET(dmy) * mmMask) >> mmShft;
    d := CARDINAL(BITSET(dmy) * ddMask) >> ddShft;
    INC(y,baseyear);
END UnpackDMY;

PROCEDURE parseDate (S : ARRAY OF CHAR;
                     VAR dmy : CARDINAL) : BOOLEAN;
CONST
    century = 1900;
CONST
    digits   = "0123456789";
    alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
CONST
    separator=dash;
    legaldateset = digits+separator+alphabet;
VAR
    i,day,month,year : CARDINAL;
    R : str80;
    v : LONGCARD;
    ok: BOOLEAN;
BEGIN
    UpperCase(S); (* in case months would be letters *)
    ReplaceChar(S,slash,separator);
    FOR i := 0 TO (Str.Length(S)-1) DO
        IF Str.CharPos(legaldateset,S[i])=MAX(CARDINAL) THEN RETURN FALSE; END;
    END;
    IF CharCount(S,separator) # 2 THEN RETURN FALSE; END;

    Str.ItemS(R,S,separator,0);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN RETURN FALSE; END;
    IF (v < mindd) OR (v > maxdd) THEN RETURN FALSE; END;
    day := CARDINAL(v);

    Str.ItemS(R,S,separator,1);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN
        Str.Prepend(R,dash); (* fake command line parameter ! *)
        i := GetOptIndex(R,"JAN"+delim+"JAN"+delim+
                           "FEB"+delim+"FEV"+delim+
                           "MAR"+delim+"MAR"+delim+
                           "APR"+delim+"AVR"+delim+
                           "MAY"+delim+"MAI"+delim+
                           "JUN"+delim+"JUN"+delim+
                           "JUL"+delim+"JUI"+delim+
                           "AUG"+delim+"AOU"+delim+
                           "SEP"+delim+"SEP"+delim+
                           "OCT"+delim+"OCT"+delim+
                           "NOV"+delim+"NOV"+delim+
                           "DEC"+delim+"DEC");
        CASE i OF
        | 1..24 :
            v := LONGCARD(i+1) DIV 2;
        ELSE
            RETURN FALSE;
        END;
    END;
    IF (v < minmm) OR (v > maxmm) THEN RETURN FALSE; END;
    month := CARDINAL(v);

    Str.ItemS(R,S,separator,2);
    v := Str.StrToCard(R,10,ok);
    IF ok=FALSE THEN RETURN FALSE; END;
    IF v < 100 THEN INC(v,century); END;
    IF (v < minyy) OR (v > maxyy) THEN RETURN FALSE; END;
    year := CARDINAL(v);
    dmy:=PackDMY (day,month,year);
    RETURN TRUE;
END parseDate;

PROCEDURE parseDateRange (S:ARRAY OF CHAR;VAR lodate,hidate:CARDINAL):BOOLEAN;
VAR
    rc:BOOLEAN;
    p:CARDINAL;
    S1,S2:str128;
    d,m,y:CARDINAL;
    dow:Lib.DayType;
BEGIN
    removeOption(S); (* we had gotten an option "$:*" *)
    rc:=FALSE;

    (* not here, because dash can be a date separator ! *)
    (* ReplaceChar(S,dash, colon); (* change possible "*-*" range TO "*:*" *) *)

    Str.Subst(S,dotdot,colon);  (* change possible "*..*" range to "*:*" *)
    p:=Str.CharPos(S,colon);

    IF p=MAX(CARDINAL) THEN
        IF same(S,"*") THEN                      (* today *)
            Lib.GetDate(y,m,d,dow);
            lodate:=PackDMY(d,m,y);
            rc:=TRUE;
        ELSE
            rc:=parseDate(S,lodate);
        END;
        hidate:=lodate;                          (* "$" means same *)
    ELSE
        Str.Slice(S1,S,0,p);
        Str.Delete(S,0,p+1); Str.Copy(S2,S);

        IF (same(S1,"") OR same(S1,"*")) THEN    (* ":$" means before/on *)
            lodate:=PackDMY(1,1,0000);
            rc:=parseDate(S2,hidate);
        ELSIF (same(S2,"") OR same(S2,"*"))THEN  (* "$:" means on/after *)
            hidate:=PackDMY(31,12,9999);
            rc:=parseDate(S1,lodate);
        ELSE
            rc:=parseDate(S1,lodate);
            IF rc THEN rc:=parseDate(S2,hidate); END;
        END;
    END;
    IF rc THEN
        rc:=(lodate <= hidate); (* safety check *)
    END;
    RETURN rc;
END parseDateRange;



PROCEDURE parsefsize (VAR v:LONGCARD;S:ARRAY OF CHAR   ):BOOLEAN ;
VAR
    ok:BOOLEAN;
    kmul:LONGCARD;
    i:CARDINAL;
    suffix:str16;
BEGIN
    i:=1-1;
    LOOP
        INC(i);
        IF i > 6 THEN kmul:=1; EXIT; END;
        CASE i OF
        | 1: suffix:="K"; kmul:=1000;
        | 2: suffix:="M"; kmul:=1000*1000;
        | 3: suffix:="G"; kmul:=1000*1000*1000;
        | 4: suffix:="KB";kmul:=1024;
        | 5: suffix:="MB";kmul:=1024*1024;
        | 6: suffix:="GB";kmul:=1024*1024*1024;
        ELSE ; (* //ISO fixed silly requirement *) END;
        Str.Prepend(suffix,"*");
        IF Str.Match(S,suffix) THEN
            i:=Str.Length(suffix);
            Str.Delete(S,Str.Length(S)-i+1,i);
            EXIT;
        END;
    END;
    ok:=GetLongCard(S,v);
    IF ok THEN v:=v*kmul; END;
    RETURN ok;
END parsefsize;

PROCEDURE parseFileSizeRange (S:ARRAY OF CHAR;VAR losize,hisize:LONGCARD ):BOOLEAN ;
VAR
    rc:BOOLEAN;
    p:CARDINAL;
    S1,S2:str128;
    tmplc:LONGCARD;
    isjokerlo,isjokerhi:BOOLEAN;
BEGIN
    removeOption(S); (* we had gotten an option "$:*" *)
    rc:=FALSE;
    ReplaceChar(S,dash, colon); (* change possible "*-*" range to "*:*" *)
    Str.Subst(S,dotdot,colon);  (* change possible "*..*" range TO "*:*" *)

    (* handle cosmetic separators now *)
    ReplaceChar(S,coma,"");
    ReplaceChar(S,dot,"");

    p:=Str.CharPos(S,colon);
    IF p=MAX(CARDINAL) THEN    (* "$" "*" "" *)
        rc:=parsefsize(losize,S);
        hisize:=losize;                          (* "$" means exact size *)
    ELSE
        Str.Slice(S1,S,0,p);
        Str.Delete(S,0,p+1); Str.Copy(S2,S);

        isjokerlo:=( same(S1,"") OR same(S1,star) );
        isjokerhi:=( same(S2,"") OR same(S2,star) );

        IF isjokerlo THEN
            IF isjokerhi THEN           (* "*:*" *)
                losize:=MIN(LONGCARD);
                hisize:=MAX(LONGCARD);
                rc:=TRUE;
            ELSE                        (* "*:$" *)
                losize:=MIN(LONGCARD); (* complicated ways to mean 0 ! *)
                rc:=parsefsize(hisize,S2);
            END;
        ELSIF isjokerhi THEN            (* "$:*" *)
            hisize:=MAX(LONGCARD);
            rc:=parsefsize(losize,S1);
        ELSE                            (* "$:$" *)
            rc:=parsefsize(losize,S1);
            IF rc THEN rc:=parsefsize(hisize,S2);END;
        END;
    END;
    IF rc THEN
        (* rc:=(losize <= hisize); (* safety check *) *)
        IF losize > hisize THEN
            tmplc:=losize;
            losize:=hisize;
            hisize:=tmplc;
        END;
    END;
    RETURN rc;
END parseFileSizeRange;

PROCEDURE using (n : CARDINAL; digits : CARDINAL; pad : CHAR) : str16;
VAR
    ok   : BOOLEAN;
    v    : LONGCARD;
    len  : CARDINAL;
    S    : str16;
BEGIN
    v := LONGCARD(n);
    Str.CardToStr(v,S,10,ok);
    len := Str.Length(S);
    LOOP
        IF Str.Length(S) >= digits THEN EXIT; END;
        Str.Prepend(S,pad);
    END;
    RETURN S;
END using;

PROCEDURE fmtDate (dmy:CARDINAL;plain:BOOLEAN) : str16;
CONST
    separator = dash;
    pad       = "0";
    baseyear  = 1900;
    tmonths   = "Jan Fv Mar Avr Mai Jun Jui Ao Sep Oct Nov Dc ???";
    tmonths2  = "Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec ???";
VAR
    R : str16;
    d,m,y:CARDINAL;
BEGIN
    UnpackDMY(dmy,d,m,y);
    IF ((m < minmm) OR (m > maxmm)) THEN m := 13; END;
    IF plain THEN
    Str.ItemS(R,tmonths2," ",m-1);
    ELSE
    Str.Copy(R, using (m,2,pad));
    END;
    Str.Prepend(R,separator);
    Str.Prepend(R,using(d,2,pad));
    Str.Append(R,separator);
    Str.Append(R,using(y,4,pad));
    RETURN R;
END fmtDate;

PROCEDURE fmtSize (v : LONGCARD; pad:CHAR; sep:CHAR) : str80;
CONST
    field = 10+3; (* #,###,###,### *) (* 1Gb+ file okay now *)
VAR
    S,R   : str80;
    len,i : CARDINAL;
    ok  : BOOLEAN;
    ch  : CHAR;
BEGIN
    Str.CardToStr( v,S,10,ok); (* fixRealToStr was overkill ! ah, cut/paste is not ALWAYS a good idea... *)
    len:=Str.Length(S);
    R := "";
    FOR i := 1 TO len DO
        Str.Prepend(R,S[len-i]);
        IF i < len THEN
            IF (i MOD 3) = 0 THEN
                Str.Prepend(R,sep);
            END;
        END;
    END;
    LOOP
        IF INTEGER(Str.Length(R)) >= ABS(field) THEN EXIT; END;
        IF field < 0 THEN
            Str.Append(R,pad);  (* right alignment *)
        ELSE
            Str.Prepend(R,pad);
        END;
    END;
    RETURN R;
END fmtSize;

PROCEDURE fmtDateRange (lodate,hidate:CARDINAL):str80;
VAR
    R:str80;
BEGIN
    IF lodate = hidate THEN
        Str.Copy(R, fmtDate(lodate,TRUE ) );
    ELSE
        R:="[~..~]";
        Str.Subst(R,"~", fmtDate(lodate,TRUE ) );
        Str.Subst(R,"~", fmtDate(hidate,TRUE ) );
    END;
    RETURN R;
END fmtDateRange;

PROCEDURE fmtSizeRange (losize,hisize:LONGCARD):str80;
VAR
    R : str80;
BEGIN
    IF losize = hisize THEN
        Str.Copy(R,      fmtSize(losize,blank,"" ) );
    ELSE
        R:="[~..~]";
        Str.Subst(R,"~", fmtSize(losize,blank,"" ) );
        Str.Subst(R,"~", fmtSize(hisize,blank,"" ) );
    END;
    ReplaceChar(R,blank,"");
    RETURN R;
END fmtSizeRange;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstindex = 1; (* because we'll need 1-1 *)
TYPE
    pEntry = POINTER TO entryType;
    entryType = RECORD
        next      : pEntry;
        index     : CARDINAL;  (* [1.. is ID of base dir for files *)
        slen      : SHORTCARD;
        str       : CHAR;
    END;

PROCEDURE initList (VAR anchor : pEntry );
BEGIN
    anchor := NIL;
END initList;

PROCEDURE freeList (anchor : pEntry);
VAR
    needed : CARDINAL;
    p      : pEntry;
BEGIN
    (* p:=anchor; *)
    WHILE anchor # NIL DO
        needed := SIZE(entryType) - SIZE(anchor^.str) + CARDINAL(anchor^.slen);
        p := anchor^.next;
        DEALLOCATE(anchor,needed);
        anchor:=p;
    END
END freeList;

PROCEDURE buildNewPtr (VAR anchor,p:pEntry; len:CARDINAL):BOOLEAN;
VAR
    needed : CARDINAL;
BEGIN
    needed := SIZE(entryType) - SIZE(p^.str) + len;
    IF anchor = NIL THEN
        ALLOCATE(anchor,needed);
        p:=anchor;
    ELSE
        p:=anchor;
        WHILE p^.next # NIL DO
            p:=p^.next;
        END;
        ALLOCATE(p^.next,needed);
        p:=p^.next;
    END;
    p^.next := NIL;
    RETURN TRUE;
END buildNewPtr;

(* ------------------------------------------------------------ *)

(* assume p is valid *)

PROCEDURE getStr (VAR S : pathtype; p:pEntry);
VAR
    len:CARDINAL;
BEGIN
    len := CARDINAL(p^.slen);
    Lib.FastMove( SYSTEM.ADR(p^.str),SYSTEM.ADR(S),len);
    S[len] := nullchar; (* REQUIRED safety ! *)
END getStr;

PROCEDURE findByIndex(wanted:CARDINAL;anchor:pEntry) : pEntry;
VAR
    p:pEntry;
BEGIN
    p := anchor;
    LOOP
        IF p = NIL THEN EXIT;END; (* gloups ! should NEVER happen ! *)
        IF p^.index = wanted THEN EXIT; END;
        p := p^.next;
    END;
    RETURN p;
END findByIndex;

PROCEDURE isReservedEntry (S:ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF same(S,dot) THEN RETURN TRUE; END;
    RETURN same(S,dotdot);
END isReservedEntry;

PROCEDURE buildDirList (VAR lastdir,lastdirReal:CARDINAL; VAR anchor:pEntry;
                       useLFN,recurse,showbusy,notice:BOOLEAN;base:pathtype):CARDINAL;
VAR
    p: pEntry;
    len : CARDINAL;
    root,rootspec,entryname,newroot : pathtype;
    entry : FIO.DirEntry;
    found : BOOLEAN;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    rc : CARDINAL;
    ok:BOOLEAN;
BEGIN
    Str.Copy(root,base);
    fixDirectory(root); (* safety *)

    (* assume base exists ! *)

    ok:=chkNoProtection(notice,showbusy,TRUE,"",root); (* empty base *)
    IF ok THEN
        len:=Str.Length(root);
        IF buildNewPtr(anchor,p,len)=FALSE THEN RETURN errStorage; END;
        INC(lastdir);
        p^.index     := lastdir;
        p^.slen      := SHORTCARD(len);
        Lib.FastMove ( SYSTEM.ADR(root),SYSTEM.ADR(p^.str),len );
    END;

    INC(lastdirReal);

    IF NOT(recurse) THEN RETURN errNone; END;

    Str.Concat(rootspec,root,"*.*");
    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
            dosattr:=entry.attr;
            IF (aDD IN dosattr) THEN
                Str.Concat(newroot,root,entryname); (* u:\xx\ + xxx *)
                fixDirectory(newroot);
                rc:= buildDirList (lastdir,lastdirReal,anchor,
                                  useLFN,recurse,showbusy,notice,newroot);
                IF rc # errNone THEN
                    RETURN rc;
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END buildDirList;

PROCEDURE dmpDirs (anchor:pEntry;useLFN:BOOLEAN);
CONST
    sInfo = "DIR  index= ~  ~"; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=anchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);  Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
        Str.Subst(S,"~", nice(useLFN,R) );
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpDirs;

PROCEDURE dmpDirsAlt (anchor:pEntry;lastdir:CARDINAL;useLFN:BOOLEAN);
CONST
    sInfo = "DIR  INDEX= ~  ~"; (* uppercase to remind it's alt proc *)
VAR
    p : pEntry;
    R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
    i:CARDINAL;
BEGIN
    FOR i:=firstindex TO lastdir DO
        p:=findByIndex(i,anchor);
        getStr(R,p);
        Str.Copy(S, sInfo);  Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
        Str.Subst(S,"~", nice(useLFN,R) );
        WrStr(S);WrLn;
    END;
END dmpDirsAlt;

PROCEDURE dmpFiles (fileanchor,diranchor:pEntry;dirindex:CARDINAL;useLFN:BOOLEAN);
CONST
    sInfo = "File index= ~  ~"; (* file must always be last with this placeholder *)
VAR
    p : pEntry;
    base,R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
BEGIN
    p:=findByIndex(dirindex,diranchor);
    getStr(base,p);

    p:=fileanchor;
    WHILE p # NIL DO
        getStr(R,p);
        Str.Copy(S, sInfo);
        Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
        Str.Prepend(R,base);
        Str.Subst(S,"~", nice(useLFN,R) );
        WrStr(S);WrLn;
        p:=p^.next;
    END;
END dmpFiles;

PROCEDURE dmpFilesAlt (fileanchor,diranchor:pEntry; lastfile,dirindex:CARDINAL;useLFN:BOOLEAN);
CONST
    sInfo = "FILE INDEX= ~  ~"; (* uppercase to remind it's alt proc *)
VAR
    p : pEntry;
    base,R: pathtype;
    ok:BOOLEAN;
    S:str1024;   (* oversized *)
    i:CARDINAL;
BEGIN
    p:=findByIndex(dirindex,diranchor);
    getStr(base,p);

    FOR i:=firstindex TO lastfile DO
        p:=findByIndex(i,fileanchor);
        getStr(R,p);
        Str.Copy(S, sInfo);
        Str.Subst(S,"~",fmt(p^.index,10,5," ",""));
        Str.Prepend(R,base);
        Str.Subst(S,"~", nice(useLFN,R) );
        WrStr(S);WrLn;
    END;
END dmpFilesAlt;


PROCEDURE fakeDirList (VAR lastdir,lastdirReal:CARDINAL; VAR anchor:pEntry):CARDINAL;
VAR
    p : pEntry;
    root:pathtype;
    len:CARDINAL;
BEGIN
    root:="";
    len:=Str.Length(root);
    IF buildNewPtr(anchor,p,len)=FALSE THEN RETURN errStorage; END;
    INC(lastdir);
    p^.index     := lastdir;
    p^.slen      := SHORTCARD(len);
    Lib.FastMove ( SYSTEM.ADR(root),SYSTEM.ADR(p^.str),len );

    INC(lastdirReal);

    RETURN errNone;
END fakeDirList;

PROCEDURE fakeAddFile (VAR globallastfile,globallastfileReal:LONGCARD;
                      VAR lastfile,lastfileReal:CARDINAL; VAR anchor:pEntry;
                      showbusy,notice:BOOLEAN; S:pathtype):CARDINAL;
VAR
    entryname:pathtype;
    pp:pEntry;
    len:CARDINAL;
    ok:BOOLEAN;
BEGIN
    Str.Copy(entryname,S);
    IF isReservedEntry (entryname) THEN RETURN errNone; END; (* skip "." AND ".." *)

    (* if file has no extension, add it as a marker *)
    IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
        Str.Append(entryname,".");
    END;

    ok:= chkNoProtection(notice,showbusy,FALSE,"",entryname) ; (* empty base *)
    IF ok THEN
        len:=Str.Length(entryname);
        IF buildNewPtr(anchor,pp,len)=FALSE THEN RETURN errStorage; END;

        INC(lastfile);
        INC(globallastfile);

        pp^.index     := lastfile;
        pp^.slen      := SHORTCARD(len);
        Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
    END;

    INC(lastfileReal);
    INC(globallastfileReal);

    RETURN errNone;
END fakeAddFile;

(* modified DD v1.0h sub *)

PROCEDURE storeFiles (VAR globallastfile,globallastfileReal:LONGCARD;
                     VAR lastfile,lastfileReal:CARDINAL;
                     VAR fileanchor : pEntry;
                     useLFN,showbusy,notice,osjokers,sizerange,daterange:BOOLEAN;
                     losize,hisize:LONGCARD; lodate,hidate:CARDINAL;
                     maskfilter : masktype;
                     base,spec:pathtype):CARDINAL;
VAR
    matchspec,rootspec,entryname : pathtype;
    dosattr:FIO.FileAttr;
    w9Xhandle,errcode:CARDINAL;
    entry : FIO.DirEntry;
    ok,keepit,found : BOOLEAN;
    len:CARDINAL;
    pp:pEntry;
    fsize:LONGCARD;
    stampdate,stamptime:CARDINAL;
BEGIN
    lastfile     := firstindex-1; (* 0 *)
    lastfileReal := firstindex-1;
    initList(fileanchor);

    IF osjokers THEN
        Str.Concat(rootspec,base,spec);
        Str.Copy(matchspec,"*");         (* match everything *)
    ELSE
        Str.Concat(rootspec,base,"*.*"); (* was spec before osjoker option *)
        Str.Copy(matchspec,spec);
    END;

    found := FIO.ReadFirstEntry(rootspec,everything,entry);
    WHILE found DO
        Str.Copy(entryname,entry.name);
        IF isReservedEntry (entryname) = FALSE THEN (* skip "." AND ".." *)
                dosattr:=entry.attr;

                fsize     := entry.sizeL; (* //FIXME *)
                stampdate := entry.datePkd;

            (* some time, be more clever here -- er... let's try to be, at least *)

            ok:=matchMask(dosattr,maskfilter);

            IF sizerange THEN (* nonsense with dirs *)
                keepit:=NOT ( (fsize < losize) OR (fsize > hisize) );
                ok := (ok AND keepit);
            END;
            IF daterange THEN
                keepit:=NOT ( (stampdate < lodate) OR (stampdate > hidate) );
                ok := (ok AND keepit);
            END;

            IF ok THEN
                (* if file has no extension, add it as a marker *)
                IF Str.RCharPos(entryname,".")=MAX(CARDINAL) THEN
                    Str.Append(entryname,".");
                END;
                ok:=Str.Match(entryname,matchspec); (* was spec *)
                IF ok THEN
                    INC(lastfileReal);
                    INC(globallastfileReal);
                    ok:= chkNoProtection(notice,showbusy,FALSE,base,entryname);
                END;

                IF ok THEN
                    len:=Str.Length(entryname);
                    IF buildNewPtr(fileanchor,pp,len)=FALSE THEN
                        RETURN errStorage;
                    END;
                    INC(lastfile);
                    INC(globallastfile);
                    pp^.index     := lastfile;
                    pp^.slen      := SHORTCARD(len);
                    Lib.FastMove ( SYSTEM.ADR(entryname),SYSTEM.ADR(pp^.str),len );
                END;
            END;
        END;
        found :=FIO.ReadNextEntry(entry);
    END;
    RETURN errNone;
END storeFiles;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* //FIXME *)

CONST
    CHKEVERY9X = 128; (* let's call chkEscape every CHKEVERY LOOP *)
    CHKEVERYDOS= 8;  (* safety *)

PROCEDURE pollEscape (VAR chkrounds:CARDINAL; useLFN,ignoreESC:BOOLEAN):BOOLEAN;
VAR
    alcatraz:BOOLEAN;
    every:CARDINAL;
BEGIN
    (*
    9x really does NOT like ChkEscape() and randomely hangs till a keypress
    Flushkey() does NOT help
    *)
    (*
    IF useLFN THEN
        hit:=FALSE;
    ELSE
        hit:=ChkEscape();
    END;
    *)
    IF ignoreESC THEN RETURN FALSE;END;
    IF useLFN THEN
        every:=CHKEVERY9X;
    ELSE
        every:=CHKEVERYDOS;
    END;
    INC(chkrounds);
    IF (chkrounds MOD every) = 0 THEN
        chkrounds:=0;
        alcatraz:=ChkEscape();
    ELSE
        alcatraz:=FALSE;
    END;
    RETURN alcatraz;
END pollEscape;

PROCEDURE chkEnvVar (VAR preview:BOOLEAN ):BOOLEAN ;
CONST
    sAllowed = "T"+delim+"TEST"+delim+"PREVIEW"; (* must match options *)
VAR
    R:str16;
    rc:BOOLEAN;
    i : CARDINAL;
BEGIN
    rc:=TRUE;
    Lib.EnvironmentFind(sPCOPYenv , R);
    LtrimBlanks(R);
    RtrimBlanks(R);
    IF same(R,"") THEN RETURN rc; END;
    CASE R[0] OF
    | "-" , "/" :
        ;
    ELSE
        Str.Prepend(R,"-");
    END;
    UpperCase(R);
    i := GetOptIndex(R, sAllowed);
    CASE i OF
    | 1..3 :
        preview:=TRUE;
    ELSE
        rc:=FALSE;
    END;
    RETURN rc;
END chkEnvVar;

(* ------------------------------------------------------------ *)

(*
Seconds are 0 to 29 -- DOS stores nearest even / 2
  hours    minutes   seconds 

 F E D C B A 9 8 7 6 5 4 3 2 1 0   <-- Bit Number
*)

PROCEDURE fmtTime (timedata:CARDINAL) : str16;
CONST
    hhMask=BITSET{11..15};
    hhShft=11;
    mmMask=BITSET{5..10};
    mmShft=5;
    ssMask=BITSET{0..4};
    ssShft=0;
CONST
    separator = colon;
    padhours = blank;
    pad="0";
VAR
    h,m,s : CARDINAL;
    R : str16;
BEGIN
    h := CARDINAL(BITSET(timedata) * hhMask) >> hhShft;
    m := CARDINAL(BITSET(timedata) * mmMask) >> mmShft;
    s := CARDINAL(BITSET(timedata) * ssMask) >> ssShft;
    s := s << 1; (* yes, yes, "* 2" works too... *)
    R := using(h,2,padhours);
    Str.Append(R,separator);
    Str.Append(R,using(m,2,pad));
    Str.Append(R,separator);
    Str.Append(R,using(s,2,pad));
    RETURN R;
END fmtTime;

PROCEDURE fmtquery (VAR R:ARRAY OF CHAR;isTarget,useLFN:BOOLEAN;canon:pathtype);
CONST
    sDOS = "| | | | |";   (* date time fsize motion file *)
    sLFN = '| | | | "|"';
    placeholder = "|";
VAR
    fsize,stamp:LONGCARD;
    jma,hms:CARDINAL;
BEGIN
    IF useLFN THEN
        Str.Copy(R,sLFN);
    ELSE
        Str.Copy(R,sDOS);
    END;
    fsize:=getFileSize(canon);
    stamp:=getFileStamp(canon);

    jma:=CARDINAL ( stamp >> 16 );
    hms:=CARDINAL ( stamp AND 0000FFFFH );

    Str.Subst(R,placeholder, fmtDate(jma,TRUE ) );
    Str.Subst(R,placeholder, fmtTime(hms) );
    Str.Subst(R,placeholder, fmtSize(fsize,blank,coma) );
    IF isTarget THEN
        Str.Subst(R,placeholder,"->");
    ELSE
        Str.Subst(R,placeholder,"  ");
    END;
    Str.Subst(R,placeholder, canon);
END fmtquery;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE doGetDir (currdrive:SHORTCARD;
                   VAR currdir: pathtype);
VAR
    longform:pathtype;
    rc:CARDINAL;
BEGIN
    FIO.GetDir(currdrive,currdir); (* we could use 0 for default drive *)
    IF currdir[1]=colon THEN Str.Delete(currdir,0,2);END; (* safety for all ! *)
END doGetDir;

(* u, "\*\", "u:\*\" *)

PROCEDURE getAnchor (useLFN:BOOLEAN;
                     VAR currdrive:SHORTCARD;
                     VAR currdir,currpath:pathtype);
VAR
    driveletter:CHAR;
BEGIN
    currdrive := FIO.GetDrive(); (* 1=A, etc. *)
    doGetDir(currdrive, currdir);
    fixDirectory(currdir);
    driveletter := CHAR (currdrive+ORD("A")-1);
    Str.Concat(currpath, driveletter,colon);
    Str.Append(currpath, currdir);
END getAnchor;

PROCEDURE doChDir (dir:pathtype ):BOOLEAN;
VAR
    rc:CARDINAL;
    S:pathtype;
    ok:BOOLEAN;
BEGIN
    FIO.ChDir(dir);
    ok:= (FIO.IOresult()=0); (* true if directory found *)
    RETURN ok; (* true if directory found *)
END doChDir;

PROCEDURE doMkDir (S:pathtype  );
VAR
    rc:CARDINAL;
    ok:BOOLEAN;
BEGIN
    FIO.MkDir(S);
END doMkDir;

(* "u:\xxx[\xxx]...", assume everything goes ok ! *)

PROCEDURE makemydir (S:pathtype;useLFN,setasdefault:BOOLEAN ):BOOLEAN ;
VAR
    i,pb : CARDINAL;
    path : pathtype; (* was str128 *)
    R    : pathtype;
    ok:BOOLEAN;
BEGIN
    pb := 0;

    isoleItemS(path,S,backslash,0);
    FOR i:= 1 TO CharCount(S,backslash) DO
        isoleItemS(R, S, backslash, i);
        Str.Append(path,backslash);
        Str.Append(path,R);
        doMkDir(path);

        (*
        WrStr(path);WrLn;
        Lib.WrDosError(SHORTCARD(FIO.IOresult()));WrLn;
        CASE FIO.IOresult() OF
        | DOSErr.NO_ERROR, DOSErr.ERROR_ACCESS_DENIED: ;
        ELSE
            INC(pb);
        END;
        *)
    END;

    IF setasdefault THEN
        IF pb=0 THEN ok:=doChDir(S); END;
    END;

    RETURN (pb=0);
END makemydir;

CONST
    buildKeepName = 0; (* flagMAKEPATH = FALSE = don't recreate path *)
    buildKeepPath = 1; (* flagMAKEPATH = TRUE  = keep full path *)
    buildXcopy    = 2; (* flagMAKEPATH = TRUE  = remove root spec in path *)
    buildUndefined= MAX(CARDINAL); (* v1.2i fix *)

PROCEDURE buildtarget (VAR R:pathtype;
                      method:CARDINAL;base,src,rootspec:pathtype);
VAR
    p : CARDINAL;
    u,d,n,e:pathtype;
BEGIN
    CASE method OF
    | buildKeepName :
        qdSplitAllPath(src,u,d,n,e);
        Lib.MakeAllPath(src,"","",n,e); (* src is a filename here *)
    | buildKeepPath :
        p:=Str.CharPos(src,colon);
        IF p # MAX(CARDINAL) THEN Str.Delete(src,0,p+1); END; (* remove "u:" if present *)
        IF src[0]=backslash THEN Str.Delete(src,0,1);END; (* remove leading "\" if present *)
    | buildXcopy :
        Str.Subst(src,rootspec,"");
        p:=Str.CharPos(src,colon);
        IF p # MAX(CARDINAL) THEN Str.Delete(src,0,p+1); END; (* remove "u:" if present *)
        IF src[0]=backslash THEN Str.Delete(src,0,1);END; (* remove leading "\" if present *)
    ELSE ; (* //ISO fixed silly requirement *) END;
    Str.Concat(R,base,src); (* assume trailing "\" for base *)
END buildtarget;

(* create target path if necessary *)

PROCEDURE handleTargetDir (useLFN,preview:BOOLEAN; currdrive:SHORTCARD;
                          currdir,target:pathtype);
VAR
    u,d,n,e:pathtype; (* "u:" "\*\" "" "" *)
    S:pathtype; (* destdir *)
    was:SHORTCARD;
    rc:BOOLEAN;
BEGIN
    IF preview=FALSE THEN
        qdSplitAllPath(target, u,d,n,e); (* d will be in "\*[\*]..\" form *)
        Lib.MakeAllPath(S,u,d,"","");
        unfixDirectory(S); (* FIO.ChDir does not like trailing "\" ! nor does FIO.Exists *)
        IF FIO.Exists(S) = FALSE THEN (* this checks for dirs too... without trailing slash *)
            rc:=makemydir(S,useLFN,FALSE); (* don't make newly created dir default *)
            FIO.SetDrive(currdrive);
            unfixDirectory(currdir);
            FIO.ChDir(currdir); (* handles unit but not trailing "\" !!! *)
        END;
    END;
END handleTargetDir;

PROCEDURE initXCOPYtarget (VAR XCOPYrootspec:pathtype;
                          method:CARDINAL;basedir:pathtype);
BEGIN
    CASE method OF
    | buildXcopy :
        Str.Copy(XCOPYrootspec,basedir);
    ELSE
        Str.Copy(XCOPYrootspec,""); (* won't be used *)
    END;
END initXCOPYtarget;



(* modified : pbroom,forceabort,askuser,dontshowcozuserdenied *)

PROCEDURE doFileCopy (VAR pbroom,forceabort,askuser,dontshowcozuserdenied:BOOLEAN;
                     showbusy,kilroy,useLFN,preview,showpercentage,DEBUG:BOOLEAN;
                     orgsource,orgtarget:pathtype);
CONST
    msgCopying = "Copying, please wait..."; (* could add a blank for percentage *)
    kYes       = "Y"; sYes       = "Yes";
    kNo        = "N"; sNo        = "No";
    kYesAll    = "A"; sYesAll    = "Yes to all";
    kQuit      = "Q"; sQuit      = "Quit"; (* "Aborted by user !"+nl+nl *)
    kEsc       = CHR(27);
    kOui       = "O";
    kOuiTous   = "T";
    (* multilingual ! well, the two languages worth consideration, eh eh ! <g> *)
    strPrompt  = "Overwrite ? [Y|O]-yes  [N]-no  [A|T]-yes to all  [Q|Esc]-quit : ";
VAR
    hin,hout:FIO.File;
    got:CARDINAL;
    curreof,askagain:BOOLEAN;
    orgstamp:LONGCARD;
    source,target,shortform,u,d,n,e,S:pathtype;
    rc:CARDINAL;
    ok:BOOLEAN;
    key : str2;
    msg: str16;
    zSource,zTarget:str1024; (* oversized *)
    fsize,fpos,targetfsize:LONGCARD;
    candy:BOOLEAN;
BEGIN
    pbroom:= FALSE; (* default just in case *)
    candy := (showpercentage AND NOT(DEBUG) ) ; (* better safe than sorry *)

    forceabort            :=FALSE; (* default *)
    dontshowcozuserdenied :=FALSE; (* default -- true if user denied operation *)

    IF kilroy THEN (* target "was here" *)
        IF askuser THEN
            busy(showbusy,FALSE); (* it was ON *)
            fmtquery(zSource, FALSE,useLFN,orgsource);
            fmtquery(zTarget, TRUE ,useLFN,orgtarget);
            WrStr(zSource);WrLn;
            WrStr(zTarget);WrLn;
            WrLn;
            IF preview THEN WrStr(sPREVIEW);END;
            WrStr(strPrompt);
            LOOP
                askagain:=FALSE;
                Flushkey;  key := Waitkey();  UpperCase(key);
                IF same(key,kYes) THEN        msg:=sYes;
                ELSIF same(key,kYesAll) THEN  msg:=sYesAll; askuser:=FALSE;
                ELSIF same(key,kQuit) THEN    msg:=sQuit; forceabort:=TRUE;
                ELSIF same(key,kEsc) THEN     msg:=sQuit; forceabort:=TRUE;
                ELSIF same(key,kOui) THEN     msg:=sYes;
                ELSIF same(key,kOuiTous) THEN msg:=sYesAll; askuser:=FALSE;
                ELSIF same(key,kNo) THEN      msg:=sNo;dontshowcozuserdenied:=TRUE;
                ELSE                          askagain:=TRUE;
                END;
                IF NOT(askagain) THEN EXIT;END;
            END;
            WrStr(msg);WrLn;
            WrLn;
            busy(showbusy,TRUE); (* restore it now *)
            IF dontshowcozuserdenied THEN RETURN; END;
            IF forceabort            THEN RETURN; END;
        END;
    END;

    curreof:=FIO.EOF; (* almost certainly useless but cannot harm *)

    IF NOT(DEBUG) THEN video(msgCopying,TRUE); END;

    IF preview=FALSE THEN

IF DEBUG THEN dbg("orgsource",orgsource);END;
IF DEBUG THEN dbg("orgtarget",orgtarget);END;
        Str.Copy(source,orgsource);
        Str.Copy(target,orgtarget);

        IF useLFN THEN

            IF FIO.Exists(orgtarget) THEN
                FIO.Erase(orgtarget);
            END;

        END;

        hin:=FIO.OpenRead(source);
        FIO.AssignBuffer(hin,ioBufferIn);
        hout:=FIO.Create(target);           (* // v1.0f it's a DOS function ! *)
        FIO.AssignBuffer(hout,ioBufferOut); (* // v1.0d bugfix ! *)

        orgstamp:=FIO.GetFileDate(hin); (* we were silly to forget that one ! *)

        fsize:=FIO.Size(hin);
        fpos :=0;

        FIO.EOF:=FALSE;
        LOOP
            got:=FIO.RdBin(hin,dataBuffer,dataBufferSize);
(* IF DEBUG THEN dbgcard("got",got);END; *)
            IF got = 0 THEN EXIT; END;
            FIO.WrBin(hout,dataBuffer,got);
            IF got # dataBufferSize THEN EXIT; END;

            INC(fpos,LONGCARD(got));

        END;


        FIO.Flush(hout);
        FIO.Close(hout);
        FIO.Close(hin);

        (* NOW and only NOW, we may update again date and time if needed *)

        hout:=FIO.Open(target);
        FIO.SetFileDate(hout,orgstamp);
        targetfsize := FIO.Size(hout); (* "yes we can" as bozos say *)
        pbroom := (fsize # targetfsize);
        FIO.Close(hout);

        IF pbroom THEN
            FIO.Erase(target); (* kill partially copied file *)
        END;


    END;
    IF NOT(DEBUG) THEN video(msgCopying,FALSE);END;

    FIO.EOF := curreof;
END doFileCopy;

(* as of v1.2o+, different algos whether DOS or LFN *)

PROCEDURE buildnewname (useLFN,DEBUG:BOOLEAN;renfix:CARDINAL;
          VAR S : pathtype):BOOLEAN ;
CONST
    firsttry = 1; (* was 0 *)
    maxtries = 9999;
    maxf8    = 8;
    max9X    = 256; (* //V09C bugfix was 128 should be more than enough *)
VAR
    u,d,n,e,newfile,fname : pathtype;
    i   : LONGCARD;
    value,num : str16;
    ok  : BOOLEAN;
    len,maxlen,wi : CARDINAL;
BEGIN
    IF useLFN THEN
        maxlen := max9X;
    ELSE
        maxlen := maxf8;
    END;
    qdSplitAllPath(S,u,d,n,e);
    len:=Str.Length(n);
    i:=firsttry;
    LOOP
        Str.CardToStr(i,value,10,ok);
        FOR wi:=Str.Length(value)+1 TO renfix DO Str.Prepend(value,"0");END;
        IF useLFN THEN
            num:=lfnrenmask;
        ELSE
            num:=dosrenmask;
        END;
        Str.Subst(num,"#",value);
        WHILE (len+Str.Length(num)) > maxlen DO
            Str.Delete(n,len-1,1); (* delete last char of name *)
            DEC(len);
        END;
        Str.Concat(fname,n,num); (* build new name *)
        Lib.MakeAllPath(newfile,u,d,fname,e);
IF DEBUG THEN dbg("newfile",newfile);END;
        IF FIO.Exists(newfile)=FALSE THEN
            Str.Copy(S,newfile);
            RETURN TRUE;
        END;
        INC(i);
        IF i > maxtries THEN EXIT; END;
    END;
    RETURN FALSE;
END buildnewname;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE aboutProblem (pb:CARDINAL;
                       VAR isSuccess:BOOLEAN;VAR msg:ARRAY OF CHAR);
VAR
    R:str128;
BEGIN
    CASE pb OF
    | pbNone:         R:=msgOK;             (* ok *)
    | pbJoker:        R:=msgJoker;
    | pbNotFound:     R:=msgNotFound;
    | pbTargetExists: R:=msgTargetExists;
    | pbTargetRO:     R:=msgTargetRO;
    | pbTargetNewer:  R:=msgTargetNewer;
    | pbRenameFailure:R:=msgRenameFailure;
    | pbRoomCopy:     R:=msgRoomCopy;
    | pbRoomMove:     R:=msgRoomMove;
    | pbSourceRO:     R:=msgSourceRO;       (* well... half a success *)
    | pbCollision:    R:=msgCollision;
    | pbRenamed:      R:=msgRenamed;        (* ok *)
    | pbMovedRO:      R:=msgMovedRO;        (* ok *)
    | pbMoved:        R:=msgMoved;          (* ok *)
    | pbFreshen:      R:=msgFreshen;
    | pbTargetSameDate:  R:=msgTargetSameDate;
    | pbTargetOlder:  R:=msgTargetOlder;
    ELSE
                      R:=msgUnexpected;
    END;
    Str.Copy(msg,R);
    CASE pb OF
    | pbNone,pbRenamed,pbMovedRO,pbMoved:
        isSuccess:=TRUE;
    | pbSourceRO:
        isSuccess:=FALSE; (* well... *)
    ELSE
        isSuccess:=FALSE;
    END;
END aboutProblem;

CONST
    INITSTATS = MAX(CARDINAL);

PROCEDURE keepStats (VAR successes,warnings:LONGCARD; pb:CARDINAL);
BEGIN
    CASE pb OF
    | INITSTATS:
        successes:=0;
        warnings :=0;
    | pbNone,pbRenamed,pbMovedRO,pbMoved:
        INC(successes);
    | pbSourceRO:
        INC(warnings); (* well... *)
    ELSE
        INC(warnings);
    END;
END keepStats;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* assume targetbasecooked is UpperCaseAlt-ed "u:\" or "u:\*\" *)

PROCEDURE chkCollision (DEBUG:BOOLEAN;src,dst,targetbasecooked:pathtype):BOOLEAN;
BEGIN
    UpperCaseAlt(src); (* keep accents *)
    UpperCaseAlt(dst);
IF DEBUG THEN
    dbg("chkCollision base",targetbasecooked);
    dbg("chkCollision dst ",dst);
    dbg("chkCollision src ",src);
END;
    IF Str.Match(src,"?:\*")=FALSE THEN (* should handle filename or partial filename *)
        Str.Prepend(src,targetbasecooked);
IF DEBUG THEN
    dbg("chkCollision SRC ",src);
    dbg("chkCollision dst ",dst);
END;
    END;
    RETURN same(src,dst);
END chkCollision;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* code adapted from FCOMP v1.3c *)

(* minimalist *)

PROCEDURE chkBothSpecsForCollision (b1,s1,b2,s2:pathtype ):BOOLEAN;
VAR
    p1,p2:pathtype;
BEGIN
    Str.Concat(p1,b1,s1);
    Str.Concat(p2,b2,s2);
    UpperCaseAlt(p1); (* keep accents *)
    UpperCaseAlt(p2);
    RETURN NOT( same(p1,p2) );
END chkBothSpecsForCollision;

(* current is "\" or "\*\" *)

PROCEDURE buildParent (VAR parent:pathtype; current:pathtype):BOOLEAN;
VAR
    p:CARDINAL;
BEGIN
    IF Str.Match(current,"\") THEN RETURN FALSE; END;
    unfixDirectory(current);
    p:=Str.RCharPos(current,"\");
    Str.Slice(parent,current,0,p+1); (* keep final "\" *)
    RETURN TRUE;
END buildParent;

PROCEDURE doGetCurrent (useLFN:BOOLEAN;drive:SHORTCARD;
                       VAR unit:str2; VAR current:pathtype);
VAR
    rc:CARDINAL;
    longform:pathtype;
BEGIN
    Str.Concat(unit, CHR( ORD("A")-1+ORD(drive) ),colon);

    FIO.GetDir(drive,current); (* \path without u: nor trailing \ except at root *)
    IF current[1] # colon THEN Str.Prepend(current,unit); END; (* safety *)
    (* LFN function seems to always return "u:\*" form except at root *)
    IF current[1] = colon THEN Str.Delete(current,0,2);END; (* safety *)
    fixDirectory(current);
END doGetCurrent;

(*
    remember dirs can have an extension, and LFNs can have inner dots
    we handle (whether u: or not) :

    .        current
    ..       parent
    .\xxx    current\xxx       F/D
    ..\xxx   parent\xxx        F/D

    xxx\     current\xxx\
    xxx\.    current\xxx\
    xxx      current\xxx       F/D

    \xxx\    \xxx\
    \xxx     \xxx              F/D
*)

PROCEDURE chkfixSpec (VAR base,spec:pathtype;
                     useLFN:BOOLEAN;orgS:pathtype):CARDINAL;
VAR
    p,len,rc:CARDINAL;
    drive:SHORTCARD;
    u:CHAR;
    unit:str2;
    current,parent,S:pathtype;
    ok:BOOLEAN;
BEGIN
    Str.Copy(S,orgS);
    IF Str.Pos(S,"\\") # MAX(CARDINAL) THEN RETURN errNetSlash;END;

    (* process u: in S *)

    CASE CharCount(S,colon) OF
    | 0 :
        drive := FIO.GetDrive();
        rc:=errNone;
    | 1 :
        IF Str.CharPos(S,colon) = 1 THEN
            u:=CAP( S[0] );
            CASE u OF
            | "A".."Z" :
                    drive := SHORTCARD( ORD(u) - ORD("A") +1 );
                    Str.Delete(S,0,2); (* remove u: *)
                    rc:=errNone;
            ELSE
                rc:=errBadUnit;
            END;
        ELSE
            rc:=errColon;
        END;
    ELSE
        rc:=errColon;
    END;
    IF rc # errNone THEN RETURN rc; END;

    (* note S no longer has u: *)

    doGetCurrent(useLFN,drive, unit,current); (* "u:" and "\" or "\*\" *)
    ok:=buildParent(parent, current);

    IF same(S,".") THEN Str.Copy(S,current);END;
    IF same(S,"..") THEN
        IF ok THEN Str.Copy(S,parent) ELSE RETURN errNoParent; END;
    END;
    IF Str.Match(S,".\*") THEN Str.Subst(S,".\",current); END;
    IF Str.Match(S,"..\*") THEN
        IF ok THEN Str.Subst(S,"..\",parent) ELSE RETURN errNoParent;END;
    END;
    IF Str.Match(S,"\*")=FALSE THEN Str.Prepend(S,current);END;
    IF Str.Match(S,"*\.") THEN
        (* S[Str.Length(S)-1]:=0C; *)
        len:=Str.Length(S);
        Str.Delete(S,len-1,1);
    END;
    (* we don't want inner or trailing ".." now *)
    IF Str.Pos(S,"..") # MAX(CARDINAL) THEN RETURN errInnerParent;END;

    (* base = "u:\xxx\" and spec = "xxx" *)

    IF Str.Match(S,"*\") THEN
        Str.Concat(base,unit,S);
        Str.Copy(spec,"*.*");
    ELSE
        Str.Prepend(S,unit);
        (* S is u:[\xxx]... without trailing "\" *)
        len:=Str.Length(S);
        p:=Str.RCharPos(S,"\");
        Str.Slice(base,S,0,p+1);
        Str.Slice(spec,S,p+1,len-p);
        IF chkJoker(spec)=FALSE THEN (* if spec has joker(s), assume files *)
            (* spec has no joker : dir or file ? *)
            IF isDirectory(S) THEN
                Str.Copy(base,S);
                fixDirectory(base); (* safety *)
                Str.Copy(spec,"*.*");
            END;
        END;
    END;
    IF chkJoker(base) THEN RETURN errDirJoker; END;
    RETURN errNone;
END chkfixSpec;

(* ------------------------------------------------------------ *)

(* R is specified base, currpath is "u:\*" current dir, was handleDir() *)
(* now fixed for JPI qdSplitAllPath() bug -- and for ".[.]\$" forms too *)

PROCEDURE preprocessDir (VAR R:pathtype;useLFN:BOOLEAN;currpath:pathtype):CARDINAL;
VAR
    u,dne:pathtype; (* "u:" *)
    current,Z:pathtype;
    p,rc:CARDINAL;
    longform:pathtype;
    thisdrive:SHORTCARD;
BEGIN
    IF Str.Match(R,colon+"*") THEN RETURN errBase; END;  (* ":xxx" *)
    IF ( same(R,dot) OR same(R,dot+backslash) ) THEN     (* "." or ".\" *)
        Str.Copy(R,currpath);RETURN errNone;
    END;
    IF ( same(R,dotdot) OR same(R,dotdot+backslash) ) THEN (* ".." or "..\" *)
        IF buildParent (R,currpath) THEN
            RETURN errNone;
        ELSE
            RETURN errBase;
        END;
    END;

    (* note qdSplitAllPath eats extension in directory part if path is fixed with a trailing "\" ! *)

    IF NOT (Str.Match(R,"?"+colon)) THEN fixDirectory(R);END; (* keep possible "u:" alone *)

    p:=Str.CharPos(R,":");
    IF p = MAX(CARDINAL) THEN
        u:="";
        Str.Copy(dne,R);
    ELSE
        Str.Slice(u,R,0,p+1); (* "u:" *)
        Str.Copy(dne,R);
        Str.Delete(dne,0,p+1);
    END;

    IF same(u,"") THEN
        IF Str.Match(R,backslash+"*") THEN (* "\xxx\" *)
            Str.Prepend(R,colon);
            Str.Prepend(R,currpath[0]); (* driveletter *)
        ELSE
            IF Str.Match(R,dot+backslash+"*") THEN        (* ".\xxx\" *)
                Str.Subst(R,dot+backslash,"");
                Str.Prepend(R,currpath);
            ELSIF Str.Match(R,dotdot+backslash+"*") THEN  (* "..\xxx\" *)
                IF buildParent(Z,currpath)=FALSE THEN RETURN errBase;END;
                Str.Subst(R,dotdot+backslash,"");
                Str.Prepend(R,Z);
            ELSE                                          (* "xxx\" *)
                Str.Prepend(R,currpath);
            END;
        END;
    ELSE
        IF Str.Match(dne,backslash+"*") THEN (* "u:\xxx\" *)
            ;
        ELSE
            thisdrive :=SHORTCARD (ORD (CAP(u[0]) )-ORD("A")+1); (* uppercase *)
            doGetDir(thisdrive, current); (* path without unit *)
            fixDirectory(current);
            IF Str.Match(dne,dot+backslash+"*") THEN       (* "u:.\xxx\" *)
                Str.Subst(dne,dot+backslash,"");
                Str.Concat(R,u,current);
                Str.Append(R,dne);
            ELSIF Str.Match(dne,dotdot+backslash+"*") THEN (* "u:..\xxx\" *)
                IF buildParent(Z,current)=FALSE THEN RETURN errBase;END;
                Str.Subst(dne,dotdot+backslash,"");
                Str.Concat(R,u,Z);
                Str.Append(R,dne);
            ELSE                                           (* "u:xxx\" *)
                Str.Concat(R,u,current);
                Str.Append(R,dne);
            END;
        END;
    END;

    (* safety : we don't want inner or trailing ".." now *)
    IF Str.Pos(R,"..") # MAX(CARDINAL) THEN RETURN errInnerParent;END;

    unfixDirectory(R);
    (* spec already filtered for joker by caller : now is dir or existing file ? *)
    IF NOT ( isDirectory(R) ) THEN
        (* either entry not found, or found an existing file *)
        IF FIO.Exists(R) THEN RETURN errTargetIsFile; END;
        (* not found ? we'll create it ! *)
    END;
    fixDirectory(R);

    RETURN errNone;
END preprocessDir;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    showmodetype = (showboth,showsuccess,showfailure);

PROCEDURE showParms (flagVERBOSEBYE,  useLFN,
                    flagLISTMODE,flagRECURSE,flagOVERWRITE,
                    flagSKIPNEWER,flagSKIPNEWERORSAMEDATE,
                    flagFRESHEN,flagAUTORENAME,
                    flagMOVE,flagPREVIEW,flagASKUSER,
                    flagDATErange,flagSIZErange,flagNOTICE,flagPERCENTAGE,
                    flagIGNOREESC,flagOSjokers,
                    flagIGNOREINI,flagFORCESWAPFILESPROTECTION:BOOLEAN;
                    renfix,buildMethod, lodate,hidate:CARDINAL;
                    losize,hisize:LONGCARD;
                    showmode:showmodetype;
                    listfile,specbase,spec,targetbase,currpath:pathtype);
CONST
    sYes       = "yes";
    sNo        = "no";
VAR
    msg:str80; (* oversized *)
    ini:pathtype;
    inihere,actualswapfilesprotection:BOOLEAN;
    p:CARDINAL;
BEGIN
    Lib.ParamStr(ini,0);
    p:=Str.RCharPos(ini,dot);
    IF p # MAX(CARDINAL) THEN ini[p]:=charnull;END;
    Str.Append(ini,extINI);
    inihere:=FIO.Exists(ini);
    actualswapfilesprotection:=swapfilesprotectionFIX (flagFORCESWAPFILESPROTECTION,inihere,flagIGNOREINI);

            WrStr(banner);WrLn;
            WrLn;
    IF NOT(flagVERBOSEBYE) THEN
        IF flagLISTMODE THEN
            wF("List file"                ,listfile,useLFN);
        ELSE
            wF("Source directory"         ,specbase,useLFN);
            wF("Source specification"     ,spec,useLFN);
        END;
            wF("Target directory"         ,targetbase,useLFN);
            WrLn;
    END;
            wF("Default directory"        ,currpath,useLFN);

            WrStr( padinf(widmp,"Recreate paths") ); (* flagMAKEPATH *)
            CASE buildMethod OF
            | buildKeepName: msg:=sNo;
            | buildKeepPath: msg:=sYes;
            | buildXcopy:    msg:=sYes+" (XCOPY mode)";
            | buildUndefined:msg:="not yet defined";
            ELSE ; (* //ISO fixed silly requirement *) END;
            WrStr(msg);WrLn;

            wB("Recurse subdirectories"   ,flagRECURSE,sYes,sNo);
            wB("Overwrite target"         ,flagOVERWRITE,sYes,sNo);
            wB("Overwrite newer"          ,NOT(flagSKIPNEWER),sYes,sNo);
            wB("Overwrite same"           ,NOT(flagSKIPNEWERORSAMEDATE),sYes,sNo);
            wB("Freshen existing target"  ,flagFRESHEN,sYes,sNo);
            wB("Autorename"               ,flagAUTORENAME,sYes,sNo);
            wB("Erase source"             ,flagMOVE,sYes,sNo);
            wB("Preview"                  ,flagPREVIEW,sYes+' (with "'+sPREVIEW+'" reminder prefix)',sNo);
            wB("Date range filter"        ,flagDATErange,fmtDateRange(lodate,hidate),sNo);
            wB("Size range filter"        ,flagSIZErange,fmtSizeRange(losize,hisize),sNo);
            wB("Show copy percentage"     ,flagPERCENTAGE,sYes,sNo);
            wB("Show successes"           ,((showmode=showboth) OR (showmode=showsuccess)),sYes,sNo);
            wB("Show failures/problems"   ,((showmode=showboth) OR (showmode=showfailure)),sYes,sNo);
            wB("List protected entries"   ,flagNOTICE,sYes,sNo);
            wB("Terminate if Escape"      ,NOT(flagIGNOREESC),sYes,sNo);

            wB("Confirmation by user"     ,flagASKUSER,sYes,sNo);

            wB("Operating system jokers"  ,flagOSjokers,sYes,sNo);
            wB("Ignore "+progEXEname+extINI+" (cli)",flagIGNOREINI,sYes,sNo);
            wB("Protect Win swapfiles (cli)",flagFORCESWAPFILESPROTECTION,sYes,sNo);
            wB(progEXEname+extINI+" found",inihere,sYes,sNo);
            wB("Autoprotect Win swapfiles",actualswapfilesprotection,sYes,sNo);
            dmpProtected(useLFN,TRUE,lastEntryProtected );

END showParms;

(* ------------------------------------------------------------ *)

TYPE
    stampcomptype = (isolder,issamedate,isnewer); (* //V12R FIX *)

(*%T USEFLOATSTAMP *)

(* now, this is UGLY -- should we use bigger K coeffs to handle rounding ? *)

PROCEDURE getPackedFileStamp (useLFN:BOOLEAN; S:pathtype):LONGREAL;
CONST
    k10e4 =   10000;
    k10e2 =     100;
    k10e6 = 1000000.0;
    baseyear = 1900; (* 2008 was 108 before this fix *)
VAR
    hnd:FIO.File;
    stamp:FIO.FileStamp;
    ok:BOOLEAN;
    y,m,d,hh,mm,ss:SHORTCARD;
    yyyymmdd : LONGCARD;
    hhmmss   : LONGCARD;
    n        : LONGREAL;
BEGIN
    hnd:=FIO.OpenRead(S);
    ok:=FIO.GetFileStamp(hnd,stamp);
    FIO.Close(hnd);
    y  := stamp.Year ;
    m  := stamp.Month;
    d  := stamp.Day  ;
    hh := stamp.Hour ;
    mm := stamp.Min  ;
    ss := stamp.Sec  ;

    yyyymmdd:=k10e4*( LONGCARD(y)+baseyear )+k10e2*LONGCARD(m)+LONGCARD(d);
    hhmmss  :=k10e4*LONGCARD(hh)+k10e2*LONGCARD(mm)+LONGCARD(ss);
    n       := LONGREAL(yyyymmdd)+(LONGREAL(hhmmss)/k10e6);
    (* //FIXME maybe we should keep ymd and hms longcards ? *)
    RETURN n;
END getPackedFileStamp;

PROCEDURE chkStamp (VAR stampcomp:stampcomptype;
                   flagSKIPNEWERORSAMEDATE,useLFN:BOOLEAN;R,S:pathtype):BOOLEAN;
VAR
    stampR,stampS:LONGREAL;
    ok:BOOLEAN;
BEGIN
    stampR:=getPackedFileStamp(useLFN,R);
    stampS:=getPackedFileStamp(useLFN,S);
    IF stampR < stampS THEN
        stampcomp := isolder;
    ELSIF stampR = stampS THEN
        stampcomp := issamedate;
    ELSE
        stampcomp := isnewer;
    END;
    IF flagSKIPNEWERORSAMEDATE THEN
        ok:=( stampR <= stampS );
    ELSE
        ok:=( stampR < stampS );
    END;
    RETURN ok;
END chkStamp;

(*%E  *)

(* ------------------------------------------------------------ *)

(*%F USEFLOATSTAMP *)

(*
PROCEDURE getPackedFileStamp (VAR yyyymmdd,hhmmss:LONGCARD;
                             useLFN:BOOLEAN; S:pathtype);
CONST
    k10e4    = LONGCARD(  10000);
    k10e2    = LONGCARD(    100);
    baseyear = LONGCARD(   1900); (* 2008 was 108 before this fix *)
VAR
    hnd:FIO.File;
    stamp:FIO.FileStamp;
    ok:BOOLEAN;
    y,m,d,hh,mm,ss:SHORTCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    ok:=FIO.GetFileStamp(hnd,stamp);
    FIO.Close(hnd);
    y  := stamp.Year ;
    m  := stamp.Month;
    d  := stamp.Day  ;
    hh := stamp.Hour ;
    mm := stamp.Min  ;
    ss := stamp.Sec  ;

    yyyymmdd:=k10e4*( LONGCARD(y)+baseyear )+k10e2*LONGCARD(m)+LONGCARD(d);
    hhmmss  :=k10e4*LONGCARD(hh)+k10e2*LONGCARD(mm)+LONGCARD(ss);
END getPackedFileStamp;

PROCEDURE chkStamp (flagSKIPNEWERORSAMEDATE,useLFN:BOOLEAN;R,S:pathtype):BOOLEAN;
VAR
    ymdR,hmsR, ymdS,hmsS:LONGCARD;
    ok:BOOLEAN;
BEGIN
    getPackedFileStamp(ymdR,hmsR,useLFN,R);
    getPackedFileStamp(ymdS,hmsS,useLFN,S);
    IF flagSKIPNEWERORSAMEDATE THEN
        IF ymdR < ymdS THEN
            ok:=TRUE;
        ELSIF ymdR > ymdS THEN
            ok:=FALSE;
        ELSE                                (* = *)
            ok:=( hmsR <= hmsS);
        END;
    ELSE
        IF ymdR < ymdS THEN
            ok:=TRUE;
        ELSIF ymdR > ymdS THEN
            ok:=FALSE;
        ELSE                                (* = *)
            ok:=( hmsR < hmsS);
        END;
    END;
    RETURN ok;
END chkStamp;
*)

PROCEDURE getPackedFileStamp (useLFN:BOOLEAN; S:pathtype):LONGCARD;
VAR
    hnd:FIO.File;
    dt:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    dt:=FIO.GetFileDate(hnd);
    FIO.Close(hnd);
    RETURN dt;
END getPackedFileStamp;

PROCEDURE chkStamp (VAR stampcomp:stampcomptype;
                   flagSKIPNEWERORSAMEDATE,useLFN:BOOLEAN;R,S:pathtype):BOOLEAN;
VAR
    stampR,stampS:LONGCARD;
    ok:BOOLEAN;
BEGIN
    stampR:=getPackedFileStamp(useLFN,R);
    stampS:=getPackedFileStamp(useLFN,S);
    IF stampR < stampS THEN
        stampcomp := isolder;
    ELSIF stampR = stampS THEN
        stampcomp := issamedate;
    ELSE
        stampcomp := isnewer;
    END;
    IF flagSKIPNEWERORSAMEDATE THEN
        ok:=( stampR <= stampS );
    ELSE
        ok:=( stampR < stampS );
    END;
    RETURN ok;
END chkStamp;

(*%E  *)

(* ------------------------------------------------------------ *)

(* //V12R FIX *)
PROCEDURE getcodePBstamp (stampcomp:stampcomptype;
                         pbTargetOlder,pbTargetSameDAte,pbTargetNewer:CARDINAL):CARDINAL;
VAR
    pb:CARDINAL;
BEGIN
    (*
    IF flagSKIPNEWERORSAMEDATE THEN
        pb:=pbTargetNewerOrSame;
    ELSE
        pb:=pbTargetNewer;
    END;
    *)
    CASE stampcomp OF
    | isolder:     pb:=pbTargetOlder;
    | issamedate:  pb:=pbTargetSameDate;
    | isnewer:     pb:=pbTargetNewer;
    ELSE ; (* //ISO fixed silly requirement *) END;
    RETURN pb;
END getcodePBstamp;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    firstparm    = 1;
    maxparm      = 2;
VAR
    i,opt,parmcount,lastparm:CARDINAL;
    orgR,S,R:pathtype;
    flagPREVIEW:BOOLEAN;
    flagOVERWRITE,flagSKIPNEWER,flagSKIPNEWERORSAMEDATE:BOOLEAN;
    flagABORT:BOOLEAN;
    flagMAKEPATH,flagAUTORENAME,flagRECURSE:BOOLEAN;
    flagMOVE,flagVERBOSE,flagLISTMODE,flagASKUSER:BOOLEAN;
    flagDONTSHOWCOZUSERDENIED,flagIGNOREESC,flagVERBOSEBYE:BOOLEAN;
    flagIGNOREINI,flagFORCESWAPFILESPROTECTION,flagNOTICE,flagOSjokers:BOOLEAN;
    flagDATErange,flagSIZErange,flagFRESHEN,flagPERCENTAGE:BOOLEAN;
    flagROOM:BOOLEAN;
    renfix:CARDINAL;
    useLFN,DEBUG : BOOLEAN;
    parm : ARRAY [firstparm..maxparm] OF pathtype;
    showmode : showmodetype;
    showbusy,isSuccess, collisionRisk : BOOLEAN;
    hin:FIO.File;
    doit:BOOLEAN;
    stampSource,stampTarget:LONGCARD;
    pb:CARDINAL;
    ok,kilroy,md : BOOLEAN; (* because kilroy "was here" -- oui, c'est lamentable *)
    globallastfile,globallastfileReal:LONGCARD;
    lastfile,lastfileReal,fileindex:CARDINAL;
    msgPrefix : str16;
    successes,warnings:LONGCARD;
    lodate,hidate:CARDINAL;
    losize,hisize:LONGCARD;
    maskfilter:masktype;
    currdrive:SHORTCARD;
    listfile,basedir,currdir,currpath,XCOPYrootspec:pathtype;
    rc:CARDINAL;
    orgspec,specbase,spec, targetbase,targetspec,targetbasecooked:pathtype;
    pf,pdir,diranchor,fileanchor:pEntry;
    buildMethod:CARDINAL;
    msg:str1024; (* allow for orgR inclusion *)
    lastdir,lastdirReal,dirindex:CARDINAL;
    chkrounds:CARDINAL;
    base:pathtype;
    stampcomp:stampcomptype;
BEGIN
    FIO.IOcheck := FALSE;
    FIO.ShareMode:=FIO.ShareDenyNone; (* very, very important ! *)

    WrLn;

    parmcount := Lib.ParamCount();
    IF parmcount = 0 THEN abort(errHelp,"");END;

	useLFN		  := TRUE; (* //V09C bugfix *)
    lastparm      := firstparm-1;
    flagPREVIEW   := FALSE;
    showmode      := showboth;
    flagOVERWRITE := FALSE;
    flagSKIPNEWER := FALSE;
    flagSKIPNEWERORSAMEDATE := FALSE;
    flagMAKEPATH  := TRUE;
    flagAUTORENAME:= FALSE; renfix := renfixdefault;
    flagMOVE      := FALSE;
    flagVERBOSE   := FALSE;
    flagVERBOSEBYE:= FALSE;
    flagLISTMODE  := FALSE;
    flagASKUSER   := FALSE;
    flagRECURSE   := FALSE;
    flagIGNOREESC := FALSE;
    flagIGNOREINI := FALSE; (* -x will force existing ini to be ignored *)
    flagFORCESWAPFILESPROTECTION := TRUE;
    flagNOTICE    := FALSE;
    flagOSjokers  := FALSE;
    flagDATErange := FALSE;
    flagSIZErange := FALSE;
    flagFRESHEN   := FALSE;
    flagPERCENTAGE:= TRUE;
    buildMethod   := buildUndefined;
    ok:=parseMask(showfilesonly,maskfilter);
    DEBUG         := FALSE;

    IF chkEnvVar(flagPREVIEW) = FALSE THEN abort(errBadEnv,sPCOPYenv);END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i); cleanCLI(S); ReplaceChar(S,dquote,"");
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,
                       "?"+delim+"H"+delim+"HELP"+delim+
                       "T"+delim+"TEST"+delim+"PREVIEW"+delim+
                       "Q"+delim+"QUIET"+delim+   (* failures and problems *)
                       "l"+delim+"lfn"+delim+
                       "O"+delim+"OVERWRITE"+delim+
                       "a"+delim+"audiowarn"+delim+
                       "P"+delim+"NOMAKEPATH"+delim+
                       "R"+delim+"RENAME"+delim+
                       "M"+delim+

                       "MOVE"+delim+"MV"+delim+

                       "mm"+delim+
                       "N"+delim+"NEWER"+delim+
                       "ON"+delim+"NO"+delim+
                       "OON"+delim+"NOO"+delim+
                       "V"+delim+"VERBOSE"+delim+
                       "PP"+delim+"PR"+delim+
                       "@"+delim+"FILELIST"+delim+
                       "I"+delim+"QUERY"+delim+"INTERACTIVE"+delim+"ASK"+delim+

                       "COPY"+delim+

                       "IO"+delim+"II"+delim+
                       "k"+delim+"keep"+delim+"attributes"+delim+
                       "S"+delim+"RECURSE"+delim+
                       "SP"+delim+"SS"+delim+
                       "Y"+delim+"T-"+delim+"DOIT"+delim+
                       "OO"+delim+
                       "E"+delim+"ESC"+delim+
                       "X"+delim+"IGNOREINI"+delim+
                       "W"+delim+"NOTICE"+delim+"REMIND"+delim+
                       "U"+delim+"UPDATE"+delim+  (* successes *)
                       "MO"+delim+
                       "MON"+delim+
                       "moo"+delim+
                       "moon"+delim+
                       "!"+delim+"JOKERS"+delim+"OS"+delim+
                       "??"+delim+
                       "D:"+delim+"BYDATE:"+delim+
                       "Z:"+delim+"BYSIZE:"+delim+
                       "F"+delim+"FRESHEN"+delim+

                       "XX"+delim+ (* obsolete but left as a mere alias for -x *)

                       "VV"+delim+
                       "FN"+delim+"NF"+delim+
                       "b"+delim+"beep"+delim+
                       "CP"+delim+"KOPY"+delim+
                       "XCP"+delim+
                       "SF"+delim+"SWAPS"+delim+"SWAPFILES"+delim+
                       "G"+delim+"PERCENTAGE"+delim+
                       "mem"+delim+"fake"+delim+
                       "J"+delim+"NEWERORSAME"+delim+"SAMEORNEWER"+delim+
                       "???"+delim+
                       "RR"+delim+
                       "PRR"+delim+"PPP"+delim+
                       "DEBUG"
                              );
            CASE opt OF
            | 1,2,3 : abort(errHelp,"");
            | 4,5,6:  flagPREVIEW   := TRUE;
            | 7,8:    CASE showmode OF
                      | showboth,showfailure : showmode:=showfailure;
                      ELSE
                          abort(errNonsenseShow,"");
                      END;
            | 9,10:   ;
            |11,12:   flagOVERWRITE := TRUE;
            |13,14:   ;
            |15,16:   flagMAKEPATH  := FALSE;
            |17,18:   flagAUTORENAME:= TRUE; renfix:=renfixdefault;
            |19:      flagMOVE      := TRUE;

            |20,21:   flagMOVE      := TRUE;
                      flagASKUSER   := TRUE; flagOVERWRITE:=TRUE;
                      (* flagMAKEPATH:=FALSE; *)

            |22:      ;
            |23,24:   flagSKIPNEWER := TRUE;
            |25,26:   flagSKIPNEWER := TRUE;
            |27,28:   flagSKIPNEWER := TRUE;
            |29,30:   flagVERBOSE   := TRUE;
            |31,32:   flagMAKEPATH  := FALSE; flagAUTORENAME:=TRUE; renfix:=renfixdefault;
            |33,34:   flagLISTMODE  := TRUE;
            |35,36,37,38:flagASKUSER:= TRUE;

            |39:      flagASKUSER   := TRUE; flagOVERWRITE:=TRUE;
                      flagMAKEPATH:=FALSE;

            |40,41:   flagASKUSER   := TRUE; flagOVERWRITE:=TRUE;
            |42,43,44:;
            |45,46:   flagRECURSE   := TRUE;
            |47,48:   flagRECURSE   := TRUE; flagMAKEPATH := FALSE;
            |49,50,51:flagPREVIEW   := FALSE;
            |52   :   flagOVERWRITE := TRUE;
            |53,54:   flagIGNOREESC := TRUE;
            |55,56:   flagIGNOREINI := TRUE;
            |57,58,59:flagNOTICE    := TRUE;
            |60,61:   CASE showmode OF
                      | showboth,showsuccess : showmode:=showsuccess;
                      ELSE
                          abort(errNonsenseShow,"");
                      END;
            |62:      flagMOVE:=TRUE; flagOVERWRITE:=TRUE;
            |63:      flagMOVE:=TRUE; flagSKIPNEWER:=TRUE;
            |64:      flagMOVE:=TRUE; flagOVERWRITE := TRUE;
            |65:      flagMOVE:=TRUE; flagSKIPNEWER:=TRUE;
            |66,67,68:flagOSjokers  := TRUE;
            |69:      abort(errMoreHelp,"");
            |70,71:   ok:=parseDateRange(R,lodate,hidate);
                      IF ok=FALSE THEN abort(errDateRange,S);END;
                      flagDATErange := TRUE;
            |72,73:   ok:=parseFileSizeRange(R,losize,hisize);
                      IF ok=FALSE THEN abort(errSizeRange,S);END;
                      flagSIZErange := TRUE;
            |74,75:   flagFRESHEN   := TRUE;

            |76:      flagIGNOREINI := TRUE;

            |77:      flagVERBOSE   := TRUE; flagVERBOSEBYE:=TRUE;
            |78,79:   flagFRESHEN   := TRUE;
                      flagSKIPNEWER := TRUE;
            |80,81:   ;
            |82,83:   flagMAKEPATH  := FALSE; flagSKIPNEWER:=TRUE;
            |84:      flagSKIPNEWER := TRUE;  flagRECURSE := TRUE;
            |85,86,87:flagFORCESWAPFILESPROTECTION:=FALSE;
            |88,89:   flagPERCENTAGE:= FALSE;
            |90,91:   ;
            |92,93,94:flagSKIPNEWERORSAMEDATE := TRUE;
            |95:      abort(errEvenMoreHelp,"");
            |96:      flagAUTORENAME:= TRUE; renfix:=renfixLFN;
            |97,98:   flagMAKEPATH  := FALSE; flagAUTORENAME:=TRUE; renfix:=renfixLFN;

            |99:      DEBUG         := TRUE; (* for later use *)
            ELSE
                abort(errUnknownOption,S);
            END;
        ELSE
            INC(lastparm);
            IF lastparm > maxparm THEN abort(errTooManyParms,S);END;
            Str.Copy(parm[lastparm],S); (* keep case *)
        END;
    END;

    IF flagSKIPNEWER THEN flagOVERWRITE:=TRUE; END; (* v1.2 default *)

    IF (flagSKIPNEWER AND NOT(flagOVERWRITE) ) THEN abort(errNonsenseStamp,"");END; (* v1.2 makes this check useless *)

    IF (flagSKIPNEWER AND flagAUTORENAME) THEN abort(errNonsense,"-n[o[o]]");END; (* v1.2q *)
    IF (flagOVERWRITE AND flagAUTORENAME) THEN abort(errNonsense,"-o[o]");END;
    IF (flagPREVIEW   AND flagAUTORENAME) THEN abort(errNonsense,"-t");END;

    IF flagSKIPNEWERORSAMEDATE THEN
        IF NOT(flagSKIPNEWER) THEN abort(errRequiredOption,"-n");END;
    END;


    IF useLFN=FALSE THEN
        IF renfix # renfixdefault THEN abort(errRenFixLFN,"");END;
    END;

    (* anchor *)
    getAnchor(useLFN, currdrive,currdir, currpath); (* u, "\*\", "u:\*\" *)

    (* don't care about syntax if we're to just show parms *)

    IF flagVERBOSEBYE THEN
        IF initProtected (lastEntryProtected,
                         flagIGNOREINI,flagFORCESWAPFILESPROTECTION,useLFN,DEBUG)=FALSE THEN
            abort(errProtection,"");
        END;

        showParms ( flagVERBOSEBYE,  useLFN,
                    flagLISTMODE,flagRECURSE,flagOVERWRITE,
                    flagSKIPNEWER,flagSKIPNEWERORSAMEDATE,
                    flagFRESHEN,flagAUTORENAME,
                    flagMOVE,flagPREVIEW,flagASKUSER,
                    flagDATErange,flagSIZErange,flagNOTICE,flagPERCENTAGE,
                    flagIGNOREESC,flagOSjokers,
                    flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                    renfix,buildMethod, lodate,hidate,
                    losize,hisize,
                    showmode,
                    listfile,specbase,spec,targetbase,currpath
                  );
        abort(errNone,"");
    END;

    (* ok, here, we must check user did not goof *)

    CASE lastparm OF
    | firstparm-1:
        abort(errMissingSource,"");
    | firstparm:
        Str.Copy(basedir,currpath);
    | maxparm:
        Str.Copy(basedir,parm[lastparm]);
        IF chkJoker(basedir) THEN abort(errJokerTarget,basedir);END;
        rc:= preprocessDir(basedir, useLFN,currpath);
        IF rc # errNone THEN abort(rc,basedir);END;
    ELSE ; (* //ISO fixed silly requirement *) END;

    Str.Copy(S,parm[firstparm]);
    IF S[0]="@" THEN
        Str.Delete(S,0,1);
        flagLISTMODE:=TRUE;
    END;


    IF flagLISTMODE THEN
        IF flagRECURSE THEN abort(errNotWithList,"-s");END;

        Str.Copy(listfile,S);
        IF chkJoker(listfile) THEN abort(errJokerList,listfile);END;
        IF Str.CharPos(listfile,dot)=MAX(CARDINAL) THEN Str.Append(listfile,extLST);END;
        IF isDirectory(listfile) THEN abort(errNotFile,listfile);END;
        IF FIO.Exists(listfile)=FALSE THEN abort(errNotFound,listfile);END;

        rc:= chkfixSpec( targetbase,targetspec,  useLFN,basedir );
        IF rc # errNone THEN abort(rc,basedir);END;

        IF flagMAKEPATH THEN
            buildMethod:=buildKeepPath; (* keep paths from list entries *)
        ELSE
            buildMethod:=buildKeepName; (* don't recreate paths *)
        END;
    ELSE
        Str.Copy(orgspec,S);

        rc:= chkfixSpec( specbase,spec,  useLFN,orgspec );
        IF rc # errNone THEN abort(rc,orgspec);END;

        rc:= chkfixSpec( targetbase,targetspec,  useLFN,basedir );
        IF rc # errNone THEN abort(rc,basedir);END;

        (* quick check before individual handling infra *)
        IF chkBothSpecsForCollision(specbase,"",targetbase,"")=FALSE THEN
            IF flagMAKEPATH THEN abort(errDirCollision,""); END;
        END;

        IF flagRECURSE THEN
            IF flagMAKEPATH THEN
                buildMethod:=buildXcopy; (* remove root base of source *)
            ELSE
                buildMethod:=buildKeepName; (* /p was specified *)
            END;
        ELSE
            flagMAKEPATH := FALSE; (* /p always forced for smarter COPY mode *)
            buildMethod  := buildKeepName; (* COPY = don't recreate paths *)
        END;
    END;

    targetbasecooked:=targetbase;
    UpperCaseAlt(targetbasecooked); (* for chkCollision() *)

    IF initProtected (lastEntryProtected,
                     flagIGNOREINI,flagFORCESWAPFILESPROTECTION,useLFN,DEBUG)=FALSE THEN
        abort(errProtection,"");
    END;

    (* let's warm up now *)

    IF flagVERBOSE THEN
        showParms ( flagVERBOSEBYE,  useLFN,
                    flagLISTMODE,flagRECURSE,flagOVERWRITE,
                    flagSKIPNEWER,flagSKIPNEWERORSAMEDATE,
                    flagFRESHEN,flagAUTORENAME,
                    flagMOVE,flagPREVIEW,flagASKUSER,
                    flagDATErange,flagSIZErange,flagNOTICE,flagPERCENTAGE,
                    flagIGNOREESC,flagOSjokers,
                    flagIGNOREINI,flagFORCESWAPFILESPROTECTION,
                    renfix,buildMethod, lodate,hidate,
                    losize,hisize,
                    showmode,
                    listfile,specbase,spec,targetbase,currpath
                   );
        WrLn;
    END;

    (* go ! go ! GO ! *)

    IF flagPREVIEW THEN
        msgPrefix := sPREVIEW; (* reminder *)
    ELSE
        msgPrefix := sPREFIX;      (* was "" but "    " seems prettier *)
    END;


    CASE showmode OF
    | showsuccess,showfailure: showbusy:=TRUE;
    | showboth:                showbusy:=FALSE;
    ELSE ; (* //ISO fixed silly requirement *) END;

    IF DEBUG THEN showbusy:=FALSE; END;

    busy(showbusy,TRUE); (* must be called before any abort() within this section *)

    chkrounds := 0;
    flagABORT:=FALSE; (* in case we'd exit before first check ! *)

    initList(diranchor); (* global *)
    lastdir            := firstindex-1; (* we can't init count in recursive buildDirList() *)
    lastdirReal        := firstindex-1; (* fix "no match" reason *)
    globallastfile     := firstindex-1;
    globallastfileReal := firstindex-1;

    IF flagLISTMODE THEN (* read entries to RAM with an empty base *)
        rc:= fakeDirList (lastdir,lastdirReal,diranchor);

        IF rc # errNone THEN busy(showbusy,FALSE);abort(rc, listfile); END;

        initList(fileanchor);
        lastfile     := firstindex-1;
        lastfileReal := firstindex-1;

        FIO.EOF := FALSE; (* //XDS //09B required for this code to work using XDS Win32 ! *)

        hin:=FIO.OpenRead(listfile);
        FIO.AssignBuffer(hin,ioBufferIn);
        LOOP
            IF FIO.EOF THEN EXIT; END;
            FIO.RdStr(hin,S);
            (* IF FIO.EOF THEN EXIT; END; //XDS quirk ! *)
            preprocessLine(S);
            CASE S[0] OF
            | CHR(0), semicolon,pound :
                ;
            ELSE
                rc:=fakeAddFile (globallastfile,globallastfileReal,
                                lastfile,lastfileReal, fileanchor,
                                showbusy,flagNOTICE,S);

                IF rc # errNone THEN busy(showbusy,FALSE);abort(rc, listfile); END;
            END;
        END;
        FIO.Close(hin);

    ELSE
        rc:= buildDirList (lastdir,lastdirReal, diranchor,
                          useLFN,flagRECURSE,showbusy,flagNOTICE, specbase);

        IF rc # errNone THEN busy(showbusy,FALSE);abort(rc, orgspec); END;
    END;

    IF DEBUG THEN
        dmpDirs(diranchor,useLFN);
        (* dmpDirsAlt(diranchor,lastdir,useLFN); *)
    END;

    (* first minimalist "no match" check *)

    IF lastdir < firstindex THEN abort(errFileNotFound,orgspec);END;

    (* let's work now *)

    keepStats (successes,warnings, INITSTATS);

    initXCOPYtarget(XCOPYrootspec, buildMethod,specbase);

    dirindex:=firstindex; (* with flagLISTMODE, lastdir = firstindex *)
    LOOP
        IF dirindex > lastdir THEN EXIT; END;
        pdir:=findByIndex(dirindex,diranchor);
        getStr(base,pdir);

        IF NOT(flagLISTMODE) THEN
            rc:= storeFiles (globallastfile,globallastfileReal,
                            lastfile,lastfileReal,
                            fileanchor,
                            useLFN,showbusy, flagNOTICE,flagOSjokers,
                            flagSIZErange,flagDATErange,
                            losize,hisize,lodate,hidate,
                            maskfilter, base,spec);

            IF rc # errNone THEN busy(showbusy,FALSE);abort(rc, orgspec); END;
        END;

        IF DEBUG THEN
           dmpFiles(fileanchor,diranchor,dirindex,useLFN);
           (* dmpFilesAlt(fileanchor,diranchor,lastfile,dirindex,useLFN); *)
        END;

        fileindex:=firstindex;
        LOOP
            IF fileindex > lastfile THEN EXIT; END;
            pf := findByIndex(fileindex,fileanchor);
            getStr(S,pf);

            Str.Prepend(S,base);

            pb:=pbNone;
            IF chkJoker(S) THEN (* can only happen with an entry from a filelist *)
                pb:=pbJoker;
            ELSE
                IF FIO.Exists(S) THEN
                    buildtarget(R, buildMethod,targetbase,S,XCOPYrootspec); (* basedir was... stupid at best ! *)

                    kilroy:=FIO.Exists(R);
                    IF kilroy THEN
                        md:=FALSE; (* no need to recreate existing target *)
                        collisionRisk := chkCollision(DEBUG,S,R,targetbase);
                    ELSE
                        md:=NOT(flagFRESHEN); (* no file to freshen, so don't recreate target path *)
                        collisionRisk := FALSE;
                    END;
                    IF (md AND (collisionRisk=FALSE)) THEN
                        handleTargetDir(useLFN,flagPREVIEW,currdrive,currdir,R);
                    END;

                    doit:=FALSE; (* default *)
                    IF (kilroy AND (collisionRisk=FALSE)) THEN
                        IF flagOVERWRITE THEN
                            IF fileIsRO(R) THEN
                                pb:=pbTargetRO;
                            ELSE
                                IF flagSKIPNEWER THEN
                                    (* IF getPackedFileStamp(useLFN,R) < getPackedFileStamp(useLFN,S) THEN *)
                                    IF chkStamp(stampcomp, flagSKIPNEWERORSAMEDATE,useLFN,R,S) THEN
                                        doit:=TRUE;
                                    ELSE
                                        pb:=getcodePBstamp (stampcomp,
                                                           pbTargetOlder,pbTargetSameDate,pbTargetNewer);
                                    END;
                                ELSE
                                    doit:=TRUE;
                                END;
                            END;
                        ELSE
                            IF flagAUTORENAME THEN
                                Str.Copy(orgR,R);
                                IF buildnewname(useLFN,DEBUG,renfix,R)=FALSE THEN
                                    pb:=pbRenameFailure;
                                ELSE
                                    pb:=pbRenamed; (* well, not a problem... *)
                                    doit:=TRUE;

                                    kilroy:=FALSE; (* never query user here *)

                                END;
                            ELSE
                                pb:=pbTargetExists;
                            END;
                        END;
                    ELSE
                        IF flagFRESHEN THEN
                            doit:= FALSE;
                            pb  := pbFreshen;
                        ELSE
                            doit:= TRUE;
                            (* pbNone is default *)
                        END;
                    END;

                    (* v1.0m check must change doit here *)

                    IF collisionRisk THEN
                        doit:=FALSE;
                        pb:=pbCollision;
                    END;

                    IF doit THEN

                        doFileCopy (flagROOM,flagABORT,flagASKUSER,flagDONTSHOWCOZUSERDENIED,
                                   showbusy,kilroy,useLFN,
                                   flagPREVIEW,flagPERCENTAGE,DEBUG,
                                   S,R);
                        IF flagROOM THEN (* ignore possible flagABORT so we can inform user of problem *)
                            IF flagMOVE THEN
                                flagMOVE:= FALSE;
                                pb:=pbRoomMove;
                            ELSE
                                pb:=pbRoomCopy;
                            END;
                        ELSE
                            IF flagABORT THEN EXIT;END;
                        END;

                        IF flagMOVE THEN
                            doit:=FALSE; (* default -- pbNone too *)
                            IF NOT( flagDONTSHOWCOZUSERDENIED ) THEN
                                IF fileIsRO(S) THEN
                                    pb:=pbSourceRO;
                                ELSE
                                    pb:=pbMoved; (* ter... *)
                                    doit:=TRUE;
                                END;
                                IF doit THEN
                                    IF NOT(flagPREVIEW) THEN FIO.Erase(S);END;
                                END;
                            END;
                        END;
                    END;
                ELSE
                    pb:=pbNotFound;
                END;
            END;

            (* S=source, R=target, orgR=original target if pbRenameFailure *)

            (* //FIXME if user was queried and replied no
            (i.e. flagDONTSHOWCOZUSERDENIED=TRUE),
            we should not display anything
            fake no problem is user answered no : after all, file WAS processed
            *)

            aboutProblem( pb, isSuccess,msg);
            (* we could just check msg for placeholder existence *)
            CASE pb OF
            | pbRenamed,pbMoved,pbMovedRO :
                Str.Subst(msg, pathplaceholder,R);
            | pbTargetNewer,pbTargetSameDate,pbTargetOlder: (* //V12R FIX *)
                Str.Subst(msg, pathplaceholder,R);
            ELSE ; (* //ISO fixed silly requirement *) END;
            keepStats(successes,warnings, pb);

            IF NOT ( flagDONTSHOWCOZUSERDENIED ) THEN
                CASE showmode OF
                | showboth:
                    busy(showbusy,FALSE);
                    wrfi(useLFN,msgPrefix,S);  (* source *)
                    IF pb=pbNone THEN
                        wrfi(useLFN,sOKDONE,R); (* target *)
                    ELSE
                        WrStr(msg);WrLn;  (* failure or info *)
                    END;
                    busy(showbusy,TRUE);
                | showsuccess:
                    IF isSuccess THEN
                        busy(showbusy,FALSE);
                        IF pb=pbNone THEN
                            wrfi(useLFN,sOKDONE,R); (* target *)
                        ELSE
                            wrfi(useLFN,msgPrefix,S);  (* source *)
                            WrStr(msg);WrLn;  (* failure or info *)
                        END;
                        busy(showbusy,TRUE);
                    END;
                | showfailure:
                    IF NOT(isSuccess) THEN
                        IF pb # pbNone THEN
                            busy(showbusy,FALSE);
                            wrfi(useLFN,msgPrefix,S);  (* source *)
                            WrStr(msg);WrLn;  (* failure or info *)
                            busy(showbusy,TRUE);
                        END;
                    END;
                ELSE ; (* //ISO fixed silly requirement *) END;
            END;

            INC(fileindex);

            flagABORT:=pollEscape(chkrounds,useLFN,flagIGNOREESC);
            IF flagABORT THEN EXIT; END;
        END;

        freeList(fileanchor);
        INC(dirindex);

        IF flagABORT THEN EXIT; END;
    END;

    (* final cleanup *)

    freeList(diranchor);

    busy(showbusy,FALSE);

    (*
    //FIXME : no match either means REAL no match, or protected source
    we could do as DD and silently hide it : this IS the M$ code kiddy Way
    anyway, a Q&D kludge will tell us the Truth...
    *)
(*
msg:= nl+"lastdir= ~  realdirs= ~   lastfile= ~  realfiles= ~"+nl;
    Str.Subst(msg,"~",fmt(lastdir,10,4," ",""));
    Str.Subst(msg,"~",fmt(lastdirReal,10,4," ",""));
    Str.Subst(msg,"~",fmtlc(globallastfile,10,4," ",""));
    Str.Subst(msg,"~",fmtlc(globallastfileReal,10,4," ",""));
WrStr(msg);
*)

    IF globallastfile < firstindex THEN
        IF lastdir = lastdirReal THEN
            IF globallastfileReal < firstindex THEN
                (* ok, this looks like a real "no match" *)
                IF (flagDATErange OR flagSIZErange) THEN
                    abort(errFilteredFileNotFound,orgspec);
                ELSE
                    abort(errFileNotFound,orgspec);
                END;
            END;
        END;
    END;

    IF flagABORT THEN abort(errUserAbort,""); END;

    (* final report *)

    Str.Copy(msg,msgDone);
    Str.Subst(msg,"~",fmtlc(successes,10,1," ",""));
    Str.Subst(msg,"~",fmtlc(warnings,10,1," ",""));
    WrStr(msg);WrLn;

    IF warnings # 0 THEN
        i:= errNoneAlt; (* freespace pbs, etc. *)
    ELSE
        i:= errNone;
    END;

    abort(i,"");
END pCopy32.
