(*
              an ugly port of my TopSpeed DOS code to an ugly Win32 compiler :-(
              we even had to include QD_* libraries in main code
              (thus making source ugly or uglier, eh eh)
              so the crap compiler would accept to do its work without complaining !!!

              many functions had to be dumped because of stupid XDS limits and choices
              remember only DOS version (both executable and source code)
              is considered validated by years of use :
              as DRI used to say "Nobody DOS it better" !

              a few DOS-specific or Win32-unsupported options have been removed
              -lfn

              see XDS, //XDSTS and //FIXME

              forced octal for character constants concatenation still sucks !
              absence of AUTOCAP still sucks too !
              the editor is crap (and its non-standard keys are a pain) !
              compiler does not catch problems before program is run : looks like C !
              requiring a USELESS "ELSE" clause when all cases are covered is STUPID !!!
              they have created the TERNARY BOOLEAN : a CASE handling TRUE and FALSE
              still REQUIRES a USELESS ELSE !!!
              with so many warnings, the crap compiler is not even able
              to warn that a variable has never been defined ! (adventure in EditLand !)
              note that XDS FIO.EOF support is weird
              note that XDS character handling does not seem correct :
              French "" (a grave) in source becomes "a" with opposite accent !
              since AppleWriter on the Apple ][, I had not seen an editor quitting
              without prompting to save modified source... thus making editing wasted !!!

              (along with a few XDS idiosyncrasies :
              anyway, let's admit it :
              even poor JPI TS M2 support is slightly better than ISO alone
              see wish list anyway ! ;-)
              a *real* J.P.I. TopSpeed Modula-2 compiler for Win32 !

Who When      What
--- --------- ----------------------------------------------------
PhG 16 Jun 19 an ugly really Q&D port from SPLINES v1.0a for DOS
*)

MODULE splines32;

IMPORT Graph;
IMPORT IO;
IMPORT Lib;
IMPORT Str;
IMPORT SYSTEM;
IMPORT FIO;

FROM IO IMPORT WrStr,WrLn;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_ASCII *)

CONST (* same as QD_TEXT *)
    cr            = 15C; (* was CHR(13) : silly XDS *requires* octal here for concatenation !!! *)
    lf            = 12C; (* was CHR(10) *)
    nl            = cr+lf;
    bs            = CHR(8);
CONST
    dash          = "-";
    slash         = "/";
    nullchar      = 0C; (* CHR(0) *)
    tabchar       = 11C; (* silly XDS passion for octal !!! *)
    space         = 40C;
    dot           = ".";
    deg           = "";      (* $f8 *)
    doublequote   = '"';
    quote         = "'";
    colon         = ":";
    percent       = "%";
    vbar          = "|";      (* $7c *)
    blank         = space;
    equal         = "=";
    dquote        = doublequote;
    charnull      = nullchar;
    singlequote   = quote;
    antislash     = "\";
    dollar        = "$";
    star          = "*";
    backslash     = antislash;
    coma          = ",";
    question      = "?";
    underscore    = "_";
    tabul         = tabchar;
    hbar          = vbar;  (* yes, nonsense but kept for historical reasons ! *)
    comma         = coma; (* typo ! *)
    semicolon     = ";";
    diese         = "#";
    pound         = diese;
    openbracket   = "[";
    closebracket  = "]";
    tilde         = "~";
    exclam        = "!";
    openbrace     = "{";
    closebrace    = "}";
    ampersand	  = "&";
CONST
    stardotstar   = star+dot+star;
    dotdot        = dot+dot;
CONST
    lettersUpp = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    lettersLow = "abcdefghijklmnopqrstuvwxyz";
    digits     = "0123456789";
    letters    = lettersUpp;   (* should be remed out *)

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_Box *)

TYPE
    str80 = ARRAY [0..79] OF CHAR;
    str2  = ARRAY [0..1] OF CHAR;
    str128= ARRAY [0..127] OF CHAR;
    str256= ARRAY [0..255] OF CHAR;
    str1024=ARRAY [0..1023] OF CHAR;
    str2048=ARRAY [0..2047] OF CHAR;
    str16  =ARRAY [0..15] OF CHAR;
    str4096=ARRAY [0..4095] OF CHAR;

CONST
    delim = ",";

CONST
    aR = FIO.readonly;
    aH = FIO.hidden;
    aS = FIO.system;
    aDD= FIO.directory; (* seems XDS already uses aD but error message is not informative ! *)
    aA = FIO.archive;
    everything       = FIO.FileAttr{aR,aH,aS,aDD,aA};
    allfiles         = FIO.FileAttr{aR,aH,aS,aA};

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE map (c : CHAR ;table : ARRAY OF CHAR) : CHAR;
BEGIN
    RETURN table [ ORD (c) ];
END map;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Rtrim (VAR S : ARRAY OF CHAR; c:CHAR);
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF S[i-1] # c THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END Rtrim;

(* ------------------------------------------------------------ *)

PROCEDURE UpperCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Caps(S);
END UpperCase;

PROCEDURE LowerCase (VAR S : ARRAY OF CHAR);
BEGIN
    Str.Lows(S);
END LowerCase;

(* ------------------------------------------------------------ *)

PROCEDURE ReplaceChar (VAR S : ARRAY OF CHAR;
                       oldchar, newchar : CHAR);
VAR
    p : CARDINAL;
BEGIN
    IF oldchar=newchar THEN RETURN; END; (* silly... *)
    LOOP
        p := Str.CharPos(S,oldchar);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        IF newchar = "" THEN
            Str.Delete(S,p,1);
        ELSE
            S[p]:=newchar;
        END;
    END;
END ReplaceChar;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(*
    use dmpTTX this way :

    continue:=dmpTTX(Z,width,S,TRUE);
    WHILE continue DO
        WrStr(S);WrLn;
        continue:=dmpTTX(Z,width,S,FALSE);
    END;
*)

VAR
    basePos:CARDINAL;
    baseLen:CARDINAL;

PROCEDURE dmpTTX (paragraph:ARRAY OF CHAR;width:CARDINAL;
                  VAR S:ARRAY OF CHAR;firstcall:BOOLEAN) : BOOLEAN;
CONST
    blank=" ";
VAR
    len,count:CARDINAL;
BEGIN
    IF firstcall THEN
        basePos := 0;
        baseLen := Str.Length(paragraph); (* do not recalc it each time *)
    END;

    IF basePos = baseLen THEN RETURN FALSE; END; (* we're done now *)

    count:=width;
    IF (basePos+count) < baseLen THEN (* more than 'width' remaining chars *)
        LOOP
            IF paragraph[basePos+count]=blank THEN
                EXIT;
            END;
            DEC(count);
            IF count=0 THEN (* no space at all in string to get *)
                count:=width;
                EXIT;
            END;
        END;
        Str.Slice(S,paragraph,basePos,count); (* slice required portion *)
        INC(basePos,count); (* advance *)
        IF paragraph[basePos] = blank THEN INC(basePos); END; (* skip possible first space *)
    ELSE (* remaining chars are just 'width' or less *)
        Str.Slice(S,paragraph,basePos,baseLen-basePos);
        basePos:=baseLen; (* right on nullchar *)
    END;
    RETURN TRUE;
END dmpTTX;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE chkJoker (S : ARRAY OF CHAR) : BOOLEAN;
CONST
    star     = "*";
    question = "?";
VAR
    p : CARDINAL;
BEGIN
    IF Str.CharPos(S,star) # MAX(CARDINAL) THEN RETURN TRUE; END;
    IF Str.CharPos(S,question) # MAX(CARDINAL) THEN RETURN TRUE; END;
    RETURN FALSE;
END chkJoker;

PROCEDURE isOption (S : ARRAY OF CHAR) : BOOLEAN;
BEGIN
CASE S[0] OF
| slash, dash :
    RETURN TRUE;
ELSE
    RETURN FALSE;
END;
END isOption;

(* ------------------------------------------------------------ *)

PROCEDURE fixEquate (VAR S:ARRAY OF CHAR);
CONST
    NOTFOUND = MAX(CARDINAL);
VAR
    pc,pe:CARDINAL;
BEGIN
    pc:=Str.CharPos(S,colon);
    pe:=Str.CharPos(S,equal);

    IF pc = NOTFOUND THEN
        IF pe # NOTFOUND THEN   (* "=" only *)
            Str.Subst(S,equal,colon); (* would do nothing IF equal does NOT exist *)
        END;
    ELSE
        IF pe # NOTFOUND THEN   (* both ":" and "=" *)
            IF pe < pc THEN     (* "=" before ":" *)
                Str.Subst(S,equal,colon);
            END;
        END;
    END;
END fixEquate;

PROCEDURE GetOptIndex (S : ARRAY OF CHAR; options : ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
BEGIN
    Str.Delete(S,0,1); (* remove leading - or / because we arrive if option *)
    Str.Append(options,delim);
    (*
    Str.Subst(S,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(S);
    ReplaceChar(options,equal,colon); (* all possibles option xxx= become xxx: *)

    i := 0;
    LOOP
        Str.ItemS(str,options,delim,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF Str.CharPos(str,colon)=MAX(CARDINAL) THEN (* normal option *)
             IF Str.Compare(str,S)=0 THEN RETURN (i+1); END;
        ELSE (* option with a number *)
             Str.Append(str,"*"); (* match any number after : *)
             IF Str.Match(S, str )=TRUE THEN RETURN (i+1); END;
        END;
        INC(i);
    END;
END GetOptIndex;



(* //FIXED with fixEquate(), we no longer always replace first "=" with ":" *)

PROCEDURE GetLongCard (s : ARRAY OF CHAR; VAR value : LONGCARD) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGCARD;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToCard(s,10,ok);
    value := v;
    RETURN ok;
END GetLongCard;

PROCEDURE GetLongInt (s : ARRAY OF CHAR; VAR value : LONGINT) : BOOLEAN;
VAR
    p  : CARDINAL;
    v  : LONGINT;
    ok : BOOLEAN;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    v := Str.StrToInt(s,10,ok);
    value := v;
    RETURN ok;
END GetLongInt;

PROCEDURE GetString (s : ARRAY OF CHAR; VAR r : ARRAY OF CHAR);
VAR
    p : CARDINAL;
BEGIN
    (*
    Str.Subst(s,equal,colon); (* command line option xxx= becomes xxx: *)
    *)
    fixEquate(s);

    p := Str.CharPos(s,colon); (* exclude MAX(CARDINAL) here! ;-) *)

    Str.Delete(s,0,p+1);
    Str.Copy (r, s);
END GetString;

(* ------------------------------------------------------------ *)

PROCEDURE CharCount (S : ARRAY OF CHAR; what : CHAR) : CARDINAL;
VAR
    n    : CARDINAL;
    oldp : CARDINAL;
    nxtp : CARDINAL;
    len  : CARDINAL;
BEGIN
    n    := 0;
    len  := Str.Length(S);
    oldp := 0;
    LOOP
        nxtp := Str.NextPos(S,what,oldp);
        IF nxtp = MAX(CARDINAL) THEN EXIT; END;
        INC(n);
        oldp := nxtp+1;
        IF oldp >= len THEN EXIT; END;
    END;
    RETURN n;
END CharCount;

(* ------------------------------------------------------------ *)

PROCEDURE same(S1,S2 : ARRAY OF CHAR) : BOOLEAN;
BEGIN
    IF Str.Compare(S1,S2)=0 THEN RETURN TRUE; END;
    RETURN FALSE;
END same;

(* ------------------------------------------------------------ *)

PROCEDURE fixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] = antislash THEN RETURN; END;
    Str.Append(S,antislash);
END fixDirectory;

(* take care of "\" or "u:\" *)

PROCEDURE unfixDirectory (VAR S : ARRAY OF CHAR);
VAR
    len : CARDINAL;
BEGIN
    len := Str.Length(S);
    IF len=0 THEN RETURN; END;
    IF S[len-1] # antislash THEN RETURN; END;
    IF same(S,"\") THEN RETURN;END;
    IF Str.Match(S,"?:\") THEN RETURN;END;
    S[len-1] := CHR(0);
END unfixDirectory;

PROCEDURE isDirectory (S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    unfixDirectory(S);
    CASE Str.Length(S) OF
    | 2 : (* avoid "u:" alone ! but what about "*.", eh ? *)
        IF S[1]=colon THEN RETURN TRUE; END; (* always but we do not check for its real life *)
    | 3 : (* avoid "u:\" alone ! *)
        IF S[1]=colon THEN
            IF S[2]=antislash THEN RETURN TRUE; END; (* always but we do not check for its real life *)
        END;
    ELSE (* //XDS USELESS SYNTAX REQUIREMENT MAKING PROGRAM CRASH WHEN RUN ! *)
        ;
    END;
    found := FIO.ReadFirstEntry(S,everything,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aDD IN entry.attr);
END isDirectory;

PROCEDURE Belongs (S : ARRAY OF CHAR; c:CHAR  ) : BOOLEAN;
BEGIN
    IF Str.CharPos(S,c)=MAX(CARDINAL) THEN
        RETURN FALSE;
    ELSE
        RETURN TRUE;
    END;
END Belongs;

(* ------------------------------------------------------------ *)

PROCEDURE LtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := 0;
    LOOP
        IF i = len THEN EXIT; END;
        IF ORD(S[i]) > espace THEN EXIT; END;
        INC (i);
    END;
    Str.Delete (S,0,i); (* procedure handles removal of i=0 *)
END LtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE RtrimBlanks (VAR S : ARRAY OF CHAR);
CONST
    espace=ORD(" ");
VAR
    i,len : CARDINAL;
BEGIN
    len := Str.Length (S);
    i   := len;
    LOOP
        IF i = 0 THEN EXIT; END;
        IF ORD(S[i-1]) > espace THEN EXIT; END;
        DEC (i);
    END;
    Str.Delete (S,i,len-i);
END RtrimBlanks;

(* ------------------------------------------------------------ *)

PROCEDURE getStrIndex (delimiter:CHAR;what,list: ARRAY OF CHAR) : CARDINAL;
VAR
    i   : CARDINAL;
    str : str80; (* option tested against s *)
    myList:str1024; (* long just in case *)
BEGIN
    Str.Concat(myList,list,delimiter);

    i := 0;
    LOOP
        Str.ItemS(str,myList,delimiter,i);
        IF Str.Length(str)=0 THEN RETURN 0; END;
        IF same(str,what) THEN RETURN (i+1); END;
        INC(i);
    END;
END getStrIndex;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    SetOfChars = SET OF CHAR;

PROCEDURE isoleItem(VAR R: ARRAY OF CHAR;
                    S: ARRAY OF CHAR; T: SetOfChars; N: CARDINAL);

VAR
    len,i,j,k:CARDINAL;
BEGIN
    len := Str.Length(S);
    i   := 0;
    WHILE ( (i<len) AND (N > 0) ) DO
        IF (S[i] IN T) THEN DEC(N); END;
        INC(i);
    END;
    (* i is at first char after separator *)
    j := i;
    WHILE ( (j<len) AND NOT (S[j] IN T) ) DO
        INC(j);
    END;
    k := 0;
    WHILE (i<j) DO
        R[k] := S[i];
        INC(k);
        INC(i);
    END;
    R[k]:=CHR(0);
END isoleItem;

(* now we can safely parse "a,b,c,,e" ! what about ",,c,d,e" ? *)
(* first element is 0 *)

PROCEDURE isoleItemS(VAR R: ARRAY OF CHAR;
                     S: ARRAY OF CHAR; T: ARRAY OF CHAR; N: CARDINAL);
VAR
    CS  : SetOfChars;
    len : CARDINAL;
BEGIN
    len := Str.Length(T);
    CS := SetOfChars{};
    WHILE len > 0 DO
        DEC(len);
        INCL(CS,T[len]);
    END;
    isoleItem(R,S,CS,N);
END isoleItemS;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE verifyString (S,allowed:ARRAY OF CHAR):BOOLEAN;
VAR
    i,mismatches : CARDINAL;
    ch : CHAR;
BEGIN
    mismatches := 0;
    FOR i := 1 TO Str.Length(S) DO
        ch := S[i-1];
        IF Belongs(allowed,ch)=FALSE THEN INC(mismatches);END;
    END;
    RETURN (mismatches=0);
END verifyString;

(* ------------------------------------------------------------ *)

(* try and fix TopSpeed bug when tabs are in command line *)

PROCEDURE cleantabs (VAR S : ARRAY OF CHAR);
CONST
    tab=CHR(9);
VAR
    p : CARDINAL;
BEGIN
    LOOP
        p:=Str.CharPos(S,tab);
        IF p = MAX(CARDINAL) THEN EXIT; END;
        Str.Delete(S,p,1); (* delete unwanted tabulation *)
    END;
END cleantabs;


PROCEDURE ChkEscape (  ) : BOOLEAN;
CONST
    escape  = CHR(27);
    special = CHR(0);
VAR
    ch : CHAR;
BEGIN
    IF IO.KeyPressed() = TRUE THEN
        ch := IO.RdKey();
        CASE ch OF
        | escape :
            RETURN TRUE;
        | special :
            ch := IO.RdKey();
            RETURN FALSE;
        ELSE
            RETURN FALSE;
        END;
    ELSE
        RETURN FALSE;
    END;
END ChkEscape;

PROCEDURE fileIsRO(S : ARRAY OF CHAR) : BOOLEAN;
VAR
    entry : FIO.DirEntry;
    found : BOOLEAN;
BEGIN
    found := FIO.ReadFirstEntry(S,allfiles,entry);
    IF found = FALSE THEN RETURN FALSE; END;
    RETURN (aR IN entry.attr);
END fileIsRO;

(* //FIXME //XDS to be done ! *)

PROCEDURE fileSetRW(S:ARRAY OF CHAR);
BEGIN
    ;
END fileSetRW;

PROCEDURE getFileSize(S:ARRAY OF CHAR):LONGCARD;
VAR
    hnd:FIO.File;
    fsize:LONGCARD;
BEGIN
    hnd:=FIO.OpenRead(S);
    fsize:=FIO.Size(hnd);
    FIO.Close(hnd);
    RETURN fsize;
END getFileSize;

PROCEDURE vidWrStr (s : ARRAY OF CHAR);
(*
CONST
    stderr        = 02H;  (* write to stderr as not to write control chars to possible redirected file *)
    stderr        = FIO.ErrorOutput;
*)
BEGIN
    FIO.WrStr(FIO.ErrorOutput,s);
END vidWrStr;

PROCEDURE video (S : ARRAY OF CHAR; flag:BOOLEAN);
CONST
    charBS    = 10C;
    charBlank = 40C;
    bsblankbs = charBS+charBlank+charBS;
VAR
    len : CARDINAL;
    i   : CARDINAL;
BEGIN
    len := Str.Length(S);
    CASE flag OF
    | TRUE :
        vidWrStr(S);
    | FALSE:
        FOR i := 1 TO len DO
            vidWrStr(bsblankbs);
        END;
    ELSE
        ; (* //XDS no kidding ??? ternary boolean logic ??? *)
    END;
END video;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* // QD_RAND *)

CONST
    firstalea = 1;
    lastalea  = 128;
VAR
    pool : ARRAY [firstalea..lastalea] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE InitRnd ();
VAR
    i : CARDINAL;
BEGIN
    Lib.RANDOMIZE;
    FOR i := firstalea TO lastalea DO
        pool[i] := Lib.RAND();
    END;
END InitRnd;

(* ------------------------------------------------------------ *)

(*
PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(firstalea);
    upperbound:=REAL(lastalea);
    rnd := (upperbound-lowerbound+1.0) * Lib.RAND() + lowerbound ;
    index := CARDINAL(rnd);
    rnd:=pool[index];
    pool[index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;
*)

PROCEDURE GetRnd () : REAL;
VAR
    index:CARDINAL;
    rnd  :REAL;
BEGIN
    index := Lib.RANDOM(lastalea-firstalea+1); (* [0..128[ [0..127] *)
    rnd:=pool[firstalea+index];
    pool[firstalea+index]:=Lib.RAND();
    RETURN rnd;
END GetRnd;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndCardRange (lowerlimit,upperlimit:CARDINAL) : CARDINAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN CARDINAL(rnd);
END GetRndCardRange;

PROCEDURE GetRndLngCardRange (lowerlimit,upperlimit:LONGCARD) : LONGCARD;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGCARD(rnd);
END GetRndLngCardRange;

(* ------------------------------------------------------------ *)

(*
    eh, the formula does not work for reals ! try removing the -1.0
    maybe add an adjustement to upper limit, such as 0.0001 ?
*)

PROCEDURE GetRndLngRealRange (lowerlimit,upperlimit:LONGREAL) : LONGREAL;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN LONGREAL(rnd);
END GetRndLngRealRange;

PROCEDURE GetRndRealRange (lowerbound,upperbound:REAL) : REAL;
VAR
    rnd:REAL;
BEGIN
    rnd :=  (upperbound-lowerbound) * GetRnd()+ lowerbound ;
    RETURN rnd;
END GetRndRealRange;

(* ------------------------------------------------------------ *)

PROCEDURE GetRndIntRange (lowerlimit,upperlimit:INTEGER) : INTEGER;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN INTEGER(rnd);
END GetRndIntRange;

PROCEDURE GetRndLngIntRange (lowerlimit,upperlimit:LONGINT) : LONGINT;
VAR
    lowerbound:REAL;
    upperbound:REAL;
    rnd:REAL;
BEGIN
    lowerbound:=REAL(lowerlimit);
    upperbound:=REAL(upperlimit);
    rnd :=  (upperbound-lowerbound+1.0) * GetRnd()+ lowerbound ;
    RETURN LONGINT(rnd);
END GetRndLngIntRange;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

(* we could use VAR cli as to go a little faster : nay, not even really faster in fact ! *)

PROCEDURE argc (cli : ARRAY OF CHAR; clean : BOOLEAN) : CARDINAL;
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch       : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    RETURN argCount;
END argc;

PROCEDURE argv (VAR argument : ARRAY OF CHAR;
                cli : ARRAY OF CHAR; n : CARDINAL; clean:BOOLEAN);
VAR
    state    : (empty,intoken,instring);
    cliLen   : CARDINAL;
    cliPos   : CARDINAL;
    argCount : CARDINAL;
    ch     : CHAR;
    code     : CARDINAL;
    arg      : str128;
    sdelim   : CARDINAL;
BEGIN
    IF ( (n < 1) OR (n > argc(cli,clean)) ) THEN
        Str.Copy(argument,"");
        RETURN;
    END;
    IF clean THEN
        LtrimBlanks(cli);
        RtrimBlanks(cli);
    END;
    cliLen   := Str.Length(cli);
    cliPos   := 1;
    argCount := 0;
    state    := empty;
    LOOP
        IF cliPos > cliLen THEN EXIT; END;
        ch := cli[cliPos-1];
        code := ORD(ch);
        CASE state OF
        | empty :
            IF n = argCount THEN EXIT; END; (* argV$ test *)
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN
                sdelim:= code;
                state := instring;        (* begin new string *)
                Str.Copy(arg,ch);
                INC(argCount);
            ELSIF code > ORD(blank) THEN  (* quote already trapped *)
                state := intoken;         (* begin new token *)
                Str.Copy(arg,ch);
                INC(argCount);
            END;
        | intoken :
            IF ( (code = ORD(doublequote)) OR (code=ORD(singlequote)) ) THEN (* quote in token *)
                sdelim:= code; (* fix *)
                state := instring;        (* if string in parameter *)
                Str.Append(arg,ch);
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                state := empty;           (* end of token *)
            END;
        | instring :
            IF code = sdelim THEN
                Str.Append(arg,ch);
                state := empty;           (* end of string *)
            ELSIF code > ORD(blank) THEN
                Str.Append(arg,ch);
            ELSE
                Str.Append(arg,blank);    (* remove TAB and controls if any *)
            END;
        ELSE ; (* //ISO fixed silly requirement *) END;
        INC(cliPos);
    END;
    Str.Copy(argument,arg);
END argv;


(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)



(*
    handle both "\" and "/" separators
    *:*\[n[.[e]]]

    grab last "\" if any then check for next "."

    we could fix "/" and "\" mix, as well as empty extension ?
*)

PROCEDURE qdSplitAllPath (udne:ARRAY OF CHAR;VAR u,d,n,e:ARRAY OF CHAR);
VAR
    F:str1024; (* bigger than pathtype *)
    p:CARDINAL;
BEGIN
    (*
    Lib.SplitAllPath(F,u,d,n,e);
    Lib.MakeAllPath(F,u,d,n,e);
    IF Str.Compare(udne,F) = 0 THEN RETURN; END;
    *)

    (* let's fix JPI buggy function so we still get "u:" "\*\" "f" ".e" *)

    p:=Str.CharPos(udne,colon);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(u,"");
    ELSE
        Str.Slice(u,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    Str.Copy(F,udne);
    LOOP
        p:=Str.CharPos(F,slash);
        IF p = MAX(CARDINAL) THEN EXIT;END;
        F[p]:=antislash;
    END;
    p:=Str.RCharPos(F,antislash);
    IF p = MAX(CARDINAL) THEN
        Str.Copy(d,"");
    ELSE
        Str.Slice(d,udne,0,p+1);
        Str.Delete(udne,0,p+1);
    END;

    p:=Str.RCharPos(udne,dot);
    CASE p OF
    | MAX(CARDINAL) :
        Str.Copy(n,udne);
        Str.Copy(e,"");
    | 0 :
        Str.Copy(n,"");
        Str.Copy(e,udne);
    ELSE
        Str.Slice(n,udne,0,p);
        Str.Delete(udne,0,p);
        Str.Copy(e,udne);
    END;

END qdSplitAllPath;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

TYPE
    pathtype = FIO.FileName;






CONST
    xmin = 0;
    xmax = 640;
    ymin = 0;
    ymax = 480;

    FIRSTKNOT = 1-1;
    MAXKNOT   = 100+1+1;
(* //XDS has it wrong !!! *)
	black  = 0;
    	yellow = 15;
    	green  = 14;
    	red    = 13;
    	white  = 10;
    	blue   = 9;

    RADIUS = 4;

CONST
    start = 1;
VAR
    NumPts   : CARDINAL;
    Res      : CARDINAL;
    MinDelta : CARDINAL;
    MaxDelta : CARDINAL;

PROCEDURE defaults (  );
BEGIN
    Res      := 10;
    NumPts   :=  5;
    MinDelta :=  1;
    MaxDelta :=  4;
END defaults;

(* ------------------------------------------------------------ *)

PROCEDURE WaitVGAretrace (n:CARDINAL );
VAR
    i:CARDINAL;
BEGIN
    FOR i:=1 TO n DO
    	(* //XDS
        WHILE (SYSTEM.In(03DAH) AND 08H) # 0 DO
        END;
        WHILE (SYSTEM.In(03DAH) AND 08H) = 0 DO
        END;
	*)
	Lib.Delay(n);
    END;
END WaitVGAretrace;

PROCEDURE HiresON () : BOOLEAN;
BEGIN
    RETURN Graph.SetVideoMode(Graph._VRES16COLOR);
END HiresON;

PROCEDURE HiresOFF() : BOOLEAN;
BEGIN
    RETURN Graph.SetVideoMode(Graph._DEFAULTMODE);
END HiresOFF;

PROCEDURE line (x1,y1,x2,y2:INTEGER;ink:CARDINAL);
BEGIN
    IF x1 < xmin THEN RETURN; END;
    IF x1 >=xmax THEN RETURN; END;
    IF y1 < ymin THEN RETURN; END;
    IF y1 >=ymax THEN RETURN; END;
    IF x2 < xmin THEN RETURN; END;
    IF x2 >=xmax THEN RETURN; END;
    IF y2 < ymin THEN RETURN; END;
    IF y2 >=ymax THEN RETURN; END;
    Graph.Line(CARDINAL(x1),CARDINAL(y1),CARDINAL(x2),CARDINAL(y2),ink);
END line;

(* ------------------------------------------------------------ *)

(* globerk ! *)

VAR
    x : ARRAY [FIRSTKNOT..MAXKNOT] OF REAL;
    y : ARRAY [FIRSTKNOT..MAXKNOT] OF REAL;
    dx: ARRAY [FIRSTKNOT..MAXKNOT] OF REAL;
    dy: ARRAY [FIRSTKNOT..MAXKNOT] OF REAL;

(* ------------------------------------------------------------ *)

PROCEDURE newdelta (lower,limit:CARDINAL) : REAL;
VAR
    rnd:CARDINAL;
    delta : REAL;
BEGIN
(*
    LOOP
        delta :=Lib.RANDOM(limit*2+1)-limit;
        IF ABS(delta) >= INTEGER(lower) THEN EXIT; END;
    END;
*)
    LOOP
        rnd :=Lib.RANDOM(limit*2+1);
        delta := REAL(rnd)-REAL(limit);
        IF ABS(delta) >= REAL(lower) THEN EXIT; END;
    END;

    RETURN REAL(delta);
END newdelta;

PROCEDURE init_knots (first,N:CARDINAL);
VAR
    i,last : CARDINAL;
BEGIN
    last := first+N-1;
    Lib.RANDOMIZE;
    FOR i := first TO last DO
        x[i]:=REAL(Lib.RANDOM(xmax));
        y[i]:=REAL(Lib.RANDOM(ymax));
        dx[i]:=newdelta(MinDelta,MaxDelta);
        dy[i]:=newdelta(MinDelta,MaxDelta);
    END;
END init_knots;

PROCEDURE move_knots (first,last:CARDINAL);
VAR
    i : CARDINAL;
    t : REAL;
BEGIN
    FOR i := first TO last DO
        LOOP
            t := x[i] + dx[i];
            IF (t >= REAL(xmin) ) AND (t < REAL(xmax) ) THEN EXIT; END;
            dx[i] := newdelta(MinDelta,MaxDelta);
        END;
        x[i] := t;
        LOOP
            t := y[i] + dy[i];
            IF (t >= REAL(ymin) ) AND (t < REAL(ymax) ) THEN EXIT; END;
            dy[i] := newdelta(MinDelta,MaxDelta);
        END;
        y[i] := t;
    END;
END move_knots;

(* ------------------------------------------------------------ *)

PROCEDURE show_knots (first,last,ink : CARDINAL );
VAR
    i,r : CARDINAL;
BEGIN
    r := RADIUS;
    FOR i := first TO last DO
        Graph.Circle(CARDINAL(x[i]),CARDINAL(y[i]), r ,ink);
    END;
END show_knots;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE BernsteinBezier (first,N : CARDINAL; ink:CARDINAL );
VAR
    b,t: REAL;
    i,j,k:CARDINAL;
    lastX,lastY,X,Y : REAL;
BEGIN
    N := first + N -1;

    lastX := x[first];
    lastY := y[first];
    t := 0.0;
    WHILE t <= 1.0 DO
        X := 0.0;
        Y := 0.0;
        FOR j := 0 TO N-1 DO
            b := 1.0;
            k := N -1;
            WHILE k > j DO
                b := b * REAL(k);
                DEC(k);
            END;
            k := N -1 -j;
            WHILE k > 1 DO
                b := b / REAL(k);
                DEC(k);
            END;
            i := 1;
            WHILE i <= j DO
                b := b * t;
                INC(i);
            END;
            i := 1;
            WHILE i <= N-1 -j DO
                b := b * (1.0 -t);
                INC(i);
            END;
            X := X +x[j +1] * b;
            Y := Y +y[j +1] * b;
        END;
        line (INTEGER(lastX),INTEGER(lastY),INTEGER(X), INTEGER(Y),ink);
        lastX := X;
        lastY := Y;
        t := t + 0.04; (* .2 = 50 curve points, .05=20 i.e. 1/0.5 , .04=25 *)
    END;
END BernsteinBezier;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Spline_Calc(T, D,Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy : REAL; VAR X,Y : REAL);
VAR
    T2,T3:REAL;
BEGIN
    T2 := T  * T;
    T3 := T2 * T;
    X := ((Apx * T3) +(Bpx * T2) +(Cpx * T) +Dpx)/D;
    Y := ((Apy * T3) +(Bpy * T2) +(Cpy * T) +Dpy)/D;
END Spline_Calc;

PROCEDURE CatMull_Rom_ComputeCoeffs (N : CARDINAL;VAR Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy:REAL);
BEGIN
    Apx := -x[N -1] +3.0 * x[N] -3.0 * x[N +1] +x[N +2];
    Bpx := 2.0 * x[N -1] -5.0 * x[N] +4.0 * x[N +1] -x[N+2];
    Cpx := -x[N -1] +x[N +1];
    Dpx := 2.0 * x[N];
    Apy := -y[N -1] +3.0 * y[N] -3.0 * y[N+1] +y[N +2];
    Bpy := 2.0 * y[N -1] -5.0 * y[N] +4.0 * y[N +1] -y[N +2];
    Cpy := -y[N -1] +y[N +1];
    Dpy := 2.0 * y[N];
END CatMull_Rom_ComputeCoeffs;

PROCEDURE CatMullRomSpline (first,N,Resolution, ink:CARDINAL);
VAR
    i,j : CARDINAL;
    lastX,lastY,X,Y:REAL;
    Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy:REAL;
BEGIN
    N := first+N-1;
    x[first-1]:=x[first];
    y[first-1]:=y[first];
    x[N+1]:=x[N];
    y[N+1]:=y[N];
    x[N+2]:=x[N];
    y[N+2]:=y[N];
    lastX:=x[first];
    lastY:=y[first];
    FOR i := first TO N-1 DO
        CatMull_Rom_ComputeCoeffs(i,Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy);
        FOR j := 1 TO Resolution DO
            Spline_Calc(REAL(j) / REAL(Resolution), 2.0,Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy ,X,Y);
            line (INTEGER(lastX),INTEGER(lastY),INTEGER(X), INTEGER(Y),ink);
            lastX := X;
            lastY := Y;
        END;
    END;
END CatMullRomSpline;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE BSpline_ComputeCoeffs (N : CARDINAL;VAR Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy:REAL );
BEGIN
    Apx := -x[N -1] +3.0 * x[N] -3.0 * x[N +1] +x[N +2];
    Bpx := 3.0 * x[N -1] -6.0 * x[N] +3.0 * x[N +1];
    Cpx := -3.0 * x[N -1] +3.0 * x[N +1];
    Dpx := x[N -1] +4.0 * x[N] +x[N +1];
    Apy := -y[N -1] +3.0 * y[N] -3.0 * y[N +1] +y[N +2];
    Bpy := 3.0 * y[N -1] -6.0 * y[N] +3.0 * y[N +1];
    Cpy := -3.0 * y[N -1] +3.0 * y[N +1];
    Dpy := y[N -1] +4.0 * y[N] +y[N +1];
END BSpline_ComputeCoeffs;

PROCEDURE BSpline (first,N,Resolution,ink:CARDINAL);
VAR
    i,j:CARDINAL;
    lastX,lastY,X,Y:REAL;
    Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy:REAL;
BEGIN
    N:=first+N-1;
    x[first-1]:=x[first];
    y[first-1]:=y[first];
    x[N+1]:=x[N];
    y[N+1]:=y[N];
    x[N+2]:=x[N];
    y[N+2]:=y[N];
    lastX:=x[first];
    lastY:=y[first];
    FOR i := first TO N DO
        BSpline_ComputeCoeffs(i,Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy);
        FOR j := 0 TO Resolution DO
            Spline_Calc( REAL(j) / REAL(Resolution), 6.0,Apx,Bpx,Cpx,Dpx,Apy,Bpy,Cpy,Dpy,X,Y );
            line (INTEGER(lastX),INTEGER(lastY),INTEGER(X), INTEGER(Y),ink);
            lastX := X;
            lastY := Y;
        END;
    END;
END BSpline;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

PROCEDURE Parab_Calc (T, D, Apx,Bpx,Cpx,Apy,Bpy,Cpy : REAL; VAR X,Y : REAL);
VAR
    T2 : REAL;
BEGIN
    T2 := T * T;
    X  := ((Apx * T2) +(Bpx * T) +Cpx) / D;
    Y  := ((Apy * T2) +(Bpy * T) +Cpy) / D;
END Parab_Calc;

PROCEDURE Parab_ComputeCoeffs(N:CARDINAL;VAR Apx,Bpx,Cpx,Apy,Bpy,Cpy:REAL);
BEGIN
    Apx := x[N -1] -2.0 * x[N] +x[N +1];
    Bpx := -2.0 * x[N -1] +2.0 * x[N];
    Cpx := x[N -1] +x[N];
    Apy := y[N -1] -2.0 * y[N] +y[N +1];
    Bpy := -2.0 * y[N -1] +2.0 * y[N];
    Cpy := y[N -1] +y[N];
END Parab_ComputeCoeffs;

PROCEDURE ParabolicSpline (first,N,Resolution,ink:CARDINAL);
VAR
    i,j:CARDINAL;
    lastX,lastY,X,Y:REAL;
    Apx,Bpx,Cpx,Apy,Bpy,Cpy:REAL;
    starting : CARDINAL;
BEGIN
    N:=first+N-1;

    x[first-1]:=x[N];
    y[first-1]:=y[N];
    x[N+1]:=x[first];
    y[N+1]:=y[first];
    x[N+2]:=x[first+1];
    y[N+2]:=y[first+1];


    lastX:=x[first];
    lastY:=y[first];

    i := first;
    Parab_ComputeCoeffs(i,Apx,Bpx,Cpx,Apy,Bpy,Cpy);
    FOR j := 0 TO Resolution DO
        Parab_Calc( REAL(j) / REAL(Resolution), 2.0,Apx,Bpx,Cpx,Apy,Bpy,Cpy,X,Y );
        IF j >= (Resolution DIV 2) THEN
            line (INTEGER(lastX),INTEGER(lastY),INTEGER(X), INTEGER(Y),ink);
        END;
        lastX := X;
        lastY := Y;
    END;

    FOR i := first+1 TO N DO
        Parab_ComputeCoeffs(i,Apx,Bpx,Cpx,Apy,Bpy,Cpy);
        FOR j := 0 TO Resolution DO
            Parab_Calc( REAL(j) / REAL(Resolution), 2.0,Apx,Bpx,Cpx,Apy,Bpy,Cpy,X,Y );
            line (INTEGER(lastX),INTEGER(lastY),INTEGER(X), INTEGER(Y),ink);
            lastX := X;
            lastY := Y;
        END;
    END;

    i := N+1;
    Parab_ComputeCoeffs(i,Apx,Bpx,Cpx,Apy,Bpy,Cpy);
    FOR j := 0 TO Resolution DO
        Parab_Calc( REAL(j) / REAL(Resolution), 2.0,Apx,Bpx,Cpx,Apy,Bpy,Cpy,X,Y );
        IF j < (Resolution DIV 2) THEN
            line (INTEGER(lastX),INTEGER(lastY),INTEGER(X), INTEGER(Y),ink);
        END;
        lastX := X;
        lastY := Y;
    END;


END ParabolicSpline;

(* ------------------------------------------------------------ *)
(* ------------------------------------------------------------ *)

CONST
    help= "Q&D PSPLINE32 (Win32) v0.9 (from v1.0a for DOS) by PhG"+nl+
          nl+
          "Syntax : PSPLINE32 B|C|P|S|* /S:# /P:# /L:# /U:# /L"+nl+
          nl+
          "    B=BernsteinBezier, C=CatMullRom, P=ParabolicSpline, S=BSpline, *=all"+nl+
          "    /S=segments, /P=points, /L=lowervelocity, /U=uppervelocity, /L=linesonly"+nl+
          nl+
         "The original J.P.I. TopSpeed Modula-2 DOS source was reluctantly ported"+nl+
         "to XDS compiler using the so-called TopSpeed Compatibility Kit."+nl+
         "Although successful compiling required (too) many modifications in source,"+nl+
         "results should match the original DOS program. ERRORINF.$$$ may happen ! ;-)"+nl;

VAR
    parmcount : CARDINAL;
    i         : CARDINAL;
    opt       : CARDINAL;
    S         : str128;
    R         : str128;
    v         : LONGCARD;
    ok        : BOOLEAN;
    showdots  : BOOLEAN;
    ch        : CHAR;
BEGIN
    WrLn;

    defaults;
    ch := "?";
    showdots := TRUE;

    parmcount := Lib.ParamCount();

    IF parmcount = 0 THEN WrStr(help);HALT;END;

    FOR i := 1 TO parmcount DO
        Lib.ParamStr(S,i);
        Str.Copy(R,S);
        UpperCase(R);
        IF isOption(R) THEN
            opt := GetOptIndex(R,"S:"+delim+
                                 "P:"+delim+
                                 "L:"+delim+
                                 "U:"+delim+
                                 "L"+delim+
                                 "?"+delim+"H"+delim+"HELP"
                              );
            CASE opt OF
            | 1 : ok:=GetLongCard(S,v); Res := CARDINAL(v);
            | 2 : ok:=GetLongCard(S,v); NumPts := CARDINAL(v);
            | 3 : ok:=GetLongCard(S,v); MinDelta := CARDINAL(v);
            | 4 : ok:=GetLongCard(S,v); MaxDelta := CARDINAL(v);
            | 5 : showdots := FALSE;
            | 6,7,8: WrStr(help); HALT;
            ELSE ; (* //ISO fixed silly requirement *) END;
        ELSE
            ch:=R[0];

        END;
    END;
    IF ch="?" THEN HALT; END;
    IF HiresON() = FALSE THEN HALT; END;
    Graph.ClearScreen(Graph._GCLEARSCREEN);

    init_knots (start,NumPts);

    LOOP
        Graph.ClearScreen(Graph._GCLEARSCREEN);
        IF showdots THEN show_knots (start,NumPts,yellow); END;
        CASE ch OF
        | "B" : BernsteinBezier(start,NumPts,white); (* ok *)
        | "C" : CatMullRomSpline(start,NumPts, Res, green); (* ok *)
        | "P" : ParabolicSpline(start,NumPts,Res,red); (* ok *)
        | "S" : BSpline(start,NumPts,Res,blue);
        | "*" : BernsteinBezier(start,NumPts,white); (* ok *)
                CatMullRomSpline(start,NumPts, Res, green); (* ok *)
                ParabolicSpline(start,NumPts,Res,red); (* ok *)
                BSpline(start,NumPts,Res,blue);
        ELSE
                EXIT;
        END;

        WaitVGAretrace(1); (* //XDS now calling Lib.Delay() *)
(*
        IF showdots THEN show_knots (start,NumPts,black); END;
        CASE ch OF
        | "B" : BernsteinBezier(start,NumPts,black); (* ok *)
        | "C" : CatMullRomSpline(start,NumPts, Res, black); (* ok *)
        | "P" : ParabolicSpline(start,NumPts,Res,black); (* ok *)
        | "S" : BSpline(start,NumPts,Res,black);
        | "*" : BernsteinBezier(start,NumPts,black); (* ok *)
                CatMullRomSpline(start,NumPts, Res, black); (* ok *)
                ParabolicSpline(start,NumPts,Res,black); (* ok *)
                BSpline(start,NumPts,Res,black);
        ELSE
                EXIT;
        END;
*)
        move_knots (start,NumPts);

        IF IO.KeyPressed() THEN EXIT; END;
    END;

    IF HiresOFF()= FALSE THEN HALT; END;
    HALT;
END splines32.


